/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* DAG Instruction Selector for the WebAssembly target                        *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

// *** NOTE: This file is #included into the middle of the target
// *** instruction selector class.  These functions are really methods.

// If GET_DAGISEL_DECL is #defined with any value, only function
// declarations will be included when this file is included.
// If GET_DAGISEL_BODY is #defined, its value should be the name of
// the instruction selector class. Function bodies will be emitted
// and each function's name will be qualified with the name of the
// class.
//
// When neither of the GET_DAGISEL* macros is defined, the functions
// are emitted inline.

#if defined(GET_DAGISEL_DECL) && defined(GET_DAGISEL_BODY)
#error GET_DAGISEL_DECL and GET_DAGISEL_BODY cannot be both defined, undef both for inline definitions
#endif

#ifdef GET_DAGISEL_BODY
#define LOCAL_DAGISEL_STRINGIZE(X) LOCAL_DAGISEL_STRINGIZE_(X)
#define LOCAL_DAGISEL_STRINGIZE_(X) #X
static_assert(sizeof(LOCAL_DAGISEL_STRINGIZE(GET_DAGISEL_BODY)) > 1,
   "GET_DAGISEL_BODY is empty: it should be defined with the class name");
#undef LOCAL_DAGISEL_STRINGIZE_
#undef LOCAL_DAGISEL_STRINGIZE
#endif

#if !defined(GET_DAGISEL_DECL) && !defined(GET_DAGISEL_BODY)
#define DAGISEL_INLINE 1
#else
#define DAGISEL_INLINE 0
#endif

#if !DAGISEL_INLINE
#define DAGISEL_CLASS_COLONCOLON GET_DAGISEL_BODY ::
#else
#define DAGISEL_CLASS_COLONCOLON
#endif

#ifdef GET_DAGISEL_DECL
void SelectCode(SDNode *N);
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
void DAGISEL_CLASS_COLONCOLON SelectCode(SDNode *N)
{
  // Some target values are emitted as 2 bytes, TARGET_VAL handles
  // this.
  #define TARGET_VAL(X) X & 255, unsigned(X) >> 8
  static const unsigned char MatcherTable[] = {
/*     0*/ OPC_SwitchOpcode /*116 cases */, 44|128,9/*1196*/, TARGET_VAL(ISD::ZERO_EXTEND),// ->1201
/*     5*/  OPC_Scope, 32|128,9/*1184*/, /*->1192*/ // 2 children in Scope
/*     8*/   OPC_MoveChild0,
/*     9*/   OPC_SwitchOpcode /*9 cases */, 124, TARGET_VAL(ISD::AssertZext),// ->137
/*    13*/    OPC_MoveChild0,
/*    14*/    OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/*    17*/    OPC_RecordMemRef,
/*    18*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*    19*/    OPC_CheckFoldableChainNode,
/*    20*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*    21*/    OPC_Scope, 56, /*->79*/ // 2 children in Scope
/*    23*/     OPC_CheckChild1TypeI32,
/*    24*/     OPC_MoveChild2,
/*    25*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    28*/     OPC_RecordChild0, // #2 = $exp
/*    29*/     OPC_MoveSibling3,
/*    30*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    33*/     OPC_RecordChild0, // #3 = $new
/*    34*/     OPC_MoveParent,
/*    35*/     OPC_Scope, 20, /*->57*/ // 2 children in Scope
/*    37*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*    38*/      OPC_MoveParent,
/*    39*/      OPC_MoveParent,
/*    40*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*    41*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*    43*/      OPC_EmitMergeInputChains1_0,
/*    44*/      OPC_EmitInteger32, 0, 
/*    46*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*    57*/     /*Scope*/ 20, /*->78*/
/*    58*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*    59*/      OPC_MoveParent,
/*    60*/      OPC_MoveParent,
/*    61*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*    62*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*    64*/      OPC_EmitMergeInputChains1_0,
/*    65*/      OPC_EmitInteger32, 0, 
/*    67*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*    78*/     0, /*End of Scope*/
/*    79*/    /*Scope*/ 56, /*->136*/
/*    80*/     OPC_CheckChild1TypeI64,
/*    81*/     OPC_MoveChild2,
/*    82*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    85*/     OPC_RecordChild0, // #2 = $exp
/*    86*/     OPC_MoveSibling3,
/*    87*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    90*/     OPC_RecordChild0, // #3 = $new
/*    91*/     OPC_MoveParent,
/*    92*/     OPC_Scope, 20, /*->114*/ // 2 children in Scope
/*    94*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*    95*/      OPC_MoveParent,
/*    96*/      OPC_MoveParent,
/*    97*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*    98*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   100*/      OPC_EmitMergeInputChains1_0,
/*   101*/      OPC_EmitInteger32, 0, 
/*   103*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   114*/     /*Scope*/ 20, /*->135*/
/*   115*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*   116*/      OPC_MoveParent,
/*   117*/      OPC_MoveParent,
/*   118*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   119*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   121*/      OPC_EmitMergeInputChains1_0,
/*   122*/      OPC_EmitInteger32, 0, 
/*   124*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   135*/     0, /*End of Scope*/
/*   136*/    0, /*End of Scope*/
/*   137*/   /*SwitchOpcode*/ 69, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),// ->209
/*   140*/    OPC_RecordMemRef,
/*   141*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*   142*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   143*/    OPC_Scope, 31, /*->176*/ // 2 children in Scope
/*   145*/     OPC_CheckChild1TypeI32,
/*   146*/     OPC_MoveChild2,
/*   147*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   150*/     OPC_RecordChild0, // #2 = $exp
/*   151*/     OPC_MoveSibling3,
/*   152*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   155*/     OPC_RecordChild0, // #3 = $new
/*   156*/     OPC_MoveParent,
/*   157*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_i32
/*   158*/     OPC_MoveParent,
/*   159*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   160*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*   162*/     OPC_EmitMergeInputChains1_0,
/*   163*/     OPC_EmitInteger32, 0, 
/*   165*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i32>>) - Complexity = 22
               // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   176*/    /*Scope*/ 31, /*->208*/
/*   177*/     OPC_CheckChild1TypeI64,
/*   178*/     OPC_MoveChild2,
/*   179*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   182*/     OPC_RecordChild0, // #2 = $exp
/*   183*/     OPC_MoveSibling3,
/*   184*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   187*/     OPC_RecordChild0, // #3 = $new
/*   188*/     OPC_MoveParent,
/*   189*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_i32
/*   190*/     OPC_MoveParent,
/*   191*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   192*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   194*/     OPC_EmitMergeInputChains1_0,
/*   195*/     OPC_EmitInteger32, 0, 
/*   197*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i32>>) - Complexity = 22
               // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   208*/    0, /*End of Scope*/
/*   209*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->352
/*   213*/    OPC_RecordMemRef,
/*   214*/    OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*   215*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   216*/    OPC_Scope, 66, /*->284*/ // 2 children in Scope
/*   218*/     OPC_CheckChild1TypeI32,
/*   219*/     OPC_MoveChild2,
/*   220*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   223*/     OPC_RecordChild0, // #2 = $val
/*   224*/     OPC_MoveParent,
/*   225*/     OPC_Scope, 18, /*->245*/ // 3 children in Scope
/*   227*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*   228*/      OPC_MoveParent,
/*   229*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   230*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   232*/      OPC_EmitMergeInputChains1_0,
/*   233*/      OPC_EmitInteger32, 0, 
/*   235*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   245*/     /*Scope*/ 18, /*->264*/
/*   246*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*   247*/      OPC_MoveParent,
/*   248*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   249*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   251*/      OPC_EmitMergeInputChains1_0,
/*   252*/      OPC_EmitInteger32, 0, 
/*   254*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   264*/     /*Scope*/ 18, /*->283*/
/*   265*/      OPC_CheckPredicate3,  // Predicate_atomic_load_add_i32
/*   266*/      OPC_MoveParent,
/*   267*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   268*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   270*/      OPC_EmitMergeInputChains1_0,
/*   271*/      OPC_EmitInteger32, 0, 
/*   273*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   283*/     0, /*End of Scope*/
/*   284*/    /*Scope*/ 66, /*->351*/
/*   285*/     OPC_CheckChild1TypeI64,
/*   286*/     OPC_MoveChild2,
/*   287*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   290*/     OPC_RecordChild0, // #2 = $val
/*   291*/     OPC_MoveParent,
/*   292*/     OPC_Scope, 18, /*->312*/ // 3 children in Scope
/*   294*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*   295*/      OPC_MoveParent,
/*   296*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   297*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   299*/      OPC_EmitMergeInputChains1_0,
/*   300*/      OPC_EmitInteger32, 0, 
/*   302*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   312*/     /*Scope*/ 18, /*->331*/
/*   313*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*   314*/      OPC_MoveParent,
/*   315*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   316*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   318*/      OPC_EmitMergeInputChains1_0,
/*   319*/      OPC_EmitInteger32, 0, 
/*   321*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   331*/     /*Scope*/ 18, /*->350*/
/*   332*/      OPC_CheckPredicate3,  // Predicate_atomic_load_add_i32
/*   333*/      OPC_MoveParent,
/*   334*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   335*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   337*/      OPC_EmitMergeInputChains1_0,
/*   338*/      OPC_EmitInteger32, 0, 
/*   340*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   350*/     0, /*End of Scope*/
/*   351*/    0, /*End of Scope*/
/*   352*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->495
/*   356*/    OPC_RecordMemRef,
/*   357*/    OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*   358*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   359*/    OPC_Scope, 66, /*->427*/ // 2 children in Scope
/*   361*/     OPC_CheckChild1TypeI32,
/*   362*/     OPC_MoveChild2,
/*   363*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   366*/     OPC_RecordChild0, // #2 = $val
/*   367*/     OPC_MoveParent,
/*   368*/     OPC_Scope, 18, /*->388*/ // 3 children in Scope
/*   370*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*   371*/      OPC_MoveParent,
/*   372*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   373*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   375*/      OPC_EmitMergeInputChains1_0,
/*   376*/      OPC_EmitInteger32, 0, 
/*   378*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   388*/     /*Scope*/ 18, /*->407*/
/*   389*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*   390*/      OPC_MoveParent,
/*   391*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   392*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   394*/      OPC_EmitMergeInputChains1_0,
/*   395*/      OPC_EmitInteger32, 0, 
/*   397*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   407*/     /*Scope*/ 18, /*->426*/
/*   408*/      OPC_CheckPredicate3,  // Predicate_atomic_load_sub_i32
/*   409*/      OPC_MoveParent,
/*   410*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   411*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   413*/      OPC_EmitMergeInputChains1_0,
/*   414*/      OPC_EmitInteger32, 0, 
/*   416*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   426*/     0, /*End of Scope*/
/*   427*/    /*Scope*/ 66, /*->494*/
/*   428*/     OPC_CheckChild1TypeI64,
/*   429*/     OPC_MoveChild2,
/*   430*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   433*/     OPC_RecordChild0, // #2 = $val
/*   434*/     OPC_MoveParent,
/*   435*/     OPC_Scope, 18, /*->455*/ // 3 children in Scope
/*   437*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*   438*/      OPC_MoveParent,
/*   439*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   440*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   442*/      OPC_EmitMergeInputChains1_0,
/*   443*/      OPC_EmitInteger32, 0, 
/*   445*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   455*/     /*Scope*/ 18, /*->474*/
/*   456*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*   457*/      OPC_MoveParent,
/*   458*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   459*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   461*/      OPC_EmitMergeInputChains1_0,
/*   462*/      OPC_EmitInteger32, 0, 
/*   464*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   474*/     /*Scope*/ 18, /*->493*/
/*   475*/      OPC_CheckPredicate3,  // Predicate_atomic_load_sub_i32
/*   476*/      OPC_MoveParent,
/*   477*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   478*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   480*/      OPC_EmitMergeInputChains1_0,
/*   481*/      OPC_EmitInteger32, 0, 
/*   483*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   493*/     0, /*End of Scope*/
/*   494*/    0, /*End of Scope*/
/*   495*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->638
/*   499*/    OPC_RecordMemRef,
/*   500*/    OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*   501*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   502*/    OPC_Scope, 66, /*->570*/ // 2 children in Scope
/*   504*/     OPC_CheckChild1TypeI32,
/*   505*/     OPC_MoveChild2,
/*   506*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   509*/     OPC_RecordChild0, // #2 = $val
/*   510*/     OPC_MoveParent,
/*   511*/     OPC_Scope, 18, /*->531*/ // 3 children in Scope
/*   513*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*   514*/      OPC_MoveParent,
/*   515*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   516*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   518*/      OPC_EmitMergeInputChains1_0,
/*   519*/      OPC_EmitInteger32, 0, 
/*   521*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   531*/     /*Scope*/ 18, /*->550*/
/*   532*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*   533*/      OPC_MoveParent,
/*   534*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   535*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   537*/      OPC_EmitMergeInputChains1_0,
/*   538*/      OPC_EmitInteger32, 0, 
/*   540*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   550*/     /*Scope*/ 18, /*->569*/
/*   551*/      OPC_CheckPredicate3,  // Predicate_atomic_load_and_i32
/*   552*/      OPC_MoveParent,
/*   553*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   554*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   556*/      OPC_EmitMergeInputChains1_0,
/*   557*/      OPC_EmitInteger32, 0, 
/*   559*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   569*/     0, /*End of Scope*/
/*   570*/    /*Scope*/ 66, /*->637*/
/*   571*/     OPC_CheckChild1TypeI64,
/*   572*/     OPC_MoveChild2,
/*   573*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   576*/     OPC_RecordChild0, // #2 = $val
/*   577*/     OPC_MoveParent,
/*   578*/     OPC_Scope, 18, /*->598*/ // 3 children in Scope
/*   580*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*   581*/      OPC_MoveParent,
/*   582*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   583*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   585*/      OPC_EmitMergeInputChains1_0,
/*   586*/      OPC_EmitInteger32, 0, 
/*   588*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   598*/     /*Scope*/ 18, /*->617*/
/*   599*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*   600*/      OPC_MoveParent,
/*   601*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   602*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   604*/      OPC_EmitMergeInputChains1_0,
/*   605*/      OPC_EmitInteger32, 0, 
/*   607*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   617*/     /*Scope*/ 18, /*->636*/
/*   618*/      OPC_CheckPredicate3,  // Predicate_atomic_load_and_i32
/*   619*/      OPC_MoveParent,
/*   620*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   621*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   623*/      OPC_EmitMergeInputChains1_0,
/*   624*/      OPC_EmitInteger32, 0, 
/*   626*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   636*/     0, /*End of Scope*/
/*   637*/    0, /*End of Scope*/
/*   638*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->781
/*   642*/    OPC_RecordMemRef,
/*   643*/    OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*   644*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   645*/    OPC_Scope, 66, /*->713*/ // 2 children in Scope
/*   647*/     OPC_CheckChild1TypeI32,
/*   648*/     OPC_MoveChild2,
/*   649*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   652*/     OPC_RecordChild0, // #2 = $val
/*   653*/     OPC_MoveParent,
/*   654*/     OPC_Scope, 18, /*->674*/ // 3 children in Scope
/*   656*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*   657*/      OPC_MoveParent,
/*   658*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   659*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   661*/      OPC_EmitMergeInputChains1_0,
/*   662*/      OPC_EmitInteger32, 0, 
/*   664*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   674*/     /*Scope*/ 18, /*->693*/
/*   675*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*   676*/      OPC_MoveParent,
/*   677*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   678*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   680*/      OPC_EmitMergeInputChains1_0,
/*   681*/      OPC_EmitInteger32, 0, 
/*   683*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   693*/     /*Scope*/ 18, /*->712*/
/*   694*/      OPC_CheckPredicate3,  // Predicate_atomic_load_or_i32
/*   695*/      OPC_MoveParent,
/*   696*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   697*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   699*/      OPC_EmitMergeInputChains1_0,
/*   700*/      OPC_EmitInteger32, 0, 
/*   702*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   712*/     0, /*End of Scope*/
/*   713*/    /*Scope*/ 66, /*->780*/
/*   714*/     OPC_CheckChild1TypeI64,
/*   715*/     OPC_MoveChild2,
/*   716*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   719*/     OPC_RecordChild0, // #2 = $val
/*   720*/     OPC_MoveParent,
/*   721*/     OPC_Scope, 18, /*->741*/ // 3 children in Scope
/*   723*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*   724*/      OPC_MoveParent,
/*   725*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   726*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   728*/      OPC_EmitMergeInputChains1_0,
/*   729*/      OPC_EmitInteger32, 0, 
/*   731*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   741*/     /*Scope*/ 18, /*->760*/
/*   742*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*   743*/      OPC_MoveParent,
/*   744*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   745*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   747*/      OPC_EmitMergeInputChains1_0,
/*   748*/      OPC_EmitInteger32, 0, 
/*   750*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   760*/     /*Scope*/ 18, /*->779*/
/*   761*/      OPC_CheckPredicate3,  // Predicate_atomic_load_or_i32
/*   762*/      OPC_MoveParent,
/*   763*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   764*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   766*/      OPC_EmitMergeInputChains1_0,
/*   767*/      OPC_EmitInteger32, 0, 
/*   769*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   779*/     0, /*End of Scope*/
/*   780*/    0, /*End of Scope*/
/*   781*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->924
/*   785*/    OPC_RecordMemRef,
/*   786*/    OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*   787*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   788*/    OPC_Scope, 66, /*->856*/ // 2 children in Scope
/*   790*/     OPC_CheckChild1TypeI32,
/*   791*/     OPC_MoveChild2,
/*   792*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   795*/     OPC_RecordChild0, // #2 = $val
/*   796*/     OPC_MoveParent,
/*   797*/     OPC_Scope, 18, /*->817*/ // 3 children in Scope
/*   799*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*   800*/      OPC_MoveParent,
/*   801*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   802*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   804*/      OPC_EmitMergeInputChains1_0,
/*   805*/      OPC_EmitInteger32, 0, 
/*   807*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   817*/     /*Scope*/ 18, /*->836*/
/*   818*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*   819*/      OPC_MoveParent,
/*   820*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   821*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   823*/      OPC_EmitMergeInputChains1_0,
/*   824*/      OPC_EmitInteger32, 0, 
/*   826*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   836*/     /*Scope*/ 18, /*->855*/
/*   837*/      OPC_CheckPredicate3,  // Predicate_atomic_load_xor_i32
/*   838*/      OPC_MoveParent,
/*   839*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   840*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   842*/      OPC_EmitMergeInputChains1_0,
/*   843*/      OPC_EmitInteger32, 0, 
/*   845*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   855*/     0, /*End of Scope*/
/*   856*/    /*Scope*/ 66, /*->923*/
/*   857*/     OPC_CheckChild1TypeI64,
/*   858*/     OPC_MoveChild2,
/*   859*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   862*/     OPC_RecordChild0, // #2 = $val
/*   863*/     OPC_MoveParent,
/*   864*/     OPC_Scope, 18, /*->884*/ // 3 children in Scope
/*   866*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*   867*/      OPC_MoveParent,
/*   868*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   869*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   871*/      OPC_EmitMergeInputChains1_0,
/*   872*/      OPC_EmitInteger32, 0, 
/*   874*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   884*/     /*Scope*/ 18, /*->903*/
/*   885*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*   886*/      OPC_MoveParent,
/*   887*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   888*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   890*/      OPC_EmitMergeInputChains1_0,
/*   891*/      OPC_EmitInteger32, 0, 
/*   893*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   903*/     /*Scope*/ 18, /*->922*/
/*   904*/      OPC_CheckPredicate3,  // Predicate_atomic_load_xor_i32
/*   905*/      OPC_MoveParent,
/*   906*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   907*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   909*/      OPC_EmitMergeInputChains1_0,
/*   910*/      OPC_EmitInteger32, 0, 
/*   912*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   922*/     0, /*End of Scope*/
/*   923*/    0, /*End of Scope*/
/*   924*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_SWAP),// ->1067
/*   928*/    OPC_RecordMemRef,
/*   929*/    OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*   930*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   931*/    OPC_Scope, 66, /*->999*/ // 2 children in Scope
/*   933*/     OPC_CheckChild1TypeI32,
/*   934*/     OPC_MoveChild2,
/*   935*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   938*/     OPC_RecordChild0, // #2 = $val
/*   939*/     OPC_MoveParent,
/*   940*/     OPC_Scope, 18, /*->960*/ // 3 children in Scope
/*   942*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*   943*/      OPC_MoveParent,
/*   944*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   945*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   947*/      OPC_EmitMergeInputChains1_0,
/*   948*/      OPC_EmitInteger32, 0, 
/*   950*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   960*/     /*Scope*/ 18, /*->979*/
/*   961*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*   962*/      OPC_MoveParent,
/*   963*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   964*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   966*/      OPC_EmitMergeInputChains1_0,
/*   967*/      OPC_EmitInteger32, 0, 
/*   969*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   979*/     /*Scope*/ 18, /*->998*/
/*   980*/      OPC_CheckPredicate3,  // Predicate_atomic_swap_i32
/*   981*/      OPC_MoveParent,
/*   982*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   983*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   985*/      OPC_EmitMergeInputChains1_0,
/*   986*/      OPC_EmitInteger32, 0, 
/*   988*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   998*/     0, /*End of Scope*/
/*   999*/    /*Scope*/ 66, /*->1066*/
/*  1000*/     OPC_CheckChild1TypeI64,
/*  1001*/     OPC_MoveChild2,
/*  1002*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1005*/     OPC_RecordChild0, // #2 = $val
/*  1006*/     OPC_MoveParent,
/*  1007*/     OPC_Scope, 18, /*->1027*/ // 3 children in Scope
/*  1009*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  1010*/      OPC_MoveParent,
/*  1011*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1012*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1014*/      OPC_EmitMergeInputChains1_0,
/*  1015*/      OPC_EmitInteger32, 0, 
/*  1017*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1027*/     /*Scope*/ 18, /*->1046*/
/*  1028*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  1029*/      OPC_MoveParent,
/*  1030*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1031*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1033*/      OPC_EmitMergeInputChains1_0,
/*  1034*/      OPC_EmitInteger32, 0, 
/*  1036*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1046*/     /*Scope*/ 18, /*->1065*/
/*  1047*/      OPC_CheckPredicate3,  // Predicate_atomic_swap_i32
/*  1048*/      OPC_MoveParent,
/*  1049*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1050*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1052*/      OPC_EmitMergeInputChains1_0,
/*  1053*/      OPC_EmitInteger32, 0, 
/*  1055*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1065*/     0, /*End of Scope*/
/*  1066*/    0, /*End of Scope*/
/*  1067*/   /*SwitchOpcode*/ 121, TARGET_VAL(ISD::ATOMIC_LOAD),// ->1191
/*  1070*/    OPC_RecordMemRef,
/*  1071*/    OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  1072*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1073*/    OPC_Scope, 57, /*->1132*/ // 2 children in Scope
/*  1075*/     OPC_CheckChild1TypeI32,
/*  1076*/     OPC_Scope, 17, /*->1095*/ // 3 children in Scope
/*  1078*/      OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  1079*/      OPC_MoveParent,
/*  1080*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  1081*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1083*/      OPC_EmitMergeInputChains1_0,
/*  1084*/      OPC_EmitInteger32, 0, 
/*  1086*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1095*/     /*Scope*/ 17, /*->1113*/
/*  1096*/      OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  1097*/      OPC_MoveParent,
/*  1098*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  1099*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1101*/      OPC_EmitMergeInputChains1_0,
/*  1102*/      OPC_EmitInteger32, 0, 
/*  1104*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1113*/     /*Scope*/ 17, /*->1131*/
/*  1114*/      OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  1115*/      OPC_MoveParent,
/*  1116*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  1117*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1119*/      OPC_EmitMergeInputChains1_0,
/*  1120*/      OPC_EmitInteger32, 0, 
/*  1122*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_32>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1131*/     0, /*End of Scope*/
/*  1132*/    /*Scope*/ 57, /*->1190*/
/*  1133*/     OPC_CheckChild1TypeI64,
/*  1134*/     OPC_Scope, 17, /*->1153*/ // 3 children in Scope
/*  1136*/      OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  1137*/      OPC_MoveParent,
/*  1138*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  1139*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1141*/      OPC_EmitMergeInputChains1_0,
/*  1142*/      OPC_EmitInteger32, 0, 
/*  1144*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1153*/     /*Scope*/ 17, /*->1171*/
/*  1154*/      OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  1155*/      OPC_MoveParent,
/*  1156*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  1157*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1159*/      OPC_EmitMergeInputChains1_0,
/*  1160*/      OPC_EmitInteger32, 0, 
/*  1162*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1171*/     /*Scope*/ 17, /*->1189*/
/*  1172*/      OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  1173*/      OPC_MoveParent,
/*  1174*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  1175*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1177*/      OPC_EmitMergeInputChains1_0,
/*  1178*/      OPC_EmitInteger32, 0, 
/*  1180*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_32>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1189*/     0, /*End of Scope*/
/*  1190*/    0, /*End of Scope*/
/*  1191*/   0, // EndSwitchOpcode
/*  1192*/  /*Scope*/ 7, /*->1200*/
/*  1193*/   OPC_RecordChild0, // #0 = $src
/*  1194*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND_U_I32),
                 /*MVT::i64*/8, 1/*#Ops*/, 0, 
             // Src: (zext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (I64_EXTEND_U_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/*  1200*/  0, /*End of Scope*/
/*  1201*/ /*SwitchOpcode*/ 86|128,6/*854*/, TARGET_VAL(ISD::ANY_EXTEND),// ->2059
/*  1205*/  OPC_Scope, 74|128,6/*842*/, /*->2050*/ // 2 children in Scope
/*  1208*/   OPC_MoveChild0,
/*  1209*/   OPC_SwitchOpcode /*8 cases */, 124, TARGET_VAL(ISD::AssertZext),// ->1337
/*  1213*/    OPC_MoveChild0,
/*  1214*/    OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/*  1217*/    OPC_RecordMemRef,
/*  1218*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*  1219*/    OPC_CheckFoldableChainNode,
/*  1220*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1221*/    OPC_Scope, 56, /*->1279*/ // 2 children in Scope
/*  1223*/     OPC_CheckChild1TypeI32,
/*  1224*/     OPC_MoveChild2,
/*  1225*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1228*/     OPC_RecordChild0, // #2 = $exp
/*  1229*/     OPC_MoveSibling3,
/*  1230*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1233*/     OPC_RecordChild0, // #3 = $new
/*  1234*/     OPC_MoveParent,
/*  1235*/     OPC_Scope, 20, /*->1257*/ // 2 children in Scope
/*  1237*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  1238*/      OPC_MoveParent,
/*  1239*/      OPC_MoveParent,
/*  1240*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1241*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  1243*/      OPC_EmitMergeInputChains1_0,
/*  1244*/      OPC_EmitInteger32, 0, 
/*  1246*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1257*/     /*Scope*/ 20, /*->1278*/
/*  1258*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  1259*/      OPC_MoveParent,
/*  1260*/      OPC_MoveParent,
/*  1261*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1262*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  1264*/      OPC_EmitMergeInputChains1_0,
/*  1265*/      OPC_EmitInteger32, 0, 
/*  1267*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1278*/     0, /*End of Scope*/
/*  1279*/    /*Scope*/ 56, /*->1336*/
/*  1280*/     OPC_CheckChild1TypeI64,
/*  1281*/     OPC_MoveChild2,
/*  1282*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1285*/     OPC_RecordChild0, // #2 = $exp
/*  1286*/     OPC_MoveSibling3,
/*  1287*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1290*/     OPC_RecordChild0, // #3 = $new
/*  1291*/     OPC_MoveParent,
/*  1292*/     OPC_Scope, 20, /*->1314*/ // 2 children in Scope
/*  1294*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  1295*/      OPC_MoveParent,
/*  1296*/      OPC_MoveParent,
/*  1297*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1298*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  1300*/      OPC_EmitMergeInputChains1_0,
/*  1301*/      OPC_EmitInteger32, 0, 
/*  1303*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1314*/     /*Scope*/ 20, /*->1335*/
/*  1315*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  1316*/      OPC_MoveParent,
/*  1317*/      OPC_MoveParent,
/*  1318*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1319*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  1321*/      OPC_EmitMergeInputChains1_0,
/*  1322*/      OPC_EmitInteger32, 0, 
/*  1324*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1335*/     0, /*End of Scope*/
/*  1336*/    0, /*End of Scope*/
/*  1337*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->1441
/*  1340*/    OPC_RecordMemRef,
/*  1341*/    OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  1342*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1343*/    OPC_Scope, 47, /*->1392*/ // 2 children in Scope
/*  1345*/     OPC_CheckChild1TypeI32,
/*  1346*/     OPC_MoveChild2,
/*  1347*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1350*/     OPC_RecordChild0, // #2 = $val
/*  1351*/     OPC_MoveParent,
/*  1352*/     OPC_Scope, 18, /*->1372*/ // 2 children in Scope
/*  1354*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  1355*/      OPC_MoveParent,
/*  1356*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1357*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1359*/      OPC_EmitMergeInputChains1_0,
/*  1360*/      OPC_EmitInteger32, 0, 
/*  1362*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1372*/     /*Scope*/ 18, /*->1391*/
/*  1373*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  1374*/      OPC_MoveParent,
/*  1375*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1376*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1378*/      OPC_EmitMergeInputChains1_0,
/*  1379*/      OPC_EmitInteger32, 0, 
/*  1381*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1391*/     0, /*End of Scope*/
/*  1392*/    /*Scope*/ 47, /*->1440*/
/*  1393*/     OPC_CheckChild1TypeI64,
/*  1394*/     OPC_MoveChild2,
/*  1395*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1398*/     OPC_RecordChild0, // #2 = $val
/*  1399*/     OPC_MoveParent,
/*  1400*/     OPC_Scope, 18, /*->1420*/ // 2 children in Scope
/*  1402*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  1403*/      OPC_MoveParent,
/*  1404*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1405*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1407*/      OPC_EmitMergeInputChains1_0,
/*  1408*/      OPC_EmitInteger32, 0, 
/*  1410*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1420*/     /*Scope*/ 18, /*->1439*/
/*  1421*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  1422*/      OPC_MoveParent,
/*  1423*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1424*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1426*/      OPC_EmitMergeInputChains1_0,
/*  1427*/      OPC_EmitInteger32, 0, 
/*  1429*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1439*/     0, /*End of Scope*/
/*  1440*/    0, /*End of Scope*/
/*  1441*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->1545
/*  1444*/    OPC_RecordMemRef,
/*  1445*/    OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  1446*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1447*/    OPC_Scope, 47, /*->1496*/ // 2 children in Scope
/*  1449*/     OPC_CheckChild1TypeI32,
/*  1450*/     OPC_MoveChild2,
/*  1451*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1454*/     OPC_RecordChild0, // #2 = $val
/*  1455*/     OPC_MoveParent,
/*  1456*/     OPC_Scope, 18, /*->1476*/ // 2 children in Scope
/*  1458*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  1459*/      OPC_MoveParent,
/*  1460*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1461*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1463*/      OPC_EmitMergeInputChains1_0,
/*  1464*/      OPC_EmitInteger32, 0, 
/*  1466*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1476*/     /*Scope*/ 18, /*->1495*/
/*  1477*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  1478*/      OPC_MoveParent,
/*  1479*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1480*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1482*/      OPC_EmitMergeInputChains1_0,
/*  1483*/      OPC_EmitInteger32, 0, 
/*  1485*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1495*/     0, /*End of Scope*/
/*  1496*/    /*Scope*/ 47, /*->1544*/
/*  1497*/     OPC_CheckChild1TypeI64,
/*  1498*/     OPC_MoveChild2,
/*  1499*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1502*/     OPC_RecordChild0, // #2 = $val
/*  1503*/     OPC_MoveParent,
/*  1504*/     OPC_Scope, 18, /*->1524*/ // 2 children in Scope
/*  1506*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  1507*/      OPC_MoveParent,
/*  1508*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1509*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1511*/      OPC_EmitMergeInputChains1_0,
/*  1512*/      OPC_EmitInteger32, 0, 
/*  1514*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1524*/     /*Scope*/ 18, /*->1543*/
/*  1525*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  1526*/      OPC_MoveParent,
/*  1527*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1528*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1530*/      OPC_EmitMergeInputChains1_0,
/*  1531*/      OPC_EmitInteger32, 0, 
/*  1533*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1543*/     0, /*End of Scope*/
/*  1544*/    0, /*End of Scope*/
/*  1545*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->1649
/*  1548*/    OPC_RecordMemRef,
/*  1549*/    OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  1550*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1551*/    OPC_Scope, 47, /*->1600*/ // 2 children in Scope
/*  1553*/     OPC_CheckChild1TypeI32,
/*  1554*/     OPC_MoveChild2,
/*  1555*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1558*/     OPC_RecordChild0, // #2 = $val
/*  1559*/     OPC_MoveParent,
/*  1560*/     OPC_Scope, 18, /*->1580*/ // 2 children in Scope
/*  1562*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  1563*/      OPC_MoveParent,
/*  1564*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1565*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1567*/      OPC_EmitMergeInputChains1_0,
/*  1568*/      OPC_EmitInteger32, 0, 
/*  1570*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1580*/     /*Scope*/ 18, /*->1599*/
/*  1581*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  1582*/      OPC_MoveParent,
/*  1583*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1584*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1586*/      OPC_EmitMergeInputChains1_0,
/*  1587*/      OPC_EmitInteger32, 0, 
/*  1589*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1599*/     0, /*End of Scope*/
/*  1600*/    /*Scope*/ 47, /*->1648*/
/*  1601*/     OPC_CheckChild1TypeI64,
/*  1602*/     OPC_MoveChild2,
/*  1603*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1606*/     OPC_RecordChild0, // #2 = $val
/*  1607*/     OPC_MoveParent,
/*  1608*/     OPC_Scope, 18, /*->1628*/ // 2 children in Scope
/*  1610*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  1611*/      OPC_MoveParent,
/*  1612*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1613*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1615*/      OPC_EmitMergeInputChains1_0,
/*  1616*/      OPC_EmitInteger32, 0, 
/*  1618*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1628*/     /*Scope*/ 18, /*->1647*/
/*  1629*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  1630*/      OPC_MoveParent,
/*  1631*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1632*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1634*/      OPC_EmitMergeInputChains1_0,
/*  1635*/      OPC_EmitInteger32, 0, 
/*  1637*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1647*/     0, /*End of Scope*/
/*  1648*/    0, /*End of Scope*/
/*  1649*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->1753
/*  1652*/    OPC_RecordMemRef,
/*  1653*/    OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  1654*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1655*/    OPC_Scope, 47, /*->1704*/ // 2 children in Scope
/*  1657*/     OPC_CheckChild1TypeI32,
/*  1658*/     OPC_MoveChild2,
/*  1659*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1662*/     OPC_RecordChild0, // #2 = $val
/*  1663*/     OPC_MoveParent,
/*  1664*/     OPC_Scope, 18, /*->1684*/ // 2 children in Scope
/*  1666*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  1667*/      OPC_MoveParent,
/*  1668*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1669*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1671*/      OPC_EmitMergeInputChains1_0,
/*  1672*/      OPC_EmitInteger32, 0, 
/*  1674*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1684*/     /*Scope*/ 18, /*->1703*/
/*  1685*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  1686*/      OPC_MoveParent,
/*  1687*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1688*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1690*/      OPC_EmitMergeInputChains1_0,
/*  1691*/      OPC_EmitInteger32, 0, 
/*  1693*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1703*/     0, /*End of Scope*/
/*  1704*/    /*Scope*/ 47, /*->1752*/
/*  1705*/     OPC_CheckChild1TypeI64,
/*  1706*/     OPC_MoveChild2,
/*  1707*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1710*/     OPC_RecordChild0, // #2 = $val
/*  1711*/     OPC_MoveParent,
/*  1712*/     OPC_Scope, 18, /*->1732*/ // 2 children in Scope
/*  1714*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  1715*/      OPC_MoveParent,
/*  1716*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1717*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1719*/      OPC_EmitMergeInputChains1_0,
/*  1720*/      OPC_EmitInteger32, 0, 
/*  1722*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1732*/     /*Scope*/ 18, /*->1751*/
/*  1733*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  1734*/      OPC_MoveParent,
/*  1735*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1736*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1738*/      OPC_EmitMergeInputChains1_0,
/*  1739*/      OPC_EmitInteger32, 0, 
/*  1741*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1751*/     0, /*End of Scope*/
/*  1752*/    0, /*End of Scope*/
/*  1753*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->1857
/*  1756*/    OPC_RecordMemRef,
/*  1757*/    OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  1758*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1759*/    OPC_Scope, 47, /*->1808*/ // 2 children in Scope
/*  1761*/     OPC_CheckChild1TypeI32,
/*  1762*/     OPC_MoveChild2,
/*  1763*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1766*/     OPC_RecordChild0, // #2 = $val
/*  1767*/     OPC_MoveParent,
/*  1768*/     OPC_Scope, 18, /*->1788*/ // 2 children in Scope
/*  1770*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  1771*/      OPC_MoveParent,
/*  1772*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1773*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1775*/      OPC_EmitMergeInputChains1_0,
/*  1776*/      OPC_EmitInteger32, 0, 
/*  1778*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1788*/     /*Scope*/ 18, /*->1807*/
/*  1789*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  1790*/      OPC_MoveParent,
/*  1791*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1792*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1794*/      OPC_EmitMergeInputChains1_0,
/*  1795*/      OPC_EmitInteger32, 0, 
/*  1797*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1807*/     0, /*End of Scope*/
/*  1808*/    /*Scope*/ 47, /*->1856*/
/*  1809*/     OPC_CheckChild1TypeI64,
/*  1810*/     OPC_MoveChild2,
/*  1811*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1814*/     OPC_RecordChild0, // #2 = $val
/*  1815*/     OPC_MoveParent,
/*  1816*/     OPC_Scope, 18, /*->1836*/ // 2 children in Scope
/*  1818*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  1819*/      OPC_MoveParent,
/*  1820*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1821*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1823*/      OPC_EmitMergeInputChains1_0,
/*  1824*/      OPC_EmitInteger32, 0, 
/*  1826*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1836*/     /*Scope*/ 18, /*->1855*/
/*  1837*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  1838*/      OPC_MoveParent,
/*  1839*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1840*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1842*/      OPC_EmitMergeInputChains1_0,
/*  1843*/      OPC_EmitInteger32, 0, 
/*  1845*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1855*/     0, /*End of Scope*/
/*  1856*/    0, /*End of Scope*/
/*  1857*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_SWAP),// ->1961
/*  1860*/    OPC_RecordMemRef,
/*  1861*/    OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  1862*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1863*/    OPC_Scope, 47, /*->1912*/ // 2 children in Scope
/*  1865*/     OPC_CheckChild1TypeI32,
/*  1866*/     OPC_MoveChild2,
/*  1867*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1870*/     OPC_RecordChild0, // #2 = $val
/*  1871*/     OPC_MoveParent,
/*  1872*/     OPC_Scope, 18, /*->1892*/ // 2 children in Scope
/*  1874*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  1875*/      OPC_MoveParent,
/*  1876*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1877*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1879*/      OPC_EmitMergeInputChains1_0,
/*  1880*/      OPC_EmitInteger32, 0, 
/*  1882*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1892*/     /*Scope*/ 18, /*->1911*/
/*  1893*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  1894*/      OPC_MoveParent,
/*  1895*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1896*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1898*/      OPC_EmitMergeInputChains1_0,
/*  1899*/      OPC_EmitInteger32, 0, 
/*  1901*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1911*/     0, /*End of Scope*/
/*  1912*/    /*Scope*/ 47, /*->1960*/
/*  1913*/     OPC_CheckChild1TypeI64,
/*  1914*/     OPC_MoveChild2,
/*  1915*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1918*/     OPC_RecordChild0, // #2 = $val
/*  1919*/     OPC_MoveParent,
/*  1920*/     OPC_Scope, 18, /*->1940*/ // 2 children in Scope
/*  1922*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  1923*/      OPC_MoveParent,
/*  1924*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1925*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1927*/      OPC_EmitMergeInputChains1_0,
/*  1928*/      OPC_EmitInteger32, 0, 
/*  1930*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1940*/     /*Scope*/ 18, /*->1959*/
/*  1941*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  1942*/      OPC_MoveParent,
/*  1943*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1944*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1946*/      OPC_EmitMergeInputChains1_0,
/*  1947*/      OPC_EmitInteger32, 0, 
/*  1949*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1959*/     0, /*End of Scope*/
/*  1960*/    0, /*End of Scope*/
/*  1961*/   /*SwitchOpcode*/ 85, TARGET_VAL(ISD::ATOMIC_LOAD),// ->2049
/*  1964*/    OPC_RecordMemRef,
/*  1965*/    OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  1966*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1967*/    OPC_Scope, 39, /*->2008*/ // 2 children in Scope
/*  1969*/     OPC_CheckChild1TypeI32,
/*  1970*/     OPC_Scope, 17, /*->1989*/ // 2 children in Scope
/*  1972*/      OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  1973*/      OPC_MoveParent,
/*  1974*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  1975*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1977*/      OPC_EmitMergeInputChains1_0,
/*  1978*/      OPC_EmitInteger32, 0, 
/*  1980*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1989*/     /*Scope*/ 17, /*->2007*/
/*  1990*/      OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  1991*/      OPC_MoveParent,
/*  1992*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  1993*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1995*/      OPC_EmitMergeInputChains1_0,
/*  1996*/      OPC_EmitInteger32, 0, 
/*  1998*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  2007*/     0, /*End of Scope*/
/*  2008*/    /*Scope*/ 39, /*->2048*/
/*  2009*/     OPC_CheckChild1TypeI64,
/*  2010*/     OPC_Scope, 17, /*->2029*/ // 2 children in Scope
/*  2012*/      OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  2013*/      OPC_MoveParent,
/*  2014*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2015*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  2017*/      OPC_EmitMergeInputChains1_0,
/*  2018*/      OPC_EmitInteger32, 0, 
/*  2020*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  2029*/     /*Scope*/ 17, /*->2047*/
/*  2030*/      OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  2031*/      OPC_MoveParent,
/*  2032*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2033*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  2035*/      OPC_EmitMergeInputChains1_0,
/*  2036*/      OPC_EmitInteger32, 0, 
/*  2038*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  2047*/     0, /*End of Scope*/
/*  2048*/    0, /*End of Scope*/
/*  2049*/   0, // EndSwitchOpcode
/*  2050*/  /*Scope*/ 7, /*->2058*/
/*  2051*/   OPC_RecordChild0, // #0 = $src
/*  2052*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND_U_I32),
                 /*MVT::i64*/8, 1/*#Ops*/, 0, 
             // Src: (anyext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (I64_EXTEND_U_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/*  2058*/  0, /*End of Scope*/
/*  2059*/ /*SwitchOpcode*/ 67|128,7/*963*/, TARGET_VAL(ISD::STORE),// ->3026
/*  2063*/  OPC_RecordMemRef,
/*  2064*/  OPC_RecordNode, // #0 = 'st' chained node
/*  2065*/  OPC_Scope, 127|128,1/*255*/, /*->2323*/ // 2 children in Scope
/*  2068*/   OPC_MoveChild1,
/*  2069*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  2072*/   OPC_RecordChild0, // #1 = $vec
/*  2073*/   OPC_Scope, 64, /*->2139*/ // 4 children in Scope
/*  2075*/    OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/*  2077*/    OPC_RecordChild1, // #2 = $idx
/*  2078*/    OPC_MoveChild1,
/*  2079*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2082*/    OPC_CheckPredicate, 18, // Predicate_LaneIdx16
/*  2084*/    OPC_CheckTypeI32,
/*  2085*/    OPC_MoveParent,
/*  2086*/    OPC_CheckTypeI32,
/*  2087*/    OPC_MoveParent,
/*  2088*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2089*/    OPC_Scope, 23, /*->2114*/ // 2 children in Scope
/*  2091*/     OPC_CheckChild2TypeI32,
/*  2092*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2093*/     OPC_CheckPredicate, 14, // Predicate_truncstore
/*  2095*/     OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2097*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2098*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2100*/     OPC_EmitMergeInputChains1_0,
/*  2101*/     OPC_EmitInteger32, 0, 
/*  2103*/     OPC_EmitConvertToTarget2,
/*  2104*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I8x16_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 21
               // Dst: (STORE_LANE_I8x16_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v16i8] }:$vec)
/*  2114*/    /*Scope*/ 23, /*->2138*/
/*  2115*/     OPC_CheckChild2TypeI64,
/*  2116*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2117*/     OPC_CheckPredicate, 14, // Predicate_truncstore
/*  2119*/     OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2121*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2122*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2124*/     OPC_EmitMergeInputChains1_0,
/*  2125*/     OPC_EmitInteger32, 0, 
/*  2127*/     OPC_EmitConvertToTarget2,
/*  2128*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I8x16_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 21
               // Dst: (STORE_LANE_I8x16_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v16i8] }:$vec)
/*  2138*/    0, /*End of Scope*/
/*  2139*/   /*Scope*/ 64, /*->2204*/
/*  2140*/    OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/*  2142*/    OPC_RecordChild1, // #2 = $idx
/*  2143*/    OPC_MoveChild1,
/*  2144*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2147*/    OPC_CheckPredicate, 13, // Predicate_LaneIdx8
/*  2149*/    OPC_CheckTypeI32,
/*  2150*/    OPC_MoveParent,
/*  2151*/    OPC_CheckTypeI32,
/*  2152*/    OPC_MoveParent,
/*  2153*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2154*/    OPC_Scope, 23, /*->2179*/ // 2 children in Scope
/*  2156*/     OPC_CheckChild2TypeI32,
/*  2157*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2158*/     OPC_CheckPredicate, 14, // Predicate_truncstore
/*  2160*/     OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2162*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2163*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2165*/     OPC_EmitMergeInputChains1_0,
/*  2166*/     OPC_EmitInteger32, 0, 
/*  2168*/     OPC_EmitConvertToTarget2,
/*  2169*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 21
               // Dst: (STORE_LANE_I16x8_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v8i16] }:$vec)
/*  2179*/    /*Scope*/ 23, /*->2203*/
/*  2180*/     OPC_CheckChild2TypeI64,
/*  2181*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2182*/     OPC_CheckPredicate, 14, // Predicate_truncstore
/*  2184*/     OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2186*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2187*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2189*/     OPC_EmitMergeInputChains1_0,
/*  2190*/     OPC_EmitInteger32, 0, 
/*  2192*/     OPC_EmitConvertToTarget2,
/*  2193*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 21
               // Dst: (STORE_LANE_I16x8_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v8i16] }:$vec)
/*  2203*/    0, /*End of Scope*/
/*  2204*/   /*Scope*/ 58, /*->2263*/
/*  2205*/    OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/*  2207*/    OPC_RecordChild1, // #2 = $idx
/*  2208*/    OPC_MoveChild1,
/*  2209*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2212*/    OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/*  2214*/    OPC_CheckTypeI32,
/*  2215*/    OPC_MoveParent,
/*  2216*/    OPC_CheckTypeI32,
/*  2217*/    OPC_MoveParent,
/*  2218*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2219*/    OPC_Scope, 20, /*->2241*/ // 2 children in Scope
/*  2221*/     OPC_CheckChild2TypeI32,
/*  2222*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2223*/     OPC_CheckPredicate5,  // Predicate_store
/*  2224*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2225*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2227*/     OPC_EmitMergeInputChains1_0,
/*  2228*/     OPC_EmitInteger32, 0, 
/*  2230*/     OPC_EmitConvertToTarget2,
/*  2231*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I32x4_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4i32] }:$vec)
/*  2241*/    /*Scope*/ 20, /*->2262*/
/*  2242*/     OPC_CheckChild2TypeI64,
/*  2243*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2244*/     OPC_CheckPredicate5,  // Predicate_store
/*  2245*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2246*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2248*/     OPC_EmitMergeInputChains1_0,
/*  2249*/     OPC_EmitInteger32, 0, 
/*  2251*/     OPC_EmitConvertToTarget2,
/*  2252*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I32x4_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4i32] }:$vec)
/*  2262*/    0, /*End of Scope*/
/*  2263*/   /*Scope*/ 58, /*->2322*/
/*  2264*/    OPC_CheckChild0Type, /*MVT::v2i64*/78, 
/*  2266*/    OPC_RecordChild1, // #2 = $idx
/*  2267*/    OPC_MoveChild1,
/*  2268*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2271*/    OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/*  2273*/    OPC_CheckTypeI32,
/*  2274*/    OPC_MoveParent,
/*  2275*/    OPC_CheckTypeI64,
/*  2276*/    OPC_MoveParent,
/*  2277*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2278*/    OPC_Scope, 20, /*->2300*/ // 2 children in Scope
/*  2280*/     OPC_CheckChild2TypeI32,
/*  2281*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2282*/     OPC_CheckPredicate5,  // Predicate_store
/*  2283*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2284*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2286*/     OPC_EmitMergeInputChains1_0,
/*  2287*/     OPC_EmitInteger32, 0, 
/*  2289*/     OPC_EmitConvertToTarget2,
/*  2290*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I64x2_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2i64] }:$vec)
/*  2300*/    /*Scope*/ 20, /*->2321*/
/*  2301*/     OPC_CheckChild2TypeI64,
/*  2302*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2303*/     OPC_CheckPredicate5,  // Predicate_store
/*  2304*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2305*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2307*/     OPC_EmitMergeInputChains1_0,
/*  2308*/     OPC_EmitInteger32, 0, 
/*  2310*/     OPC_EmitConvertToTarget2,
/*  2311*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I64x2_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2i64] }:$vec)
/*  2321*/    0, /*End of Scope*/
/*  2322*/   0, /*End of Scope*/
/*  2323*/  /*Scope*/ 60|128,5/*700*/, /*->3025*/
/*  2325*/   OPC_RecordChild1, // #1 = $val
/*  2326*/   OPC_Scope, 2|128,1/*130*/, /*->2459*/ // 11 children in Scope
/*  2329*/    OPC_CheckChild1TypeI32,
/*  2330*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2331*/    OPC_Scope, 62, /*->2395*/ // 2 children in Scope
/*  2333*/     OPC_CheckChild2TypeI32,
/*  2334*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2335*/     OPC_Scope, 16, /*->2353*/ // 2 children in Scope
/*  2337*/      OPC_CheckPredicate5,  // Predicate_store
/*  2338*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2339*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2341*/      OPC_EmitMergeInputChains1_0,
/*  2342*/      OPC_EmitInteger32, 0, 
/*  2344*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2353*/     /*Scope*/ 40, /*->2394*/
/*  2354*/      OPC_CheckPredicate, 14, // Predicate_truncstore
/*  2356*/      OPC_Scope, 17, /*->2375*/ // 2 children in Scope
/*  2358*/       OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2360*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2361*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2363*/       OPC_EmitMergeInputChains1_0,
/*  2364*/       OPC_EmitInteger32, 0, 
/*  2366*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2375*/      /*Scope*/ 17, /*->2393*/
/*  2376*/       OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2378*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2379*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2381*/       OPC_EmitMergeInputChains1_0,
/*  2382*/       OPC_EmitInteger32, 0, 
/*  2384*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2393*/      0, /*End of Scope*/
/*  2394*/     0, /*End of Scope*/
/*  2395*/    /*Scope*/ 62, /*->2458*/
/*  2396*/     OPC_CheckChild2TypeI64,
/*  2397*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2398*/     OPC_Scope, 16, /*->2416*/ // 2 children in Scope
/*  2400*/      OPC_CheckPredicate5,  // Predicate_store
/*  2401*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2402*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2404*/      OPC_EmitMergeInputChains1_0,
/*  2405*/      OPC_EmitInteger32, 0, 
/*  2407*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2416*/     /*Scope*/ 40, /*->2457*/
/*  2417*/      OPC_CheckPredicate, 14, // Predicate_truncstore
/*  2419*/      OPC_Scope, 17, /*->2438*/ // 2 children in Scope
/*  2421*/       OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2423*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2424*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2426*/       OPC_EmitMergeInputChains1_0,
/*  2427*/       OPC_EmitInteger32, 0, 
/*  2429*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2438*/      /*Scope*/ 17, /*->2456*/
/*  2439*/       OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2441*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2442*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2444*/       OPC_EmitMergeInputChains1_0,
/*  2445*/       OPC_EmitInteger32, 0, 
/*  2447*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2456*/      0, /*End of Scope*/
/*  2457*/     0, /*End of Scope*/
/*  2458*/    0, /*End of Scope*/
/*  2459*/   /*Scope*/ 38|128,1/*166*/, /*->2627*/
/*  2461*/    OPC_CheckChild1TypeI64,
/*  2462*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2463*/    OPC_Scope, 80, /*->2545*/ // 2 children in Scope
/*  2465*/     OPC_CheckChild2TypeI32,
/*  2466*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2467*/     OPC_Scope, 16, /*->2485*/ // 2 children in Scope
/*  2469*/      OPC_CheckPredicate5,  // Predicate_store
/*  2470*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2471*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2473*/      OPC_EmitMergeInputChains1_0,
/*  2474*/      OPC_EmitInteger32, 0, 
/*  2476*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2485*/     /*Scope*/ 58, /*->2544*/
/*  2486*/      OPC_CheckPredicate, 14, // Predicate_truncstore
/*  2488*/      OPC_Scope, 17, /*->2507*/ // 3 children in Scope
/*  2490*/       OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2492*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2493*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2495*/       OPC_EmitMergeInputChains1_0,
/*  2496*/       OPC_EmitInteger32, 0, 
/*  2498*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2507*/      /*Scope*/ 17, /*->2525*/
/*  2508*/       OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2510*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2511*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2513*/       OPC_EmitMergeInputChains1_0,
/*  2514*/       OPC_EmitInteger32, 0, 
/*  2516*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2525*/      /*Scope*/ 17, /*->2543*/
/*  2526*/       OPC_CheckPredicate, 25, // Predicate_truncstorei32
/*  2528*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2529*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2531*/       OPC_EmitMergeInputChains1_0,
/*  2532*/       OPC_EmitInteger32, 0, 
/*  2534*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 13
                 // Dst: (STORE32_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2543*/      0, /*End of Scope*/
/*  2544*/     0, /*End of Scope*/
/*  2545*/    /*Scope*/ 80, /*->2626*/
/*  2546*/     OPC_CheckChild2TypeI64,
/*  2547*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2548*/     OPC_Scope, 16, /*->2566*/ // 2 children in Scope
/*  2550*/      OPC_CheckPredicate5,  // Predicate_store
/*  2551*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2552*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2554*/      OPC_EmitMergeInputChains1_0,
/*  2555*/      OPC_EmitInteger32, 0, 
/*  2557*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2566*/     /*Scope*/ 58, /*->2625*/
/*  2567*/      OPC_CheckPredicate, 14, // Predicate_truncstore
/*  2569*/      OPC_Scope, 17, /*->2588*/ // 3 children in Scope
/*  2571*/       OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2573*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2574*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2576*/       OPC_EmitMergeInputChains1_0,
/*  2577*/       OPC_EmitInteger32, 0, 
/*  2579*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2588*/      /*Scope*/ 17, /*->2606*/
/*  2589*/       OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2591*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2592*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2594*/       OPC_EmitMergeInputChains1_0,
/*  2595*/       OPC_EmitInteger32, 0, 
/*  2597*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2606*/      /*Scope*/ 17, /*->2624*/
/*  2607*/       OPC_CheckPredicate, 25, // Predicate_truncstorei32
/*  2609*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2610*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2612*/       OPC_EmitMergeInputChains1_0,
/*  2613*/       OPC_EmitInteger32, 0, 
/*  2615*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 13
                 // Dst: (STORE32_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2624*/      0, /*End of Scope*/
/*  2625*/     0, /*End of Scope*/
/*  2626*/    0, /*End of Scope*/
/*  2627*/   /*Scope*/ 43, /*->2671*/
/*  2628*/    OPC_CheckChild1Type, /*MVT::f32*/12, 
/*  2630*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2631*/    OPC_Scope, 18, /*->2651*/ // 2 children in Scope
/*  2633*/     OPC_CheckChild2TypeI32,
/*  2634*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2635*/     OPC_CheckPredicate5,  // Predicate_store
/*  2636*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2637*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2639*/     OPC_EmitMergeInputChains1_0,
/*  2640*/     OPC_EmitInteger32, 0, 
/*  2642*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f32:{ *:[f32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, f32:{ *:[f32] }:$val)
/*  2651*/    /*Scope*/ 18, /*->2670*/
/*  2652*/     OPC_CheckChild2TypeI64,
/*  2653*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2654*/     OPC_CheckPredicate5,  // Predicate_store
/*  2655*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2656*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2658*/     OPC_EmitMergeInputChains1_0,
/*  2659*/     OPC_EmitInteger32, 0, 
/*  2661*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f32:{ *:[f32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, f32:{ *:[f32] }:$val)
/*  2670*/    0, /*End of Scope*/
/*  2671*/   /*Scope*/ 43, /*->2715*/
/*  2672*/    OPC_CheckChild1Type, /*MVT::f64*/13, 
/*  2674*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2675*/    OPC_Scope, 18, /*->2695*/ // 2 children in Scope
/*  2677*/     OPC_CheckChild2TypeI32,
/*  2678*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2679*/     OPC_CheckPredicate5,  // Predicate_store
/*  2680*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2681*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2683*/     OPC_EmitMergeInputChains1_0,
/*  2684*/     OPC_EmitInteger32, 0, 
/*  2686*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f64:{ *:[f64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, f64:{ *:[f64] }:$val)
/*  2695*/    /*Scope*/ 18, /*->2714*/
/*  2696*/     OPC_CheckChild2TypeI64,
/*  2697*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2698*/     OPC_CheckPredicate5,  // Predicate_store
/*  2699*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2700*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2702*/     OPC_EmitMergeInputChains1_0,
/*  2703*/     OPC_EmitInteger32, 0, 
/*  2705*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f64:{ *:[f64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, f64:{ *:[f64] }:$val)
/*  2714*/    0, /*End of Scope*/
/*  2715*/   /*Scope*/ 43, /*->2759*/
/*  2716*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/*  2718*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2719*/    OPC_Scope, 18, /*->2739*/ // 2 children in Scope
/*  2721*/     OPC_CheckChild2TypeI32,
/*  2722*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2723*/     OPC_CheckPredicate5,  // Predicate_store
/*  2724*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2725*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2727*/     OPC_EmitMergeInputChains1_0,
/*  2728*/     OPC_EmitInteger32, 0, 
/*  2730*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v16i8:{ *:[v16i8] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v16i8:{ *:[v16i8] }:$val)
/*  2739*/    /*Scope*/ 18, /*->2758*/
/*  2740*/     OPC_CheckChild2TypeI64,
/*  2741*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2742*/     OPC_CheckPredicate5,  // Predicate_store
/*  2743*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2744*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2746*/     OPC_EmitMergeInputChains1_0,
/*  2747*/     OPC_EmitInteger32, 0, 
/*  2749*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v16i8:{ *:[v16i8] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v16i8:{ *:[v16i8] }:$val)
/*  2758*/    0, /*End of Scope*/
/*  2759*/   /*Scope*/ 43, /*->2803*/
/*  2760*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/*  2762*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2763*/    OPC_Scope, 18, /*->2783*/ // 2 children in Scope
/*  2765*/     OPC_CheckChild2TypeI32,
/*  2766*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2767*/     OPC_CheckPredicate5,  // Predicate_store
/*  2768*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2769*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2771*/     OPC_EmitMergeInputChains1_0,
/*  2772*/     OPC_EmitInteger32, 0, 
/*  2774*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v8i16:{ *:[v8i16] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v8i16:{ *:[v8i16] }:$val)
/*  2783*/    /*Scope*/ 18, /*->2802*/
/*  2784*/     OPC_CheckChild2TypeI64,
/*  2785*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2786*/     OPC_CheckPredicate5,  // Predicate_store
/*  2787*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2788*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2790*/     OPC_EmitMergeInputChains1_0,
/*  2791*/     OPC_EmitInteger32, 0, 
/*  2793*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v8i16:{ *:[v8i16] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v8i16:{ *:[v8i16] }:$val)
/*  2802*/    0, /*End of Scope*/
/*  2803*/   /*Scope*/ 43, /*->2847*/
/*  2804*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/*  2806*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2807*/    OPC_Scope, 18, /*->2827*/ // 2 children in Scope
/*  2809*/     OPC_CheckChild2TypeI32,
/*  2810*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2811*/     OPC_CheckPredicate5,  // Predicate_store
/*  2812*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2813*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2815*/     OPC_EmitMergeInputChains1_0,
/*  2816*/     OPC_EmitInteger32, 0, 
/*  2818*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4i32:{ *:[v4i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v4i32:{ *:[v4i32] }:$val)
/*  2827*/    /*Scope*/ 18, /*->2846*/
/*  2828*/     OPC_CheckChild2TypeI64,
/*  2829*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2830*/     OPC_CheckPredicate5,  // Predicate_store
/*  2831*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2832*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2834*/     OPC_EmitMergeInputChains1_0,
/*  2835*/     OPC_EmitInteger32, 0, 
/*  2837*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4i32:{ *:[v4i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v4i32:{ *:[v4i32] }:$val)
/*  2846*/    0, /*End of Scope*/
/*  2847*/   /*Scope*/ 43, /*->2891*/
/*  2848*/    OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/*  2850*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2851*/    OPC_Scope, 18, /*->2871*/ // 2 children in Scope
/*  2853*/     OPC_CheckChild2TypeI32,
/*  2854*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2855*/     OPC_CheckPredicate5,  // Predicate_store
/*  2856*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2857*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2859*/     OPC_EmitMergeInputChains1_0,
/*  2860*/     OPC_EmitInteger32, 0, 
/*  2862*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2i64:{ *:[v2i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v2i64:{ *:[v2i64] }:$val)
/*  2871*/    /*Scope*/ 18, /*->2890*/
/*  2872*/     OPC_CheckChild2TypeI64,
/*  2873*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2874*/     OPC_CheckPredicate5,  // Predicate_store
/*  2875*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2876*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2878*/     OPC_EmitMergeInputChains1_0,
/*  2879*/     OPC_EmitInteger32, 0, 
/*  2881*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2i64:{ *:[v2i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v2i64:{ *:[v2i64] }:$val)
/*  2890*/    0, /*End of Scope*/
/*  2891*/   /*Scope*/ 43, /*->2935*/
/*  2892*/    OPC_CheckChild1Type, /*MVT::v4f32*/110, 
/*  2894*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2895*/    OPC_Scope, 18, /*->2915*/ // 2 children in Scope
/*  2897*/     OPC_CheckChild2TypeI32,
/*  2898*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2899*/     OPC_CheckPredicate5,  // Predicate_store
/*  2900*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2901*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2903*/     OPC_EmitMergeInputChains1_0,
/*  2904*/     OPC_EmitInteger32, 0, 
/*  2906*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4f32:{ *:[v4f32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v4f32:{ *:[v4f32] }:$val)
/*  2915*/    /*Scope*/ 18, /*->2934*/
/*  2916*/     OPC_CheckChild2TypeI64,
/*  2917*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2918*/     OPC_CheckPredicate5,  // Predicate_store
/*  2919*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2920*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2922*/     OPC_EmitMergeInputChains1_0,
/*  2923*/     OPC_EmitInteger32, 0, 
/*  2925*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4f32:{ *:[v4f32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v4f32:{ *:[v4f32] }:$val)
/*  2934*/    0, /*End of Scope*/
/*  2935*/   /*Scope*/ 44, /*->2980*/
/*  2936*/    OPC_CheckChild1Type, /*MVT::v2f64*/0|128,1/*128*/, 
/*  2939*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2940*/    OPC_Scope, 18, /*->2960*/ // 2 children in Scope
/*  2942*/     OPC_CheckChild2TypeI32,
/*  2943*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2944*/     OPC_CheckPredicate5,  // Predicate_store
/*  2945*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2946*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2948*/     OPC_EmitMergeInputChains1_0,
/*  2949*/     OPC_EmitInteger32, 0, 
/*  2951*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2f64:{ *:[v2f64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v2f64:{ *:[v2f64] }:$val)
/*  2960*/    /*Scope*/ 18, /*->2979*/
/*  2961*/     OPC_CheckChild2TypeI64,
/*  2962*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2963*/     OPC_CheckPredicate5,  // Predicate_store
/*  2964*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2965*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2967*/     OPC_EmitMergeInputChains1_0,
/*  2968*/     OPC_EmitInteger32, 0, 
/*  2970*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2f64:{ *:[v2f64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v2f64:{ *:[v2f64] }:$val)
/*  2979*/    0, /*End of Scope*/
/*  2980*/   /*Scope*/ 43, /*->3024*/
/*  2981*/    OPC_CheckChild1Type, /*MVT::v8f16*/92, 
/*  2983*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2984*/    OPC_Scope, 18, /*->3004*/ // 2 children in Scope
/*  2986*/     OPC_CheckChild2TypeI32,
/*  2987*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2988*/     OPC_CheckPredicate5,  // Predicate_store
/*  2989*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2990*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2992*/     OPC_EmitMergeInputChains1_0,
/*  2993*/     OPC_EmitInteger32, 0, 
/*  2995*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v8f16:{ *:[v8f16] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v8f16:{ *:[v8f16] }:$val)
/*  3004*/    /*Scope*/ 18, /*->3023*/
/*  3005*/     OPC_CheckChild2TypeI64,
/*  3006*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  3007*/     OPC_CheckPredicate5,  // Predicate_store
/*  3008*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  3009*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3011*/     OPC_EmitMergeInputChains1_0,
/*  3012*/     OPC_EmitInteger32, 0, 
/*  3014*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v8f16:{ *:[v8f16] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v8f16:{ *:[v8f16] }:$val)
/*  3023*/    0, /*End of Scope*/
/*  3024*/   0, /*End of Scope*/
/*  3025*/  0, /*End of Scope*/
/*  3026*/ /*SwitchOpcode*/ 22|128,2/*278*/, TARGET_VAL(ISD::INTRINSIC_VOID),// ->3308
/*  3030*/  OPC_Scope, 40, /*->3072*/ // 3 children in Scope
/*  3032*/   OPC_RecordNode, // #0 = 'intrinsic_void' chained node
/*  3033*/   OPC_CheckChild1Integer, 120|128,67|128,1/*25080*/, 
/*  3037*/   OPC_MoveChild2,
/*  3038*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3041*/   OPC_RecordChild0, // #1 = $table1
/*  3042*/   OPC_MoveChild0,
/*  3043*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3046*/   OPC_MoveParent,
/*  3047*/   OPC_MoveSibling3,
/*  3048*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3051*/   OPC_RecordChild0, // #2 = $table2
/*  3052*/   OPC_MoveChild0,
/*  3053*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3056*/   OPC_MoveParent,
/*  3057*/   OPC_MoveParent,
/*  3058*/   OPC_RecordChild4, // #3 = $d
/*  3059*/   OPC_RecordChild5, // #4 = $s
/*  3060*/   OPC_RecordChild6, // #5 = $n
/*  3061*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3062*/   OPC_EmitMergeInputChains1_0,
/*  3063*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_COPY),
                 5/*#Ops*/, 1, 2, 3, 4, 5, 
             // Src: (intrinsic_void 12540:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table1), (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table2), I32:{ *:[i32] }:$d, I32:{ *:[i32] }:$s, I32:{ *:[i32] }:$n) - Complexity = 20
             // Dst: (TABLE_COPY (tglobaladdr:{ *:[i32] }):$table1, (tglobaladdr:{ *:[i32] }):$table2, I32:{ *:[i32] }:$d, I32:{ *:[i32] }:$s, I32:{ *:[i32] }:$n)
/*  3072*/  /*Scope*/ 44, /*->3117*/
/*  3073*/   OPC_RecordMemRef,
/*  3074*/   OPC_RecordNode, // #0 = 'intrinsic_void' chained node
/*  3075*/   OPC_CheckChild1Integer, 112|128,67|128,1/*25072*/, 
/*  3079*/   OPC_RecordChild2, // #1 = $val
/*  3080*/   OPC_RecordChild3, // #2 = $AddrOps32:offset:addr
/*  3081*/   OPC_Scope, 16, /*->3099*/ // 2 children in Scope
/*  3083*/    OPC_CheckChild3TypeI32,
/*  3084*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  3085*/    OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3087*/    OPC_EmitMergeInputChains1_0,
/*  3088*/    OPC_EmitInteger32, 0, 
/*  3090*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F16_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  4/*#Ops*/, 5, 3, 4, 1, 
              // Src: (intrinsic_void 12536:{ *:[iPTR] }, f32:{ *:[f32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)) - Complexity = 17
              // Dst: (STORE_F16_F32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, f32:{ *:[f32] }:$val)
/*  3099*/   /*Scope*/ 16, /*->3116*/
/*  3100*/    OPC_CheckChild3TypeI64,
/*  3101*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  3102*/    OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3104*/    OPC_EmitMergeInputChains1_0,
/*  3105*/    OPC_EmitInteger32, 0, 
/*  3107*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F16_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  4/*#Ops*/, 5, 3, 4, 1, 
              // Src: (intrinsic_void 12536:{ *:[iPTR] }, f32:{ *:[f32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)) - Complexity = 17
              // Dst: (STORE_F16_F32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, f32:{ *:[f32] }:$val)
/*  3116*/   0, /*End of Scope*/
/*  3117*/  /*Scope*/ 60|128,1/*188*/, /*->3307*/
/*  3119*/   OPC_RecordNode, // #0 = 'intrinsic_void' chained node
/*  3120*/   OPC_Scope, 26, /*->3148*/ // 7 children in Scope
/*  3122*/    OPC_CheckChild1Integer, 16|128,68|128,1/*25104*/, 
/*  3126*/    OPC_MoveChild2,
/*  3127*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3130*/    OPC_RecordChild0, // #1 = $table
/*  3131*/    OPC_MoveChild0,
/*  3132*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3135*/    OPC_MoveParent,
/*  3136*/    OPC_MoveParent,
/*  3137*/    OPC_RecordChild3, // #2 = $i
/*  3138*/    OPC_RecordChild4, // #3 = $val
/*  3139*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3140*/    OPC_EmitMergeInputChains1_0,
/*  3141*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF),
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_void 12552:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val) - Complexity = 14
              // Dst: (TABLE_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val)
/*  3148*/   /*Scope*/ 28, /*->3177*/
/*  3149*/    OPC_CheckChild1Integer, 126|128,67|128,1/*25086*/, 
/*  3153*/    OPC_MoveChild2,
/*  3154*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3157*/    OPC_RecordChild0, // #1 = $table
/*  3158*/    OPC_MoveChild0,
/*  3159*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3162*/    OPC_MoveParent,
/*  3163*/    OPC_MoveParent,
/*  3164*/    OPC_RecordChild3, // #2 = $i
/*  3165*/    OPC_RecordChild4, // #3 = $val
/*  3166*/    OPC_RecordChild5, // #4 = $n
/*  3167*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3168*/    OPC_EmitMergeInputChains1_0,
/*  3169*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_FILL_FUNCREF),
                  4/*#Ops*/, 1, 2, 3, 4, 
              // Src: (intrinsic_void 12543:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_FILL_FUNCREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n)
/*  3177*/   /*Scope*/ 26, /*->3204*/
/*  3178*/    OPC_CheckChild1Integer, 14|128,68|128,1/*25102*/, 
/*  3182*/    OPC_MoveChild2,
/*  3183*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3186*/    OPC_RecordChild0, // #1 = $table
/*  3187*/    OPC_MoveChild0,
/*  3188*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3191*/    OPC_MoveParent,
/*  3192*/    OPC_MoveParent,
/*  3193*/    OPC_RecordChild3, // #2 = $i
/*  3194*/    OPC_RecordChild4, // #3 = $val
/*  3195*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3196*/    OPC_EmitMergeInputChains1_0,
/*  3197*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_SET_EXTERNREF),
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_void 12551:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val) - Complexity = 14
              // Dst: (TABLE_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val)
/*  3204*/   /*Scope*/ 28, /*->3233*/
/*  3205*/    OPC_CheckChild1Integer, 124|128,67|128,1/*25084*/, 
/*  3209*/    OPC_MoveChild2,
/*  3210*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3213*/    OPC_RecordChild0, // #1 = $table
/*  3214*/    OPC_MoveChild0,
/*  3215*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3218*/    OPC_MoveParent,
/*  3219*/    OPC_MoveParent,
/*  3220*/    OPC_RecordChild3, // #2 = $i
/*  3221*/    OPC_RecordChild4, // #3 = $val
/*  3222*/    OPC_RecordChild5, // #4 = $n
/*  3223*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3224*/    OPC_EmitMergeInputChains1_0,
/*  3225*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_FILL_EXTERNREF),
                  4/*#Ops*/, 1, 2, 3, 4, 
              // Src: (intrinsic_void 12542:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_FILL_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n)
/*  3233*/   /*Scope*/ 27, /*->3261*/
/*  3234*/    OPC_CheckChild1Integer, 12|128,68|128,1/*25100*/, 
/*  3238*/    OPC_MoveChild2,
/*  3239*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3242*/    OPC_RecordChild0, // #1 = $table
/*  3243*/    OPC_MoveChild0,
/*  3244*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3247*/    OPC_MoveParent,
/*  3248*/    OPC_MoveParent,
/*  3249*/    OPC_RecordChild3, // #2 = $i
/*  3250*/    OPC_RecordChild4, // #3 = $val
/*  3251*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/*  3253*/    OPC_EmitMergeInputChains1_0,
/*  3254*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_SET_EXNREF),
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_void 12550:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXNREF:{ *:[exnref] }:$val) - Complexity = 14
              // Dst: (TABLE_SET_EXNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXNREF:{ *:[exnref] }:$val)
/*  3261*/   /*Scope*/ 29, /*->3291*/
/*  3262*/    OPC_CheckChild1Integer, 122|128,67|128,1/*25082*/, 
/*  3266*/    OPC_MoveChild2,
/*  3267*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3270*/    OPC_RecordChild0, // #1 = $table
/*  3271*/    OPC_MoveChild0,
/*  3272*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3275*/    OPC_MoveParent,
/*  3276*/    OPC_MoveParent,
/*  3277*/    OPC_RecordChild3, // #2 = $i
/*  3278*/    OPC_RecordChild4, // #3 = $val
/*  3279*/    OPC_RecordChild5, // #4 = $n
/*  3280*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/*  3282*/    OPC_EmitMergeInputChains1_0,
/*  3283*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_FILL_EXNREF),
                  4/*#Ops*/, 1, 2, 3, 4, 
              // Src: (intrinsic_void 12541:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXNREF:{ *:[exnref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_FILL_EXNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXNREF:{ *:[exnref] }:$val, I32:{ *:[i32] }:$n)
/*  3291*/   /*Scope*/ 14, /*->3306*/
/*  3292*/    OPC_CheckChild1Integer, 106|128,67|128,1/*25066*/, 
/*  3296*/    OPC_CheckPatternPredicate, 16, // (Subtarget->hasExceptionHandling())
/*  3298*/    OPC_EmitMergeInputChains1_0,
/*  3299*/    OPC_EmitInteger32, 0, 
/*  3301*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::RETHROW),
                  1/*#Ops*/, 1, 
              // Src: (intrinsic_void 12533:{ *:[iPTR] }) - Complexity = 8
              // Dst: (RETHROW 0:{ *:[i32] })
/*  3306*/   0, /*End of Scope*/
/*  3307*/  0, /*End of Scope*/
/*  3308*/ /*SwitchOpcode*/ 81|128,3/*465*/, TARGET_VAL(ISD::INTRINSIC_W_CHAIN),// ->3777
/*  3312*/  OPC_Scope, 22|128,1/*150*/, /*->3465*/ // 3 children in Scope
/*  3315*/   OPC_RecordMemRef,
/*  3316*/   OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/*  3317*/   OPC_Scope, 45, /*->3364*/ // 3 children in Scope
/*  3319*/    OPC_CheckChild1Integer, 44|128,67|128,1/*25004*/, 
/*  3323*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3324*/    OPC_Scope, 18, /*->3344*/ // 2 children in Scope
/*  3326*/     OPC_CheckChild2TypeI32,
/*  3327*/     OPC_RecordChild3, // #2 = $count
/*  3328*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3329*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  3331*/     OPC_EmitMergeInputChains1_0,
/*  3332*/     OPC_EmitInteger32, 0, 
/*  3334*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12502:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), I32:{ *:[i32] }:$count) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_NOTIFY_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$count)
/*  3344*/    /*Scope*/ 18, /*->3363*/
/*  3345*/     OPC_CheckChild2TypeI64,
/*  3346*/     OPC_RecordChild3, // #2 = $count
/*  3347*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3348*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  3350*/     OPC_EmitMergeInputChains1_0,
/*  3351*/     OPC_EmitInteger32, 0, 
/*  3353*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12502:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), I32:{ *:[i32] }:$count) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_NOTIFY_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$count)
/*  3363*/    0, /*End of Scope*/
/*  3364*/   /*Scope*/ 49, /*->3414*/
/*  3365*/    OPC_CheckChild1Integer, 46|128,67|128,1/*25006*/, 
/*  3369*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3370*/    OPC_Scope, 20, /*->3392*/ // 2 children in Scope
/*  3372*/     OPC_CheckChild2TypeI32,
/*  3373*/     OPC_RecordChild3, // #2 = $exp
/*  3374*/     OPC_RecordChild4, // #3 = $timeout
/*  3375*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3376*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  3378*/     OPC_EmitMergeInputChains1_0,
/*  3379*/     OPC_EmitInteger32, 0, 
/*  3381*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12503:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3392*/    /*Scope*/ 20, /*->3413*/
/*  3393*/     OPC_CheckChild2TypeI64,
/*  3394*/     OPC_RecordChild3, // #2 = $exp
/*  3395*/     OPC_RecordChild4, // #3 = $timeout
/*  3396*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3397*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  3399*/     OPC_EmitMergeInputChains1_0,
/*  3400*/     OPC_EmitInteger32, 0, 
/*  3402*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12503:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3413*/    0, /*End of Scope*/
/*  3414*/   /*Scope*/ 49, /*->3464*/
/*  3415*/    OPC_CheckChild1Integer, 48|128,67|128,1/*25008*/, 
/*  3419*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3420*/    OPC_Scope, 20, /*->3442*/ // 2 children in Scope
/*  3422*/     OPC_CheckChild2TypeI32,
/*  3423*/     OPC_RecordChild3, // #2 = $exp
/*  3424*/     OPC_RecordChild4, // #3 = $timeout
/*  3425*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3426*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  3428*/     OPC_EmitMergeInputChains1_0,
/*  3429*/     OPC_EmitInteger32, 0, 
/*  3431*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12504:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT64_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3442*/    /*Scope*/ 20, /*->3463*/
/*  3443*/     OPC_CheckChild2TypeI64,
/*  3444*/     OPC_RecordChild3, // #2 = $exp
/*  3445*/     OPC_RecordChild4, // #3 = $timeout
/*  3446*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3447*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  3449*/     OPC_EmitMergeInputChains1_0,
/*  3450*/     OPC_EmitInteger32, 0, 
/*  3452*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12504:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT64_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3463*/    0, /*End of Scope*/
/*  3464*/   0, /*End of Scope*/
/*  3465*/  /*Scope*/ 9|128,2/*265*/, /*->3732*/
/*  3467*/   OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/*  3468*/   OPC_Scope, 26, /*->3496*/ // 9 children in Scope
/*  3470*/    OPC_CheckChild1Integer, 4|128,68|128,1/*25092*/, 
/*  3474*/    OPC_MoveChild2,
/*  3475*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3478*/    OPC_RecordChild0, // #1 = $table
/*  3479*/    OPC_MoveChild0,
/*  3480*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3483*/    OPC_MoveParent,
/*  3484*/    OPC_MoveParent,
/*  3485*/    OPC_RecordChild3, // #2 = $i
/*  3486*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3487*/    OPC_EmitMergeInputChains1_0,
/*  3488*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GET_FUNCREF),
                  /*MVT::funcref*/98|128,1/*226*/, 2/*#Ops*/, 1, 2, 
              // Src: (intrinsic_w_chain:{ *:[funcref] } 12546:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i) - Complexity = 14
              // Dst: (TABLE_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i)
/*  3496*/   /*Scope*/ 27, /*->3524*/
/*  3497*/    OPC_CheckChild1Integer, 10|128,68|128,1/*25098*/, 
/*  3501*/    OPC_MoveChild2,
/*  3502*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3505*/    OPC_RecordChild0, // #1 = $table
/*  3506*/    OPC_MoveChild0,
/*  3507*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3510*/    OPC_MoveParent,
/*  3511*/    OPC_MoveParent,
/*  3512*/    OPC_RecordChild3, // #2 = $val
/*  3513*/    OPC_RecordChild4, // #3 = $n
/*  3514*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3515*/    OPC_EmitMergeInputChains1_0,
/*  3516*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GROW_FUNCREF),
                  /*MVT::i32*/7, 3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 12549:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_GROW_FUNCREF:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n)
/*  3524*/   /*Scope*/ 26, /*->3551*/
/*  3525*/    OPC_CheckChild1Integer, 2|128,68|128,1/*25090*/, 
/*  3529*/    OPC_MoveChild2,
/*  3530*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3533*/    OPC_RecordChild0, // #1 = $table
/*  3534*/    OPC_MoveChild0,
/*  3535*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3538*/    OPC_MoveParent,
/*  3539*/    OPC_MoveParent,
/*  3540*/    OPC_RecordChild3, // #2 = $i
/*  3541*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3542*/    OPC_EmitMergeInputChains1_0,
/*  3543*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GET_EXTERNREF),
                  /*MVT::externref*/99|128,1/*227*/, 2/*#Ops*/, 1, 2, 
              // Src: (intrinsic_w_chain:{ *:[externref] } 12545:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i) - Complexity = 14
              // Dst: (TABLE_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i)
/*  3551*/   /*Scope*/ 27, /*->3579*/
/*  3552*/    OPC_CheckChild1Integer, 8|128,68|128,1/*25096*/, 
/*  3556*/    OPC_MoveChild2,
/*  3557*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3560*/    OPC_RecordChild0, // #1 = $table
/*  3561*/    OPC_MoveChild0,
/*  3562*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3565*/    OPC_MoveParent,
/*  3566*/    OPC_MoveParent,
/*  3567*/    OPC_RecordChild3, // #2 = $val
/*  3568*/    OPC_RecordChild4, // #3 = $n
/*  3569*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3570*/    OPC_EmitMergeInputChains1_0,
/*  3571*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GROW_EXTERNREF),
                  /*MVT::i32*/7, 3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 12548:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_GROW_EXTERNREF:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n)
/*  3579*/   /*Scope*/ 27, /*->3607*/
/*  3580*/    OPC_CheckChild1Integer, 0|128,68|128,1/*25088*/, 
/*  3584*/    OPC_MoveChild2,
/*  3585*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3588*/    OPC_RecordChild0, // #1 = $table
/*  3589*/    OPC_MoveChild0,
/*  3590*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3593*/    OPC_MoveParent,
/*  3594*/    OPC_MoveParent,
/*  3595*/    OPC_RecordChild3, // #2 = $i
/*  3596*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/*  3598*/    OPC_EmitMergeInputChains1_0,
/*  3599*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GET_EXNREF),
                  /*MVT::exnref*/100|128,1/*228*/, 2/*#Ops*/, 1, 2, 
              // Src: (intrinsic_w_chain:{ *:[exnref] } 12544:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i) - Complexity = 14
              // Dst: (TABLE_GET_EXNREF:{ *:[exnref] } (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i)
/*  3607*/   /*Scope*/ 28, /*->3636*/
/*  3608*/    OPC_CheckChild1Integer, 6|128,68|128,1/*25094*/, 
/*  3612*/    OPC_MoveChild2,
/*  3613*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3616*/    OPC_RecordChild0, // #1 = $table
/*  3617*/    OPC_MoveChild0,
/*  3618*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3621*/    OPC_MoveParent,
/*  3622*/    OPC_MoveParent,
/*  3623*/    OPC_RecordChild3, // #2 = $val
/*  3624*/    OPC_RecordChild4, // #3 = $n
/*  3625*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/*  3627*/    OPC_EmitMergeInputChains1_0,
/*  3628*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GROW_EXNREF),
                  /*MVT::i32*/7, 3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 12547:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), EXNREF:{ *:[exnref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_GROW_EXNREF:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table, EXNREF:{ *:[exnref] }:$val, I32:{ *:[i32] }:$n)
/*  3636*/   /*Scope*/ 23, /*->3660*/
/*  3637*/    OPC_CheckChild1Integer, 18|128,68|128,1/*25106*/, 
/*  3641*/    OPC_MoveChild2,
/*  3642*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3645*/    OPC_RecordChild0, // #1 = $table
/*  3646*/    OPC_MoveChild0,
/*  3647*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3650*/    OPC_MoveParent,
/*  3651*/    OPC_MoveParent,
/*  3652*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3653*/    OPC_EmitMergeInputChains1_0,
/*  3654*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_SIZE),
                  /*MVT::i32*/7, 1/*#Ops*/, 1, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 12553:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table)) - Complexity = 14
              // Dst: (TABLE_SIZE:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table)
/*  3660*/   /*Scope*/ 32, /*->3693*/
/*  3661*/    OPC_CheckChild1Integer, 52|128,67|128,1/*25012*/, 
/*  3665*/    OPC_RecordChild2, // #1 = $flags
/*  3666*/    OPC_MoveChild2,
/*  3667*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3670*/    OPC_MoveParent,
/*  3671*/    OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->3682
/*  3674*/     OPC_EmitMergeInputChains1_0,
/*  3675*/     OPC_EmitConvertToTarget1,
/*  3676*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_8212MEMORY_SIZE_A32),
                   /*MVT::i32*/7, 1/*#Ops*/, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12506:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags) - Complexity = 11
               // Dst: (anonymous_8212MEMORY_SIZE_A32:{ *:[i32] } (imm:{ *:[i32] }):$flags)
/*  3682*/    /*SwitchType*/ 8, /*MVT::i64*/8, // ->3692
/*  3684*/     OPC_EmitMergeInputChains1_0,
/*  3685*/     OPC_EmitConvertToTarget1,
/*  3686*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_8213MEMORY_SIZE_A64),
                   /*MVT::i64*/8, 1/*#Ops*/, 2, 
               // Src: (intrinsic_w_chain:{ *:[i64] } 12506:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags) - Complexity = 11
               // Dst: (anonymous_8213MEMORY_SIZE_A64:{ *:[i64] } (imm:{ *:[i32] }):$flags)
/*  3692*/    0, // EndSwitchType
/*  3693*/   /*Scope*/ 37, /*->3731*/
/*  3694*/    OPC_CheckChild1Integer, 50|128,67|128,1/*25010*/, 
/*  3698*/    OPC_RecordChild2, // #1 = $flags
/*  3699*/    OPC_MoveChild2,
/*  3700*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3703*/    OPC_MoveParent,
/*  3704*/    OPC_RecordChild3, // #2 = $delta
/*  3705*/    OPC_SwitchType /*2 cases */, 10, /*MVT::i32*/7, // ->3718
/*  3708*/     OPC_CheckChild3TypeI32,
/*  3709*/     OPC_EmitMergeInputChains1_0,
/*  3710*/     OPC_EmitConvertToTarget1,
/*  3711*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_8212MEMORY_GROW_A32),
                   /*MVT::i32*/7, 2/*#Ops*/, 3, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12505:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags, I32:{ *:[i32] }:$delta) - Complexity = 11
               // Dst: (anonymous_8212MEMORY_GROW_A32:{ *:[i32] } (imm:{ *:[i32] }):$flags, I32:{ *:[i32] }:$delta)
/*  3718*/    /*SwitchType*/ 10, /*MVT::i64*/8, // ->3730
/*  3720*/     OPC_CheckChild3TypeI64,
/*  3721*/     OPC_EmitMergeInputChains1_0,
/*  3722*/     OPC_EmitConvertToTarget1,
/*  3723*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_8213MEMORY_GROW_A64),
                   /*MVT::i64*/8, 2/*#Ops*/, 3, 2, 
               // Src: (intrinsic_w_chain:{ *:[i64] } 12505:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags, I64:{ *:[i64] }:$delta) - Complexity = 11
               // Dst: (anonymous_8213MEMORY_GROW_A64:{ *:[i64] } (imm:{ *:[i32] }):$flags, I64:{ *:[i64] }:$delta)
/*  3730*/    0, // EndSwitchType
/*  3731*/   0, /*End of Scope*/
/*  3732*/  /*Scope*/ 43, /*->3776*/
/*  3733*/   OPC_RecordMemRef,
/*  3734*/   OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/*  3735*/   OPC_CheckChild1Integer, 40|128,67|128,1/*25000*/, 
/*  3739*/   OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3740*/   OPC_Scope, 16, /*->3758*/ // 2 children in Scope
/*  3742*/    OPC_CheckChild2TypeI32,
/*  3743*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  3744*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  3746*/    OPC_EmitMergeInputChains1_0,
/*  3747*/    OPC_EmitInteger32, 0, 
/*  3749*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F16_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::f32*/12, 3/*#Ops*/, 4, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[f32] } 12500:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)) - Complexity = 17
              // Dst: (LOAD_F16_F32_A32:{ *:[f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  3758*/   /*Scope*/ 16, /*->3775*/
/*  3759*/    OPC_CheckChild2TypeI64,
/*  3760*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  3761*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  3763*/    OPC_EmitMergeInputChains1_0,
/*  3764*/    OPC_EmitInteger32, 0, 
/*  3766*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F16_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::f32*/12, 3/*#Ops*/, 4, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[f32] } 12500:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)) - Complexity = 17
              // Dst: (LOAD_F16_F32_A64:{ *:[f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  3775*/   0, /*End of Scope*/
/*  3776*/  0, /*End of Scope*/
/*  3777*/ /*SwitchOpcode*/ 29|128,2/*285*/, TARGET_VAL(ISD::ATOMIC_STORE),// ->4066
/*  3781*/  OPC_RecordMemRef,
/*  3782*/  OPC_RecordNode, // #0 = 'atomic_store' chained node
/*  3783*/  OPC_Scope, 119, /*->3904*/ // 2 children in Scope
/*  3785*/   OPC_MoveChild1,
/*  3786*/   OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  3789*/   OPC_RecordChild0, // #1 = $val
/*  3790*/   OPC_MoveParent,
/*  3791*/   OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3792*/   OPC_Scope, 54, /*->3848*/ // 2 children in Scope
/*  3794*/    OPC_CheckChild2TypeI32,
/*  3795*/    OPC_Scope, 16, /*->3813*/ // 3 children in Scope
/*  3797*/     OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  3798*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3799*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3801*/     OPC_EmitMergeInputChains1_0,
/*  3802*/     OPC_EmitInteger32, 0, 
/*  3804*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 16
               // Dst: (ATOMIC_STORE8_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  3813*/    /*Scope*/ 16, /*->3830*/
/*  3814*/     OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  3815*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3816*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3818*/     OPC_EmitMergeInputChains1_0,
/*  3819*/     OPC_EmitInteger32, 0, 
/*  3821*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 16
               // Dst: (ATOMIC_STORE16_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  3830*/    /*Scope*/ 16, /*->3847*/
/*  3831*/     OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  3832*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3833*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3835*/     OPC_EmitMergeInputChains1_0,
/*  3836*/     OPC_EmitInteger32, 0, 
/*  3838*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 16
               // Dst: (ATOMIC_STORE32_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  3847*/    0, /*End of Scope*/
/*  3848*/   /*Scope*/ 54, /*->3903*/
/*  3849*/    OPC_CheckChild2TypeI64,
/*  3850*/    OPC_Scope, 16, /*->3868*/ // 3 children in Scope
/*  3852*/     OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  3853*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3854*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3856*/     OPC_EmitMergeInputChains1_0,
/*  3857*/     OPC_EmitInteger32, 0, 
/*  3859*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 16
               // Dst: (ATOMIC_STORE8_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  3868*/    /*Scope*/ 16, /*->3885*/
/*  3869*/     OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  3870*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3871*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3873*/     OPC_EmitMergeInputChains1_0,
/*  3874*/     OPC_EmitInteger32, 0, 
/*  3876*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 16
               // Dst: (ATOMIC_STORE16_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  3885*/    /*Scope*/ 16, /*->3902*/
/*  3886*/     OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  3887*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3888*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3890*/     OPC_EmitMergeInputChains1_0,
/*  3891*/     OPC_EmitInteger32, 0, 
/*  3893*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 16
               // Dst: (ATOMIC_STORE32_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  3902*/    0, /*End of Scope*/
/*  3903*/   0, /*End of Scope*/
/*  3904*/  /*Scope*/ 31|128,1/*159*/, /*->4065*/
/*  3906*/   OPC_RecordChild1, // #1 = $val
/*  3907*/   OPC_Scope, 114, /*->4023*/ // 2 children in Scope
/*  3909*/    OPC_CheckChild1TypeI32,
/*  3910*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3911*/    OPC_Scope, 54, /*->3967*/ // 2 children in Scope
/*  3913*/     OPC_CheckChild2TypeI32,
/*  3914*/     OPC_Scope, 16, /*->3932*/ // 3 children in Scope
/*  3916*/      OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  3917*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3918*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3920*/      OPC_EmitMergeInputChains1_0,
/*  3921*/      OPC_EmitInteger32, 0, 
/*  3923*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 13
                // Dst: (ATOMIC_STORE_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  3932*/     /*Scope*/ 16, /*->3949*/
/*  3933*/      OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  3934*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3935*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3937*/      OPC_EmitMergeInputChains1_0,
/*  3938*/      OPC_EmitInteger32, 0, 
/*  3940*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 13
                // Dst: (ATOMIC_STORE8_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  3949*/     /*Scope*/ 16, /*->3966*/
/*  3950*/      OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  3951*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3952*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3954*/      OPC_EmitMergeInputChains1_0,
/*  3955*/      OPC_EmitInteger32, 0, 
/*  3957*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 13
                // Dst: (ATOMIC_STORE16_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  3966*/     0, /*End of Scope*/
/*  3967*/    /*Scope*/ 54, /*->4022*/
/*  3968*/     OPC_CheckChild2TypeI64,
/*  3969*/     OPC_Scope, 16, /*->3987*/ // 3 children in Scope
/*  3971*/      OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  3972*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3973*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3975*/      OPC_EmitMergeInputChains1_0,
/*  3976*/      OPC_EmitInteger32, 0, 
/*  3978*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 13
                // Dst: (ATOMIC_STORE_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  3987*/     /*Scope*/ 16, /*->4004*/
/*  3988*/      OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  3989*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3990*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3992*/      OPC_EmitMergeInputChains1_0,
/*  3993*/      OPC_EmitInteger32, 0, 
/*  3995*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 13
                // Dst: (ATOMIC_STORE8_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  4004*/     /*Scope*/ 16, /*->4021*/
/*  4005*/      OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  4006*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4007*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  4009*/      OPC_EmitMergeInputChains1_0,
/*  4010*/      OPC_EmitInteger32, 0, 
/*  4012*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 13
                // Dst: (ATOMIC_STORE16_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  4021*/     0, /*End of Scope*/
/*  4022*/    0, /*End of Scope*/
/*  4023*/   /*Scope*/ 40, /*->4064*/
/*  4024*/    OPC_CheckChild1TypeI64,
/*  4025*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  4026*/    OPC_Scope, 17, /*->4045*/ // 2 children in Scope
/*  4028*/     OPC_CheckChild2TypeI32,
/*  4029*/     OPC_CheckPredicate7,  // Predicate_atomic_store_64
/*  4030*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4031*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  4033*/     OPC_EmitMergeInputChains1_0,
/*  4034*/     OPC_EmitInteger32, 0, 
/*  4036*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_64>> - Complexity = 13
               // Dst: (ATOMIC_STORE_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  4045*/    /*Scope*/ 17, /*->4063*/
/*  4046*/     OPC_CheckChild2TypeI64,
/*  4047*/     OPC_CheckPredicate7,  // Predicate_atomic_store_64
/*  4048*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4049*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  4051*/     OPC_EmitMergeInputChains1_0,
/*  4052*/     OPC_EmitInteger32, 0, 
/*  4054*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_64>> - Complexity = 13
               // Dst: (ATOMIC_STORE_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  4063*/    0, /*End of Scope*/
/*  4064*/   0, /*End of Scope*/
/*  4065*/  0, /*End of Scope*/
/*  4066*/ /*SwitchOpcode*/ 90|128,2/*346*/, TARGET_VAL(ISD::AND),// ->4416
/*  4070*/  OPC_Scope, 118, /*->4190*/ // 6 children in Scope
/*  4072*/   OPC_MoveChild0,
/*  4073*/   OPC_CheckOpcode, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),
/*  4076*/   OPC_Scope, 55, /*->4133*/ // 2 children in Scope
/*  4078*/    OPC_CheckChild0Integer, 16|128,67|128,1/*24976*/, 
/*  4082*/    OPC_RecordChild1, // #0 = $x
/*  4083*/    OPC_Scope, 11, /*->4096*/ // 4 children in Scope
/*  4085*/     OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/*  4087*/     OPC_MoveParent,
/*  4088*/     OPC_CheckChild1Integer, 2, 
/*  4090*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12488:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4096*/    /*Scope*/ 11, /*->4108*/
/*  4097*/     OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/*  4099*/     OPC_MoveParent,
/*  4100*/     OPC_CheckChild1Integer, 2, 
/*  4102*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12488:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4108*/    /*Scope*/ 11, /*->4120*/
/*  4109*/     OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/*  4111*/     OPC_MoveParent,
/*  4112*/     OPC_CheckChild1Integer, 2, 
/*  4114*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12488:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4120*/    /*Scope*/ 11, /*->4132*/
/*  4121*/     OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/*  4123*/     OPC_MoveParent,
/*  4124*/     OPC_CheckChild1Integer, 2, 
/*  4126*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12488:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4132*/    0, /*End of Scope*/
/*  4133*/   /*Scope*/ 55, /*->4189*/
/*  4134*/    OPC_CheckChild0Integer, 14|128,67|128,1/*24974*/, 
/*  4138*/    OPC_RecordChild1, // #0 = $x
/*  4139*/    OPC_Scope, 11, /*->4152*/ // 4 children in Scope
/*  4141*/     OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/*  4143*/     OPC_MoveParent,
/*  4144*/     OPC_CheckChild1Integer, 2, 
/*  4146*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12487:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4152*/    /*Scope*/ 11, /*->4164*/
/*  4153*/     OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/*  4155*/     OPC_MoveParent,
/*  4156*/     OPC_CheckChild1Integer, 2, 
/*  4158*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12487:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4164*/    /*Scope*/ 11, /*->4176*/
/*  4165*/     OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/*  4167*/     OPC_MoveParent,
/*  4168*/     OPC_CheckChild1Integer, 2, 
/*  4170*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12487:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4176*/    /*Scope*/ 11, /*->4188*/
/*  4177*/     OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/*  4179*/     OPC_MoveParent,
/*  4180*/     OPC_CheckChild1Integer, 2, 
/*  4182*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12487:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4188*/    0, /*End of Scope*/
/*  4189*/   0, /*End of Scope*/
/*  4190*/  /*Scope*/ 29, /*->4220*/
/*  4191*/   OPC_CheckAndImm, 127|128,1/*255*/, 
/*  4194*/   OPC_MoveChild0,
/*  4195*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  4198*/   OPC_RecordChild0, // #0 = $vec
/*  4199*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/*  4201*/   OPC_RecordChild1, // #1 = $idx
/*  4202*/   OPC_MoveChild1,
/*  4203*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4206*/   OPC_CheckPredicate, 18, // Predicate_LaneIdx16
/*  4208*/   OPC_CheckTypeI32,
/*  4209*/   OPC_MoveParent,
/*  4210*/   OPC_MoveParent,
/*  4211*/   OPC_CheckTypeI32,
/*  4212*/   OPC_EmitConvertToTarget1,
/*  4213*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_u),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 2, 
             // Src: (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), 255:{ *:[i32] }) - Complexity = 15
             // Dst: (EXTRACT_LANE_I8x16_u:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/*  4220*/  /*Scope*/ 30, /*->4251*/
/*  4221*/   OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  4225*/   OPC_MoveChild0,
/*  4226*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  4229*/   OPC_RecordChild0, // #0 = $vec
/*  4230*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/*  4232*/   OPC_RecordChild1, // #1 = $idx
/*  4233*/   OPC_MoveChild1,
/*  4234*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4237*/   OPC_CheckPredicate, 13, // Predicate_LaneIdx8
/*  4239*/   OPC_CheckTypeI32,
/*  4240*/   OPC_MoveParent,
/*  4241*/   OPC_MoveParent,
/*  4242*/   OPC_CheckTypeI32,
/*  4243*/   OPC_EmitConvertToTarget1,
/*  4244*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_u),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 2, 
             // Src: (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), 65535:{ *:[i32] }) - Complexity = 15
             // Dst: (EXTRACT_LANE_I16x8_u:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/*  4251*/  /*Scope*/ 73, /*->4325*/
/*  4252*/   OPC_RecordChild0, // #0 = $lhs
/*  4253*/   OPC_Scope, 21, /*->4276*/ // 2 children in Scope
/*  4255*/    OPC_RecordChild1, // #1 = $rhs
/*  4256*/    OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->4266
/*  4259*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND_I32),
                   /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
               // Dst: (AND_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4266*/    /*SwitchType*/ 7, /*MVT::i64*/8, // ->4275
/*  4268*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND_I64),
                   /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
               // Dst: (AND_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4275*/    0, // EndSwitchType
/*  4276*/   /*Scope*/ 47, /*->4324*/
/*  4277*/    OPC_MoveChild1,
/*  4278*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/*  4281*/    OPC_RecordChild0, // #1 = $rhs
/*  4282*/    OPC_MoveChild1,
/*  4283*/    OPC_CheckImmAllOnesV,
/*  4284*/    OPC_MoveParent,
/*  4285*/    OPC_MoveParent,
/*  4286*/    OPC_SwitchType /*4 cases */, 7, /*MVT::v16i8*/39, // ->4296
/*  4289*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$rhs, immAllOnesV:{ *:[v16i8] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4296*/    /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->4305
/*  4298*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$rhs, immAllOnesV:{ *:[v8i16] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4305*/    /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->4314
/*  4307*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$rhs, immAllOnesV:{ *:[v4i32] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4314*/    /*SwitchType*/ 7, /*MVT::v2i64*/78, // ->4323
/*  4316*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$rhs, immAllOnesV:{ *:[v2i64] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4323*/    0, // EndSwitchType
/*  4324*/   0, /*End of Scope*/
/*  4325*/  /*Scope*/ 48, /*->4374*/
/*  4326*/   OPC_MoveChild0,
/*  4327*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/*  4330*/   OPC_RecordChild0, // #0 = $rhs
/*  4331*/   OPC_MoveChild1,
/*  4332*/   OPC_CheckImmAllOnesV,
/*  4333*/   OPC_MoveParent,
/*  4334*/   OPC_MoveParent,
/*  4335*/   OPC_RecordChild1, // #1 = $lhs
/*  4336*/   OPC_SwitchType /*4 cases */, 7, /*MVT::v16i8*/39, // ->4346
/*  4339*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$rhs, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4346*/   /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->4355
/*  4348*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$rhs, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4355*/   /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->4364
/*  4357*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$rhs, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4364*/   /*SwitchType*/ 7, /*MVT::v2i64*/78, // ->4373
/*  4366*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$rhs, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4373*/   0, // EndSwitchType
/*  4374*/  /*Scope*/ 40, /*->4415*/
/*  4375*/   OPC_RecordChild0, // #0 = $lhs
/*  4376*/   OPC_RecordChild1, // #1 = $rhs
/*  4377*/   OPC_SwitchType /*4 cases */, 7, /*MVT::v16i8*/39, // ->4387
/*  4380*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4387*/   /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->4396
/*  4389*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4396*/   /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->4405
/*  4398*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4405*/   /*SwitchType*/ 7, /*MVT::v2i64*/78, // ->4414
/*  4407*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4414*/   0, // EndSwitchType
/*  4415*/  0, /*End of Scope*/
/*  4416*/ /*SwitchOpcode*/ 125|128,11/*1533*/, TARGET_VAL(ISD::SETCC),// ->5953
/*  4420*/  OPC_Scope, 126|128,1/*254*/, /*->4677*/ // 2 children in Scope
/*  4423*/   OPC_MoveChild0,
/*  4424*/   OPC_CheckOpcode, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),
/*  4427*/   OPC_Scope, 123, /*->4552*/ // 2 children in Scope
/*  4429*/    OPC_CheckChild0Integer, 16|128,67|128,1/*24976*/, 
/*  4433*/    OPC_RecordChild1, // #0 = $x
/*  4434*/    OPC_Scope, 28, /*->4464*/ // 4 children in Scope
/*  4436*/     OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/*  4438*/     OPC_MoveParent,
/*  4439*/     OPC_CheckTypeI32,
/*  4440*/     OPC_Scope, 10, /*->4452*/ // 2 children in Scope
/*  4442*/      OPC_CheckChild1Integer, 0, 
/*  4444*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4446*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12488:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4452*/     /*Scope*/ 10, /*->4463*/
/*  4453*/      OPC_CheckChild1Integer, 2, 
/*  4455*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4457*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12488:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4463*/     0, /*End of Scope*/
/*  4464*/    /*Scope*/ 28, /*->4493*/
/*  4465*/     OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/*  4467*/     OPC_MoveParent,
/*  4468*/     OPC_CheckTypeI32,
/*  4469*/     OPC_Scope, 10, /*->4481*/ // 2 children in Scope
/*  4471*/      OPC_CheckChild1Integer, 0, 
/*  4473*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4475*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12488:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4481*/     /*Scope*/ 10, /*->4492*/
/*  4482*/      OPC_CheckChild1Integer, 2, 
/*  4484*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4486*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12488:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4492*/     0, /*End of Scope*/
/*  4493*/    /*Scope*/ 28, /*->4522*/
/*  4494*/     OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/*  4496*/     OPC_MoveParent,
/*  4497*/     OPC_CheckTypeI32,
/*  4498*/     OPC_Scope, 10, /*->4510*/ // 2 children in Scope
/*  4500*/      OPC_CheckChild1Integer, 0, 
/*  4502*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4504*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12488:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4510*/     /*Scope*/ 10, /*->4521*/
/*  4511*/      OPC_CheckChild1Integer, 2, 
/*  4513*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4515*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12488:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4521*/     0, /*End of Scope*/
/*  4522*/    /*Scope*/ 28, /*->4551*/
/*  4523*/     OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/*  4525*/     OPC_MoveParent,
/*  4526*/     OPC_CheckTypeI32,
/*  4527*/     OPC_Scope, 10, /*->4539*/ // 2 children in Scope
/*  4529*/      OPC_CheckChild1Integer, 0, 
/*  4531*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4533*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12488:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4539*/     /*Scope*/ 10, /*->4550*/
/*  4540*/      OPC_CheckChild1Integer, 2, 
/*  4542*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4544*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12488:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4550*/     0, /*End of Scope*/
/*  4551*/    0, /*End of Scope*/
/*  4552*/   /*Scope*/ 123, /*->4676*/
/*  4553*/    OPC_CheckChild0Integer, 14|128,67|128,1/*24974*/, 
/*  4557*/    OPC_RecordChild1, // #0 = $x
/*  4558*/    OPC_Scope, 28, /*->4588*/ // 4 children in Scope
/*  4560*/     OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/*  4562*/     OPC_MoveParent,
/*  4563*/     OPC_CheckTypeI32,
/*  4564*/     OPC_Scope, 10, /*->4576*/ // 2 children in Scope
/*  4566*/      OPC_CheckChild1Integer, 0, 
/*  4568*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4570*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12487:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4576*/     /*Scope*/ 10, /*->4587*/
/*  4577*/      OPC_CheckChild1Integer, 2, 
/*  4579*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4581*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12487:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4587*/     0, /*End of Scope*/
/*  4588*/    /*Scope*/ 28, /*->4617*/
/*  4589*/     OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/*  4591*/     OPC_MoveParent,
/*  4592*/     OPC_CheckTypeI32,
/*  4593*/     OPC_Scope, 10, /*->4605*/ // 2 children in Scope
/*  4595*/      OPC_CheckChild1Integer, 0, 
/*  4597*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4599*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12487:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4605*/     /*Scope*/ 10, /*->4616*/
/*  4606*/      OPC_CheckChild1Integer, 2, 
/*  4608*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4610*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12487:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4616*/     0, /*End of Scope*/
/*  4617*/    /*Scope*/ 28, /*->4646*/
/*  4618*/     OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/*  4620*/     OPC_MoveParent,
/*  4621*/     OPC_CheckTypeI32,
/*  4622*/     OPC_Scope, 10, /*->4634*/ // 2 children in Scope
/*  4624*/      OPC_CheckChild1Integer, 0, 
/*  4626*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4628*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12487:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4634*/     /*Scope*/ 10, /*->4645*/
/*  4635*/      OPC_CheckChild1Integer, 2, 
/*  4637*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4639*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12487:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4645*/     0, /*End of Scope*/
/*  4646*/    /*Scope*/ 28, /*->4675*/
/*  4647*/     OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/*  4649*/     OPC_MoveParent,
/*  4650*/     OPC_CheckTypeI32,
/*  4651*/     OPC_Scope, 10, /*->4663*/ // 2 children in Scope
/*  4653*/      OPC_CheckChild1Integer, 0, 
/*  4655*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4657*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12487:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4663*/     /*Scope*/ 10, /*->4674*/
/*  4664*/      OPC_CheckChild1Integer, 2, 
/*  4666*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4668*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12487:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4674*/     0, /*End of Scope*/
/*  4675*/    0, /*End of Scope*/
/*  4676*/   0, /*End of Scope*/
/*  4677*/  /*Scope*/ 121|128,9/*1273*/, /*->5952*/
/*  4679*/   OPC_RecordChild0, // #0 = $src
/*  4680*/   OPC_SwitchType /*5 cases */, 108|128,3/*492*/, /*MVT::i32*/7, // ->5176
/*  4684*/    OPC_Scope, 118, /*->4804*/ // 4 children in Scope
/*  4686*/     OPC_CheckChild0TypeI32,
/*  4687*/     OPC_Scope, 10, /*->4699*/ // 2 children in Scope
/*  4689*/      OPC_CheckChild1Integer, 0, 
/*  4691*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4693*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQZ_I32),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$src, 0:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 8
                // Dst: (EQZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/*  4699*/     /*Scope*/ 103, /*->4803*/
/*  4700*/      OPC_RecordChild1, // #1 = $rhs
/*  4701*/      OPC_Scope, 9, /*->4712*/ // 10 children in Scope
/*  4703*/       OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4705*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                 // Dst: (EQ_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4712*/      /*Scope*/ 9, /*->4722*/
/*  4713*/       OPC_CheckChild2CondCode, ISD::SETNE,
/*  4715*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                 // Dst: (NE_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4722*/      /*Scope*/ 9, /*->4732*/
/*  4723*/       OPC_CheckChild2CondCode, ISD::SETLT,
/*  4725*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4732*/      /*Scope*/ 9, /*->4742*/
/*  4733*/       OPC_CheckChild2CondCode, ISD::SETULT,
/*  4735*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4742*/      /*Scope*/ 9, /*->4752*/
/*  4743*/       OPC_CheckChild2CondCode, ISD::SETGT,
/*  4745*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4752*/      /*Scope*/ 9, /*->4762*/
/*  4753*/       OPC_CheckChild2CondCode, ISD::SETUGT,
/*  4755*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4762*/      /*Scope*/ 9, /*->4772*/
/*  4763*/       OPC_CheckChild2CondCode, ISD::SETLE,
/*  4765*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4772*/      /*Scope*/ 9, /*->4782*/
/*  4773*/       OPC_CheckChild2CondCode, ISD::SETULE,
/*  4775*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4782*/      /*Scope*/ 9, /*->4792*/
/*  4783*/       OPC_CheckChild2CondCode, ISD::SETGE,
/*  4785*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4792*/      /*Scope*/ 9, /*->4802*/
/*  4793*/       OPC_CheckChild2CondCode, ISD::SETUGE,
/*  4795*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4802*/      0, /*End of Scope*/
/*  4803*/     0, /*End of Scope*/
/*  4804*/    /*Scope*/ 118, /*->4923*/
/*  4805*/     OPC_CheckChild0TypeI64,
/*  4806*/     OPC_Scope, 10, /*->4818*/ // 2 children in Scope
/*  4808*/      OPC_CheckChild1Integer, 0, 
/*  4810*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4812*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQZ_I64),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$src, 0:{ *:[i64] }, SETEQ:{ *:[Other] }) - Complexity = 8
                // Dst: (EQZ_I64:{ *:[i32] } I64:{ *:[i64] }:$src)
/*  4818*/     /*Scope*/ 103, /*->4922*/
/*  4819*/      OPC_RecordChild1, // #1 = $rhs
/*  4820*/      OPC_Scope, 9, /*->4831*/ // 10 children in Scope
/*  4822*/       OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4824*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                 // Dst: (EQ_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4831*/      /*Scope*/ 9, /*->4841*/
/*  4832*/       OPC_CheckChild2CondCode, ISD::SETNE,
/*  4834*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                 // Dst: (NE_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4841*/      /*Scope*/ 9, /*->4851*/
/*  4842*/       OPC_CheckChild2CondCode, ISD::SETLT,
/*  4844*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4851*/      /*Scope*/ 9, /*->4861*/
/*  4852*/       OPC_CheckChild2CondCode, ISD::SETULT,
/*  4854*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4861*/      /*Scope*/ 9, /*->4871*/
/*  4862*/       OPC_CheckChild2CondCode, ISD::SETGT,
/*  4864*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4871*/      /*Scope*/ 9, /*->4881*/
/*  4872*/       OPC_CheckChild2CondCode, ISD::SETUGT,
/*  4874*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4881*/      /*Scope*/ 9, /*->4891*/
/*  4882*/       OPC_CheckChild2CondCode, ISD::SETLE,
/*  4884*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4891*/      /*Scope*/ 9, /*->4901*/
/*  4892*/       OPC_CheckChild2CondCode, ISD::SETULE,
/*  4894*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4901*/      /*Scope*/ 9, /*->4911*/
/*  4902*/       OPC_CheckChild2CondCode, ISD::SETGE,
/*  4904*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4911*/      /*Scope*/ 9, /*->4921*/
/*  4912*/       OPC_CheckChild2CondCode, ISD::SETUGE,
/*  4914*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4921*/      0, /*End of Scope*/
/*  4922*/     0, /*End of Scope*/
/*  4923*/    /*Scope*/ 125, /*->5049*/
/*  4924*/     OPC_CheckChild0Type, /*MVT::f32*/12, 
/*  4926*/     OPC_RecordChild1, // #1 = $rhs
/*  4927*/     OPC_Scope, 9, /*->4938*/ // 12 children in Scope
/*  4929*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  4931*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4938*/     /*Scope*/ 9, /*->4948*/
/*  4939*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  4941*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4948*/     /*Scope*/ 9, /*->4958*/
/*  4949*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  4951*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4958*/     /*Scope*/ 9, /*->4968*/
/*  4959*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  4961*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4968*/     /*Scope*/ 9, /*->4978*/
/*  4969*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  4971*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4978*/     /*Scope*/ 9, /*->4988*/
/*  4979*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  4981*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4988*/     /*Scope*/ 9, /*->4998*/
/*  4989*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4991*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  4998*/     /*Scope*/ 9, /*->5008*/
/*  4999*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5001*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5008*/     /*Scope*/ 9, /*->5018*/
/*  5009*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5011*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5018*/     /*Scope*/ 9, /*->5028*/
/*  5019*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5021*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5028*/     /*Scope*/ 9, /*->5038*/
/*  5029*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5031*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5038*/     /*Scope*/ 9, /*->5048*/
/*  5039*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5041*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5048*/     0, /*End of Scope*/
/*  5049*/    /*Scope*/ 125, /*->5175*/
/*  5050*/     OPC_CheckChild0Type, /*MVT::f64*/13, 
/*  5052*/     OPC_RecordChild1, // #1 = $rhs
/*  5053*/     OPC_Scope, 9, /*->5064*/ // 12 children in Scope
/*  5055*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5057*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5064*/     /*Scope*/ 9, /*->5074*/
/*  5065*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5067*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5074*/     /*Scope*/ 9, /*->5084*/
/*  5075*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5077*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5084*/     /*Scope*/ 9, /*->5094*/
/*  5085*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5087*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5094*/     /*Scope*/ 9, /*->5104*/
/*  5095*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5097*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5104*/     /*Scope*/ 9, /*->5114*/
/*  5105*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5107*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5114*/     /*Scope*/ 9, /*->5124*/
/*  5115*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5117*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5124*/     /*Scope*/ 9, /*->5134*/
/*  5125*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5127*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5134*/     /*Scope*/ 9, /*->5144*/
/*  5135*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5137*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5144*/     /*Scope*/ 9, /*->5154*/
/*  5145*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5147*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5154*/     /*Scope*/ 9, /*->5164*/
/*  5155*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5157*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5164*/     /*Scope*/ 9, /*->5174*/
/*  5165*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5167*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5174*/     0, /*End of Scope*/
/*  5175*/    0, /*End of Scope*/
/*  5176*/   /*SwitchType*/ 115, /*MVT::v16i8*/39, // ->5293
/*  5178*/    OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/*  5180*/    OPC_RecordChild1, // #1 = $rhs
/*  5181*/    OPC_Scope, 10, /*->5193*/ // 10 children in Scope
/*  5183*/     OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5185*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5186*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
               // Dst: (EQ_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5193*/    /*Scope*/ 10, /*->5204*/
/*  5194*/     OPC_CheckChild2CondCode, ISD::SETNE,
/*  5196*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5197*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
               // Dst: (NE_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5204*/    /*Scope*/ 10, /*->5215*/
/*  5205*/     OPC_CheckChild2CondCode, ISD::SETLT,
/*  5207*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5208*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5215*/    /*Scope*/ 10, /*->5226*/
/*  5216*/     OPC_CheckChild2CondCode, ISD::SETULT,
/*  5218*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5219*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5226*/    /*Scope*/ 10, /*->5237*/
/*  5227*/     OPC_CheckChild2CondCode, ISD::SETGT,
/*  5229*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5230*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5237*/    /*Scope*/ 10, /*->5248*/
/*  5238*/     OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5240*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5241*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5248*/    /*Scope*/ 10, /*->5259*/
/*  5249*/     OPC_CheckChild2CondCode, ISD::SETLE,
/*  5251*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5252*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5259*/    /*Scope*/ 10, /*->5270*/
/*  5260*/     OPC_CheckChild2CondCode, ISD::SETULE,
/*  5262*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5263*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5270*/    /*Scope*/ 10, /*->5281*/
/*  5271*/     OPC_CheckChild2CondCode, ISD::SETGE,
/*  5273*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5274*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5281*/    /*Scope*/ 10, /*->5292*/
/*  5282*/     OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5284*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5285*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5292*/    0, /*End of Scope*/
/*  5293*/   /*SwitchType*/ 62|128,1/*190*/, /*MVT::v8i16*/50, // ->5486
/*  5296*/    OPC_Scope, 115, /*->5413*/ // 2 children in Scope
/*  5298*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/*  5300*/     OPC_RecordChild1, // #1 = $rhs
/*  5301*/     OPC_Scope, 10, /*->5313*/ // 10 children in Scope
/*  5303*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5305*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5306*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5313*/     /*Scope*/ 10, /*->5324*/
/*  5314*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5316*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5317*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5324*/     /*Scope*/ 10, /*->5335*/
/*  5325*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5327*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5328*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5335*/     /*Scope*/ 10, /*->5346*/
/*  5336*/      OPC_CheckChild2CondCode, ISD::SETULT,
/*  5338*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5339*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5346*/     /*Scope*/ 10, /*->5357*/
/*  5347*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5349*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5350*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5357*/     /*Scope*/ 10, /*->5368*/
/*  5358*/      OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5360*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5361*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5368*/     /*Scope*/ 10, /*->5379*/
/*  5369*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5371*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5372*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5379*/     /*Scope*/ 10, /*->5390*/
/*  5380*/      OPC_CheckChild2CondCode, ISD::SETULE,
/*  5382*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5383*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5390*/     /*Scope*/ 10, /*->5401*/
/*  5391*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5393*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5394*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5401*/     /*Scope*/ 10, /*->5412*/
/*  5402*/      OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5404*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5405*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5412*/     0, /*End of Scope*/
/*  5413*/    /*Scope*/ 71, /*->5485*/
/*  5414*/     OPC_CheckChild0Type, /*MVT::v8f16*/92, 
/*  5416*/     OPC_RecordChild1, // #1 = $rhs
/*  5417*/     OPC_Scope, 10, /*->5429*/ // 6 children in Scope
/*  5419*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5421*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/*  5422*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5429*/     /*Scope*/ 10, /*->5440*/
/*  5430*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5432*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/*  5433*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5440*/     /*Scope*/ 10, /*->5451*/
/*  5441*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5443*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/*  5444*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5451*/     /*Scope*/ 10, /*->5462*/
/*  5452*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5454*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/*  5455*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5462*/     /*Scope*/ 10, /*->5473*/
/*  5463*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5465*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/*  5466*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5473*/     /*Scope*/ 10, /*->5484*/
/*  5474*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5476*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/*  5477*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5484*/     0, /*End of Scope*/
/*  5485*/    0, /*End of Scope*/
/*  5486*/   /*SwitchType*/ 123|128,1/*251*/, /*MVT::v4i32*/60, // ->5740
/*  5489*/    OPC_Scope, 115, /*->5606*/ // 2 children in Scope
/*  5491*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/*  5493*/     OPC_RecordChild1, // #1 = $rhs
/*  5494*/     OPC_Scope, 10, /*->5506*/ // 10 children in Scope
/*  5496*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5498*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5499*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5506*/     /*Scope*/ 10, /*->5517*/
/*  5507*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5509*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5510*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5517*/     /*Scope*/ 10, /*->5528*/
/*  5518*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5520*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5521*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5528*/     /*Scope*/ 10, /*->5539*/
/*  5529*/      OPC_CheckChild2CondCode, ISD::SETULT,
/*  5531*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5532*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5539*/     /*Scope*/ 10, /*->5550*/
/*  5540*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5542*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5543*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5550*/     /*Scope*/ 10, /*->5561*/
/*  5551*/      OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5553*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5554*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5561*/     /*Scope*/ 10, /*->5572*/
/*  5562*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5564*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5565*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5572*/     /*Scope*/ 10, /*->5583*/
/*  5573*/      OPC_CheckChild2CondCode, ISD::SETULE,
/*  5575*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5576*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5583*/     /*Scope*/ 10, /*->5594*/
/*  5584*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5586*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5587*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5594*/     /*Scope*/ 10, /*->5605*/
/*  5595*/      OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5597*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5598*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5605*/     0, /*End of Scope*/
/*  5606*/    /*Scope*/ 3|128,1/*131*/, /*->5739*/
/*  5608*/     OPC_CheckChild0Type, /*MVT::v4f32*/110, 
/*  5610*/     OPC_RecordChild1, // #1 = $rhs
/*  5611*/     OPC_Scope, 10, /*->5623*/ // 12 children in Scope
/*  5613*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5615*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5616*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5623*/     /*Scope*/ 10, /*->5634*/
/*  5624*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5626*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5627*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5634*/     /*Scope*/ 10, /*->5645*/
/*  5635*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5637*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5638*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5645*/     /*Scope*/ 10, /*->5656*/
/*  5646*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5648*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5649*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5656*/     /*Scope*/ 10, /*->5667*/
/*  5657*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5659*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5660*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5667*/     /*Scope*/ 10, /*->5678*/
/*  5668*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5670*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5671*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5678*/     /*Scope*/ 9, /*->5688*/
/*  5679*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5681*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5688*/     /*Scope*/ 9, /*->5698*/
/*  5689*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5691*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5698*/     /*Scope*/ 9, /*->5708*/
/*  5699*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5701*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5708*/     /*Scope*/ 9, /*->5718*/
/*  5709*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5711*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5718*/     /*Scope*/ 9, /*->5728*/
/*  5719*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5721*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5728*/     /*Scope*/ 9, /*->5738*/
/*  5729*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5731*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5738*/     0, /*End of Scope*/
/*  5739*/    0, /*End of Scope*/
/*  5740*/   /*SwitchType*/ 80|128,1/*208*/, /*MVT::v2i64*/78, // ->5951
/*  5743*/    OPC_Scope, 71, /*->5816*/ // 2 children in Scope
/*  5745*/     OPC_CheckChild0Type, /*MVT::v2i64*/78, 
/*  5747*/     OPC_RecordChild1, // #1 = $rhs
/*  5748*/     OPC_Scope, 10, /*->5760*/ // 6 children in Scope
/*  5750*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5752*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5753*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5760*/     /*Scope*/ 10, /*->5771*/
/*  5761*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5763*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5764*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5771*/     /*Scope*/ 10, /*->5782*/
/*  5772*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5774*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5775*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5782*/     /*Scope*/ 10, /*->5793*/
/*  5783*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5785*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5786*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5793*/     /*Scope*/ 10, /*->5804*/
/*  5794*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5796*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5797*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5804*/     /*Scope*/ 10, /*->5815*/
/*  5805*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5807*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5808*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5815*/     0, /*End of Scope*/
/*  5816*/    /*Scope*/ 4|128,1/*132*/, /*->5950*/
/*  5818*/     OPC_CheckChild0Type, /*MVT::v2f64*/0|128,1/*128*/, 
/*  5821*/     OPC_RecordChild1, // #1 = $rhs
/*  5822*/     OPC_Scope, 10, /*->5834*/ // 12 children in Scope
/*  5824*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5826*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5827*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5834*/     /*Scope*/ 10, /*->5845*/
/*  5835*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5837*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5838*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5845*/     /*Scope*/ 10, /*->5856*/
/*  5846*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5848*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5849*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5856*/     /*Scope*/ 10, /*->5867*/
/*  5857*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5859*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5860*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5867*/     /*Scope*/ 10, /*->5878*/
/*  5868*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5870*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5871*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5878*/     /*Scope*/ 10, /*->5889*/
/*  5879*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5881*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5882*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5889*/     /*Scope*/ 9, /*->5899*/
/*  5890*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5892*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5899*/     /*Scope*/ 9, /*->5909*/
/*  5900*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5902*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5909*/     /*Scope*/ 9, /*->5919*/
/*  5910*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5912*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5919*/     /*Scope*/ 9, /*->5929*/
/*  5920*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5922*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5929*/     /*Scope*/ 9, /*->5939*/
/*  5930*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5932*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5939*/     /*Scope*/ 9, /*->5949*/
/*  5940*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5942*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5949*/     0, /*End of Scope*/
/*  5950*/    0, /*End of Scope*/
/*  5951*/   0, // EndSwitchType
/*  5952*/  0, /*End of Scope*/
/*  5953*/ /*SwitchOpcode*/ 59|128,11/*1467*/, TARGET_VAL(ISD::LOAD),// ->7424
/*  5957*/  OPC_RecordMemRef,
/*  5958*/  OPC_RecordNode, // #0 = 'ld' chained node
/*  5959*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  5960*/  OPC_Scope, 89|128,5/*729*/, /*->6692*/ // 2 children in Scope
/*  5963*/   OPC_CheckChild1TypeI32,
/*  5964*/   OPC_CheckPredicate, 8, // Predicate_unindexedload
/*  5966*/   OPC_Scope, 37, /*->6005*/ // 16 children in Scope
/*  5968*/    OPC_CheckPredicate6,  // Predicate_load
/*  5969*/    OPC_SwitchType /*2 cases */, 15, /*MVT::i32*/7, // ->5987
/*  5972*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  5973*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5975*/     OPC_EmitMergeInputChains1_0,
/*  5976*/     OPC_EmitInteger32, 0, 
/*  5978*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5987*/    /*SwitchType*/ 15, /*MVT::i64*/8, // ->6004
/*  5989*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  5990*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5992*/     OPC_EmitMergeInputChains1_0,
/*  5993*/     OPC_EmitInteger32, 0, 
/*  5995*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6004*/    0, // EndSwitchType
/*  6005*/   /*Scope*/ 97, /*->6103*/
/*  6006*/    OPC_CheckPredicate, 15, // Predicate_sextload
/*  6008*/    OPC_SwitchType /*2 cases */, 36, /*MVT::i32*/7, // ->6047
/*  6011*/     OPC_Scope, 16, /*->6029*/ // 2 children in Scope
/*  6013*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  6014*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6015*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6017*/      OPC_EmitMergeInputChains1_0,
/*  6018*/      OPC_EmitInteger32, 0, 
/*  6020*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6029*/     /*Scope*/ 16, /*->6046*/
/*  6030*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  6031*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6032*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6034*/      OPC_EmitMergeInputChains1_0,
/*  6035*/      OPC_EmitInteger32, 0, 
/*  6037*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6046*/     0, /*End of Scope*/
/*  6047*/    /*SwitchType*/ 53, /*MVT::i64*/8, // ->6102
/*  6049*/     OPC_Scope, 16, /*->6067*/ // 3 children in Scope
/*  6051*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  6052*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6053*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6055*/      OPC_EmitMergeInputChains1_0,
/*  6056*/      OPC_EmitInteger32, 0, 
/*  6058*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6067*/     /*Scope*/ 16, /*->6084*/
/*  6068*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  6069*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6070*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6072*/      OPC_EmitMergeInputChains1_0,
/*  6073*/      OPC_EmitInteger32, 0, 
/*  6075*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6084*/     /*Scope*/ 16, /*->6101*/
/*  6085*/      OPC_CheckPredicate3,  // Predicate_sextloadi32
/*  6086*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6087*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6089*/      OPC_EmitMergeInputChains1_0,
/*  6090*/      OPC_EmitInteger32, 0, 
/*  6092*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 13
                // Dst: (LOAD32_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6101*/     0, /*End of Scope*/
/*  6102*/    0, // EndSwitchType
/*  6103*/   /*Scope*/ 97, /*->6201*/
/*  6104*/    OPC_CheckPredicate, 16, // Predicate_zextload
/*  6106*/    OPC_SwitchType /*2 cases */, 36, /*MVT::i32*/7, // ->6145
/*  6109*/     OPC_Scope, 16, /*->6127*/ // 2 children in Scope
/*  6111*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  6112*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6113*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6115*/      OPC_EmitMergeInputChains1_0,
/*  6116*/      OPC_EmitInteger32, 0, 
/*  6118*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6127*/     /*Scope*/ 16, /*->6144*/
/*  6128*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  6129*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6130*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6132*/      OPC_EmitMergeInputChains1_0,
/*  6133*/      OPC_EmitInteger32, 0, 
/*  6135*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6144*/     0, /*End of Scope*/
/*  6145*/    /*SwitchType*/ 53, /*MVT::i64*/8, // ->6200
/*  6147*/     OPC_Scope, 16, /*->6165*/ // 3 children in Scope
/*  6149*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  6150*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6151*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6153*/      OPC_EmitMergeInputChains1_0,
/*  6154*/      OPC_EmitInteger32, 0, 
/*  6156*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6165*/     /*Scope*/ 16, /*->6182*/
/*  6166*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  6167*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6168*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6170*/      OPC_EmitMergeInputChains1_0,
/*  6171*/      OPC_EmitInteger32, 0, 
/*  6173*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6182*/     /*Scope*/ 16, /*->6199*/
/*  6183*/      OPC_CheckPredicate3,  // Predicate_zextloadi32
/*  6184*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6185*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6187*/      OPC_EmitMergeInputChains1_0,
/*  6188*/      OPC_EmitInteger32, 0, 
/*  6190*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6199*/     0, /*End of Scope*/
/*  6200*/    0, // EndSwitchType
/*  6201*/   /*Scope*/ 97, /*->6299*/
/*  6202*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6204*/    OPC_SwitchType /*2 cases */, 36, /*MVT::i32*/7, // ->6243
/*  6207*/     OPC_Scope, 16, /*->6225*/ // 2 children in Scope
/*  6209*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  6210*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6211*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6213*/      OPC_EmitMergeInputChains1_0,
/*  6214*/      OPC_EmitInteger32, 0, 
/*  6216*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6225*/     /*Scope*/ 16, /*->6242*/
/*  6226*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  6227*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6228*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6230*/      OPC_EmitMergeInputChains1_0,
/*  6231*/      OPC_EmitInteger32, 0, 
/*  6233*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6242*/     0, /*End of Scope*/
/*  6243*/    /*SwitchType*/ 53, /*MVT::i64*/8, // ->6298
/*  6245*/     OPC_Scope, 16, /*->6263*/ // 3 children in Scope
/*  6247*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  6248*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6249*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6251*/      OPC_EmitMergeInputChains1_0,
/*  6252*/      OPC_EmitInteger32, 0, 
/*  6254*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6263*/     /*Scope*/ 16, /*->6280*/
/*  6264*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  6265*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6266*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6268*/      OPC_EmitMergeInputChains1_0,
/*  6269*/      OPC_EmitInteger32, 0, 
/*  6271*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6280*/     /*Scope*/ 16, /*->6297*/
/*  6281*/      OPC_CheckPredicate3,  // Predicate_extloadi32
/*  6282*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6283*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6285*/      OPC_EmitMergeInputChains1_0,
/*  6286*/      OPC_EmitInteger32, 0, 
/*  6288*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6297*/     0, /*End of Scope*/
/*  6298*/    0, // EndSwitchType
/*  6299*/   /*Scope*/ 105, /*->6405*/
/*  6300*/    OPC_CheckPredicate6,  // Predicate_load
/*  6301*/    OPC_SwitchType /*6 cases */, 15, /*MVT::f32*/12, // ->6319
/*  6304*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6305*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6307*/     OPC_EmitMergeInputChains1_0,
/*  6308*/     OPC_EmitInteger32, 0, 
/*  6310*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::f32*/12, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F32_A32:{ *:[f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6319*/    /*SwitchType*/ 15, /*MVT::f64*/13, // ->6336
/*  6321*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6322*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6324*/     OPC_EmitMergeInputChains1_0,
/*  6325*/     OPC_EmitInteger32, 0, 
/*  6327*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::f64*/13, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F64_A32:{ *:[f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6336*/    /*SwitchType*/ 15, /*MVT::v16i8*/39, // ->6353
/*  6338*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6339*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6341*/     OPC_EmitMergeInputChains1_0,
/*  6342*/     OPC_EmitInteger32, 0, 
/*  6344*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v16i8*/39, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v16i8] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v16i8] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6353*/    /*SwitchType*/ 15, /*MVT::v8i16*/50, // ->6370
/*  6355*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6356*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6358*/     OPC_EmitMergeInputChains1_0,
/*  6359*/     OPC_EmitInteger32, 0, 
/*  6361*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6370*/    /*SwitchType*/ 15, /*MVT::v4i32*/60, // ->6387
/*  6372*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6373*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6375*/     OPC_EmitMergeInputChains1_0,
/*  6376*/     OPC_EmitInteger32, 0, 
/*  6378*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6387*/    /*SwitchType*/ 15, /*MVT::v2i64*/78, // ->6404
/*  6389*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6390*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6392*/     OPC_EmitMergeInputChains1_0,
/*  6393*/     OPC_EmitInteger32, 0, 
/*  6395*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6404*/    0, // EndSwitchType
/*  6405*/   /*Scope*/ 21, /*->6427*/
/*  6406*/    OPC_CheckPredicate, 15, // Predicate_sextload
/*  6408*/    OPC_CheckPredicate, 21, // Predicate_sextloadvi8
/*  6410*/    OPC_CheckType, /*MVT::v8i16*/50, 
/*  6412*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6413*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6415*/    OPC_EmitMergeInputChains1_0,
/*  6416*/    OPC_EmitInteger32, 0, 
/*  6418*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6427*/   /*Scope*/ 21, /*->6449*/
/*  6428*/    OPC_CheckPredicate, 16, // Predicate_zextload
/*  6430*/    OPC_CheckPredicate, 21, // Predicate_zextloadvi8
/*  6432*/    OPC_CheckType, /*MVT::v8i16*/50, 
/*  6434*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6435*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6437*/    OPC_EmitMergeInputChains1_0,
/*  6438*/    OPC_EmitInteger32, 0, 
/*  6440*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6449*/   /*Scope*/ 21, /*->6471*/
/*  6450*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6452*/    OPC_CheckPredicate, 21, // Predicate_extloadvi8
/*  6454*/    OPC_CheckType, /*MVT::v8i16*/50, 
/*  6456*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6457*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6459*/    OPC_EmitMergeInputChains1_0,
/*  6460*/    OPC_EmitInteger32, 0, 
/*  6462*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6471*/   /*Scope*/ 21, /*->6493*/
/*  6472*/    OPC_CheckPredicate, 15, // Predicate_sextload
/*  6474*/    OPC_CheckPredicate, 22, // Predicate_sextloadvi16
/*  6476*/    OPC_CheckType, /*MVT::v4i32*/60, 
/*  6478*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6479*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6481*/    OPC_EmitMergeInputChains1_0,
/*  6482*/    OPC_EmitInteger32, 0, 
/*  6484*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6493*/   /*Scope*/ 21, /*->6515*/
/*  6494*/    OPC_CheckPredicate, 16, // Predicate_zextload
/*  6496*/    OPC_CheckPredicate, 22, // Predicate_zextloadvi16
/*  6498*/    OPC_CheckType, /*MVT::v4i32*/60, 
/*  6500*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6501*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6503*/    OPC_EmitMergeInputChains1_0,
/*  6504*/    OPC_EmitInteger32, 0, 
/*  6506*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6515*/   /*Scope*/ 21, /*->6537*/
/*  6516*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6518*/    OPC_CheckPredicate, 22, // Predicate_extloadvi16
/*  6520*/    OPC_CheckType, /*MVT::v4i32*/60, 
/*  6522*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6523*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6525*/    OPC_EmitMergeInputChains1_0,
/*  6526*/    OPC_EmitInteger32, 0, 
/*  6528*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6537*/   /*Scope*/ 21, /*->6559*/
/*  6538*/    OPC_CheckPredicate, 15, // Predicate_sextload
/*  6540*/    OPC_CheckPredicate, 23, // Predicate_sextloadvi32
/*  6542*/    OPC_CheckType, /*MVT::v2i64*/78, 
/*  6544*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6545*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6547*/    OPC_EmitMergeInputChains1_0,
/*  6548*/    OPC_EmitInteger32, 0, 
/*  6550*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6559*/   /*Scope*/ 21, /*->6581*/
/*  6560*/    OPC_CheckPredicate, 16, // Predicate_zextload
/*  6562*/    OPC_CheckPredicate, 23, // Predicate_zextloadvi32
/*  6564*/    OPC_CheckType, /*MVT::v2i64*/78, 
/*  6566*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6567*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6569*/    OPC_EmitMergeInputChains1_0,
/*  6570*/    OPC_EmitInteger32, 0, 
/*  6572*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6581*/   /*Scope*/ 21, /*->6603*/
/*  6582*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6584*/    OPC_CheckPredicate, 23, // Predicate_extloadvi32
/*  6586*/    OPC_CheckType, /*MVT::v2i64*/78, 
/*  6588*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6589*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6591*/    OPC_EmitMergeInputChains1_0,
/*  6592*/    OPC_EmitInteger32, 0, 
/*  6594*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6603*/   /*Scope*/ 56, /*->6660*/
/*  6604*/    OPC_CheckPredicate6,  // Predicate_load
/*  6605*/    OPC_SwitchType /*3 cases */, 15, /*MVT::v4f32*/110, // ->6623
/*  6608*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6609*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6611*/     OPC_EmitMergeInputChains1_0,
/*  6612*/     OPC_EmitInteger32, 0, 
/*  6614*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4f32*/110, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v4f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6623*/    /*SwitchType*/ 16, /*MVT::v2f64*/0|128,1/*128*/, // ->6642
/*  6626*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6627*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6629*/     OPC_EmitMergeInputChains1_0,
/*  6630*/     OPC_EmitInteger32, 0, 
/*  6632*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2f64*/0|128,1/*128*/, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v2f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6642*/    /*SwitchType*/ 15, /*MVT::v8f16*/92, // ->6659
/*  6644*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6645*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6647*/     OPC_EmitMergeInputChains1_0,
/*  6648*/     OPC_EmitInteger32, 0, 
/*  6650*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v8f16*/92, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v8f16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v8f16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6659*/    0, // EndSwitchType
/*  6660*/   /*Scope*/ 30, /*->6691*/
/*  6661*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6663*/    OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/*  6666*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6667*/    OPC_EmitMergeInputChains1_0,
/*  6668*/    OPC_EmitInteger32, 0, 
/*  6670*/    OPC_EmitInteger32, 0, 
/*  6672*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v16i8*/39, 3/*#Ops*/, 2, 3, 1,  // Results = #4
/*  6681*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::promote_low_F64x2),
                  /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 4,  // Results = #5
/*  6688*/    OPC_CompleteMatch, 1, 5, 
               // Src: (ld:{ *:[v2f64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>> - Complexity = 4
               // Dst: (promote_low_F64x2:{ *:[v2f64] } (LOAD_ZERO_64_A32:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr))
/*  6691*/   0, /*End of Scope*/
/*  6692*/  /*Scope*/ 89|128,5/*729*/, /*->7423*/
/*  6694*/   OPC_CheckChild1TypeI64,
/*  6695*/   OPC_CheckPredicate, 8, // Predicate_unindexedload
/*  6697*/   OPC_Scope, 37, /*->6736*/ // 16 children in Scope
/*  6699*/    OPC_CheckPredicate6,  // Predicate_load
/*  6700*/    OPC_SwitchType /*2 cases */, 15, /*MVT::i32*/7, // ->6718
/*  6703*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6704*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6706*/     OPC_EmitMergeInputChains1_0,
/*  6707*/     OPC_EmitInteger32, 0, 
/*  6709*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6718*/    /*SwitchType*/ 15, /*MVT::i64*/8, // ->6735
/*  6720*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6721*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6723*/     OPC_EmitMergeInputChains1_0,
/*  6724*/     OPC_EmitInteger32, 0, 
/*  6726*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6735*/    0, // EndSwitchType
/*  6736*/   /*Scope*/ 97, /*->6834*/
/*  6737*/    OPC_CheckPredicate, 15, // Predicate_sextload
/*  6739*/    OPC_SwitchType /*2 cases */, 36, /*MVT::i32*/7, // ->6778
/*  6742*/     OPC_Scope, 16, /*->6760*/ // 2 children in Scope
/*  6744*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  6745*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6746*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6748*/      OPC_EmitMergeInputChains1_0,
/*  6749*/      OPC_EmitInteger32, 0, 
/*  6751*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6760*/     /*Scope*/ 16, /*->6777*/
/*  6761*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  6762*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6763*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6765*/      OPC_EmitMergeInputChains1_0,
/*  6766*/      OPC_EmitInteger32, 0, 
/*  6768*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6777*/     0, /*End of Scope*/
/*  6778*/    /*SwitchType*/ 53, /*MVT::i64*/8, // ->6833
/*  6780*/     OPC_Scope, 16, /*->6798*/ // 3 children in Scope
/*  6782*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  6783*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6784*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6786*/      OPC_EmitMergeInputChains1_0,
/*  6787*/      OPC_EmitInteger32, 0, 
/*  6789*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6798*/     /*Scope*/ 16, /*->6815*/
/*  6799*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  6800*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6801*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6803*/      OPC_EmitMergeInputChains1_0,
/*  6804*/      OPC_EmitInteger32, 0, 
/*  6806*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6815*/     /*Scope*/ 16, /*->6832*/
/*  6816*/      OPC_CheckPredicate3,  // Predicate_sextloadi32
/*  6817*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6818*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6820*/      OPC_EmitMergeInputChains1_0,
/*  6821*/      OPC_EmitInteger32, 0, 
/*  6823*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 13
                // Dst: (LOAD32_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6832*/     0, /*End of Scope*/
/*  6833*/    0, // EndSwitchType
/*  6834*/   /*Scope*/ 97, /*->6932*/
/*  6835*/    OPC_CheckPredicate, 16, // Predicate_zextload
/*  6837*/    OPC_SwitchType /*2 cases */, 36, /*MVT::i32*/7, // ->6876
/*  6840*/     OPC_Scope, 16, /*->6858*/ // 2 children in Scope
/*  6842*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  6843*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6844*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6846*/      OPC_EmitMergeInputChains1_0,
/*  6847*/      OPC_EmitInteger32, 0, 
/*  6849*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6858*/     /*Scope*/ 16, /*->6875*/
/*  6859*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  6860*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6861*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6863*/      OPC_EmitMergeInputChains1_0,
/*  6864*/      OPC_EmitInteger32, 0, 
/*  6866*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6875*/     0, /*End of Scope*/
/*  6876*/    /*SwitchType*/ 53, /*MVT::i64*/8, // ->6931
/*  6878*/     OPC_Scope, 16, /*->6896*/ // 3 children in Scope
/*  6880*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  6881*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6882*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6884*/      OPC_EmitMergeInputChains1_0,
/*  6885*/      OPC_EmitInteger32, 0, 
/*  6887*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6896*/     /*Scope*/ 16, /*->6913*/
/*  6897*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  6898*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6899*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6901*/      OPC_EmitMergeInputChains1_0,
/*  6902*/      OPC_EmitInteger32, 0, 
/*  6904*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6913*/     /*Scope*/ 16, /*->6930*/
/*  6914*/      OPC_CheckPredicate3,  // Predicate_zextloadi32
/*  6915*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6916*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6918*/      OPC_EmitMergeInputChains1_0,
/*  6919*/      OPC_EmitInteger32, 0, 
/*  6921*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6930*/     0, /*End of Scope*/
/*  6931*/    0, // EndSwitchType
/*  6932*/   /*Scope*/ 97, /*->7030*/
/*  6933*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6935*/    OPC_SwitchType /*2 cases */, 36, /*MVT::i32*/7, // ->6974
/*  6938*/     OPC_Scope, 16, /*->6956*/ // 2 children in Scope
/*  6940*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  6941*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6942*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6944*/      OPC_EmitMergeInputChains1_0,
/*  6945*/      OPC_EmitInteger32, 0, 
/*  6947*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6956*/     /*Scope*/ 16, /*->6973*/
/*  6957*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  6958*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6959*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6961*/      OPC_EmitMergeInputChains1_0,
/*  6962*/      OPC_EmitInteger32, 0, 
/*  6964*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6973*/     0, /*End of Scope*/
/*  6974*/    /*SwitchType*/ 53, /*MVT::i64*/8, // ->7029
/*  6976*/     OPC_Scope, 16, /*->6994*/ // 3 children in Scope
/*  6978*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  6979*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6980*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6982*/      OPC_EmitMergeInputChains1_0,
/*  6983*/      OPC_EmitInteger32, 0, 
/*  6985*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6994*/     /*Scope*/ 16, /*->7011*/
/*  6995*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  6996*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6997*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6999*/      OPC_EmitMergeInputChains1_0,
/*  7000*/      OPC_EmitInteger32, 0, 
/*  7002*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7011*/     /*Scope*/ 16, /*->7028*/
/*  7012*/      OPC_CheckPredicate3,  // Predicate_extloadi32
/*  7013*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7014*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7016*/      OPC_EmitMergeInputChains1_0,
/*  7017*/      OPC_EmitInteger32, 0, 
/*  7019*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7028*/     0, /*End of Scope*/
/*  7029*/    0, // EndSwitchType
/*  7030*/   /*Scope*/ 105, /*->7136*/
/*  7031*/    OPC_CheckPredicate6,  // Predicate_load
/*  7032*/    OPC_SwitchType /*6 cases */, 15, /*MVT::f32*/12, // ->7050
/*  7035*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7036*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7038*/     OPC_EmitMergeInputChains1_0,
/*  7039*/     OPC_EmitInteger32, 0, 
/*  7041*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::f32*/12, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F32_A64:{ *:[f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7050*/    /*SwitchType*/ 15, /*MVT::f64*/13, // ->7067
/*  7052*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7053*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7055*/     OPC_EmitMergeInputChains1_0,
/*  7056*/     OPC_EmitInteger32, 0, 
/*  7058*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::f64*/13, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F64_A64:{ *:[f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7067*/    /*SwitchType*/ 15, /*MVT::v16i8*/39, // ->7084
/*  7069*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7070*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7072*/     OPC_EmitMergeInputChains1_0,
/*  7073*/     OPC_EmitInteger32, 0, 
/*  7075*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v16i8*/39, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v16i8] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v16i8] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7084*/    /*SwitchType*/ 15, /*MVT::v8i16*/50, // ->7101
/*  7086*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7087*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7089*/     OPC_EmitMergeInputChains1_0,
/*  7090*/     OPC_EmitInteger32, 0, 
/*  7092*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7101*/    /*SwitchType*/ 15, /*MVT::v4i32*/60, // ->7118
/*  7103*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7104*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7106*/     OPC_EmitMergeInputChains1_0,
/*  7107*/     OPC_EmitInteger32, 0, 
/*  7109*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7118*/    /*SwitchType*/ 15, /*MVT::v2i64*/78, // ->7135
/*  7120*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7121*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7123*/     OPC_EmitMergeInputChains1_0,
/*  7124*/     OPC_EmitInteger32, 0, 
/*  7126*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7135*/    0, // EndSwitchType
/*  7136*/   /*Scope*/ 21, /*->7158*/
/*  7137*/    OPC_CheckPredicate, 15, // Predicate_sextload
/*  7139*/    OPC_CheckPredicate, 21, // Predicate_sextloadvi8
/*  7141*/    OPC_CheckType, /*MVT::v8i16*/50, 
/*  7143*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7144*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7146*/    OPC_EmitMergeInputChains1_0,
/*  7147*/    OPC_EmitInteger32, 0, 
/*  7149*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7158*/   /*Scope*/ 21, /*->7180*/
/*  7159*/    OPC_CheckPredicate, 16, // Predicate_zextload
/*  7161*/    OPC_CheckPredicate, 21, // Predicate_zextloadvi8
/*  7163*/    OPC_CheckType, /*MVT::v8i16*/50, 
/*  7165*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7166*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7168*/    OPC_EmitMergeInputChains1_0,
/*  7169*/    OPC_EmitInteger32, 0, 
/*  7171*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7180*/   /*Scope*/ 21, /*->7202*/
/*  7181*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  7183*/    OPC_CheckPredicate, 21, // Predicate_extloadvi8
/*  7185*/    OPC_CheckType, /*MVT::v8i16*/50, 
/*  7187*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7188*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7190*/    OPC_EmitMergeInputChains1_0,
/*  7191*/    OPC_EmitInteger32, 0, 
/*  7193*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7202*/   /*Scope*/ 21, /*->7224*/
/*  7203*/    OPC_CheckPredicate, 15, // Predicate_sextload
/*  7205*/    OPC_CheckPredicate, 22, // Predicate_sextloadvi16
/*  7207*/    OPC_CheckType, /*MVT::v4i32*/60, 
/*  7209*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7210*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7212*/    OPC_EmitMergeInputChains1_0,
/*  7213*/    OPC_EmitInteger32, 0, 
/*  7215*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7224*/   /*Scope*/ 21, /*->7246*/
/*  7225*/    OPC_CheckPredicate, 16, // Predicate_zextload
/*  7227*/    OPC_CheckPredicate, 22, // Predicate_zextloadvi16
/*  7229*/    OPC_CheckType, /*MVT::v4i32*/60, 
/*  7231*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7232*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7234*/    OPC_EmitMergeInputChains1_0,
/*  7235*/    OPC_EmitInteger32, 0, 
/*  7237*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7246*/   /*Scope*/ 21, /*->7268*/
/*  7247*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  7249*/    OPC_CheckPredicate, 22, // Predicate_extloadvi16
/*  7251*/    OPC_CheckType, /*MVT::v4i32*/60, 
/*  7253*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7254*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7256*/    OPC_EmitMergeInputChains1_0,
/*  7257*/    OPC_EmitInteger32, 0, 
/*  7259*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7268*/   /*Scope*/ 21, /*->7290*/
/*  7269*/    OPC_CheckPredicate, 15, // Predicate_sextload
/*  7271*/    OPC_CheckPredicate, 23, // Predicate_sextloadvi32
/*  7273*/    OPC_CheckType, /*MVT::v2i64*/78, 
/*  7275*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7276*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7278*/    OPC_EmitMergeInputChains1_0,
/*  7279*/    OPC_EmitInteger32, 0, 
/*  7281*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7290*/   /*Scope*/ 21, /*->7312*/
/*  7291*/    OPC_CheckPredicate, 16, // Predicate_zextload
/*  7293*/    OPC_CheckPredicate, 23, // Predicate_zextloadvi32
/*  7295*/    OPC_CheckType, /*MVT::v2i64*/78, 
/*  7297*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7298*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7300*/    OPC_EmitMergeInputChains1_0,
/*  7301*/    OPC_EmitInteger32, 0, 
/*  7303*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7312*/   /*Scope*/ 21, /*->7334*/
/*  7313*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  7315*/    OPC_CheckPredicate, 23, // Predicate_extloadvi32
/*  7317*/    OPC_CheckType, /*MVT::v2i64*/78, 
/*  7319*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7320*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7322*/    OPC_EmitMergeInputChains1_0,
/*  7323*/    OPC_EmitInteger32, 0, 
/*  7325*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7334*/   /*Scope*/ 56, /*->7391*/
/*  7335*/    OPC_CheckPredicate6,  // Predicate_load
/*  7336*/    OPC_SwitchType /*3 cases */, 15, /*MVT::v4f32*/110, // ->7354
/*  7339*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7340*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7342*/     OPC_EmitMergeInputChains1_0,
/*  7343*/     OPC_EmitInteger32, 0, 
/*  7345*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4f32*/110, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v4f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7354*/    /*SwitchType*/ 16, /*MVT::v2f64*/0|128,1/*128*/, // ->7373
/*  7357*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7358*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7360*/     OPC_EmitMergeInputChains1_0,
/*  7361*/     OPC_EmitInteger32, 0, 
/*  7363*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2f64*/0|128,1/*128*/, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v2f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7373*/    /*SwitchType*/ 15, /*MVT::v8f16*/92, // ->7390
/*  7375*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7376*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7378*/     OPC_EmitMergeInputChains1_0,
/*  7379*/     OPC_EmitInteger32, 0, 
/*  7381*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v8f16*/92, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v8f16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v8f16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7390*/    0, // EndSwitchType
/*  7391*/   /*Scope*/ 30, /*->7422*/
/*  7392*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  7394*/    OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/*  7397*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7398*/    OPC_EmitMergeInputChains1_0,
/*  7399*/    OPC_EmitInteger32, 0, 
/*  7401*/    OPC_EmitInteger64, 0, 
/*  7403*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v16i8*/39, 3/*#Ops*/, 2, 3, 1,  // Results = #4
/*  7412*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::promote_low_F64x2),
                  /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 4,  // Results = #5
/*  7419*/    OPC_CompleteMatch, 1, 5, 
               // Src: (ld:{ *:[v2f64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>> - Complexity = 4
               // Dst: (promote_low_F64x2:{ *:[v2f64] } (LOAD_ZERO_64_A64:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr))
/*  7422*/   0, /*End of Scope*/
/*  7423*/  0, /*End of Scope*/
/*  7424*/ /*SwitchOpcode*/ 31|128,1/*159*/, TARGET_VAL(ISD::ATOMIC_LOAD),// ->7587
/*  7428*/  OPC_RecordMemRef,
/*  7429*/  OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  7430*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  7431*/  OPC_Scope, 76, /*->7509*/ // 2 children in Scope
/*  7433*/   OPC_CheckChild1TypeI32,
/*  7434*/   OPC_SwitchType /*2 cases */, 53, /*MVT::i32*/7, // ->7490
/*  7437*/    OPC_Scope, 16, /*->7455*/ // 3 children in Scope
/*  7439*/     OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  7440*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  7441*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7443*/     OPC_EmitMergeInputChains1_0,
/*  7444*/     OPC_EmitInteger32, 0, 
/*  7446*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_32>> - Complexity = 13
               // Dst: (ATOMIC_LOAD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7455*/    /*Scope*/ 16, /*->7472*/
/*  7456*/     OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  7457*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  7458*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7460*/     OPC_EmitMergeInputChains1_0,
/*  7461*/     OPC_EmitInteger32, 0, 
/*  7463*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>> - Complexity = 13
               // Dst: (ATOMIC_LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7472*/    /*Scope*/ 16, /*->7489*/
/*  7473*/     OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  7474*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  7475*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7477*/     OPC_EmitMergeInputChains1_0,
/*  7478*/     OPC_EmitInteger32, 0, 
/*  7480*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>> - Complexity = 13
               // Dst: (ATOMIC_LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7489*/    0, /*End of Scope*/
/*  7490*/   /*SwitchType*/ 16, /*MVT::i64*/8, // ->7508
/*  7492*/    OPC_CheckPredicate7,  // Predicate_atomic_load_64
/*  7493*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  7494*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7496*/    OPC_EmitMergeInputChains1_0,
/*  7497*/    OPC_EmitInteger32, 0, 
/*  7499*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
              // Src: (atomic_load:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_64>> - Complexity = 13
              // Dst: (ATOMIC_LOAD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7508*/   0, // EndSwitchType
/*  7509*/  /*Scope*/ 76, /*->7586*/
/*  7510*/   OPC_CheckChild1TypeI64,
/*  7511*/   OPC_SwitchType /*2 cases */, 53, /*MVT::i32*/7, // ->7567
/*  7514*/    OPC_Scope, 16, /*->7532*/ // 3 children in Scope
/*  7516*/     OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  7517*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7518*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7520*/     OPC_EmitMergeInputChains1_0,
/*  7521*/     OPC_EmitInteger32, 0, 
/*  7523*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_32>> - Complexity = 13
               // Dst: (ATOMIC_LOAD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7532*/    /*Scope*/ 16, /*->7549*/
/*  7533*/     OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  7534*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7535*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7537*/     OPC_EmitMergeInputChains1_0,
/*  7538*/     OPC_EmitInteger32, 0, 
/*  7540*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_8>> - Complexity = 13
               // Dst: (ATOMIC_LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7549*/    /*Scope*/ 16, /*->7566*/
/*  7550*/     OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  7551*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7552*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7554*/     OPC_EmitMergeInputChains1_0,
/*  7555*/     OPC_EmitInteger32, 0, 
/*  7557*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_16>> - Complexity = 13
               // Dst: (ATOMIC_LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7566*/    0, /*End of Scope*/
/*  7567*/   /*SwitchType*/ 16, /*MVT::i64*/8, // ->7585
/*  7569*/    OPC_CheckPredicate7,  // Predicate_atomic_load_64
/*  7570*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7571*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7573*/    OPC_EmitMergeInputChains1_0,
/*  7574*/    OPC_EmitInteger32, 0, 
/*  7576*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
              // Src: (atomic_load:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_64>> - Complexity = 13
              // Dst: (ATOMIC_LOAD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7585*/   0, // EndSwitchType
/*  7586*/  0, /*End of Scope*/
/*  7587*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->7832
/*  7591*/  OPC_RecordMemRef,
/*  7592*/  OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  7593*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  7594*/  OPC_Scope, 117, /*->7713*/ // 2 children in Scope
/*  7596*/   OPC_CheckChild1TypeI32,
/*  7597*/   OPC_RecordChild2, // #2 = $val
/*  7598*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->7693
/*  7601*/    OPC_Scope, 17, /*->7620*/ // 5 children in Scope
/*  7603*/     OPC_CheckPredicate3,  // Predicate_atomic_load_add_i32
/*  7604*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7605*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7607*/     OPC_EmitMergeInputChains1_0,
/*  7608*/     OPC_EmitInteger32, 0, 
/*  7610*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7620*/    /*Scope*/ 17, /*->7638*/
/*  7621*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  7622*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7623*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7625*/     OPC_EmitMergeInputChains1_0,
/*  7626*/     OPC_EmitInteger32, 0, 
/*  7628*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7638*/    /*Scope*/ 17, /*->7656*/
/*  7639*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  7640*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7641*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7643*/     OPC_EmitMergeInputChains1_0,
/*  7644*/     OPC_EmitInteger32, 0, 
/*  7646*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7656*/    /*Scope*/ 17, /*->7674*/
/*  7657*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  7658*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7659*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7661*/     OPC_EmitMergeInputChains1_0,
/*  7662*/     OPC_EmitInteger32, 0, 
/*  7664*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7674*/    /*Scope*/ 17, /*->7692*/
/*  7675*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  7676*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7677*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7679*/     OPC_EmitMergeInputChains1_0,
/*  7680*/     OPC_EmitInteger32, 0, 
/*  7682*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7692*/    0, /*End of Scope*/
/*  7693*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->7712
/*  7695*/    OPC_CheckPredicate7,  // Predicate_atomic_load_add_i64
/*  7696*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7697*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7699*/    OPC_EmitMergeInputChains1_0,
/*  7700*/    OPC_EmitInteger32, 0, 
/*  7702*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_add:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  7712*/   0, // EndSwitchType
/*  7713*/  /*Scope*/ 117, /*->7831*/
/*  7714*/   OPC_CheckChild1TypeI64,
/*  7715*/   OPC_RecordChild2, // #2 = $val
/*  7716*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->7811
/*  7719*/    OPC_Scope, 17, /*->7738*/ // 5 children in Scope
/*  7721*/     OPC_CheckPredicate3,  // Predicate_atomic_load_add_i32
/*  7722*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7723*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7725*/     OPC_EmitMergeInputChains1_0,
/*  7726*/     OPC_EmitInteger32, 0, 
/*  7728*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7738*/    /*Scope*/ 17, /*->7756*/
/*  7739*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  7740*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7741*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7743*/     OPC_EmitMergeInputChains1_0,
/*  7744*/     OPC_EmitInteger32, 0, 
/*  7746*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7756*/    /*Scope*/ 17, /*->7774*/
/*  7757*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  7758*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7759*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7761*/     OPC_EmitMergeInputChains1_0,
/*  7762*/     OPC_EmitInteger32, 0, 
/*  7764*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7774*/    /*Scope*/ 17, /*->7792*/
/*  7775*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  7776*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7777*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7779*/     OPC_EmitMergeInputChains1_0,
/*  7780*/     OPC_EmitInteger32, 0, 
/*  7782*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7792*/    /*Scope*/ 17, /*->7810*/
/*  7793*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  7794*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7795*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7797*/     OPC_EmitMergeInputChains1_0,
/*  7798*/     OPC_EmitInteger32, 0, 
/*  7800*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7810*/    0, /*End of Scope*/
/*  7811*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->7830
/*  7813*/    OPC_CheckPredicate7,  // Predicate_atomic_load_add_i64
/*  7814*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7815*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7817*/    OPC_EmitMergeInputChains1_0,
/*  7818*/    OPC_EmitInteger32, 0, 
/*  7820*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_add:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  7830*/   0, // EndSwitchType
/*  7831*/  0, /*End of Scope*/
/*  7832*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->8077
/*  7836*/  OPC_RecordMemRef,
/*  7837*/  OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  7838*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  7839*/  OPC_Scope, 117, /*->7958*/ // 2 children in Scope
/*  7841*/   OPC_CheckChild1TypeI32,
/*  7842*/   OPC_RecordChild2, // #2 = $val
/*  7843*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->7938
/*  7846*/    OPC_Scope, 17, /*->7865*/ // 5 children in Scope
/*  7848*/     OPC_CheckPredicate3,  // Predicate_atomic_load_sub_i32
/*  7849*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7850*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7852*/     OPC_EmitMergeInputChains1_0,
/*  7853*/     OPC_EmitInteger32, 0, 
/*  7855*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7865*/    /*Scope*/ 17, /*->7883*/
/*  7866*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  7867*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7868*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7870*/     OPC_EmitMergeInputChains1_0,
/*  7871*/     OPC_EmitInteger32, 0, 
/*  7873*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7883*/    /*Scope*/ 17, /*->7901*/
/*  7884*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  7885*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7886*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7888*/     OPC_EmitMergeInputChains1_0,
/*  7889*/     OPC_EmitInteger32, 0, 
/*  7891*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7901*/    /*Scope*/ 17, /*->7919*/
/*  7902*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  7903*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7904*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7906*/     OPC_EmitMergeInputChains1_0,
/*  7907*/     OPC_EmitInteger32, 0, 
/*  7909*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7919*/    /*Scope*/ 17, /*->7937*/
/*  7920*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  7921*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7922*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7924*/     OPC_EmitMergeInputChains1_0,
/*  7925*/     OPC_EmitInteger32, 0, 
/*  7927*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7937*/    0, /*End of Scope*/
/*  7938*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->7957
/*  7940*/    OPC_CheckPredicate7,  // Predicate_atomic_load_sub_i64
/*  7941*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7942*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7944*/    OPC_EmitMergeInputChains1_0,
/*  7945*/    OPC_EmitInteger32, 0, 
/*  7947*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_sub:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  7957*/   0, // EndSwitchType
/*  7958*/  /*Scope*/ 117, /*->8076*/
/*  7959*/   OPC_CheckChild1TypeI64,
/*  7960*/   OPC_RecordChild2, // #2 = $val
/*  7961*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8056
/*  7964*/    OPC_Scope, 17, /*->7983*/ // 5 children in Scope
/*  7966*/     OPC_CheckPredicate3,  // Predicate_atomic_load_sub_i32
/*  7967*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7968*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7970*/     OPC_EmitMergeInputChains1_0,
/*  7971*/     OPC_EmitInteger32, 0, 
/*  7973*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7983*/    /*Scope*/ 17, /*->8001*/
/*  7984*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  7985*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7986*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7988*/     OPC_EmitMergeInputChains1_0,
/*  7989*/     OPC_EmitInteger32, 0, 
/*  7991*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8001*/    /*Scope*/ 17, /*->8019*/
/*  8002*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  8003*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8004*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8006*/     OPC_EmitMergeInputChains1_0,
/*  8007*/     OPC_EmitInteger32, 0, 
/*  8009*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8019*/    /*Scope*/ 17, /*->8037*/
/*  8020*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  8021*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8022*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8024*/     OPC_EmitMergeInputChains1_0,
/*  8025*/     OPC_EmitInteger32, 0, 
/*  8027*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8037*/    /*Scope*/ 17, /*->8055*/
/*  8038*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  8039*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8040*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8042*/     OPC_EmitMergeInputChains1_0,
/*  8043*/     OPC_EmitInteger32, 0, 
/*  8045*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8055*/    0, /*End of Scope*/
/*  8056*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8075
/*  8058*/    OPC_CheckPredicate7,  // Predicate_atomic_load_sub_i64
/*  8059*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8060*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8062*/    OPC_EmitMergeInputChains1_0,
/*  8063*/    OPC_EmitInteger32, 0, 
/*  8065*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_sub:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8075*/   0, // EndSwitchType
/*  8076*/  0, /*End of Scope*/
/*  8077*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->8322
/*  8081*/  OPC_RecordMemRef,
/*  8082*/  OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  8083*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8084*/  OPC_Scope, 117, /*->8203*/ // 2 children in Scope
/*  8086*/   OPC_CheckChild1TypeI32,
/*  8087*/   OPC_RecordChild2, // #2 = $val
/*  8088*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8183
/*  8091*/    OPC_Scope, 17, /*->8110*/ // 5 children in Scope
/*  8093*/     OPC_CheckPredicate3,  // Predicate_atomic_load_and_i32
/*  8094*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8095*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8097*/     OPC_EmitMergeInputChains1_0,
/*  8098*/     OPC_EmitInteger32, 0, 
/*  8100*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8110*/    /*Scope*/ 17, /*->8128*/
/*  8111*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  8112*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8113*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8115*/     OPC_EmitMergeInputChains1_0,
/*  8116*/     OPC_EmitInteger32, 0, 
/*  8118*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8128*/    /*Scope*/ 17, /*->8146*/
/*  8129*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  8130*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8131*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8133*/     OPC_EmitMergeInputChains1_0,
/*  8134*/     OPC_EmitInteger32, 0, 
/*  8136*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8146*/    /*Scope*/ 17, /*->8164*/
/*  8147*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  8148*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8149*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8151*/     OPC_EmitMergeInputChains1_0,
/*  8152*/     OPC_EmitInteger32, 0, 
/*  8154*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8164*/    /*Scope*/ 17, /*->8182*/
/*  8165*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  8166*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8167*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8169*/     OPC_EmitMergeInputChains1_0,
/*  8170*/     OPC_EmitInteger32, 0, 
/*  8172*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8182*/    0, /*End of Scope*/
/*  8183*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8202
/*  8185*/    OPC_CheckPredicate7,  // Predicate_atomic_load_and_i64
/*  8186*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8187*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8189*/    OPC_EmitMergeInputChains1_0,
/*  8190*/    OPC_EmitInteger32, 0, 
/*  8192*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_and:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8202*/   0, // EndSwitchType
/*  8203*/  /*Scope*/ 117, /*->8321*/
/*  8204*/   OPC_CheckChild1TypeI64,
/*  8205*/   OPC_RecordChild2, // #2 = $val
/*  8206*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8301
/*  8209*/    OPC_Scope, 17, /*->8228*/ // 5 children in Scope
/*  8211*/     OPC_CheckPredicate3,  // Predicate_atomic_load_and_i32
/*  8212*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8213*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8215*/     OPC_EmitMergeInputChains1_0,
/*  8216*/     OPC_EmitInteger32, 0, 
/*  8218*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8228*/    /*Scope*/ 17, /*->8246*/
/*  8229*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  8230*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8231*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8233*/     OPC_EmitMergeInputChains1_0,
/*  8234*/     OPC_EmitInteger32, 0, 
/*  8236*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8246*/    /*Scope*/ 17, /*->8264*/
/*  8247*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  8248*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8249*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8251*/     OPC_EmitMergeInputChains1_0,
/*  8252*/     OPC_EmitInteger32, 0, 
/*  8254*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8264*/    /*Scope*/ 17, /*->8282*/
/*  8265*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  8266*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8267*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8269*/     OPC_EmitMergeInputChains1_0,
/*  8270*/     OPC_EmitInteger32, 0, 
/*  8272*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8282*/    /*Scope*/ 17, /*->8300*/
/*  8283*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  8284*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8285*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8287*/     OPC_EmitMergeInputChains1_0,
/*  8288*/     OPC_EmitInteger32, 0, 
/*  8290*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8300*/    0, /*End of Scope*/
/*  8301*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8320
/*  8303*/    OPC_CheckPredicate7,  // Predicate_atomic_load_and_i64
/*  8304*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8305*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8307*/    OPC_EmitMergeInputChains1_0,
/*  8308*/    OPC_EmitInteger32, 0, 
/*  8310*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_and:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8320*/   0, // EndSwitchType
/*  8321*/  0, /*End of Scope*/
/*  8322*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->8567
/*  8326*/  OPC_RecordMemRef,
/*  8327*/  OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  8328*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8329*/  OPC_Scope, 117, /*->8448*/ // 2 children in Scope
/*  8331*/   OPC_CheckChild1TypeI32,
/*  8332*/   OPC_RecordChild2, // #2 = $val
/*  8333*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8428
/*  8336*/    OPC_Scope, 17, /*->8355*/ // 5 children in Scope
/*  8338*/     OPC_CheckPredicate3,  // Predicate_atomic_load_or_i32
/*  8339*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8340*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8342*/     OPC_EmitMergeInputChains1_0,
/*  8343*/     OPC_EmitInteger32, 0, 
/*  8345*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8355*/    /*Scope*/ 17, /*->8373*/
/*  8356*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  8357*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8358*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8360*/     OPC_EmitMergeInputChains1_0,
/*  8361*/     OPC_EmitInteger32, 0, 
/*  8363*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8373*/    /*Scope*/ 17, /*->8391*/
/*  8374*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  8375*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8376*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8378*/     OPC_EmitMergeInputChains1_0,
/*  8379*/     OPC_EmitInteger32, 0, 
/*  8381*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8391*/    /*Scope*/ 17, /*->8409*/
/*  8392*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  8393*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8394*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8396*/     OPC_EmitMergeInputChains1_0,
/*  8397*/     OPC_EmitInteger32, 0, 
/*  8399*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8409*/    /*Scope*/ 17, /*->8427*/
/*  8410*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  8411*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8412*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8414*/     OPC_EmitMergeInputChains1_0,
/*  8415*/     OPC_EmitInteger32, 0, 
/*  8417*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8427*/    0, /*End of Scope*/
/*  8428*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8447
/*  8430*/    OPC_CheckPredicate7,  // Predicate_atomic_load_or_i64
/*  8431*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8432*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8434*/    OPC_EmitMergeInputChains1_0,
/*  8435*/    OPC_EmitInteger32, 0, 
/*  8437*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_or:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8447*/   0, // EndSwitchType
/*  8448*/  /*Scope*/ 117, /*->8566*/
/*  8449*/   OPC_CheckChild1TypeI64,
/*  8450*/   OPC_RecordChild2, // #2 = $val
/*  8451*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8546
/*  8454*/    OPC_Scope, 17, /*->8473*/ // 5 children in Scope
/*  8456*/     OPC_CheckPredicate3,  // Predicate_atomic_load_or_i32
/*  8457*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8458*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8460*/     OPC_EmitMergeInputChains1_0,
/*  8461*/     OPC_EmitInteger32, 0, 
/*  8463*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8473*/    /*Scope*/ 17, /*->8491*/
/*  8474*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  8475*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8476*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8478*/     OPC_EmitMergeInputChains1_0,
/*  8479*/     OPC_EmitInteger32, 0, 
/*  8481*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8491*/    /*Scope*/ 17, /*->8509*/
/*  8492*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  8493*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8494*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8496*/     OPC_EmitMergeInputChains1_0,
/*  8497*/     OPC_EmitInteger32, 0, 
/*  8499*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8509*/    /*Scope*/ 17, /*->8527*/
/*  8510*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  8511*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8512*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8514*/     OPC_EmitMergeInputChains1_0,
/*  8515*/     OPC_EmitInteger32, 0, 
/*  8517*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8527*/    /*Scope*/ 17, /*->8545*/
/*  8528*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  8529*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8530*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8532*/     OPC_EmitMergeInputChains1_0,
/*  8533*/     OPC_EmitInteger32, 0, 
/*  8535*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8545*/    0, /*End of Scope*/
/*  8546*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8565
/*  8548*/    OPC_CheckPredicate7,  // Predicate_atomic_load_or_i64
/*  8549*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8550*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8552*/    OPC_EmitMergeInputChains1_0,
/*  8553*/    OPC_EmitInteger32, 0, 
/*  8555*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_or:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8565*/   0, // EndSwitchType
/*  8566*/  0, /*End of Scope*/
/*  8567*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->8812
/*  8571*/  OPC_RecordMemRef,
/*  8572*/  OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  8573*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8574*/  OPC_Scope, 117, /*->8693*/ // 2 children in Scope
/*  8576*/   OPC_CheckChild1TypeI32,
/*  8577*/   OPC_RecordChild2, // #2 = $val
/*  8578*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8673
/*  8581*/    OPC_Scope, 17, /*->8600*/ // 5 children in Scope
/*  8583*/     OPC_CheckPredicate3,  // Predicate_atomic_load_xor_i32
/*  8584*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8585*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8587*/     OPC_EmitMergeInputChains1_0,
/*  8588*/     OPC_EmitInteger32, 0, 
/*  8590*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8600*/    /*Scope*/ 17, /*->8618*/
/*  8601*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  8602*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8603*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8605*/     OPC_EmitMergeInputChains1_0,
/*  8606*/     OPC_EmitInteger32, 0, 
/*  8608*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8618*/    /*Scope*/ 17, /*->8636*/
/*  8619*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  8620*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8621*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8623*/     OPC_EmitMergeInputChains1_0,
/*  8624*/     OPC_EmitInteger32, 0, 
/*  8626*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8636*/    /*Scope*/ 17, /*->8654*/
/*  8637*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  8638*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8639*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8641*/     OPC_EmitMergeInputChains1_0,
/*  8642*/     OPC_EmitInteger32, 0, 
/*  8644*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8654*/    /*Scope*/ 17, /*->8672*/
/*  8655*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  8656*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8657*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8659*/     OPC_EmitMergeInputChains1_0,
/*  8660*/     OPC_EmitInteger32, 0, 
/*  8662*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8672*/    0, /*End of Scope*/
/*  8673*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8692
/*  8675*/    OPC_CheckPredicate7,  // Predicate_atomic_load_xor_i64
/*  8676*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8677*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8679*/    OPC_EmitMergeInputChains1_0,
/*  8680*/    OPC_EmitInteger32, 0, 
/*  8682*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_xor:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8692*/   0, // EndSwitchType
/*  8693*/  /*Scope*/ 117, /*->8811*/
/*  8694*/   OPC_CheckChild1TypeI64,
/*  8695*/   OPC_RecordChild2, // #2 = $val
/*  8696*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8791
/*  8699*/    OPC_Scope, 17, /*->8718*/ // 5 children in Scope
/*  8701*/     OPC_CheckPredicate3,  // Predicate_atomic_load_xor_i32
/*  8702*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8703*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8705*/     OPC_EmitMergeInputChains1_0,
/*  8706*/     OPC_EmitInteger32, 0, 
/*  8708*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8718*/    /*Scope*/ 17, /*->8736*/
/*  8719*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  8720*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8721*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8723*/     OPC_EmitMergeInputChains1_0,
/*  8724*/     OPC_EmitInteger32, 0, 
/*  8726*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8736*/    /*Scope*/ 17, /*->8754*/
/*  8737*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  8738*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8739*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8741*/     OPC_EmitMergeInputChains1_0,
/*  8742*/     OPC_EmitInteger32, 0, 
/*  8744*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8754*/    /*Scope*/ 17, /*->8772*/
/*  8755*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  8756*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8757*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8759*/     OPC_EmitMergeInputChains1_0,
/*  8760*/     OPC_EmitInteger32, 0, 
/*  8762*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8772*/    /*Scope*/ 17, /*->8790*/
/*  8773*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  8774*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8775*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8777*/     OPC_EmitMergeInputChains1_0,
/*  8778*/     OPC_EmitInteger32, 0, 
/*  8780*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8790*/    0, /*End of Scope*/
/*  8791*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8810
/*  8793*/    OPC_CheckPredicate7,  // Predicate_atomic_load_xor_i64
/*  8794*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8795*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8797*/    OPC_EmitMergeInputChains1_0,
/*  8798*/    OPC_EmitInteger32, 0, 
/*  8800*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_xor:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8810*/   0, // EndSwitchType
/*  8811*/  0, /*End of Scope*/
/*  8812*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_SWAP),// ->9057
/*  8816*/  OPC_RecordMemRef,
/*  8817*/  OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  8818*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8819*/  OPC_Scope, 117, /*->8938*/ // 2 children in Scope
/*  8821*/   OPC_CheckChild1TypeI32,
/*  8822*/   OPC_RecordChild2, // #2 = $val
/*  8823*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8918
/*  8826*/    OPC_Scope, 17, /*->8845*/ // 5 children in Scope
/*  8828*/     OPC_CheckPredicate3,  // Predicate_atomic_swap_i32
/*  8829*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8830*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8832*/     OPC_EmitMergeInputChains1_0,
/*  8833*/     OPC_EmitInteger32, 0, 
/*  8835*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8845*/    /*Scope*/ 17, /*->8863*/
/*  8846*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  8847*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8848*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8850*/     OPC_EmitMergeInputChains1_0,
/*  8851*/     OPC_EmitInteger32, 0, 
/*  8853*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8863*/    /*Scope*/ 17, /*->8881*/
/*  8864*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  8865*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8866*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8868*/     OPC_EmitMergeInputChains1_0,
/*  8869*/     OPC_EmitInteger32, 0, 
/*  8871*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8881*/    /*Scope*/ 17, /*->8899*/
/*  8882*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  8883*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8884*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8886*/     OPC_EmitMergeInputChains1_0,
/*  8887*/     OPC_EmitInteger32, 0, 
/*  8889*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8899*/    /*Scope*/ 17, /*->8917*/
/*  8900*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  8901*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8902*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8904*/     OPC_EmitMergeInputChains1_0,
/*  8905*/     OPC_EmitInteger32, 0, 
/*  8907*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8917*/    0, /*End of Scope*/
/*  8918*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8937
/*  8920*/    OPC_CheckPredicate7,  // Predicate_atomic_swap_i64
/*  8921*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8922*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8924*/    OPC_EmitMergeInputChains1_0,
/*  8925*/    OPC_EmitInteger32, 0, 
/*  8927*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_swap:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8937*/   0, // EndSwitchType
/*  8938*/  /*Scope*/ 117, /*->9056*/
/*  8939*/   OPC_CheckChild1TypeI64,
/*  8940*/   OPC_RecordChild2, // #2 = $val
/*  8941*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->9036
/*  8944*/    OPC_Scope, 17, /*->8963*/ // 5 children in Scope
/*  8946*/     OPC_CheckPredicate3,  // Predicate_atomic_swap_i32
/*  8947*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8948*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8950*/     OPC_EmitMergeInputChains1_0,
/*  8951*/     OPC_EmitInteger32, 0, 
/*  8953*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8963*/    /*Scope*/ 17, /*->8981*/
/*  8964*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  8965*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8966*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8968*/     OPC_EmitMergeInputChains1_0,
/*  8969*/     OPC_EmitInteger32, 0, 
/*  8971*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8981*/    /*Scope*/ 17, /*->8999*/
/*  8982*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  8983*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8984*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8986*/     OPC_EmitMergeInputChains1_0,
/*  8987*/     OPC_EmitInteger32, 0, 
/*  8989*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8999*/    /*Scope*/ 17, /*->9017*/
/*  9000*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  9001*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9002*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9004*/     OPC_EmitMergeInputChains1_0,
/*  9005*/     OPC_EmitInteger32, 0, 
/*  9007*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9017*/    /*Scope*/ 17, /*->9035*/
/*  9018*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  9019*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9020*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9022*/     OPC_EmitMergeInputChains1_0,
/*  9023*/     OPC_EmitInteger32, 0, 
/*  9025*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9035*/    0, /*End of Scope*/
/*  9036*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->9055
/*  9038*/    OPC_CheckPredicate7,  // Predicate_atomic_swap_i64
/*  9039*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9040*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9042*/    OPC_EmitMergeInputChains1_0,
/*  9043*/    OPC_EmitInteger32, 0, 
/*  9045*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_swap:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  9055*/   0, // EndSwitchType
/*  9056*/  0, /*End of Scope*/
/*  9057*/ /*SwitchOpcode*/ 127|128,1/*255*/, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),// ->9316
/*  9061*/  OPC_RecordMemRef,
/*  9062*/  OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*  9063*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  9064*/  OPC_Scope, 124, /*->9190*/ // 2 children in Scope
/*  9066*/   OPC_CheckChild1TypeI32,
/*  9067*/   OPC_RecordChild2, // #2 = $exp
/*  9068*/   OPC_RecordChild3, // #3 = $new
/*  9069*/   OPC_SwitchType /*2 cases */, 97, /*MVT::i32*/7, // ->9169
/*  9072*/    OPC_Scope, 18, /*->9092*/ // 5 children in Scope
/*  9074*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_i32
/*  9075*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9076*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9078*/     OPC_EmitMergeInputChains1_0,
/*  9079*/     OPC_EmitInteger32, 0, 
/*  9081*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9092*/    /*Scope*/ 18, /*->9111*/
/*  9093*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  9094*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9095*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9097*/     OPC_EmitMergeInputChains1_0,
/*  9098*/     OPC_EmitInteger32, 0, 
/*  9100*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9111*/    /*Scope*/ 18, /*->9130*/
/*  9112*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  9113*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9114*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9116*/     OPC_EmitMergeInputChains1_0,
/*  9117*/     OPC_EmitInteger32, 0, 
/*  9119*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9130*/    /*Scope*/ 18, /*->9149*/
/*  9131*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  9132*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9133*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9135*/     OPC_EmitMergeInputChains1_0,
/*  9136*/     OPC_EmitInteger32, 0, 
/*  9138*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9149*/    /*Scope*/ 18, /*->9168*/
/*  9150*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  9151*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9152*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9154*/     OPC_EmitMergeInputChains1_0,
/*  9155*/     OPC_EmitInteger32, 0, 
/*  9157*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9168*/    0, /*End of Scope*/
/*  9169*/   /*SwitchType*/ 18, /*MVT::i64*/8, // ->9189
/*  9171*/    OPC_CheckPredicate7,  // Predicate_atomic_cmp_swap_i64
/*  9172*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9173*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9175*/    OPC_EmitMergeInputChains1_0,
/*  9176*/    OPC_EmitInteger32, 0, 
/*  9178*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
              // Src: (atomic_cmp_swap:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  9189*/   0, // EndSwitchType
/*  9190*/  /*Scope*/ 124, /*->9315*/
/*  9191*/   OPC_CheckChild1TypeI64,
/*  9192*/   OPC_RecordChild2, // #2 = $exp
/*  9193*/   OPC_RecordChild3, // #3 = $new
/*  9194*/   OPC_SwitchType /*2 cases */, 97, /*MVT::i32*/7, // ->9294
/*  9197*/    OPC_Scope, 18, /*->9217*/ // 5 children in Scope
/*  9199*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_i32
/*  9200*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9201*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9203*/     OPC_EmitMergeInputChains1_0,
/*  9204*/     OPC_EmitInteger32, 0, 
/*  9206*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9217*/    /*Scope*/ 18, /*->9236*/
/*  9218*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  9219*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9220*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9222*/     OPC_EmitMergeInputChains1_0,
/*  9223*/     OPC_EmitInteger32, 0, 
/*  9225*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9236*/    /*Scope*/ 18, /*->9255*/
/*  9237*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  9238*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9239*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9241*/     OPC_EmitMergeInputChains1_0,
/*  9242*/     OPC_EmitInteger32, 0, 
/*  9244*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9255*/    /*Scope*/ 18, /*->9274*/
/*  9256*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  9257*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9258*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9260*/     OPC_EmitMergeInputChains1_0,
/*  9261*/     OPC_EmitInteger32, 0, 
/*  9263*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9274*/    /*Scope*/ 18, /*->9293*/
/*  9275*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  9276*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9277*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9279*/     OPC_EmitMergeInputChains1_0,
/*  9280*/     OPC_EmitInteger32, 0, 
/*  9282*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9293*/    0, /*End of Scope*/
/*  9294*/   /*SwitchType*/ 18, /*MVT::i64*/8, // ->9314
/*  9296*/    OPC_CheckPredicate7,  // Predicate_atomic_cmp_swap_i64
/*  9297*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9298*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9300*/    OPC_EmitMergeInputChains1_0,
/*  9301*/    OPC_EmitInteger32, 0, 
/*  9303*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
              // Src: (atomic_cmp_swap:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  9314*/   0, // EndSwitchType
/*  9315*/  0, /*End of Scope*/
/*  9316*/ /*SwitchOpcode*/ 89, TARGET_VAL(ISD::BRCOND),// ->9408
/*  9319*/  OPC_RecordNode, // #0 = 'brcond' chained node
/*  9320*/  OPC_Scope, 69, /*->9391*/ // 2 children in Scope
/*  9322*/   OPC_MoveChild1,
/*  9323*/   OPC_SwitchOpcode /*2 cases */, 21, TARGET_VAL(ISD::XOR),// ->9348
/*  9327*/    OPC_RecordChild0, // #1 = $cond
/*  9328*/    OPC_MoveChild0,
/*  9329*/    OPC_CheckPredicate, 26, // Predicate_bool_node
/*  9331*/    OPC_MoveParent,
/*  9332*/    OPC_CheckChild1Integer, 2, 
/*  9334*/    OPC_CheckTypeI32,
/*  9335*/    OPC_MoveSibling2,
/*  9336*/    OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9339*/    OPC_RecordNode, // #2 = $dst
/*  9340*/    OPC_MoveParent,
/*  9341*/    OPC_EmitMergeInputChains1_0,
/*  9342*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_UNLESS),
                  2/*#Ops*/, 2, 1, 
              // Src: (brcond (xor:{ *:[i32] } I32:{ *:[i32] }<<P:Predicate_bool_node>>:$cond, 1:{ *:[i32] }), (bb:{ *:[Other] }):$dst) - Complexity = 12
              // Dst: (BR_UNLESS bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/*  9348*/   /*SwitchOpcode*/ 39, TARGET_VAL(ISD::SETCC),// ->9390
/*  9351*/    OPC_RecordChild0, // #1 = $cond
/*  9352*/    OPC_CheckChild0TypeI32,
/*  9353*/    OPC_CheckChild1Integer, 0, 
/*  9355*/    OPC_CheckTypeI32,
/*  9356*/    OPC_Scope, 15, /*->9373*/ // 2 children in Scope
/*  9358*/     OPC_CheckChild2CondCode, ISD::SETNE,
/*  9360*/     OPC_MoveSibling2,
/*  9361*/     OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9364*/     OPC_RecordNode, // #2 = $dst
/*  9365*/     OPC_MoveParent,
/*  9366*/     OPC_EmitMergeInputChains1_0,
/*  9367*/     OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_IF),
                   2/*#Ops*/, 2, 1, 
               // Src: (brcond (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$dst) - Complexity = 11
               // Dst: (BR_IF bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/*  9373*/    /*Scope*/ 15, /*->9389*/
/*  9374*/     OPC_CheckChild2CondCode, ISD::SETEQ,
/*  9376*/     OPC_MoveSibling2,
/*  9377*/     OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9380*/     OPC_RecordNode, // #2 = $dst
/*  9381*/     OPC_MoveParent,
/*  9382*/     OPC_EmitMergeInputChains1_0,
/*  9383*/     OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_UNLESS),
                   2/*#Ops*/, 2, 1, 
               // Src: (brcond (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$dst) - Complexity = 11
               // Dst: (BR_UNLESS bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/*  9389*/    0, /*End of Scope*/
/*  9390*/   0, // EndSwitchOpcode
/*  9391*/  /*Scope*/ 15, /*->9407*/
/*  9392*/   OPC_RecordChild1, // #1 = $cond
/*  9393*/   OPC_CheckChild1TypeI32,
/*  9394*/   OPC_RecordChild2, // #2 = $dst
/*  9395*/   OPC_MoveChild2,
/*  9396*/   OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9399*/   OPC_MoveParent,
/*  9400*/   OPC_EmitMergeInputChains1_0,
/*  9401*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_IF),
                 2/*#Ops*/, 2, 1, 
             // Src: (brcond I32:{ *:[i32] }:$cond, (bb:{ *:[Other] }):$dst) - Complexity = 3
             // Dst: (BR_IF (bb:{ *:[Other] }):$dst, I32:{ *:[i32] }:$cond)
/*  9407*/  0, /*End of Scope*/
/*  9408*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::SHL),// ->9470
/*  9411*/  OPC_RecordChild0, // #0 = $lhs
/*  9412*/  OPC_Scope, 31, /*->9445*/ // 2 children in Scope
/*  9414*/   OPC_MoveChild1,
/*  9415*/   OPC_SwitchType /*2 cases */, 12, /*MVT::i32*/7, // ->9430
/*  9418*/    OPC_CheckAndImm, 31, 
/*  9420*/    OPC_RecordChild0, // #1 = $rhs
/*  9421*/    OPC_MoveParent,
/*  9422*/    OPC_CheckTypeI32,
/*  9423*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9430*/   /*SwitchType*/ 12, /*MVT::i64*/8, // ->9444
/*  9432*/    OPC_CheckAndImm, 63, 
/*  9434*/    OPC_RecordChild0, // #1 = $rhs
/*  9435*/    OPC_MoveParent,
/*  9436*/    OPC_CheckTypeI64,
/*  9437*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9444*/   0, // EndSwitchType
/*  9445*/  /*Scope*/ 23, /*->9469*/
/*  9446*/   OPC_RecordChild1, // #1 = $rhs
/*  9447*/   OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->9458
/*  9450*/    OPC_CheckChild1TypeI32,
/*  9451*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9458*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->9468
/*  9460*/    OPC_CheckChild1TypeI64,
/*  9461*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9468*/   0, // EndSwitchType
/*  9469*/  0, /*End of Scope*/
/*  9470*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::SRA),// ->9532
/*  9473*/  OPC_RecordChild0, // #0 = $lhs
/*  9474*/  OPC_Scope, 31, /*->9507*/ // 2 children in Scope
/*  9476*/   OPC_MoveChild1,
/*  9477*/   OPC_SwitchType /*2 cases */, 12, /*MVT::i32*/7, // ->9492
/*  9480*/    OPC_CheckAndImm, 31, 
/*  9482*/    OPC_RecordChild0, // #1 = $rhs
/*  9483*/    OPC_MoveParent,
/*  9484*/    OPC_CheckTypeI32,
/*  9485*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9492*/   /*SwitchType*/ 12, /*MVT::i64*/8, // ->9506
/*  9494*/    OPC_CheckAndImm, 63, 
/*  9496*/    OPC_RecordChild0, // #1 = $rhs
/*  9497*/    OPC_MoveParent,
/*  9498*/    OPC_CheckTypeI64,
/*  9499*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHR_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9506*/   0, // EndSwitchType
/*  9507*/  /*Scope*/ 23, /*->9531*/
/*  9508*/   OPC_RecordChild1, // #1 = $rhs
/*  9509*/   OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->9520
/*  9512*/    OPC_CheckChild1TypeI32,
/*  9513*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHR_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9520*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->9530
/*  9522*/    OPC_CheckChild1TypeI64,
/*  9523*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHR_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9530*/   0, // EndSwitchType
/*  9531*/  0, /*End of Scope*/
/*  9532*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::SRL),// ->9594
/*  9535*/  OPC_RecordChild0, // #0 = $lhs
/*  9536*/  OPC_Scope, 31, /*->9569*/ // 2 children in Scope
/*  9538*/   OPC_MoveChild1,
/*  9539*/   OPC_SwitchType /*2 cases */, 12, /*MVT::i32*/7, // ->9554
/*  9542*/    OPC_CheckAndImm, 31, 
/*  9544*/    OPC_RecordChild0, // #1 = $rhs
/*  9545*/    OPC_MoveParent,
/*  9546*/    OPC_CheckTypeI32,
/*  9547*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9554*/   /*SwitchType*/ 12, /*MVT::i64*/8, // ->9568
/*  9556*/    OPC_CheckAndImm, 63, 
/*  9558*/    OPC_RecordChild0, // #1 = $rhs
/*  9559*/    OPC_MoveParent,
/*  9560*/    OPC_CheckTypeI64,
/*  9561*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHR_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9568*/   0, // EndSwitchType
/*  9569*/  /*Scope*/ 23, /*->9593*/
/*  9570*/   OPC_RecordChild1, // #1 = $rhs
/*  9571*/   OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->9582
/*  9574*/    OPC_CheckChild1TypeI32,
/*  9575*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHR_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9582*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->9592
/*  9584*/    OPC_CheckChild1TypeI64,
/*  9585*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHR_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9592*/   0, // EndSwitchType
/*  9593*/  0, /*End of Scope*/
/*  9594*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::ROTL),// ->9656
/*  9597*/  OPC_RecordChild0, // #0 = $lhs
/*  9598*/  OPC_Scope, 31, /*->9631*/ // 2 children in Scope
/*  9600*/   OPC_MoveChild1,
/*  9601*/   OPC_SwitchType /*2 cases */, 12, /*MVT::i32*/7, // ->9616
/*  9604*/    OPC_CheckAndImm, 31, 
/*  9606*/    OPC_RecordChild0, // #1 = $rhs
/*  9607*/    OPC_MoveParent,
/*  9608*/    OPC_CheckTypeI32,
/*  9609*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (ROTL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9616*/   /*SwitchType*/ 12, /*MVT::i64*/8, // ->9630
/*  9618*/    OPC_CheckAndImm, 63, 
/*  9620*/    OPC_RecordChild0, // #1 = $rhs
/*  9621*/    OPC_MoveParent,
/*  9622*/    OPC_CheckTypeI64,
/*  9623*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (ROTL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9630*/   0, // EndSwitchType
/*  9631*/  /*Scope*/ 23, /*->9655*/
/*  9632*/   OPC_RecordChild1, // #1 = $rhs
/*  9633*/   OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->9644
/*  9636*/    OPC_CheckChild1TypeI32,
/*  9637*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (ROTL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9644*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->9654
/*  9646*/    OPC_CheckChild1TypeI64,
/*  9647*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (ROTL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9654*/   0, // EndSwitchType
/*  9655*/  0, /*End of Scope*/
/*  9656*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::ROTR),// ->9718
/*  9659*/  OPC_RecordChild0, // #0 = $lhs
/*  9660*/  OPC_Scope, 31, /*->9693*/ // 2 children in Scope
/*  9662*/   OPC_MoveChild1,
/*  9663*/   OPC_SwitchType /*2 cases */, 12, /*MVT::i32*/7, // ->9678
/*  9666*/    OPC_CheckAndImm, 31, 
/*  9668*/    OPC_RecordChild0, // #1 = $rhs
/*  9669*/    OPC_MoveParent,
/*  9670*/    OPC_CheckTypeI32,
/*  9671*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (ROTR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9678*/   /*SwitchType*/ 12, /*MVT::i64*/8, // ->9692
/*  9680*/    OPC_CheckAndImm, 63, 
/*  9682*/    OPC_RecordChild0, // #1 = $rhs
/*  9683*/    OPC_MoveParent,
/*  9684*/    OPC_CheckTypeI64,
/*  9685*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (ROTR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9692*/   0, // EndSwitchType
/*  9693*/  /*Scope*/ 23, /*->9717*/
/*  9694*/   OPC_RecordChild1, // #1 = $rhs
/*  9695*/   OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->9706
/*  9698*/    OPC_CheckChild1TypeI32,
/*  9699*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (ROTR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9706*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->9716
/*  9708*/    OPC_CheckChild1TypeI64,
/*  9709*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (ROTR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9716*/   0, // EndSwitchType
/*  9717*/  0, /*End of Scope*/
/*  9718*/ /*SwitchOpcode*/ 48|128,4/*560*/, TARGET_VAL(ISD::SELECT),// ->10282
/*  9722*/  OPC_Scope, 11|128,1/*139*/, /*->9864*/ // 8 children in Scope
/*  9725*/   OPC_MoveChild0,
/*  9726*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/*  9729*/   OPC_RecordChild0, // #0 = $cond
/*  9730*/   OPC_CheckChild0TypeI32,
/*  9731*/   OPC_CheckChild1Integer, 0, 
/*  9733*/   OPC_CheckTypeI32,
/*  9734*/   OPC_Scope, 63, /*->9799*/ // 2 children in Scope
/*  9736*/    OPC_CheckChild2CondCode, ISD::SETNE,
/*  9738*/    OPC_MoveParent,
/*  9739*/    OPC_RecordChild1, // #1 = $lhs
/*  9740*/    OPC_RecordChild2, // #2 = $rhs
/*  9741*/    OPC_SwitchType /*5 cases */, 8, /*MVT::i32*/7, // ->9752
/*  9744*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I32),
                   /*MVT::i32*/7, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9752*/    /*SwitchType*/ 8, /*MVT::i64*/8, // ->9762
/*  9754*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I64),
                   /*MVT::i64*/8, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9762*/    /*SwitchType*/ 9, /*MVT::funcref*/98|128,1/*226*/, // ->9774
/*  9765*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_FUNCREF),
                   /*MVT::funcref*/98|128,1/*226*/, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[funcref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9774*/    /*SwitchType*/ 9, /*MVT::externref*/99|128,1/*227*/, // ->9786
/*  9777*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXTERNREF),
                   /*MVT::externref*/99|128,1/*227*/, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[externref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9786*/    /*SwitchType*/ 9, /*MVT::exnref*/100|128,1/*228*/, // ->9798
/*  9789*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXNREF),
                   /*MVT::exnref*/100|128,1/*228*/, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[exnref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXNREF:{ *:[exnref] } EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9798*/    0, // EndSwitchType
/*  9799*/   /*Scope*/ 63, /*->9863*/
/*  9800*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/*  9802*/    OPC_MoveParent,
/*  9803*/    OPC_RecordChild1, // #1 = $lhs
/*  9804*/    OPC_RecordChild2, // #2 = $rhs
/*  9805*/    OPC_SwitchType /*5 cases */, 8, /*MVT::i32*/7, // ->9816
/*  9808*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I32),
                   /*MVT::i32*/7, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9816*/    /*SwitchType*/ 8, /*MVT::i64*/8, // ->9826
/*  9818*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I64),
                   /*MVT::i64*/8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$rhs, I64:{ *:[i64] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9826*/    /*SwitchType*/ 9, /*MVT::funcref*/98|128,1/*226*/, // ->9838
/*  9829*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_FUNCREF),
                   /*MVT::funcref*/98|128,1/*226*/, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[funcref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$rhs, FUNCREF:{ *:[funcref] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9838*/    /*SwitchType*/ 9, /*MVT::externref*/99|128,1/*227*/, // ->9850
/*  9841*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXTERNREF),
                   /*MVT::externref*/99|128,1/*227*/, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[externref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$rhs, EXTERNREF:{ *:[externref] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9850*/    /*SwitchType*/ 9, /*MVT::exnref*/100|128,1/*228*/, // ->9862
/*  9853*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXNREF),
                   /*MVT::exnref*/100|128,1/*228*/, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[exnref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXNREF:{ *:[exnref] } EXNREF:{ *:[exnref] }:$rhs, EXNREF:{ *:[exnref] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9862*/    0, // EndSwitchType
/*  9863*/   0, /*End of Scope*/
/*  9864*/  /*Scope*/ 65, /*->9930*/
/*  9865*/   OPC_RecordChild0, // #0 = $cond
/*  9866*/   OPC_CheckChild0TypeI32,
/*  9867*/   OPC_RecordChild1, // #1 = $lhs
/*  9868*/   OPC_RecordChild2, // #2 = $rhs
/*  9869*/   OPC_SwitchType /*5 cases */, 8, /*MVT::i32*/7, // ->9880
/*  9872*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I32),
                  /*MVT::i32*/7, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[i32] } I32:{ *:[i32] }:$cond, I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9880*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->9890
/*  9882*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I64),
                  /*MVT::i64*/8, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[i64] } I32:{ *:[i32] }:$cond, I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9890*/   /*SwitchType*/ 10, /*MVT::funcref*/98|128,1/*226*/, // ->9903
/*  9893*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  9894*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_FUNCREF),
                  /*MVT::funcref*/98|128,1/*226*/, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[funcref] } I32:{ *:[i32] }:$cond, FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 3
              // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9903*/   /*SwitchType*/ 10, /*MVT::externref*/99|128,1/*227*/, // ->9916
/*  9906*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  9907*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXTERNREF),
                  /*MVT::externref*/99|128,1/*227*/, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[externref] } I32:{ *:[i32] }:$cond, EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 3
              // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9916*/   /*SwitchType*/ 10, /*MVT::exnref*/100|128,1/*228*/, // ->9929
/*  9919*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  9920*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXNREF),
                  /*MVT::exnref*/100|128,1/*228*/, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[exnref] } I32:{ *:[i32] }:$cond, EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs) - Complexity = 3
              // Dst: (SELECT_EXNREF:{ *:[exnref] } EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9929*/   0, // EndSwitchType
/*  9930*/  /*Scope*/ 67, /*->9998*/
/*  9931*/   OPC_MoveChild0,
/*  9932*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/*  9935*/   OPC_RecordChild0, // #0 = $cond
/*  9936*/   OPC_CheckChild0TypeI32,
/*  9937*/   OPC_CheckChild1Integer, 0, 
/*  9939*/   OPC_CheckTypeI32,
/*  9940*/   OPC_Scope, 27, /*->9969*/ // 2 children in Scope
/*  9942*/    OPC_CheckChild2CondCode, ISD::SETNE,
/*  9944*/    OPC_MoveParent,
/*  9945*/    OPC_RecordChild1, // #1 = $lhs
/*  9946*/    OPC_RecordChild2, // #2 = $rhs
/*  9947*/    OPC_SwitchType /*2 cases */, 8, /*MVT::f32*/12, // ->9958
/*  9950*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F32),
                   /*MVT::f32*/12, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9958*/    /*SwitchType*/ 8, /*MVT::f64*/13, // ->9968
/*  9960*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F64),
                   /*MVT::f64*/13, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9968*/    0, // EndSwitchType
/*  9969*/   /*Scope*/ 27, /*->9997*/
/*  9970*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/*  9972*/    OPC_MoveParent,
/*  9973*/    OPC_RecordChild1, // #1 = $lhs
/*  9974*/    OPC_RecordChild2, // #2 = $rhs
/*  9975*/    OPC_SwitchType /*2 cases */, 8, /*MVT::f32*/12, // ->9986
/*  9978*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F32),
                   /*MVT::f32*/12, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$rhs, F32:{ *:[f32] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9986*/    /*SwitchType*/ 8, /*MVT::f64*/13, // ->9996
/*  9988*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F64),
                   /*MVT::f64*/13, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$rhs, F64:{ *:[f64] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9996*/    0, // EndSwitchType
/*  9997*/   0, /*End of Scope*/
/*  9998*/  /*Scope*/ 26, /*->10025*/
/*  9999*/   OPC_RecordChild0, // #0 = $cond
/* 10000*/   OPC_CheckChild0TypeI32,
/* 10001*/   OPC_RecordChild1, // #1 = $lhs
/* 10002*/   OPC_RecordChild2, // #2 = $rhs
/* 10003*/   OPC_SwitchType /*2 cases */, 8, /*MVT::f32*/12, // ->10014
/* 10006*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F32),
                  /*MVT::f32*/12, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[f32] } I32:{ *:[i32] }:$cond, F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, I32:{ *:[i32] }:$cond)
/* 10014*/   /*SwitchType*/ 8, /*MVT::f64*/13, // ->10024
/* 10016*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F64),
                  /*MVT::f64*/13, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[f64] } I32:{ *:[i32] }:$cond, F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, I32:{ *:[i32] }:$cond)
/* 10024*/   0, // EndSwitchType
/* 10025*/  /*Scope*/ 107, /*->10133*/
/* 10026*/   OPC_MoveChild0,
/* 10027*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 10030*/   OPC_RecordChild0, // #0 = $cond
/* 10031*/   OPC_CheckChild0TypeI32,
/* 10032*/   OPC_CheckChild1Integer, 0, 
/* 10034*/   OPC_CheckTypeI32,
/* 10035*/   OPC_Scope, 47, /*->10084*/ // 2 children in Scope
/* 10037*/    OPC_CheckChild2CondCode, ISD::SETNE,
/* 10039*/    OPC_MoveParent,
/* 10040*/    OPC_RecordChild1, // #1 = $lhs
/* 10041*/    OPC_RecordChild2, // #2 = $rhs
/* 10042*/    OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->10053
/* 10045*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v16i8] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10053*/    /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->10063
/* 10055*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v8i16] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10063*/    /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->10073
/* 10065*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v4i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10073*/    /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->10083
/* 10075*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v2i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10083*/    0, // EndSwitchType
/* 10084*/   /*Scope*/ 47, /*->10132*/
/* 10085*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/* 10087*/    OPC_MoveParent,
/* 10088*/    OPC_RecordChild1, // #1 = $lhs
/* 10089*/    OPC_RecordChild2, // #2 = $rhs
/* 10090*/    OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->10101
/* 10093*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v16i8] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$rhs, ?:{ *:[v16i8] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10101*/    /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->10111
/* 10103*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v8i16] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$rhs, ?:{ *:[v8i16] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10111*/    /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->10121
/* 10113*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v4i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$rhs, ?:{ *:[v4i32] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10121*/    /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->10131
/* 10123*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v2i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$rhs, ?:{ *:[v2i64] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10131*/    0, // EndSwitchType
/* 10132*/   0, /*End of Scope*/
/* 10133*/  /*Scope*/ 46, /*->10180*/
/* 10134*/   OPC_RecordChild0, // #0 = $cond
/* 10135*/   OPC_CheckChild0TypeI32,
/* 10136*/   OPC_RecordChild1, // #1 = $lhs
/* 10137*/   OPC_RecordChild2, // #2 = $rhs
/* 10138*/   OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->10149
/* 10141*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  /*MVT::v16i8*/39, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v16i8] } I32:{ *:[i32] }:$cond, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10149*/   /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->10159
/* 10151*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v8i16] } I32:{ *:[i32] }:$cond, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10159*/   /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->10169
/* 10161*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v4i32] } I32:{ *:[i32] }:$cond, V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10169*/   /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->10179
/* 10171*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v2i64] } I32:{ *:[i32] }:$cond, V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10179*/   0, // EndSwitchType
/* 10180*/  /*Scope*/ 71, /*->10252*/
/* 10181*/   OPC_MoveChild0,
/* 10182*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 10185*/   OPC_RecordChild0, // #0 = $cond
/* 10186*/   OPC_CheckChild0TypeI32,
/* 10187*/   OPC_CheckChild1Integer, 0, 
/* 10189*/   OPC_CheckTypeI32,
/* 10190*/   OPC_Scope, 29, /*->10221*/ // 2 children in Scope
/* 10192*/    OPC_CheckChild2CondCode, ISD::SETNE,
/* 10194*/    OPC_MoveParent,
/* 10195*/    OPC_RecordChild1, // #1 = $lhs
/* 10196*/    OPC_RecordChild2, // #2 = $rhs
/* 10197*/    OPC_SwitchType /*2 cases */, 8, /*MVT::v4f32*/110, // ->10208
/* 10200*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v4f32*/110, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v4f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10208*/    /*SwitchType*/ 9, /*MVT::v2f64*/0|128,1/*128*/, // ->10220
/* 10211*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v2f64*/0|128,1/*128*/, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v2f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10220*/    0, // EndSwitchType
/* 10221*/   /*Scope*/ 29, /*->10251*/
/* 10222*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/* 10224*/    OPC_MoveParent,
/* 10225*/    OPC_RecordChild1, // #1 = $lhs
/* 10226*/    OPC_RecordChild2, // #2 = $rhs
/* 10227*/    OPC_SwitchType /*2 cases */, 8, /*MVT::v4f32*/110, // ->10238
/* 10230*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v4f32*/110, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v4f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$rhs, ?:{ *:[v4f32] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10238*/    /*SwitchType*/ 9, /*MVT::v2f64*/0|128,1/*128*/, // ->10250
/* 10241*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v2f64*/0|128,1/*128*/, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v2f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$rhs, ?:{ *:[v2f64] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10250*/    0, // EndSwitchType
/* 10251*/   0, /*End of Scope*/
/* 10252*/  /*Scope*/ 28, /*->10281*/
/* 10253*/   OPC_RecordChild0, // #0 = $cond
/* 10254*/   OPC_CheckChild0TypeI32,
/* 10255*/   OPC_RecordChild1, // #1 = $lhs
/* 10256*/   OPC_RecordChild2, // #2 = $rhs
/* 10257*/   OPC_SwitchType /*2 cases */, 8, /*MVT::v4f32*/110, // ->10268
/* 10260*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  /*MVT::v4f32*/110, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v4f32] } I32:{ *:[i32] }:$cond, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10268*/   /*SwitchType*/ 9, /*MVT::v2f64*/0|128,1/*128*/, // ->10280
/* 10271*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  /*MVT::v2f64*/0|128,1/*128*/, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v2f64] } I32:{ *:[i32] }:$cond, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10280*/   0, // EndSwitchType
/* 10281*/  0, /*End of Scope*/
/* 10282*/ /*SwitchOpcode*/ 1|128,1/*129*/, TARGET_VAL(ISD::SIGN_EXTEND_INREG),// ->10415
/* 10286*/  OPC_Scope, 57, /*->10345*/ // 2 children in Scope
/* 10288*/   OPC_MoveChild0,
/* 10289*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/* 10292*/   OPC_RecordChild0, // #0 = $vec
/* 10293*/   OPC_Scope, 24, /*->10319*/ // 2 children in Scope
/* 10295*/    OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 10297*/    OPC_RecordChild1, // #1 = $idx
/* 10298*/    OPC_MoveChild1,
/* 10299*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10302*/    OPC_CheckPredicate, 18, // Predicate_LaneIdx16
/* 10304*/    OPC_CheckTypeI32,
/* 10305*/    OPC_MoveParent,
/* 10306*/    OPC_MoveSibling1,
/* 10307*/    OPC_CheckValueType, /*MVT::i8*/5, 
/* 10309*/    OPC_MoveParent,
/* 10310*/    OPC_CheckTypeI32,
/* 10311*/    OPC_EmitConvertToTarget1,
/* 10312*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_s),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 2, 
              // Src: (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), i8:{ *:[Other] }) - Complexity = 10
              // Dst: (EXTRACT_LANE_I8x16_s:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/* 10319*/   /*Scope*/ 24, /*->10344*/
/* 10320*/    OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 10322*/    OPC_RecordChild1, // #1 = $idx
/* 10323*/    OPC_MoveChild1,
/* 10324*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10327*/    OPC_CheckPredicate, 13, // Predicate_LaneIdx8
/* 10329*/    OPC_CheckTypeI32,
/* 10330*/    OPC_MoveParent,
/* 10331*/    OPC_MoveSibling1,
/* 10332*/    OPC_CheckValueType, /*MVT::i16*/6, 
/* 10334*/    OPC_MoveParent,
/* 10335*/    OPC_CheckTypeI32,
/* 10336*/    OPC_EmitConvertToTarget1,
/* 10337*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_s),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 2, 
              // Src: (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), i16:{ *:[Other] }) - Complexity = 10
              // Dst: (EXTRACT_LANE_I16x8_s:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 10344*/   0, /*End of Scope*/
/* 10345*/  /*Scope*/ 68, /*->10414*/
/* 10346*/   OPC_RecordChild0, // #0 = $src
/* 10347*/   OPC_MoveChild1,
/* 10348*/   OPC_Scope, 25, /*->10375*/ // 3 children in Scope
/* 10350*/    OPC_CheckValueType, /*MVT::i8*/5, 
/* 10352*/    OPC_MoveParent,
/* 10353*/    OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->10364
/* 10356*/     OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10358*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_EXTEND8_S_I32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i32] } I32:{ *:[i32] }:$src, i8:{ *:[Other] }) - Complexity = 3
               // Dst: (I32_EXTEND8_S_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 10364*/    /*SwitchType*/ 8, /*MVT::i64*/8, // ->10374
/* 10366*/     OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10368*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND8_S_I64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i8:{ *:[Other] }) - Complexity = 3
               // Dst: (I64_EXTEND8_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 10374*/    0, // EndSwitchType
/* 10375*/   /*Scope*/ 25, /*->10401*/
/* 10376*/    OPC_CheckValueType, /*MVT::i16*/6, 
/* 10378*/    OPC_MoveParent,
/* 10379*/    OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->10390
/* 10382*/     OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10384*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_EXTEND16_S_I32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i32] } I32:{ *:[i32] }:$src, i16:{ *:[Other] }) - Complexity = 3
               // Dst: (I32_EXTEND16_S_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 10390*/    /*SwitchType*/ 8, /*MVT::i64*/8, // ->10400
/* 10392*/     OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10394*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND16_S_I64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i16:{ *:[Other] }) - Complexity = 3
               // Dst: (I64_EXTEND16_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 10400*/    0, // EndSwitchType
/* 10401*/   /*Scope*/ 11, /*->10413*/
/* 10402*/    OPC_CheckValueType, /*MVT::i32*/7, 
/* 10404*/    OPC_MoveParent,
/* 10405*/    OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10407*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND32_S_I64),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_EXTEND32_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 10413*/   0, /*End of Scope*/
/* 10414*/  0, /*End of Scope*/
/* 10415*/ /*SwitchOpcode*/ 46|128,1/*174*/, TARGET_VAL(WebAssemblyISD::GLOBAL_GET),// ->10593
/* 10419*/  OPC_RecordMemRef,
/* 10420*/  OPC_RecordNode, // #0 = 'WebAssemblyglobal_get' chained node
/* 10421*/  OPC_MoveChild1,
/* 10422*/  OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10425*/  OPC_RecordChild0, // #1 = $addr
/* 10426*/  OPC_MoveChild0,
/* 10427*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10430*/  OPC_MoveParent,
/* 10431*/  OPC_MoveParent,
/* 10432*/  OPC_SwitchType /*14 cases */, 8, /*MVT::i32*/7, // ->10443
/* 10435*/   OPC_EmitMergeInputChains1_0,
/* 10436*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I32), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::i32*/7, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[i32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10443*/  /*SwitchType*/ 8, /*MVT::i64*/8, // ->10453
/* 10445*/   OPC_EmitMergeInputChains1_0,
/* 10446*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I64), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::i64*/8, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[i64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 10453*/  /*SwitchType*/ 10, /*MVT::funcref*/98|128,1/*226*/, // ->10466
/* 10456*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 10457*/   OPC_EmitMergeInputChains1_0,
/* 10458*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::funcref*/98|128,1/*226*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[funcref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10466*/  /*SwitchType*/ 10, /*MVT::externref*/99|128,1/*227*/, // ->10479
/* 10469*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 10470*/   OPC_EmitMergeInputChains1_0,
/* 10471*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::externref*/99|128,1/*227*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[externref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10479*/  /*SwitchType*/ 11, /*MVT::exnref*/100|128,1/*228*/, // ->10493
/* 10482*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 10484*/   OPC_EmitMergeInputChains1_0,
/* 10485*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::exnref*/100|128,1/*228*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[exnref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_EXNREF:{ *:[exnref] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10493*/  /*SwitchType*/ 8, /*MVT::f32*/12, // ->10503
/* 10495*/   OPC_EmitMergeInputChains1_0,
/* 10496*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_F32), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::f32*/12, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[f32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_F32:{ *:[f32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10503*/  /*SwitchType*/ 8, /*MVT::f64*/13, // ->10513
/* 10505*/   OPC_EmitMergeInputChains1_0,
/* 10506*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_F64), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::f64*/13, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[f64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_F64:{ *:[f64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10513*/  /*SwitchType*/ 9, /*MVT::v2i64*/78, // ->10524
/* 10515*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10516*/   OPC_EmitMergeInputChains1_0,
/* 10517*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::v2i64*/78, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v2i64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v2i64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10524*/  /*SwitchType*/ 9, /*MVT::v4i32*/60, // ->10535
/* 10526*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10527*/   OPC_EmitMergeInputChains1_0,
/* 10528*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::v4i32*/60, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v4i32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v4i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10535*/  /*SwitchType*/ 9, /*MVT::v16i8*/39, // ->10546
/* 10537*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10538*/   OPC_EmitMergeInputChains1_0,
/* 10539*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::v16i8*/39, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v16i8] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v16i8] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10546*/  /*SwitchType*/ 9, /*MVT::v8i16*/50, // ->10557
/* 10548*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10549*/   OPC_EmitMergeInputChains1_0,
/* 10550*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::v8i16*/50, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v8i16] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v8i16] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10557*/  /*SwitchType*/ 9, /*MVT::v8f16*/92, // ->10568
/* 10559*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10560*/   OPC_EmitMergeInputChains1_0,
/* 10561*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::v8f16*/92, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v8f16] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v8f16] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10568*/  /*SwitchType*/ 9, /*MVT::v4f32*/110, // ->10579
/* 10570*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10571*/   OPC_EmitMergeInputChains1_0,
/* 10572*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::v4f32*/110, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v4f32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v4f32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10579*/  /*SwitchType*/ 10, /*MVT::v2f64*/0|128,1/*128*/, // ->10592
/* 10582*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10583*/   OPC_EmitMergeInputChains1_0,
/* 10584*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v2f64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v2f64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10592*/  0, // EndSwitchType
/* 10593*/ /*SwitchOpcode*/ 70|128,2/*326*/, TARGET_VAL(WebAssemblyISD::GLOBAL_SET),// ->10923
/* 10597*/  OPC_RecordMemRef,
/* 10598*/  OPC_RecordNode, // #0 = 'WebAssemblyglobal_set' chained node
/* 10599*/  OPC_RecordChild1, // #1 = $src
/* 10600*/  OPC_Scope, 20, /*->10622*/ // 14 children in Scope
/* 10602*/   OPC_CheckChild1TypeI32,
/* 10603*/   OPC_MoveChild2,
/* 10604*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10607*/   OPC_RecordChild0, // #2 = $addr
/* 10608*/   OPC_MoveChild0,
/* 10609*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10612*/   OPC_MoveParent,
/* 10613*/   OPC_MoveParent,
/* 10614*/   OPC_EmitMergeInputChains1_0,
/* 10615*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_I32), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set i32:{ *:[i32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_I32 (tglobaladdr:{ *:[i32] }):$addr, i32:{ *:[i32] }:$src)
/* 10622*/  /*Scope*/ 20, /*->10643*/
/* 10623*/   OPC_CheckChild1TypeI64,
/* 10624*/   OPC_MoveChild2,
/* 10625*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10628*/   OPC_RecordChild0, // #2 = $addr
/* 10629*/   OPC_MoveChild0,
/* 10630*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10633*/   OPC_MoveParent,
/* 10634*/   OPC_MoveParent,
/* 10635*/   OPC_EmitMergeInputChains1_0,
/* 10636*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_I64), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set i64:{ *:[i64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_I64 (tglobaladdr:{ *:[i64] }):$addr, i64:{ *:[i64] }:$src)
/* 10643*/  /*Scope*/ 21, /*->10665*/
/* 10644*/   OPC_CheckChild1Type, /*MVT::f32*/12, 
/* 10646*/   OPC_MoveChild2,
/* 10647*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10650*/   OPC_RecordChild0, // #2 = $addr
/* 10651*/   OPC_MoveChild0,
/* 10652*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10655*/   OPC_MoveParent,
/* 10656*/   OPC_MoveParent,
/* 10657*/   OPC_EmitMergeInputChains1_0,
/* 10658*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_F32), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set f32:{ *:[f32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_F32 (tglobaladdr:{ *:[i32] }):$addr, f32:{ *:[f32] }:$src)
/* 10665*/  /*Scope*/ 21, /*->10687*/
/* 10666*/   OPC_CheckChild1Type, /*MVT::f64*/13, 
/* 10668*/   OPC_MoveChild2,
/* 10669*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10672*/   OPC_RecordChild0, // #2 = $addr
/* 10673*/   OPC_MoveChild0,
/* 10674*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10677*/   OPC_MoveParent,
/* 10678*/   OPC_MoveParent,
/* 10679*/   OPC_EmitMergeInputChains1_0,
/* 10680*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_F64), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set f64:{ *:[f64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_F64 (tglobaladdr:{ *:[i32] }):$addr, f64:{ *:[f64] }:$src)
/* 10687*/  /*Scope*/ 22, /*->10710*/
/* 10688*/   OPC_CheckChild1Type, /*MVT::v8f16*/92, 
/* 10690*/   OPC_MoveChild2,
/* 10691*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10694*/   OPC_RecordChild0, // #2 = $addr
/* 10695*/   OPC_MoveChild0,
/* 10696*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10699*/   OPC_MoveParent,
/* 10700*/   OPC_MoveParent,
/* 10701*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10702*/   OPC_EmitMergeInputChains1_0,
/* 10703*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v8f16:{ *:[v8f16] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v8f16:{ *:[v8f16] }:$src)
/* 10710*/  /*Scope*/ 22, /*->10733*/
/* 10711*/   OPC_CheckChild1Type, /*MVT::v4f32*/110, 
/* 10713*/   OPC_MoveChild2,
/* 10714*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10717*/   OPC_RecordChild0, // #2 = $addr
/* 10718*/   OPC_MoveChild0,
/* 10719*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10722*/   OPC_MoveParent,
/* 10723*/   OPC_MoveParent,
/* 10724*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10725*/   OPC_EmitMergeInputChains1_0,
/* 10726*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v4f32:{ *:[v4f32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v4f32:{ *:[v4f32] }:$src)
/* 10733*/  /*Scope*/ 23, /*->10757*/
/* 10734*/   OPC_CheckChild1Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 10737*/   OPC_MoveChild2,
/* 10738*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10741*/   OPC_RecordChild0, // #2 = $addr
/* 10742*/   OPC_MoveChild0,
/* 10743*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10746*/   OPC_MoveParent,
/* 10747*/   OPC_MoveParent,
/* 10748*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10749*/   OPC_EmitMergeInputChains1_0,
/* 10750*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v2f64:{ *:[v2f64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v2f64:{ *:[v2f64] }:$src)
/* 10757*/  /*Scope*/ 22, /*->10780*/
/* 10758*/   OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/* 10760*/   OPC_MoveChild2,
/* 10761*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10764*/   OPC_RecordChild0, // #2 = $addr
/* 10765*/   OPC_MoveChild0,
/* 10766*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10769*/   OPC_MoveParent,
/* 10770*/   OPC_MoveParent,
/* 10771*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10772*/   OPC_EmitMergeInputChains1_0,
/* 10773*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v2i64:{ *:[v2i64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v2i64:{ *:[v2i64] }:$src)
/* 10780*/  /*Scope*/ 22, /*->10803*/
/* 10781*/   OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 10783*/   OPC_MoveChild2,
/* 10784*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10787*/   OPC_RecordChild0, // #2 = $addr
/* 10788*/   OPC_MoveChild0,
/* 10789*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10792*/   OPC_MoveParent,
/* 10793*/   OPC_MoveParent,
/* 10794*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10795*/   OPC_EmitMergeInputChains1_0,
/* 10796*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v4i32:{ *:[v4i32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v4i32:{ *:[v4i32] }:$src)
/* 10803*/  /*Scope*/ 22, /*->10826*/
/* 10804*/   OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 10806*/   OPC_MoveChild2,
/* 10807*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10810*/   OPC_RecordChild0, // #2 = $addr
/* 10811*/   OPC_MoveChild0,
/* 10812*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10815*/   OPC_MoveParent,
/* 10816*/   OPC_MoveParent,
/* 10817*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10818*/   OPC_EmitMergeInputChains1_0,
/* 10819*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v16i8:{ *:[v16i8] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v16i8:{ *:[v16i8] }:$src)
/* 10826*/  /*Scope*/ 22, /*->10849*/
/* 10827*/   OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 10829*/   OPC_MoveChild2,
/* 10830*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10833*/   OPC_RecordChild0, // #2 = $addr
/* 10834*/   OPC_MoveChild0,
/* 10835*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10838*/   OPC_MoveParent,
/* 10839*/   OPC_MoveParent,
/* 10840*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10841*/   OPC_EmitMergeInputChains1_0,
/* 10842*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v8i16:{ *:[v8i16] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v8i16:{ *:[v8i16] }:$src)
/* 10849*/  /*Scope*/ 23, /*->10873*/
/* 10850*/   OPC_CheckChild1Type, /*MVT::funcref*/98|128,1/*226*/, 
/* 10853*/   OPC_MoveChild2,
/* 10854*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10857*/   OPC_RecordChild0, // #2 = $addr
/* 10858*/   OPC_MoveChild0,
/* 10859*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10862*/   OPC_MoveParent,
/* 10863*/   OPC_MoveParent,
/* 10864*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 10865*/   OPC_EmitMergeInputChains1_0,
/* 10866*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set funcref:{ *:[funcref] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$addr, funcref:{ *:[funcref] }:$src)
/* 10873*/  /*Scope*/ 23, /*->10897*/
/* 10874*/   OPC_CheckChild1Type, /*MVT::externref*/99|128,1/*227*/, 
/* 10877*/   OPC_MoveChild2,
/* 10878*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10881*/   OPC_RecordChild0, // #2 = $addr
/* 10882*/   OPC_MoveChild0,
/* 10883*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10886*/   OPC_MoveParent,
/* 10887*/   OPC_MoveParent,
/* 10888*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 10889*/   OPC_EmitMergeInputChains1_0,
/* 10890*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set externref:{ *:[externref] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$addr, externref:{ *:[externref] }:$src)
/* 10897*/  /*Scope*/ 24, /*->10922*/
/* 10898*/   OPC_CheckChild1Type, /*MVT::exnref*/100|128,1/*228*/, 
/* 10901*/   OPC_MoveChild2,
/* 10902*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10905*/   OPC_RecordChild0, // #2 = $addr
/* 10906*/   OPC_MoveChild0,
/* 10907*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10910*/   OPC_MoveParent,
/* 10911*/   OPC_MoveParent,
/* 10912*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 10914*/   OPC_EmitMergeInputChains1_0,
/* 10915*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set exnref:{ *:[exnref] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_EXNREF (tglobaladdr:{ *:[i32] }):$addr, exnref:{ *:[exnref] }:$src)
/* 10922*/  0, /*End of Scope*/
/* 10923*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CALLSEQ_START),// ->10947
/* 10926*/  OPC_RecordNode, // #0 = 'WebAssemblycallseq_start' chained node
/* 10927*/  OPC_RecordChild1, // #1 = $amt
/* 10928*/  OPC_MoveChild1,
/* 10929*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 10932*/  OPC_MoveSibling2,
/* 10933*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 10936*/  OPC_RecordNode, // #2 = $amt2
/* 10937*/  OPC_MoveParent,
/* 10938*/  OPC_EmitMergeInputChains1_0,
/* 10939*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADJCALLSTACKDOWN), 0|OPFL_Chain|OPFL_GlueOutput,
                /*MVT::i32*/7, 2/*#Ops*/, 1, 2, 
            // Src: (WebAssemblycallseq_start (timm:{ *:[iPTR] }):$amt, (timm:{ *:[iPTR] }):$amt2) - Complexity = 9
            // Dst: (ADJCALLSTACKDOWN:{ *:[i32] } (timm:{ *:[i32] }):$amt, (timm:{ *:[i32] }):$amt2)
/* 10947*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::CALLSEQ_END),// ->10972
/* 10950*/  OPC_RecordNode, // #0 = 'WebAssemblycallseq_end' chained node
/* 10951*/  OPC_CaptureGlueInput,
/* 10952*/  OPC_RecordChild1, // #1 = $amt
/* 10953*/  OPC_MoveChild1,
/* 10954*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 10957*/  OPC_MoveSibling2,
/* 10958*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 10961*/  OPC_RecordNode, // #2 = $amt2
/* 10962*/  OPC_MoveParent,
/* 10963*/  OPC_EmitMergeInputChains1_0,
/* 10964*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADJCALLSTACKUP), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput,
                /*MVT::i32*/7, 2/*#Ops*/, 1, 2, 
            // Src: (WebAssemblycallseq_end (timm:{ *:[iPTR] }):$amt, (timm:{ *:[iPTR] }):$amt2) - Complexity = 9
            // Dst: (ADJCALLSTACKUP:{ *:[i32] } (timm:{ *:[i32] }):$amt, (timm:{ *:[i32] }):$amt2)
/* 10972*/ /*SwitchOpcode*/ 57, TARGET_VAL(WebAssemblyISD::MEMORY_COPY),// ->11032
/* 10975*/  OPC_RecordNode, // #0 = 'wasm_memcpy' chained node
/* 10976*/  OPC_RecordChild1, // #1 = $src_idx
/* 10977*/  OPC_MoveChild1,
/* 10978*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10981*/  OPC_CheckTypeI32,
/* 10982*/  OPC_MoveSibling2,
/* 10983*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10986*/  OPC_RecordNode, // #2 = $dst_idx
/* 10987*/  OPC_CheckTypeI32,
/* 10988*/  OPC_MoveParent,
/* 10989*/  OPC_RecordChild3, // #3 = $dst
/* 10990*/  OPC_Scope, 19, /*->11011*/ // 2 children in Scope
/* 10992*/   OPC_CheckChild3TypeI32,
/* 10993*/   OPC_RecordChild4, // #4 = $src
/* 10994*/   OPC_CheckChild4TypeI32,
/* 10995*/   OPC_RecordChild5, // #5 = $len
/* 10996*/   OPC_CheckChild5TypeI32,
/* 10997*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemory())
/* 10999*/   OPC_EmitMergeInputChains1_0,
/* 11000*/   OPC_EmitConvertToTarget1,
/* 11001*/   OPC_EmitConvertToTarget2,
/* 11002*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::anonymous_8933MEMORY_COPY_A32),
                 5/*#Ops*/, 6, 7, 3, 4, 5, 
             // Src: (wasm_memcpy (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$src, I32:{ *:[i32] }:$len) - Complexity = 9
             // Dst: (anonymous_8933MEMORY_COPY_A32 (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$src, I32:{ *:[i32] }:$len)
/* 11011*/  /*Scope*/ 19, /*->11031*/
/* 11012*/   OPC_CheckChild3TypeI64,
/* 11013*/   OPC_RecordChild4, // #4 = $src
/* 11014*/   OPC_CheckChild4TypeI64,
/* 11015*/   OPC_RecordChild5, // #5 = $len
/* 11016*/   OPC_CheckChild5TypeI64,
/* 11017*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemory())
/* 11019*/   OPC_EmitMergeInputChains1_0,
/* 11020*/   OPC_EmitConvertToTarget1,
/* 11021*/   OPC_EmitConvertToTarget2,
/* 11022*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::anonymous_8934MEMORY_COPY_A64),
                 5/*#Ops*/, 6, 7, 3, 4, 5, 
             // Src: (wasm_memcpy (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I64:{ *:[i64] }:$dst, I64:{ *:[i64] }:$src, I64:{ *:[i64] }:$len) - Complexity = 9
             // Dst: (anonymous_8934MEMORY_COPY_A64 (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I64:{ *:[i64] }:$dst, I64:{ *:[i64] }:$src, I64:{ *:[i64] }:$len)
/* 11031*/  0, /*End of Scope*/
/* 11032*/ /*SwitchOpcode*/ 60, TARGET_VAL(WebAssemblyISD::TABLE_GET),// ->11095
/* 11035*/  OPC_RecordMemRef,
/* 11036*/  OPC_RecordNode, // #0 = 'WebAssemblyTableGet' chained node
/* 11037*/  OPC_MoveChild1,
/* 11038*/  OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11041*/  OPC_RecordChild0, // #1 = $table
/* 11042*/  OPC_MoveChild0,
/* 11043*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11046*/  OPC_MoveParent,
/* 11047*/  OPC_MoveParent,
/* 11048*/  OPC_RecordChild2, // #2 = $idx
/* 11049*/  OPC_CheckChild2TypeI32,
/* 11050*/  OPC_SwitchType /*3 cases */, 11, /*MVT::funcref*/98|128,1/*226*/, // ->11065
/* 11054*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11055*/   OPC_EmitMergeInputChains1_0,
/* 11056*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::funcref*/98|128,1/*226*/, 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblyTableGet:{ *:[funcref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx) - Complexity = 9
             // Dst: (TABLE_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx)
/* 11065*/  /*SwitchType*/ 11, /*MVT::externref*/99|128,1/*227*/, // ->11079
/* 11068*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11069*/   OPC_EmitMergeInputChains1_0,
/* 11070*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::externref*/99|128,1/*227*/, 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblyTableGet:{ *:[externref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx) - Complexity = 9
             // Dst: (TABLE_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx)
/* 11079*/  /*SwitchType*/ 12, /*MVT::exnref*/100|128,1/*228*/, // ->11094
/* 11082*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 11084*/   OPC_EmitMergeInputChains1_0,
/* 11085*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::exnref*/100|128,1/*228*/, 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblyTableGet:{ *:[exnref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx) - Complexity = 9
             // Dst: (TABLE_GET_EXNREF:{ *:[exnref] } (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx)
/* 11094*/  0, // EndSwitchType
/* 11095*/ /*SwitchOpcode*/ 87, TARGET_VAL(WebAssemblyISD::TABLE_SET),// ->11185
/* 11098*/  OPC_RecordMemRef,
/* 11099*/  OPC_RecordNode, // #0 = 'WebAssemblyTableSet' chained node
/* 11100*/  OPC_Scope, 59, /*->11161*/ // 2 children in Scope
/* 11102*/   OPC_MoveChild1,
/* 11103*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11106*/   OPC_RecordChild0, // #1 = $table
/* 11107*/   OPC_MoveChild0,
/* 11108*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11111*/   OPC_MoveParent,
/* 11112*/   OPC_MoveParent,
/* 11113*/   OPC_RecordChild2, // #2 = $idx
/* 11114*/   OPC_CheckChild2TypeI32,
/* 11115*/   OPC_RecordChild3, // #3 = $src
/* 11116*/   OPC_Scope, 13, /*->11131*/ // 3 children in Scope
/* 11118*/    OPC_CheckChild3Type, /*MVT::funcref*/98|128,1/*226*/, 
/* 11121*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11122*/    OPC_EmitMergeInputChains1_0,
/* 11123*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (WebAssemblyTableSet (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$src) - Complexity = 9
              // Dst: (TABLE_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$src)
/* 11131*/   /*Scope*/ 13, /*->11145*/
/* 11132*/    OPC_CheckChild3Type, /*MVT::externref*/99|128,1/*227*/, 
/* 11135*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11136*/    OPC_EmitMergeInputChains1_0,
/* 11137*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (WebAssemblyTableSet (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx, externref:{ *:[externref] }:$src) - Complexity = 9
              // Dst: (TABLE_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, externref:{ *:[externref] }:$src)
/* 11145*/   /*Scope*/ 14, /*->11160*/
/* 11146*/    OPC_CheckChild3Type, /*MVT::exnref*/100|128,1/*228*/, 
/* 11149*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 11151*/    OPC_EmitMergeInputChains1_0,
/* 11152*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (WebAssemblyTableSet (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx, exnref:{ *:[exnref] }:$src) - Complexity = 9
              // Dst: (TABLE_SET_EXNREF (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, exnref:{ *:[exnref] }:$src)
/* 11160*/   0, /*End of Scope*/
/* 11161*/  /*Scope*/ 22, /*->11184*/
/* 11162*/   OPC_RecordChild1, // #1 = $table
/* 11163*/   OPC_MoveChild1,
/* 11164*/   OPC_CheckOpcode, TARGET_VAL(ISD::MCSymbol),
/* 11167*/   OPC_MoveParent,
/* 11168*/   OPC_RecordChild2, // #2 = $idx
/* 11169*/   OPC_CheckChild2TypeI32,
/* 11170*/   OPC_RecordChild3, // #3 = $r
/* 11171*/   OPC_CheckChild3Type, /*MVT::funcref*/98|128,1/*226*/, 
/* 11174*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11175*/   OPC_EmitMergeInputChains1_0,
/* 11176*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 3/*#Ops*/, 1, 2, 3, 
             // Src: (WebAssemblyTableSet (mcsym:{ *:[iPTR] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$r) - Complexity = 6
             // Dst: (TABLE_SET_FUNCREF (mcsym:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$r)
/* 11184*/  0, /*End of Scope*/
/* 11185*/ /*SwitchOpcode*/ 67|128,10/*1347*/, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),// ->12536
/* 11189*/  OPC_Scope, 49, /*->11240*/ // 41 children in Scope
/* 11191*/   OPC_CheckChild0Integer, 32|128,68|128,1/*25120*/, 
/* 11195*/   OPC_RecordChild1, // #0 = $src
/* 11196*/   OPC_Scope, 20, /*->11218*/ // 2 children in Scope
/* 11198*/    OPC_CheckChild1Type, /*MVT::f32*/12, 
/* 11200*/    OPC_SwitchType /*2 cases */, 6, /*MVT::i32*/7, // ->11209
/* 11203*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_F32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 12560:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_S_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 11209*/    /*SwitchType*/ 6, /*MVT::i64*/8, // ->11217
/* 11211*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_F32),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 12560:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_S_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 11217*/    0, // EndSwitchType
/* 11218*/   /*Scope*/ 20, /*->11239*/
/* 11219*/    OPC_CheckChild1Type, /*MVT::f64*/13, 
/* 11221*/    OPC_SwitchType /*2 cases */, 6, /*MVT::i32*/7, // ->11230
/* 11224*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_F64),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 12560:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_S_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 11230*/    /*SwitchType*/ 6, /*MVT::i64*/8, // ->11238
/* 11232*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_F64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 12560:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_S_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 11238*/    0, // EndSwitchType
/* 11239*/   0, /*End of Scope*/
/* 11240*/  /*Scope*/ 49, /*->11290*/
/* 11241*/   OPC_CheckChild0Integer, 34|128,68|128,1/*25122*/, 
/* 11245*/   OPC_RecordChild1, // #0 = $src
/* 11246*/   OPC_Scope, 20, /*->11268*/ // 2 children in Scope
/* 11248*/    OPC_CheckChild1Type, /*MVT::f32*/12, 
/* 11250*/    OPC_SwitchType /*2 cases */, 6, /*MVT::i32*/7, // ->11259
/* 11253*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_F32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 12561:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_U_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 11259*/    /*SwitchType*/ 6, /*MVT::i64*/8, // ->11267
/* 11261*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_F32),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 12561:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_U_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 11267*/    0, // EndSwitchType
/* 11268*/   /*Scope*/ 20, /*->11289*/
/* 11269*/    OPC_CheckChild1Type, /*MVT::f64*/13, 
/* 11271*/    OPC_SwitchType /*2 cases */, 6, /*MVT::i32*/7, // ->11280
/* 11274*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_F64),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 12561:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_U_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 11280*/    /*SwitchType*/ 6, /*MVT::i64*/8, // ->11288
/* 11282*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_F64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 12561:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_U_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 11288*/    0, // EndSwitchType
/* 11289*/   0, /*End of Scope*/
/* 11290*/  /*Scope*/ 43, /*->11334*/
/* 11291*/   OPC_CheckChild0Integer, 16|128,67|128,1/*24976*/, 
/* 11295*/   OPC_RecordChild1, // #0 = $vec
/* 11296*/   OPC_Scope, 8, /*->11306*/ // 4 children in Scope
/* 11298*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11300*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12488:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 11306*/   /*Scope*/ 8, /*->11315*/
/* 11307*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11309*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12488:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 11315*/   /*Scope*/ 8, /*->11324*/
/* 11316*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 11318*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12488:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 11324*/   /*Scope*/ 8, /*->11333*/
/* 11325*/    OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/* 11327*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12488:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 11333*/   0, /*End of Scope*/
/* 11334*/  /*Scope*/ 47, /*->11382*/
/* 11335*/   OPC_CheckChild0Integer, 14|128,67|128,1/*24974*/, 
/* 11339*/   OPC_RecordChild1, // #0 = $vec
/* 11340*/   OPC_Scope, 9, /*->11351*/ // 4 children in Scope
/* 11342*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11344*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11345*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12487:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I8x16:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 11351*/   /*Scope*/ 9, /*->11361*/
/* 11352*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11354*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11355*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12487:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I16x8:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 11361*/   /*Scope*/ 9, /*->11371*/
/* 11362*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 11364*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11365*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12487:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I32x4:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 11371*/   /*Scope*/ 9, /*->11381*/
/* 11372*/    OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/* 11374*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11375*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12487:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I64x2:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 11381*/   0, /*End of Scope*/
/* 11382*/  /*Scope*/ 47, /*->11430*/
/* 11383*/   OPC_CheckChild0Integer, 20|128,67|128,1/*24980*/, 
/* 11387*/   OPC_RecordChild1, // #0 = $vec
/* 11388*/   OPC_Scope, 9, /*->11399*/ // 4 children in Scope
/* 11390*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11392*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11393*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I8x16),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12490:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I8x16:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 11399*/   /*Scope*/ 9, /*->11409*/
/* 11400*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11402*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11403*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I16x8),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12490:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I16x8:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 11409*/   /*Scope*/ 9, /*->11419*/
/* 11410*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 11412*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11413*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I32x4),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12490:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I32x4:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 11419*/   /*Scope*/ 9, /*->11429*/
/* 11420*/    OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/* 11422*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11423*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I64x2),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12490:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I64x2:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 11429*/   0, /*End of Scope*/
/* 11430*/  /*Scope*/ 11, /*->11442*/
/* 11431*/   OPC_CheckChild0Integer, 74|128,67|128,1/*25034*/, 
/* 11435*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11436*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_NULL_FUNCREF),
                 /*MVT::funcref*/98|128,1/*226*/, 0/*#Ops*/, 
             // Src: (intrinsic_wo_chain:{ *:[funcref] } 12517:{ *:[iPTR] }) - Complexity = 8
             // Dst: (REF_NULL_FUNCREF:{ *:[funcref] })
/* 11442*/  /*Scope*/ 12, /*->11455*/
/* 11443*/   OPC_CheckChild0Integer, 68|128,67|128,1/*25028*/, 
/* 11447*/   OPC_RecordChild1, // #0 = $ref
/* 11448*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11449*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_IS_NULL_FUNCREF),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[i32] } 12514:{ *:[iPTR] }, FUNCREF:{ *:[funcref] }:$ref) - Complexity = 8
             // Dst: (REF_IS_NULL_FUNCREF:{ *:[i32] } FUNCREF:{ *:[funcref] }:$ref)
/* 11455*/  /*Scope*/ 11, /*->11467*/
/* 11456*/   OPC_CheckChild0Integer, 72|128,67|128,1/*25032*/, 
/* 11460*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11461*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_NULL_EXTERNREF),
                 /*MVT::externref*/99|128,1/*227*/, 0/*#Ops*/, 
             // Src: (intrinsic_wo_chain:{ *:[externref] } 12516:{ *:[iPTR] }) - Complexity = 8
             // Dst: (REF_NULL_EXTERNREF:{ *:[externref] })
/* 11467*/  /*Scope*/ 12, /*->11480*/
/* 11468*/   OPC_CheckChild0Integer, 66|128,67|128,1/*25026*/, 
/* 11472*/   OPC_RecordChild1, // #0 = $ref
/* 11473*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11474*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_IS_NULL_EXTERNREF),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[i32] } 12513:{ *:[iPTR] }, EXTERNREF:{ *:[externref] }:$ref) - Complexity = 8
             // Dst: (REF_IS_NULL_EXTERNREF:{ *:[i32] } EXTERNREF:{ *:[externref] }:$ref)
/* 11480*/  /*Scope*/ 11, /*->11492*/
/* 11481*/   OPC_CheckChild0Integer, 70|128,67|128,1/*25030*/, 
/* 11485*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11486*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_NULL_EXNREF),
                 /*MVT::exnref*/100|128,1/*228*/, 0/*#Ops*/, 
             // Src: (intrinsic_wo_chain:{ *:[exnref] } 12515:{ *:[iPTR] }) - Complexity = 8
             // Dst: (REF_NULL_EXNREF:{ *:[exnref] })
/* 11492*/  /*Scope*/ 12, /*->11505*/
/* 11493*/   OPC_CheckChild0Integer, 64|128,67|128,1/*25024*/, 
/* 11497*/   OPC_RecordChild1, // #0 = $ref
/* 11498*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11499*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_IS_NULL_EXNREF),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[i32] } 12512:{ *:[iPTR] }, EXNREF:{ *:[exnref] }:$ref) - Complexity = 8
             // Dst: (REF_IS_NULL_EXNREF:{ *:[i32] } EXNREF:{ *:[exnref] }:$ref)
/* 11505*/  /*Scope*/ 23, /*->11529*/
/* 11506*/   OPC_CheckChild0Integer, 32|128,67|128,1/*24992*/, 
/* 11510*/   OPC_RecordChild1, // #0 = $vec
/* 11511*/   OPC_RecordChild2, // #1 = $idx
/* 11512*/   OPC_MoveChild2,
/* 11513*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11516*/   OPC_CheckPredicate, 13, // Predicate_LaneIdx8
/* 11518*/   OPC_MoveParent,
/* 11519*/   OPC_CheckPatternPredicate, 17, // (Subtarget->hasFP16())
/* 11521*/   OPC_EmitConvertToTarget1,
/* 11522*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_F16x8),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 2, 
             // Src: (intrinsic_wo_chain:{ *:[f32] } 12496:{ *:[iPTR] }, V128:{ *:[v8f16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 12
             // Dst: (EXTRACT_LANE_F16x8:{ *:[f32] } V128:{ *:[v8f16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 11529*/  /*Scope*/ 13, /*->11543*/
/* 11530*/   OPC_CheckChild0Integer, 118|128,67|128,1/*25078*/, 
/* 11534*/   OPC_RecordChild1, // #0 = $src
/* 11535*/   OPC_RecordChild2, // #1 = $mask
/* 11536*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SWIZZLE),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12539:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 8
             // Dst: (SWIZZLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$src, ?:{ *:[v16i8] }:$mask)
/* 11543*/  /*Scope*/ 120, /*->11664*/
/* 11544*/   OPC_CheckChild0Integer, 22|128,67|128,1/*24982*/, 
/* 11548*/   OPC_RecordChild1, // #0 = $v1
/* 11549*/   OPC_SwitchType /*6 cases */, 16, /*MVT::v16i8*/39, // ->11568
/* 11552*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11554*/    OPC_RecordChild2, // #1 = $v2
/* 11555*/    OPC_CheckChild2Type, /*MVT::v16i8*/39, 
/* 11557*/    OPC_RecordChild3, // #2 = $c
/* 11558*/    OPC_CheckChild3Type, /*MVT::v16i8*/39, 
/* 11560*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v16i8*/39, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12491:{ *:[iPTR] }, V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 11568*/   /*SwitchType*/ 16, /*MVT::v8i16*/50, // ->11586
/* 11570*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11572*/    OPC_RecordChild2, // #1 = $v2
/* 11573*/    OPC_CheckChild2Type, /*MVT::v8i16*/50, 
/* 11575*/    OPC_RecordChild3, // #2 = $c
/* 11576*/    OPC_CheckChild3Type, /*MVT::v8i16*/50, 
/* 11578*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12491:{ *:[iPTR] }, V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 11586*/   /*SwitchType*/ 16, /*MVT::v4i32*/60, // ->11604
/* 11588*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 11590*/    OPC_RecordChild2, // #1 = $v2
/* 11591*/    OPC_CheckChild2Type, /*MVT::v4i32*/60, 
/* 11593*/    OPC_RecordChild3, // #2 = $c
/* 11594*/    OPC_CheckChild3Type, /*MVT::v4i32*/60, 
/* 11596*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12491:{ *:[iPTR] }, V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 11604*/   /*SwitchType*/ 16, /*MVT::v2i64*/78, // ->11622
/* 11606*/    OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/* 11608*/    OPC_RecordChild2, // #1 = $v2
/* 11609*/    OPC_CheckChild2Type, /*MVT::v2i64*/78, 
/* 11611*/    OPC_RecordChild3, // #2 = $c
/* 11612*/    OPC_CheckChild3Type, /*MVT::v2i64*/78, 
/* 11614*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2i64] } 12491:{ *:[iPTR] }, V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 11622*/   /*SwitchType*/ 16, /*MVT::v4f32*/110, // ->11640
/* 11624*/    OPC_CheckChild1Type, /*MVT::v4f32*/110, 
/* 11626*/    OPC_RecordChild2, // #1 = $v2
/* 11627*/    OPC_CheckChild2Type, /*MVT::v4f32*/110, 
/* 11629*/    OPC_RecordChild3, // #2 = $c
/* 11630*/    OPC_CheckChild3Type, /*MVT::v4f32*/110, 
/* 11632*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4f32*/110, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12491:{ *:[iPTR] }, V128:{ *:[v4f32] }:$v1, V128:{ *:[v4f32] }:$v2, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v4f32] } ?:{ *:[v4f32] }:$v1, ?:{ *:[v4f32] }:$v2, ?:{ *:[v4f32] }:$c)
/* 11640*/   /*SwitchType*/ 20, /*MVT::v2f64*/0|128,1/*128*/, // ->11663
/* 11643*/    OPC_CheckChild1Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 11646*/    OPC_RecordChild2, // #1 = $v2
/* 11647*/    OPC_CheckChild2Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 11650*/    OPC_RecordChild3, // #2 = $c
/* 11651*/    OPC_CheckChild3Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 11654*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2f64*/0|128,1/*128*/, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12491:{ *:[iPTR] }, V128:{ *:[v2f64] }:$v1, V128:{ *:[v2f64] }:$v2, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v2f64] } ?:{ *:[v2f64] }:$v1, ?:{ *:[v2f64] }:$v2, ?:{ *:[v2f64] }:$c)
/* 11663*/   0, // EndSwitchType
/* 11664*/  /*Scope*/ 37, /*->11702*/
/* 11665*/   OPC_CheckChild0Integer, 114|128,67|128,1/*25074*/, 
/* 11669*/   OPC_RecordChild1, // #0 = $lhs
/* 11670*/   OPC_SwitchType /*2 cases */, 13, /*MVT::v16i8*/39, // ->11686
/* 11673*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11675*/    OPC_RecordChild2, // #1 = $rhs
/* 11676*/    OPC_CheckChild2Type, /*MVT::v16i8*/39, 
/* 11678*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11679*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_S_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12537:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 11686*/   /*SwitchType*/ 13, /*MVT::v8i16*/50, // ->11701
/* 11688*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11690*/    OPC_RecordChild2, // #1 = $rhs
/* 11691*/    OPC_CheckChild2Type, /*MVT::v8i16*/50, 
/* 11693*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11694*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_S_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12537:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11701*/   0, // EndSwitchType
/* 11702*/  /*Scope*/ 37, /*->11740*/
/* 11703*/   OPC_CheckChild0Integer, 116|128,67|128,1/*25076*/, 
/* 11707*/   OPC_RecordChild1, // #0 = $lhs
/* 11708*/   OPC_SwitchType /*2 cases */, 13, /*MVT::v16i8*/39, // ->11724
/* 11711*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11713*/    OPC_RecordChild2, // #1 = $rhs
/* 11714*/    OPC_CheckChild2Type, /*MVT::v16i8*/39, 
/* 11716*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11717*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_U_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12538:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 11724*/   /*SwitchType*/ 13, /*MVT::v8i16*/50, // ->11739
/* 11726*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11728*/    OPC_RecordChild2, // #1 = $rhs
/* 11729*/    OPC_CheckChild2Type, /*MVT::v8i16*/50, 
/* 11731*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11732*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_U_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12538:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11739*/   0, // EndSwitchType
/* 11740*/  /*Scope*/ 37, /*->11778*/
/* 11741*/   OPC_CheckChild0Integer, 18|128,67|128,1/*24978*/, 
/* 11745*/   OPC_RecordChild1, // #0 = $lhs
/* 11746*/   OPC_SwitchType /*2 cases */, 13, /*MVT::v16i8*/39, // ->11762
/* 11749*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11751*/    OPC_RecordChild2, // #1 = $rhs
/* 11752*/    OPC_CheckChild2Type, /*MVT::v16i8*/39, 
/* 11754*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11755*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12489:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
              // Dst: (AVGR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 11762*/   /*SwitchType*/ 13, /*MVT::v8i16*/50, // ->11777
/* 11764*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11766*/    OPC_RecordChild2, // #1 = $rhs
/* 11767*/    OPC_CheckChild2Type, /*MVT::v8i16*/50, 
/* 11769*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11770*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12489:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
              // Dst: (AVGR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11777*/   0, // EndSwitchType
/* 11778*/  /*Scope*/ 14, /*->11793*/
/* 11779*/   OPC_CheckChild0Integer, 26|128,67|128,1/*24986*/, 
/* 11783*/   OPC_RecordChild1, // #0 = $lhs
/* 11784*/   OPC_RecordChild2, // #1 = $rhs
/* 11785*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11786*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DOT),
                 /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12493:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (DOT:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11793*/  /*Scope*/ 37, /*->11831*/
/* 11794*/   OPC_CheckChild0Integer, 54|128,67|128,1/*25014*/, 
/* 11798*/   OPC_RecordChild1, // #0 = $low
/* 11799*/   OPC_SwitchType /*2 cases */, 13, /*MVT::v16i8*/39, // ->11815
/* 11802*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11804*/    OPC_RecordChild2, // #1 = $high
/* 11805*/    OPC_CheckChild2Type, /*MVT::v8i16*/50, 
/* 11807*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11808*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_S_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12507:{ *:[iPTR] }, V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high) - Complexity = 8
              // Dst: (NARROW_S_I8x16:{ *:[v16i8] } V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high)
/* 11815*/   /*SwitchType*/ 13, /*MVT::v8i16*/50, // ->11830
/* 11817*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 11819*/    OPC_RecordChild2, // #1 = $high
/* 11820*/    OPC_CheckChild2Type, /*MVT::v4i32*/60, 
/* 11822*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11823*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_S_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12507:{ *:[iPTR] }, V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high) - Complexity = 8
              // Dst: (NARROW_S_I16x8:{ *:[v8i16] } V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high)
/* 11830*/   0, // EndSwitchType
/* 11831*/  /*Scope*/ 37, /*->11869*/
/* 11832*/   OPC_CheckChild0Integer, 56|128,67|128,1/*25016*/, 
/* 11836*/   OPC_RecordChild1, // #0 = $low
/* 11837*/   OPC_SwitchType /*2 cases */, 13, /*MVT::v16i8*/39, // ->11853
/* 11840*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11842*/    OPC_RecordChild2, // #1 = $high
/* 11843*/    OPC_CheckChild2Type, /*MVT::v8i16*/50, 
/* 11845*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11846*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12508:{ *:[iPTR] }, V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high) - Complexity = 8
              // Dst: (NARROW_U_I8x16:{ *:[v16i8] } V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high)
/* 11853*/   /*SwitchType*/ 13, /*MVT::v8i16*/50, // ->11868
/* 11855*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 11857*/    OPC_RecordChild2, // #1 = $high
/* 11858*/    OPC_CheckChild2Type, /*MVT::v4i32*/60, 
/* 11860*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11861*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12508:{ *:[iPTR] }, V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high) - Complexity = 8
              // Dst: (NARROW_U_I16x8:{ *:[v8i16] } V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high)
/* 11868*/   0, // EndSwitchType
/* 11869*/  /*Scope*/ 29, /*->11899*/
/* 11870*/   OPC_CheckChild0Integer, 28|128,67|128,1/*24988*/, 
/* 11874*/   OPC_RecordChild1, // #0 = $vec
/* 11875*/   OPC_SwitchType /*2 cases */, 9, /*MVT::v8i16*/50, // ->11887
/* 11878*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11880*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11881*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_signed_I16x8),
                  /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12494:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_signed_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 11887*/   /*SwitchType*/ 9, /*MVT::v4i32*/60, // ->11898
/* 11889*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11891*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11892*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_signed_I32x4),
                  /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12494:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_signed_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 11898*/   0, // EndSwitchType
/* 11899*/  /*Scope*/ 29, /*->11929*/
/* 11900*/   OPC_CheckChild0Integer, 30|128,67|128,1/*24990*/, 
/* 11904*/   OPC_RecordChild1, // #0 = $vec
/* 11905*/   OPC_SwitchType /*2 cases */, 9, /*MVT::v8i16*/50, // ->11917
/* 11908*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11910*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11911*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_unsigned_I16x8),
                  /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12495:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_unsigned_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 11917*/   /*SwitchType*/ 9, /*MVT::v4i32*/60, // ->11928
/* 11919*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11921*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11922*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_unsigned_I32x4),
                  /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12495:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_unsigned_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 11928*/   0, // EndSwitchType
/* 11929*/  /*Scope*/ 14, /*->11944*/
/* 11930*/   OPC_CheckChild0Integer, 62|128,67|128,1/*25022*/, 
/* 11934*/   OPC_RecordChild1, // #0 = $lhs
/* 11935*/   OPC_RecordChild2, // #1 = $rhs
/* 11936*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11937*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::Q15MULR_SAT_S_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12511:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (Q15MULR_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11944*/  /*Scope*/ 14, /*->11959*/
/* 11945*/   OPC_CheckChild0Integer, 94|128,67|128,1/*25054*/, 
/* 11949*/   OPC_RecordChild1, // #0 = $src
/* 11950*/   OPC_RecordChild2, // #1 = $mask
/* 11951*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11952*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_SWIZZLE),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12527:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 8
             // Dst: (RELAXED_SWIZZLE:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask)
/* 11959*/  /*Scope*/ 12, /*->11972*/
/* 11960*/   OPC_CheckChild0Integer, 96|128,67|128,1/*25056*/, 
/* 11964*/   OPC_RecordChild1, // #0 = $vec
/* 11965*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11966*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_signed_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12528:{ *:[iPTR] }, V128:{ *:[v4f32] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_signed_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 11972*/  /*Scope*/ 12, /*->11985*/
/* 11973*/   OPC_CheckChild0Integer, 100|128,67|128,1/*25060*/, 
/* 11977*/   OPC_RecordChild1, // #0 = $vec
/* 11978*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11979*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_unsigned_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12530:{ *:[iPTR] }, V128:{ *:[v4f32] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_unsigned_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 11985*/  /*Scope*/ 12, /*->11998*/
/* 11986*/   OPC_CheckChild0Integer, 98|128,67|128,1/*25058*/, 
/* 11990*/   OPC_RecordChild1, // #0 = $vec
/* 11991*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11992*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_signed_zero_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12529:{ *:[iPTR] }, V128:{ *:[v2f64] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_signed_zero_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 11998*/  /*Scope*/ 12, /*->12011*/
/* 11999*/   OPC_CheckChild0Integer, 102|128,67|128,1/*25062*/, 
/* 12003*/   OPC_RecordChild1, // #0 = $vec
/* 12004*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12005*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_unsigned_zero_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12531:{ *:[iPTR] }, V128:{ *:[v2f64] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_unsigned_zero_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 12011*/  /*Scope*/ 83, /*->12095*/
/* 12012*/   OPC_CheckChild0Integer, 82|128,67|128,1/*25042*/, 
/* 12016*/   OPC_RecordChild1, // #0 = $a
/* 12017*/   OPC_SwitchType /*4 cases */, 17, /*MVT::v16i8*/39, // ->12037
/* 12020*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 12022*/    OPC_RecordChild2, // #1 = $b
/* 12023*/    OPC_CheckChild2Type, /*MVT::v16i8*/39, 
/* 12025*/    OPC_RecordChild3, // #2 = $c
/* 12026*/    OPC_CheckChild3Type, /*MVT::v16i8*/39, 
/* 12028*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12029*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I8x16),
                  /*MVT::v16i8*/39, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12521:{ *:[iPTR] }, V128:{ *:[v16i8] }:$a, V128:{ *:[v16i8] }:$b, V128:{ *:[v16i8] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$a, V128:{ *:[v16i8] }:$b, V128:{ *:[v16i8] }:$c)
/* 12037*/   /*SwitchType*/ 17, /*MVT::v8i16*/50, // ->12056
/* 12039*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 12041*/    OPC_RecordChild2, // #1 = $b
/* 12042*/    OPC_CheckChild2Type, /*MVT::v8i16*/50, 
/* 12044*/    OPC_RecordChild3, // #2 = $c
/* 12045*/    OPC_CheckChild3Type, /*MVT::v8i16*/50, 
/* 12047*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12048*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I16x8),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12521:{ *:[iPTR] }, V128:{ *:[v8i16] }:$a, V128:{ *:[v8i16] }:$b, V128:{ *:[v8i16] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$a, V128:{ *:[v8i16] }:$b, V128:{ *:[v8i16] }:$c)
/* 12056*/   /*SwitchType*/ 17, /*MVT::v4i32*/60, // ->12075
/* 12058*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 12060*/    OPC_RecordChild2, // #1 = $b
/* 12061*/    OPC_CheckChild2Type, /*MVT::v4i32*/60, 
/* 12063*/    OPC_RecordChild3, // #2 = $c
/* 12064*/    OPC_CheckChild3Type, /*MVT::v4i32*/60, 
/* 12066*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12067*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I32x4),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12521:{ *:[iPTR] }, V128:{ *:[v4i32] }:$a, V128:{ *:[v4i32] }:$b, V128:{ *:[v4i32] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$a, V128:{ *:[v4i32] }:$b, V128:{ *:[v4i32] }:$c)
/* 12075*/   /*SwitchType*/ 17, /*MVT::v2i64*/78, // ->12094
/* 12077*/    OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/* 12079*/    OPC_RecordChild2, // #1 = $b
/* 12080*/    OPC_CheckChild2Type, /*MVT::v2i64*/78, 
/* 12082*/    OPC_RecordChild3, // #2 = $c
/* 12083*/    OPC_CheckChild3Type, /*MVT::v2i64*/78, 
/* 12085*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12086*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I64x2),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2i64] } 12521:{ *:[iPTR] }, V128:{ *:[v2i64] }:$a, V128:{ *:[v2i64] }:$b, V128:{ *:[v2i64] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$a, V128:{ *:[v2i64] }:$b, V128:{ *:[v2i64] }:$c)
/* 12094*/   0, // EndSwitchType
/* 12095*/  /*Scope*/ 14, /*->12110*/
/* 12096*/   OPC_CheckChild0Integer, 92|128,67|128,1/*25052*/, 
/* 12100*/   OPC_RecordChild1, // #0 = $lhs
/* 12101*/   OPC_RecordChild2, // #1 = $rhs
/* 12102*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12103*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_Q15MULR_S_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12526:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (RELAXED_Q15MULR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 12110*/  /*Scope*/ 14, /*->12125*/
/* 12111*/   OPC_CheckChild0Integer, 80|128,67|128,1/*25040*/, 
/* 12115*/   OPC_RecordChild1, // #0 = $lhs
/* 12116*/   OPC_RecordChild2, // #1 = $rhs
/* 12117*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12118*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_DOT),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12520:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
             // Dst: (RELAXED_DOT:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 12125*/  /*Scope*/ 16, /*->12142*/
/* 12126*/   OPC_CheckChild0Integer, 78|128,67|128,1/*25038*/, 
/* 12130*/   OPC_RecordChild1, // #0 = $lhs
/* 12131*/   OPC_RecordChild2, // #1 = $rhs
/* 12132*/   OPC_RecordChild3, // #2 = $acc
/* 12133*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12134*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_DOT_ADD),
                 /*MVT::v4i32*/60, 3/*#Ops*/, 0, 1, 2, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12519:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, V128:{ *:[v4i32] }:$acc) - Complexity = 8
             // Dst: (RELAXED_DOT_ADD:{ *:[v4i32] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, V128:{ *:[v4i32] }:$acc)
/* 12142*/  /*Scope*/ 25, /*->12168*/
/* 12143*/   OPC_CheckChild0Integer, 104|128,67|128,1/*25064*/, 
/* 12147*/   OPC_RecordChild1, // #0 = $vec
/* 12148*/   OPC_RecordChild2, // #1 = $idx
/* 12149*/   OPC_MoveChild2,
/* 12150*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12153*/   OPC_CheckPredicate, 13, // Predicate_LaneIdx8
/* 12155*/   OPC_MoveParent,
/* 12156*/   OPC_RecordChild3, // #2 = $x
/* 12157*/   OPC_CheckPatternPredicate, 17, // (Subtarget->hasFP16())
/* 12159*/   OPC_EmitConvertToTarget1,
/* 12160*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F16x8),
                 /*MVT::v8f16*/92, 3/*#Ops*/, 0, 3, 2, 
             // Src: (intrinsic_wo_chain:{ *:[v8f16] } 12532:{ *:[iPTR] }, V128:{ *:[v8f16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx, F32:{ *:[f32] }:$x) - Complexity = 12
             // Dst: (REPLACE_LANE_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$vec, (imm:{ *:[i32] }):$idx, F32:{ *:[f32] }:$x)
/* 12168*/  /*Scope*/ 13, /*->12182*/
/* 12169*/   OPC_CheckChild0Integer, 110|128,67|128,1/*25070*/, 
/* 12173*/   OPC_RecordChild1, // #0 = $x
/* 12174*/   OPC_CheckPatternPredicate, 17, // (Subtarget->hasFP16())
/* 12176*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v8f16] } 12535:{ *:[iPTR] }, F32:{ *:[f32] }:$x) - Complexity = 8
             // Dst: (SPLAT_F16x8:{ *:[v8f16] } F32:{ *:[f32] }:$x)
/* 12182*/  /*Scope*/ 53, /*->12236*/
/* 12183*/   OPC_CheckChild0Integer, 60|128,67|128,1/*25020*/, 
/* 12187*/   OPC_RecordChild1, // #0 = $lhs
/* 12188*/   OPC_SwitchType /*3 cases */, 12, /*MVT::v4f32*/110, // ->12203
/* 12191*/    OPC_CheckChild1Type, /*MVT::v4f32*/110, 
/* 12193*/    OPC_RecordChild2, // #1 = $rhs
/* 12194*/    OPC_CheckChild2Type, /*MVT::v4f32*/110, 
/* 12196*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                  /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12510:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12203*/   /*SwitchType*/ 15, /*MVT::v2f64*/0|128,1/*128*/, // ->12221
/* 12206*/    OPC_CheckChild1Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 12209*/    OPC_RecordChild2, // #1 = $rhs
/* 12210*/    OPC_CheckChild2Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 12213*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                  /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12510:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12221*/   /*SwitchType*/ 12, /*MVT::v8f16*/92, // ->12235
/* 12223*/    OPC_CheckChild1Type, /*MVT::v8f16*/92, 
/* 12225*/    OPC_RecordChild2, // #1 = $rhs
/* 12226*/    OPC_CheckChild2Type, /*MVT::v8f16*/92, 
/* 12228*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                  /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8f16] } 12510:{ *:[iPTR] }, V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 8
              // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 12235*/   0, // EndSwitchType
/* 12236*/  /*Scope*/ 53, /*->12290*/
/* 12237*/   OPC_CheckChild0Integer, 58|128,67|128,1/*25018*/, 
/* 12241*/   OPC_RecordChild1, // #0 = $lhs
/* 12242*/   OPC_SwitchType /*3 cases */, 12, /*MVT::v4f32*/110, // ->12257
/* 12245*/    OPC_CheckChild1Type, /*MVT::v4f32*/110, 
/* 12247*/    OPC_RecordChild2, // #1 = $rhs
/* 12248*/    OPC_CheckChild2Type, /*MVT::v4f32*/110, 
/* 12250*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                  /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12509:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12257*/   /*SwitchType*/ 15, /*MVT::v2f64*/0|128,1/*128*/, // ->12275
/* 12260*/    OPC_CheckChild1Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 12263*/    OPC_RecordChild2, // #1 = $rhs
/* 12264*/    OPC_CheckChild2Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 12267*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                  /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12509:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12275*/   /*SwitchType*/ 12, /*MVT::v8f16*/92, // ->12289
/* 12277*/    OPC_CheckChild1Type, /*MVT::v8f16*/92, 
/* 12279*/    OPC_RecordChild2, // #1 = $rhs
/* 12280*/    OPC_CheckChild2Type, /*MVT::v8f16*/92, 
/* 12282*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                  /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8f16] } 12509:{ *:[iPTR] }, V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 8
              // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 12289*/   0, // EndSwitchType
/* 12290*/  /*Scope*/ 71, /*->12362*/
/* 12291*/   OPC_CheckChild0Integer, 84|128,67|128,1/*25044*/, 
/* 12295*/   OPC_RecordChild1, // #0 = $a
/* 12296*/   OPC_SwitchType /*3 cases */, 18, /*MVT::v4f32*/110, // ->12317
/* 12299*/    OPC_CheckChild1Type, /*MVT::v4f32*/110, 
/* 12301*/    OPC_RecordChild2, // #1 = $b
/* 12302*/    OPC_CheckChild2Type, /*MVT::v4f32*/110, 
/* 12304*/    OPC_RecordChild3, // #2 = $c
/* 12305*/    OPC_CheckChild3Type, /*MVT::v4f32*/110, 
/* 12307*/    OPC_CheckPatternPredicate, 13, // (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128())
/* 12309*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MADD_F32x4),
                  /*MVT::v4f32*/110, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12522:{ *:[iPTR] }, V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (MADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c)
/* 12317*/   /*SwitchType*/ 22, /*MVT::v2f64*/0|128,1/*128*/, // ->12342
/* 12320*/    OPC_CheckChild1Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 12323*/    OPC_RecordChild2, // #1 = $b
/* 12324*/    OPC_CheckChild2Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 12327*/    OPC_RecordChild3, // #2 = $c
/* 12328*/    OPC_CheckChild3Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 12331*/    OPC_CheckPatternPredicate, 13, // (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128())
/* 12333*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MADD_F64x2),
                  /*MVT::v2f64*/0|128,1/*128*/, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12522:{ *:[iPTR] }, V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (MADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c)
/* 12342*/   /*SwitchType*/ 17, /*MVT::v8f16*/92, // ->12361
/* 12344*/    OPC_CheckChild1Type, /*MVT::v8f16*/92, 
/* 12346*/    OPC_RecordChild2, // #1 = $b
/* 12347*/    OPC_CheckChild2Type, /*MVT::v8f16*/92, 
/* 12349*/    OPC_RecordChild3, // #2 = $c
/* 12350*/    OPC_CheckChild3Type, /*MVT::v8f16*/92, 
/* 12352*/    OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 12353*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MADD_F16x8),
                  /*MVT::v8f16*/92, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8f16] } 12522:{ *:[iPTR] }, V128:{ *:[v8f16] }:$a, V128:{ *:[v8f16] }:$b, V128:{ *:[v8f16] }:$c) - Complexity = 8
              // Dst: (MADD_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$a, V128:{ *:[v8f16] }:$b, V128:{ *:[v8f16] }:$c)
/* 12361*/   0, // EndSwitchType
/* 12362*/  /*Scope*/ 71, /*->12434*/
/* 12363*/   OPC_CheckChild0Integer, 90|128,67|128,1/*25050*/, 
/* 12367*/   OPC_RecordChild1, // #0 = $a
/* 12368*/   OPC_SwitchType /*3 cases */, 18, /*MVT::v4f32*/110, // ->12389
/* 12371*/    OPC_CheckChild1Type, /*MVT::v4f32*/110, 
/* 12373*/    OPC_RecordChild2, // #1 = $b
/* 12374*/    OPC_CheckChild2Type, /*MVT::v4f32*/110, 
/* 12376*/    OPC_RecordChild3, // #2 = $c
/* 12377*/    OPC_CheckChild3Type, /*MVT::v4f32*/110, 
/* 12379*/    OPC_CheckPatternPredicate, 13, // (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128())
/* 12381*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NMADD_F32x4),
                  /*MVT::v4f32*/110, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12525:{ *:[iPTR] }, V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (NMADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c)
/* 12389*/   /*SwitchType*/ 22, /*MVT::v2f64*/0|128,1/*128*/, // ->12414
/* 12392*/    OPC_CheckChild1Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 12395*/    OPC_RecordChild2, // #1 = $b
/* 12396*/    OPC_CheckChild2Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 12399*/    OPC_RecordChild3, // #2 = $c
/* 12400*/    OPC_CheckChild3Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 12403*/    OPC_CheckPatternPredicate, 13, // (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128())
/* 12405*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NMADD_F64x2),
                  /*MVT::v2f64*/0|128,1/*128*/, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12525:{ *:[iPTR] }, V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (NMADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c)
/* 12414*/   /*SwitchType*/ 17, /*MVT::v8f16*/92, // ->12433
/* 12416*/    OPC_CheckChild1Type, /*MVT::v8f16*/92, 
/* 12418*/    OPC_RecordChild2, // #1 = $b
/* 12419*/    OPC_CheckChild2Type, /*MVT::v8f16*/92, 
/* 12421*/    OPC_RecordChild3, // #2 = $c
/* 12422*/    OPC_CheckChild3Type, /*MVT::v8f16*/92, 
/* 12424*/    OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 12425*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NMADD_F16x8),
                  /*MVT::v8f16*/92, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8f16] } 12525:{ *:[iPTR] }, V128:{ *:[v8f16] }:$a, V128:{ *:[v8f16] }:$b, V128:{ *:[v8f16] }:$c) - Complexity = 8
              // Dst: (NMADD_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$a, V128:{ *:[v8f16] }:$b, V128:{ *:[v8f16] }:$c)
/* 12433*/   0, // EndSwitchType
/* 12434*/  /*Scope*/ 41, /*->12476*/
/* 12435*/   OPC_CheckChild0Integer, 88|128,67|128,1/*25048*/, 
/* 12439*/   OPC_RecordChild1, // #0 = $lhs
/* 12440*/   OPC_SwitchType /*2 cases */, 13, /*MVT::v4f32*/110, // ->12456
/* 12443*/    OPC_CheckChild1Type, /*MVT::v4f32*/110, 
/* 12445*/    OPC_RecordChild2, // #1 = $rhs
/* 12446*/    OPC_CheckChild2Type, /*MVT::v4f32*/110, 
/* 12448*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12449*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMIN_F32x4),
                  /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12524:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12456*/   /*SwitchType*/ 16, /*MVT::v2f64*/0|128,1/*128*/, // ->12475
/* 12459*/    OPC_CheckChild1Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 12462*/    OPC_RecordChild2, // #1 = $rhs
/* 12463*/    OPC_CheckChild2Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 12466*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12467*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMIN_F64x2),
                  /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12524:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12475*/   0, // EndSwitchType
/* 12476*/  /*Scope*/ 41, /*->12518*/
/* 12477*/   OPC_CheckChild0Integer, 86|128,67|128,1/*25046*/, 
/* 12481*/   OPC_RecordChild1, // #0 = $lhs
/* 12482*/   OPC_SwitchType /*2 cases */, 13, /*MVT::v4f32*/110, // ->12498
/* 12485*/    OPC_CheckChild1Type, /*MVT::v4f32*/110, 
/* 12487*/    OPC_RecordChild2, // #1 = $rhs
/* 12488*/    OPC_CheckChild2Type, /*MVT::v4f32*/110, 
/* 12490*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12491*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMAX_F32x4),
                  /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12523:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12498*/   /*SwitchType*/ 16, /*MVT::v2f64*/0|128,1/*128*/, // ->12517
/* 12501*/    OPC_CheckChild1Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 12504*/    OPC_RecordChild2, // #1 = $rhs
/* 12505*/    OPC_CheckChild2Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 12508*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12509*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMAX_F64x2),
                  /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12523:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12517*/   0, // EndSwitchType
/* 12518*/  /*Scope*/ 16, /*->12535*/
/* 12519*/   OPC_CheckChild0Integer, 76|128,67|128,1/*25036*/, 
/* 12523*/   OPC_RecordChild1, // #0 = $lhs
/* 12524*/   OPC_RecordChild2, // #1 = $rhs
/* 12525*/   OPC_RecordChild3, // #2 = $acc
/* 12526*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12527*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_DOT_BFLOAT),
                 /*MVT::v4f32*/110, 3/*#Ops*/, 0, 1, 2, 
             // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12518:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, V128:{ *:[v4f32] }:$acc) - Complexity = 8
             // Dst: (RELAXED_DOT_BFLOAT:{ *:[v4f32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, V128:{ *:[v4f32] }:$acc)
/* 12535*/  0, /*End of Scope*/
/* 12536*/ /*SwitchOpcode*/ 4|128,1/*132*/, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),// ->12672
/* 12540*/  OPC_RecordChild0, // #0 = $vec
/* 12541*/  OPC_Scope, 20, /*->12563*/ // 6 children in Scope
/* 12543*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 12545*/   OPC_RecordChild1, // #1 = $idx
/* 12546*/   OPC_MoveChild1,
/* 12547*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12550*/   OPC_CheckPredicate, 18, // Predicate_LaneIdx16
/* 12552*/   OPC_CheckTypeI32,
/* 12553*/   OPC_MoveParent,
/* 12554*/   OPC_CheckTypeI32,
/* 12555*/   OPC_EmitConvertToTarget1,
/* 12556*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_u),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I8x16_u:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12563*/  /*Scope*/ 20, /*->12584*/
/* 12564*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 12566*/   OPC_RecordChild1, // #1 = $idx
/* 12567*/   OPC_MoveChild1,
/* 12568*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12571*/   OPC_CheckPredicate, 13, // Predicate_LaneIdx8
/* 12573*/   OPC_CheckTypeI32,
/* 12574*/   OPC_MoveParent,
/* 12575*/   OPC_CheckTypeI32,
/* 12576*/   OPC_EmitConvertToTarget1,
/* 12577*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_u),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I16x8_u:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12584*/  /*Scope*/ 20, /*->12605*/
/* 12585*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 12587*/   OPC_RecordChild1, // #1 = $idx
/* 12588*/   OPC_MoveChild1,
/* 12589*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12592*/   OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 12594*/   OPC_CheckTypeI32,
/* 12595*/   OPC_MoveParent,
/* 12596*/   OPC_CheckTypeI32,
/* 12597*/   OPC_EmitConvertToTarget1,
/* 12598*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I32x4),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12605*/  /*Scope*/ 20, /*->12626*/
/* 12606*/   OPC_CheckChild0Type, /*MVT::v2i64*/78, 
/* 12608*/   OPC_RecordChild1, // #1 = $idx
/* 12609*/   OPC_MoveChild1,
/* 12610*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12613*/   OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 12615*/   OPC_CheckTypeI32,
/* 12616*/   OPC_MoveParent,
/* 12617*/   OPC_CheckTypeI64,
/* 12618*/   OPC_EmitConvertToTarget1,
/* 12619*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I64x2),
                 /*MVT::i64*/8, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I64x2:{ *:[i64] } ?:{ *:[v2i64] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12626*/  /*Scope*/ 21, /*->12648*/
/* 12627*/   OPC_CheckChild0Type, /*MVT::v4f32*/110, 
/* 12629*/   OPC_RecordChild1, // #1 = $idx
/* 12630*/   OPC_MoveChild1,
/* 12631*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12634*/   OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 12636*/   OPC_CheckTypeI32,
/* 12637*/   OPC_MoveParent,
/* 12638*/   OPC_CheckType, /*MVT::f32*/12, 
/* 12640*/   OPC_EmitConvertToTarget1,
/* 12641*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_F32x4),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_F32x4:{ *:[f32] } ?:{ *:[v4f32] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12648*/  /*Scope*/ 22, /*->12671*/
/* 12649*/   OPC_CheckChild0Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 12652*/   OPC_RecordChild1, // #1 = $idx
/* 12653*/   OPC_MoveChild1,
/* 12654*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12657*/   OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 12659*/   OPC_CheckTypeI32,
/* 12660*/   OPC_MoveParent,
/* 12661*/   OPC_CheckType, /*MVT::f64*/13, 
/* 12663*/   OPC_EmitConvertToTarget1,
/* 12664*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_F64x2),
                 /*MVT::f64*/13, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_F64x2:{ *:[f64] } ?:{ *:[v2f64] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12671*/  0, /*End of Scope*/
/* 12672*/ /*SwitchOpcode*/ 0|128,1/*128*/, TARGET_VAL(WebAssemblyISD::ARGUMENT),// ->12804
/* 12676*/  OPC_RecordChild0, // #0 = $argno
/* 12677*/  OPC_MoveChild0,
/* 12678*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 12681*/  OPC_MoveParent,
/* 12682*/  OPC_SwitchType /*14 cases */, 6, /*MVT::i32*/7, // ->12691
/* 12685*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_i32),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[i32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_i32:{ *:[i32] } (timm:{ *:[i32] }):$argno)
/* 12691*/  /*SwitchType*/ 6, /*MVT::i64*/8, // ->12699
/* 12693*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_i64),
                 /*MVT::i64*/8, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[i64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_i64:{ *:[i64] } (timm:{ *:[i32] }):$argno)
/* 12699*/  /*SwitchType*/ 7, /*MVT::funcref*/98|128,1/*226*/, // ->12709
/* 12702*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_funcref),
                 /*MVT::funcref*/98|128,1/*226*/, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[funcref] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_funcref:{ *:[funcref] } (timm:{ *:[i32] }):$argno)
/* 12709*/  /*SwitchType*/ 7, /*MVT::externref*/99|128,1/*227*/, // ->12719
/* 12712*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_externref),
                 /*MVT::externref*/99|128,1/*227*/, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[externref] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_externref:{ *:[externref] } (timm:{ *:[i32] }):$argno)
/* 12719*/  /*SwitchType*/ 7, /*MVT::exnref*/100|128,1/*228*/, // ->12729
/* 12722*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_exnref),
                 /*MVT::exnref*/100|128,1/*228*/, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[exnref] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_exnref:{ *:[exnref] } (timm:{ *:[i32] }):$argno)
/* 12729*/  /*SwitchType*/ 6, /*MVT::f32*/12, // ->12737
/* 12731*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_f32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[f32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_f32:{ *:[f32] } (timm:{ *:[i32] }):$argno)
/* 12737*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->12745
/* 12739*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_f64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[f64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_f64:{ *:[f64] } (timm:{ *:[i32] }):$argno)
/* 12745*/  /*SwitchType*/ 6, /*MVT::v16i8*/39, // ->12753
/* 12747*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v16i8),
                 /*MVT::v16i8*/39, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v16i8] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v16i8:{ *:[v16i8] } (timm:{ *:[i32] }):$argno)
/* 12753*/  /*SwitchType*/ 6, /*MVT::v8i16*/50, // ->12761
/* 12755*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v8i16),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v8i16] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v8i16:{ *:[v8i16] } (timm:{ *:[i32] }):$argno)
/* 12761*/  /*SwitchType*/ 6, /*MVT::v4i32*/60, // ->12769
/* 12763*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v4i32),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v4i32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v4i32:{ *:[v4i32] } (timm:{ *:[i32] }):$argno)
/* 12769*/  /*SwitchType*/ 6, /*MVT::v2i64*/78, // ->12777
/* 12771*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v2i64),
                 /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v2i64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v2i64:{ *:[v2i64] } (timm:{ *:[i32] }):$argno)
/* 12777*/  /*SwitchType*/ 6, /*MVT::v4f32*/110, // ->12785
/* 12779*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v4f32),
                 /*MVT::v4f32*/110, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v4f32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v4f32:{ *:[v4f32] } (timm:{ *:[i32] }):$argno)
/* 12785*/  /*SwitchType*/ 7, /*MVT::v2f64*/0|128,1/*128*/, // ->12795
/* 12788*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v2f64),
                 /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v2f64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v2f64:{ *:[v2f64] } (timm:{ *:[i32] }):$argno)
/* 12795*/  /*SwitchType*/ 6, /*MVT::v8f16*/92, // ->12803
/* 12797*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v8f16),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v8f16] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v8f16:{ *:[v8f16] } (timm:{ *:[i32] }):$argno)
/* 12803*/  0, // EndSwitchType
/* 12804*/ /*SwitchOpcode*/ 26|128,1/*154*/, TARGET_VAL(WebAssemblyISD::LOCAL_GET),// ->12962
/* 12808*/  OPC_RecordNode, // #0 = 'WebAssemblylocal_get' chained node
/* 12809*/  OPC_RecordChild1, // #1 = $local
/* 12810*/  OPC_MoveChild1,
/* 12811*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 12814*/  OPC_MoveParent,
/* 12815*/  OPC_SwitchType /*14 cases */, 7, /*MVT::i32*/7, // ->12825
/* 12818*/   OPC_EmitMergeInputChains1_0,
/* 12819*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_I32),
                 /*MVT::i32*/7, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[i32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_I32:{ *:[i32] } (timm:{ *:[i32] }):$local)
/* 12825*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->12834
/* 12827*/   OPC_EmitMergeInputChains1_0,
/* 12828*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_I64),
                 /*MVT::i64*/8, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[i64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_I64:{ *:[i64] } (timm:{ *:[i32] }):$local)
/* 12834*/  /*SwitchType*/ 9, /*MVT::funcref*/98|128,1/*226*/, // ->12846
/* 12837*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 12838*/   OPC_EmitMergeInputChains1_0,
/* 12839*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_FUNCREF),
                 /*MVT::funcref*/98|128,1/*226*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[funcref] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_FUNCREF:{ *:[funcref] } (timm:{ *:[i32] }):$local)
/* 12846*/  /*SwitchType*/ 9, /*MVT::externref*/99|128,1/*227*/, // ->12858
/* 12849*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 12850*/   OPC_EmitMergeInputChains1_0,
/* 12851*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_EXTERNREF),
                 /*MVT::externref*/99|128,1/*227*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[externref] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_EXTERNREF:{ *:[externref] } (timm:{ *:[i32] }):$local)
/* 12858*/  /*SwitchType*/ 10, /*MVT::exnref*/100|128,1/*228*/, // ->12871
/* 12861*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 12863*/   OPC_EmitMergeInputChains1_0,
/* 12864*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_EXNREF),
                 /*MVT::exnref*/100|128,1/*228*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[exnref] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_EXNREF:{ *:[exnref] } (timm:{ *:[i32] }):$local)
/* 12871*/  /*SwitchType*/ 7, /*MVT::f32*/12, // ->12880
/* 12873*/   OPC_EmitMergeInputChains1_0,
/* 12874*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[f32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_F32:{ *:[f32] } (timm:{ *:[i32] }):$local)
/* 12880*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->12889
/* 12882*/   OPC_EmitMergeInputChains1_0,
/* 12883*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[f64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_F64:{ *:[f64] } (timm:{ *:[i32] }):$local)
/* 12889*/  /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->12899
/* 12891*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12892*/   OPC_EmitMergeInputChains1_0,
/* 12893*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 /*MVT::v2i64*/78, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v2i64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v2i64] } (timm:{ *:[i32] }):$local)
/* 12899*/  /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->12909
/* 12901*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12902*/   OPC_EmitMergeInputChains1_0,
/* 12903*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v4i32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v4i32] } (timm:{ *:[i32] }):$local)
/* 12909*/  /*SwitchType*/ 8, /*MVT::v16i8*/39, // ->12919
/* 12911*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12912*/   OPC_EmitMergeInputChains1_0,
/* 12913*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 /*MVT::v16i8*/39, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v16i8] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v16i8] } (timm:{ *:[i32] }):$local)
/* 12919*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->12929
/* 12921*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12922*/   OPC_EmitMergeInputChains1_0,
/* 12923*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v8i16] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v8i16] } (timm:{ *:[i32] }):$local)
/* 12929*/  /*SwitchType*/ 8, /*MVT::v8f16*/92, // ->12939
/* 12931*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12932*/   OPC_EmitMergeInputChains1_0,
/* 12933*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v8f16] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v8f16] } (timm:{ *:[i32] }):$local)
/* 12939*/  /*SwitchType*/ 8, /*MVT::v4f32*/110, // ->12949
/* 12941*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12942*/   OPC_EmitMergeInputChains1_0,
/* 12943*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 /*MVT::v4f32*/110, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v4f32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v4f32] } (timm:{ *:[i32] }):$local)
/* 12949*/  /*SwitchType*/ 9, /*MVT::v2f64*/0|128,1/*128*/, // ->12961
/* 12952*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12953*/   OPC_EmitMergeInputChains1_0,
/* 12954*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v2f64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v2f64] } (timm:{ *:[i32] }):$local)
/* 12961*/  0, // EndSwitchType
/* 12962*/ /*SwitchOpcode*/ 35|128,1/*163*/, TARGET_VAL(WebAssemblyISD::LOCAL_SET),// ->13129
/* 12966*/  OPC_RecordNode, // #0 = 'WebAssemblylocal_set' chained node
/* 12967*/  OPC_RecordChild1, // #1 = $local
/* 12968*/  OPC_MoveChild1,
/* 12969*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 12972*/  OPC_MoveParent,
/* 12973*/  OPC_RecordChild2, // #2 = $src
/* 12974*/  OPC_Scope, 8, /*->12984*/ // 14 children in Scope
/* 12976*/   OPC_CheckChild2TypeI32,
/* 12977*/   OPC_EmitMergeInputChains1_0,
/* 12978*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_I32),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, i32:{ *:[i32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_I32 (timm:{ *:[i32] }):$local, i32:{ *:[i32] }:$src)
/* 12984*/  /*Scope*/ 8, /*->12993*/
/* 12985*/   OPC_CheckChild2TypeI64,
/* 12986*/   OPC_EmitMergeInputChains1_0,
/* 12987*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_I64),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, i64:{ *:[i64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_I64 (timm:{ *:[i32] }):$local, i64:{ *:[i64] }:$src)
/* 12993*/  /*Scope*/ 9, /*->13003*/
/* 12994*/   OPC_CheckChild2Type, /*MVT::f32*/12, 
/* 12996*/   OPC_EmitMergeInputChains1_0,
/* 12997*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_F32),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, f32:{ *:[f32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_F32 (timm:{ *:[i32] }):$local, f32:{ *:[f32] }:$src)
/* 13003*/  /*Scope*/ 9, /*->13013*/
/* 13004*/   OPC_CheckChild2Type, /*MVT::f64*/13, 
/* 13006*/   OPC_EmitMergeInputChains1_0,
/* 13007*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_F64),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, f64:{ *:[f64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_F64 (timm:{ *:[i32] }):$local, f64:{ *:[f64] }:$src)
/* 13013*/  /*Scope*/ 10, /*->13024*/
/* 13014*/   OPC_CheckChild2Type, /*MVT::v8f16*/92, 
/* 13016*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13017*/   OPC_EmitMergeInputChains1_0,
/* 13018*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v8f16:{ *:[v8f16] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v8f16:{ *:[v8f16] }:$src)
/* 13024*/  /*Scope*/ 10, /*->13035*/
/* 13025*/   OPC_CheckChild2Type, /*MVT::v4f32*/110, 
/* 13027*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13028*/   OPC_EmitMergeInputChains1_0,
/* 13029*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v4f32:{ *:[v4f32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v4f32:{ *:[v4f32] }:$src)
/* 13035*/  /*Scope*/ 11, /*->13047*/
/* 13036*/   OPC_CheckChild2Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 13039*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13040*/   OPC_EmitMergeInputChains1_0,
/* 13041*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v2f64:{ *:[v2f64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v2f64:{ *:[v2f64] }:$src)
/* 13047*/  /*Scope*/ 10, /*->13058*/
/* 13048*/   OPC_CheckChild2Type, /*MVT::v2i64*/78, 
/* 13050*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13051*/   OPC_EmitMergeInputChains1_0,
/* 13052*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v2i64:{ *:[v2i64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v2i64:{ *:[v2i64] }:$src)
/* 13058*/  /*Scope*/ 10, /*->13069*/
/* 13059*/   OPC_CheckChild2Type, /*MVT::v4i32*/60, 
/* 13061*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13062*/   OPC_EmitMergeInputChains1_0,
/* 13063*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v4i32:{ *:[v4i32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v4i32:{ *:[v4i32] }:$src)
/* 13069*/  /*Scope*/ 10, /*->13080*/
/* 13070*/   OPC_CheckChild2Type, /*MVT::v16i8*/39, 
/* 13072*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13073*/   OPC_EmitMergeInputChains1_0,
/* 13074*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v16i8:{ *:[v16i8] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v16i8:{ *:[v16i8] }:$src)
/* 13080*/  /*Scope*/ 10, /*->13091*/
/* 13081*/   OPC_CheckChild2Type, /*MVT::v8i16*/50, 
/* 13083*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13084*/   OPC_EmitMergeInputChains1_0,
/* 13085*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v8i16:{ *:[v8i16] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v8i16:{ *:[v8i16] }:$src)
/* 13091*/  /*Scope*/ 11, /*->13103*/
/* 13092*/   OPC_CheckChild2Type, /*MVT::funcref*/98|128,1/*226*/, 
/* 13095*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 13096*/   OPC_EmitMergeInputChains1_0,
/* 13097*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_FUNCREF),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, funcref:{ *:[funcref] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_FUNCREF (timm:{ *:[i32] }):$local, funcref:{ *:[funcref] }:$src)
/* 13103*/  /*Scope*/ 11, /*->13115*/
/* 13104*/   OPC_CheckChild2Type, /*MVT::externref*/99|128,1/*227*/, 
/* 13107*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 13108*/   OPC_EmitMergeInputChains1_0,
/* 13109*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_EXTERNREF),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, externref:{ *:[externref] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_EXTERNREF (timm:{ *:[i32] }):$local, externref:{ *:[externref] }:$src)
/* 13115*/  /*Scope*/ 12, /*->13128*/
/* 13116*/   OPC_CheckChild2Type, /*MVT::exnref*/100|128,1/*228*/, 
/* 13119*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 13121*/   OPC_EmitMergeInputChains1_0,
/* 13122*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_EXNREF),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, exnref:{ *:[exnref] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_EXNREF (timm:{ *:[i32] }):$local, exnref:{ *:[exnref] }:$src)
/* 13128*/  0, /*End of Scope*/
/* 13129*/ /*SwitchOpcode*/ 0|128,1/*128*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->13261
/* 13133*/  OPC_RecordChild0, // #0 = $addr
/* 13134*/  OPC_MoveChild0,
/* 13135*/  OPC_SwitchOpcode /*3 cases */, 47, TARGET_VAL(ISD::TargetGlobalAddress),// ->13186
/* 13139*/   OPC_MoveParent,
/* 13140*/   OPC_SwitchType /*2 cases */, 20, /*MVT::i32*/7, // ->13163
/* 13143*/    OPC_Scope, 8, /*->13153*/ // 2 children in Scope
/* 13145*/     OPC_CheckPatternPredicate, 18, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 13147*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (CONST_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 13153*/    /*Scope*/ 8, /*->13162*/
/* 13154*/     OPC_CheckPatternPredicate, 14, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13156*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 13162*/    0, /*End of Scope*/
/* 13163*/   /*SwitchType*/ 20, /*MVT::i64*/8, // ->13185
/* 13165*/    OPC_Scope, 8, /*->13175*/ // 2 children in Scope
/* 13167*/     OPC_CheckPatternPredicate, 19, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 13169*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (CONST_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 13175*/    /*Scope*/ 8, /*->13184*/
/* 13176*/     OPC_CheckPatternPredicate, 15, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13178*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 13184*/    0, /*End of Scope*/
/* 13185*/   0, // EndSwitchType
/* 13186*/  /*SwitchOpcode*/ 21, TARGET_VAL(ISD::TargetGlobalTLSAddress),// ->13210
/* 13189*/   OPC_MoveParent,
/* 13190*/   OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->13200
/* 13193*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 13194*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I32),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr)
/* 13200*/   /*SwitchType*/ 7, /*MVT::i64*/8, // ->13209
/* 13202*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 13203*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I64),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr)
/* 13209*/   0, // EndSwitchType
/* 13210*/  /*SwitchOpcode*/ 47, TARGET_VAL(ISD::TargetExternalSymbol),// ->13260
/* 13213*/   OPC_MoveParent,
/* 13214*/   OPC_SwitchType /*2 cases */, 20, /*MVT::i32*/7, // ->13237
/* 13217*/    OPC_Scope, 8, /*->13227*/ // 2 children in Scope
/* 13219*/     OPC_CheckPatternPredicate, 14, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13221*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 13227*/    /*Scope*/ 8, /*->13236*/
/* 13228*/     OPC_CheckPatternPredicate, 18, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 13230*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (CONST_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 13236*/    0, /*End of Scope*/
/* 13237*/   /*SwitchType*/ 20, /*MVT::i64*/8, // ->13259
/* 13239*/    OPC_Scope, 8, /*->13249*/ // 2 children in Scope
/* 13241*/     OPC_CheckPatternPredicate, 15, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13243*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 13249*/    /*Scope*/ 8, /*->13258*/
/* 13250*/     OPC_CheckPatternPredicate, 19, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 13252*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (CONST_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 13258*/    0, /*End of Scope*/
/* 13259*/   0, // EndSwitchType
/* 13260*/  0, // EndSwitchOpcode
/* 13261*/ /*SwitchOpcode*/ 80, TARGET_VAL(WebAssemblyISD::WrapperREL),// ->13344
/* 13264*/  OPC_RecordChild0, // #0 = $addr
/* 13265*/  OPC_MoveChild0,
/* 13266*/  OPC_SwitchOpcode /*3 cases */, 23, TARGET_VAL(ISD::TargetGlobalAddress),// ->13293
/* 13270*/   OPC_MoveParent,
/* 13271*/   OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->13282
/* 13274*/    OPC_CheckPatternPredicate, 14, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13276*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 13282*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->13292
/* 13284*/    OPC_CheckPatternPredicate, 15, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13286*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 13292*/   0, // EndSwitchType
/* 13293*/  /*SwitchOpcode*/ 21, TARGET_VAL(ISD::TargetGlobalTLSAddress),// ->13317
/* 13296*/   OPC_MoveParent,
/* 13297*/   OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->13307
/* 13300*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 13301*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr)
/* 13307*/   /*SwitchType*/ 7, /*MVT::i64*/8, // ->13316
/* 13309*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 13310*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr)
/* 13316*/   0, // EndSwitchType
/* 13317*/  /*SwitchOpcode*/ 23, TARGET_VAL(ISD::TargetExternalSymbol),// ->13343
/* 13320*/   OPC_MoveParent,
/* 13321*/   OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->13332
/* 13324*/    OPC_CheckPatternPredicate, 14, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13326*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 13332*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->13342
/* 13334*/    OPC_CheckPatternPredicate, 15, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13336*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 13342*/   0, // EndSwitchType
/* 13343*/  0, // EndSwitchOpcode
/* 13344*/ /*SwitchOpcode*/ 47, TARGET_VAL(WebAssemblyISD::MEMORY_FILL),// ->13394
/* 13347*/  OPC_RecordNode, // #0 = 'wasm_memset' chained node
/* 13348*/  OPC_RecordChild1, // #1 = $idx
/* 13349*/  OPC_MoveChild1,
/* 13350*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 13353*/  OPC_CheckTypeI32,
/* 13354*/  OPC_MoveParent,
/* 13355*/  OPC_RecordChild2, // #2 = $dst
/* 13356*/  OPC_Scope, 17, /*->13375*/ // 2 children in Scope
/* 13358*/   OPC_CheckChild2TypeI32,
/* 13359*/   OPC_RecordChild3, // #3 = $value
/* 13360*/   OPC_CheckChild3TypeI32,
/* 13361*/   OPC_RecordChild4, // #4 = $size
/* 13362*/   OPC_CheckChild4TypeI32,
/* 13363*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemory())
/* 13365*/   OPC_EmitMergeInputChains1_0,
/* 13366*/   OPC_EmitConvertToTarget1,
/* 13367*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::anonymous_8933MEMORY_FILL_A32),
                 4/*#Ops*/, 5, 2, 3, 4, 
             // Src: (wasm_memset (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$value, I32:{ *:[i32] }:$size) - Complexity = 6
             // Dst: (anonymous_8933MEMORY_FILL_A32 (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$value, I32:{ *:[i32] }:$size)
/* 13375*/  /*Scope*/ 17, /*->13393*/
/* 13376*/   OPC_CheckChild2TypeI64,
/* 13377*/   OPC_RecordChild3, // #3 = $value
/* 13378*/   OPC_CheckChild3TypeI32,
/* 13379*/   OPC_RecordChild4, // #4 = $size
/* 13380*/   OPC_CheckChild4TypeI64,
/* 13381*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemory())
/* 13383*/   OPC_EmitMergeInputChains1_0,
/* 13384*/   OPC_EmitConvertToTarget1,
/* 13385*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::anonymous_8934MEMORY_FILL_A64),
                 4/*#Ops*/, 5, 2, 3, 4, 
             // Src: (wasm_memset (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$dst, I32:{ *:[i32] }:$value, I64:{ *:[i64] }:$size) - Complexity = 6
             // Dst: (anonymous_8934MEMORY_FILL_A64 (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$dst, I32:{ *:[i32] }:$value, I64:{ *:[i64] }:$size)
/* 13393*/  0, /*End of Scope*/
/* 13394*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::Constant),// ->13418
/* 13397*/  OPC_RecordNode, // #0 = $imm
/* 13398*/  OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->13408
/* 13401*/   OPC_EmitConvertToTarget0,
/* 13402*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                 /*MVT::i32*/7, 1/*#Ops*/, 1, 
             // Src: (imm:{ *:[i32] }):$imm - Complexity = 3
             // Dst: (CONST_I32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
/* 13408*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->13417
/* 13410*/   OPC_EmitConvertToTarget0,
/* 13411*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                 /*MVT::i64*/8, 1/*#Ops*/, 1, 
             // Src: (imm:{ *:[i64] }):$imm - Complexity = 3
             // Dst: (CONST_I64:{ *:[i64] } (imm:{ *:[i64] }):$imm)
/* 13417*/  0, // EndSwitchType
/* 13418*/ /*SwitchOpcode*/ 13, TARGET_VAL(ISD::BR),// ->13434
/* 13421*/  OPC_RecordNode, // #0 = 'br' chained node
/* 13422*/  OPC_RecordChild1, // #1 = $dst
/* 13423*/  OPC_MoveChild1,
/* 13424*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 13427*/  OPC_MoveParent,
/* 13428*/  OPC_EmitMergeInputChains1_0,
/* 13429*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR),
                1/*#Ops*/, 1, 
            // Src: (br (bb:{ *:[Other] }):$dst) - Complexity = 3
            // Dst: (BR (bb:{ *:[Other] }):$dst)
/* 13434*/ /*SwitchOpcode*/ 22, TARGET_VAL(WebAssemblyISD::BR_TABLE),// ->13459
/* 13437*/  OPC_RecordNode, // #0 = 'WebAssemblybr_table' chained node
/* 13438*/  OPC_RecordChild1, // #1 = $index
/* 13439*/  OPC_Scope, 8, /*->13449*/ // 2 children in Scope
/* 13441*/   OPC_CheckChild1TypeI32,
/* 13442*/   OPC_EmitMergeInputChains1_0,
/* 13443*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_TABLE_I32), 0|OPFL_Chain|OPFL_Variadic1,
                 1/*#Ops*/, 1, 
             // Src: (WebAssemblybr_table I32:{ *:[i32] }:$index) - Complexity = 3
             // Dst: (BR_TABLE_I32 I32:{ *:[i32] }:$index)
/* 13449*/  /*Scope*/ 8, /*->13458*/
/* 13450*/   OPC_CheckChild1TypeI64,
/* 13451*/   OPC_EmitMergeInputChains1_0,
/* 13452*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_TABLE_I64), 0|OPFL_Chain|OPFL_Variadic1,
                 1/*#Ops*/, 1, 
             // Src: (WebAssemblybr_table I64:{ *:[i64] }:$index) - Complexity = 3
             // Dst: (BR_TABLE_I64 I64:{ *:[i64] }:$index)
/* 13458*/  0, /*End of Scope*/
/* 13459*/ /*SwitchOpcode*/ 7, TARGET_VAL(WebAssemblyISD::RETURN),// ->13469
/* 13462*/  OPC_RecordNode, // #0 = 'WebAssemblyreturn' chained node
/* 13463*/  OPC_EmitMergeInputChains1_0,
/* 13464*/  OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::RETURN), 0|OPFL_Chain|OPFL_Variadic0,
                0/*#Ops*/, 
            // Src: (WebAssemblyreturn) - Complexity = 3
            // Dst: (RETURN)
/* 13469*/ /*SwitchOpcode*/ 6, TARGET_VAL(ISD::TRAP),// ->13478
/* 13472*/  OPC_RecordNode, // #0 = 'trap' chained node
/* 13473*/  OPC_EmitMergeInputChains1_0,
/* 13474*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::UNREACHABLE),
                0/*#Ops*/, 
            // Src: (trap) - Complexity = 3
            // Dst: (UNREACHABLE)
/* 13478*/ /*SwitchOpcode*/ 6, TARGET_VAL(ISD::DEBUGTRAP),// ->13487
/* 13481*/  OPC_RecordNode, // #0 = 'debugtrap' chained node
/* 13482*/  OPC_EmitMergeInputChains1_0,
/* 13483*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::DEBUG_UNREACHABLE),
                0/*#Ops*/, 
            // Src: (debugtrap) - Complexity = 3
            // Dst: (DEBUG_UNREACHABLE)
/* 13487*/ /*SwitchOpcode*/ 8, TARGET_VAL(ISD::CLEANUPRET),// ->13498
/* 13490*/  OPC_RecordNode, // #0 = 'cleanupret' chained node
/* 13491*/  OPC_CheckPatternPredicate, 16, // (Subtarget->hasExceptionHandling())
/* 13493*/  OPC_EmitMergeInputChains1_0,
/* 13494*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::CLEANUPRET),
                0/*#Ops*/, 
            // Src: (cleanupret) - Complexity = 3
            // Dst: (CLEANUPRET)
/* 13498*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CATCHRET),// ->13522
/* 13501*/  OPC_RecordNode, // #0 = 'catchret' chained node
/* 13502*/  OPC_RecordChild1, // #1 = $dst
/* 13503*/  OPC_MoveChild1,
/* 13504*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 13507*/  OPC_MoveSibling2,
/* 13508*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 13511*/  OPC_RecordNode, // #2 = $from
/* 13512*/  OPC_MoveParent,
/* 13513*/  OPC_CheckPatternPredicate, 16, // (Subtarget->hasExceptionHandling())
/* 13515*/  OPC_EmitMergeInputChains1_0,
/* 13516*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::CATCHRET),
                2/*#Ops*/, 1, 2, 
            // Src: (catchret (bb:{ *:[Other] }):$dst, (bb:{ *:[Other] }):$from) - Complexity = 3
            // Dst: (CATCHRET (bb:{ *:[Other] }):$dst, (bb:{ *:[Other] }):$from)
/* 13522*/ /*SwitchOpcode*/ 62, TARGET_VAL(ISD::ADD),// ->13587
/* 13525*/  OPC_RecordChild0, // #0 = $lhs
/* 13526*/  OPC_RecordChild1, // #1 = $rhs
/* 13527*/  OPC_SwitchType /*6 cases */, 7, /*MVT::i32*/7, // ->13537
/* 13530*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I32),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (ADD_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13537*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->13546
/* 13539*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I64),
                 /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (ADD_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13546*/  /*SwitchType*/ 8, /*MVT::v16i8*/39, // ->13556
/* 13548*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13549*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13556*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->13566
/* 13558*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13559*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13566*/  /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->13576
/* 13568*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13569*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I32x4),
                 /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (ADD_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13576*/  /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->13586
/* 13578*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13579*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I64x2),
                 /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
             // Dst: (ADD_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 13586*/  0, // EndSwitchType
/* 13587*/ /*SwitchOpcode*/ 113, TARGET_VAL(ISD::SUB),// ->13703
/* 13590*/  OPC_Scope, 22, /*->13614*/ // 3 children in Scope
/* 13592*/   OPC_RecordChild0, // #0 = $lhs
/* 13593*/   OPC_RecordChild1, // #1 = $rhs
/* 13594*/   OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->13604
/* 13597*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SUB_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13604*/   /*SwitchType*/ 7, /*MVT::i64*/8, // ->13613
/* 13606*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SUB_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13613*/   0, // EndSwitchType
/* 13614*/  /*Scope*/ 42, /*->13657*/
/* 13615*/   OPC_MoveChild0,
/* 13616*/   OPC_CheckImmAllZerosV,
/* 13617*/   OPC_MoveParent,
/* 13618*/   OPC_RecordChild1, // #0 = $v
/* 13619*/   OPC_SwitchType /*4 cases */, 7, /*MVT::v16i8*/39, // ->13629
/* 13622*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13623*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I8x16),
                  /*MVT::v16i8*/39, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$v) - Complexity = 7
              // Dst: (NEG_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 13629*/   /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->13638
/* 13631*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13632*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I16x8),
                  /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$v) - Complexity = 7
              // Dst: (NEG_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$v)
/* 13638*/   /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->13647
/* 13640*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13641*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I32x4),
                  /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$v) - Complexity = 7
              // Dst: (NEG_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$v)
/* 13647*/   /*SwitchType*/ 7, /*MVT::v2i64*/78, // ->13656
/* 13649*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13650*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I64x2),
                  /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$v) - Complexity = 7
              // Dst: (NEG_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$v)
/* 13656*/   0, // EndSwitchType
/* 13657*/  /*Scope*/ 44, /*->13702*/
/* 13658*/   OPC_RecordChild0, // #0 = $lhs
/* 13659*/   OPC_RecordChild1, // #1 = $rhs
/* 13660*/   OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->13671
/* 13663*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13664*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (SUB_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13671*/   /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->13681
/* 13673*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13674*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (SUB_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13681*/   /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->13691
/* 13683*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13684*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I32x4),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (SUB_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13691*/   /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->13701
/* 13693*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13694*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (SUB_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 13701*/   0, // EndSwitchType
/* 13702*/  0, /*End of Scope*/
/* 13703*/ /*SwitchOpcode*/ 85|128,2/*341*/, TARGET_VAL(ISD::MUL),// ->14048
/* 13707*/  OPC_Scope, 22, /*->13731*/ // 3 children in Scope
/* 13709*/   OPC_RecordChild0, // #0 = $lhs
/* 13710*/   OPC_RecordChild1, // #1 = $rhs
/* 13711*/   OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->13721
/* 13714*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (MUL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13721*/   /*SwitchType*/ 7, /*MVT::i64*/8, // ->13730
/* 13723*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (MUL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13730*/   0, // EndSwitchType
/* 13731*/  /*Scope*/ 23|128,2/*279*/, /*->14012*/
/* 13733*/   OPC_MoveChild0,
/* 13734*/   OPC_SwitchOpcode /*4 cases */, 66, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),// ->13804
/* 13738*/    OPC_RecordChild0, // #0 = $lhs
/* 13739*/    OPC_Scope, 20, /*->13761*/ // 3 children in Scope
/* 13741*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13743*/     OPC_MoveSibling1,
/* 13744*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 13747*/     OPC_RecordChild0, // #1 = $rhs
/* 13748*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13750*/     OPC_MoveParent,
/* 13751*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 13753*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13754*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13761*/    /*Scope*/ 20, /*->13782*/
/* 13762*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13764*/     OPC_MoveSibling1,
/* 13765*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 13768*/     OPC_RecordChild0, // #1 = $rhs
/* 13769*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13771*/     OPC_MoveParent,
/* 13772*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 13774*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13775*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13782*/    /*Scope*/ 20, /*->13803*/
/* 13783*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13785*/     OPC_MoveSibling1,
/* 13786*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 13789*/     OPC_RecordChild0, // #1 = $rhs
/* 13790*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13792*/     OPC_MoveParent,
/* 13793*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 13795*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13796*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13803*/    0, /*End of Scope*/
/* 13804*/   /*SwitchOpcode*/ 66, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),// ->13873
/* 13807*/    OPC_RecordChild0, // #0 = $lhs
/* 13808*/    OPC_Scope, 20, /*->13830*/ // 3 children in Scope
/* 13810*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13812*/     OPC_MoveSibling1,
/* 13813*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 13816*/     OPC_RecordChild0, // #1 = $rhs
/* 13817*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13819*/     OPC_MoveParent,
/* 13820*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 13822*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13823*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13830*/    /*Scope*/ 20, /*->13851*/
/* 13831*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13833*/     OPC_MoveSibling1,
/* 13834*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 13837*/     OPC_RecordChild0, // #1 = $rhs
/* 13838*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13840*/     OPC_MoveParent,
/* 13841*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 13843*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13844*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13851*/    /*Scope*/ 20, /*->13872*/
/* 13852*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13854*/     OPC_MoveSibling1,
/* 13855*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 13858*/     OPC_RecordChild0, // #1 = $rhs
/* 13859*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13861*/     OPC_MoveParent,
/* 13862*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 13864*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13865*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13872*/    0, /*End of Scope*/
/* 13873*/   /*SwitchOpcode*/ 66, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),// ->13942
/* 13876*/    OPC_RecordChild0, // #0 = $lhs
/* 13877*/    OPC_Scope, 20, /*->13899*/ // 3 children in Scope
/* 13879*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13881*/     OPC_MoveSibling1,
/* 13882*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 13885*/     OPC_RecordChild0, // #1 = $rhs
/* 13886*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13888*/     OPC_MoveParent,
/* 13889*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 13891*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13892*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13899*/    /*Scope*/ 20, /*->13920*/
/* 13900*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13902*/     OPC_MoveSibling1,
/* 13903*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 13906*/     OPC_RecordChild0, // #1 = $rhs
/* 13907*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13909*/     OPC_MoveParent,
/* 13910*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 13912*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13913*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13920*/    /*Scope*/ 20, /*->13941*/
/* 13921*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13923*/     OPC_MoveSibling1,
/* 13924*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 13927*/     OPC_RecordChild0, // #1 = $rhs
/* 13928*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13930*/     OPC_MoveParent,
/* 13931*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 13933*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13934*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13941*/    0, /*End of Scope*/
/* 13942*/   /*SwitchOpcode*/ 66, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),// ->14011
/* 13945*/    OPC_RecordChild0, // #0 = $lhs
/* 13946*/    OPC_Scope, 20, /*->13968*/ // 3 children in Scope
/* 13948*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13950*/     OPC_MoveSibling1,
/* 13951*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 13954*/     OPC_RecordChild0, // #1 = $rhs
/* 13955*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13957*/     OPC_MoveParent,
/* 13958*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 13960*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13961*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13968*/    /*Scope*/ 20, /*->13989*/
/* 13969*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13971*/     OPC_MoveSibling1,
/* 13972*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 13975*/     OPC_RecordChild0, // #1 = $rhs
/* 13976*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13978*/     OPC_MoveParent,
/* 13979*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 13981*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13982*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13989*/    /*Scope*/ 20, /*->14010*/
/* 13990*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13992*/     OPC_MoveSibling1,
/* 13993*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 13996*/     OPC_RecordChild0, // #1 = $rhs
/* 13997*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13999*/     OPC_MoveParent,
/* 14000*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 14002*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 14003*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 14010*/    0, /*End of Scope*/
/* 14011*/   0, // EndSwitchOpcode
/* 14012*/  /*Scope*/ 34, /*->14047*/
/* 14013*/   OPC_RecordChild0, // #0 = $lhs
/* 14014*/   OPC_RecordChild1, // #1 = $rhs
/* 14015*/   OPC_SwitchType /*3 cases */, 8, /*MVT::v8i16*/50, // ->14026
/* 14018*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 14019*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (MUL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 14026*/   /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->14036
/* 14028*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 14029*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I32x4),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (MUL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 14036*/   /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->14046
/* 14038*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 14039*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (MUL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 14046*/   0, // EndSwitchType
/* 14047*/  0, /*End of Scope*/
/* 14048*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::SDIV),// ->14073
/* 14051*/  OPC_RecordChild0, // #0 = $lhs
/* 14052*/  OPC_RecordChild1, // #1 = $rhs
/* 14053*/  OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->14063
/* 14056*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_S_I32),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
             // Src: (sdiv:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (DIV_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14063*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->14072
/* 14065*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_S_I64),
                 /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
             // Src: (sdiv:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (DIV_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14072*/  0, // EndSwitchType
/* 14073*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::UDIV),// ->14098
/* 14076*/  OPC_RecordChild0, // #0 = $lhs
/* 14077*/  OPC_RecordChild1, // #1 = $rhs
/* 14078*/  OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->14088
/* 14081*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_U_I32),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
             // Src: (udiv:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (DIV_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14088*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->14097
/* 14090*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_U_I64),
                 /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
             // Src: (udiv:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (DIV_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14097*/  0, // EndSwitchType
/* 14098*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::SREM),// ->14123
/* 14101*/  OPC_RecordChild0, // #0 = $lhs
/* 14102*/  OPC_RecordChild1, // #1 = $rhs
/* 14103*/  OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->14113
/* 14106*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_S_I32),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
             // Src: (srem:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (REM_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14113*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->14122
/* 14115*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_S_I64),
                 /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
             // Src: (srem:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (REM_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14122*/  0, // EndSwitchType
/* 14123*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::UREM),// ->14148
/* 14126*/  OPC_RecordChild0, // #0 = $lhs
/* 14127*/  OPC_RecordChild1, // #1 = $rhs
/* 14128*/  OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->14138
/* 14131*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_U_I32),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
             // Src: (urem:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (REM_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14138*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->14147
/* 14140*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_U_I64),
                 /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
             // Src: (urem:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (REM_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14147*/  0, // EndSwitchType
/* 14148*/ /*SwitchOpcode*/ 56|128,6/*824*/, TARGET_VAL(ISD::OR),// ->14976
/* 14152*/  OPC_Scope, 22, /*->14176*/ // 3 children in Scope
/* 14154*/   OPC_RecordChild0, // #0 = $lhs
/* 14155*/   OPC_RecordChild1, // #1 = $rhs
/* 14156*/   OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->14166
/* 14159*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (OR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14166*/   /*SwitchType*/ 7, /*MVT::i64*/8, // ->14175
/* 14168*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (OR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14175*/   0, // EndSwitchType
/* 14176*/  /*Scope*/ 116|128,5/*756*/, /*->14934*/
/* 14178*/   OPC_MoveChild0,
/* 14179*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14182*/   OPC_Scope, 4|128,1/*132*/, /*->14317*/ // 9 children in Scope
/* 14185*/    OPC_RecordChild0, // #0 = $c
/* 14186*/    OPC_RecordChild1, // #1 = $v1
/* 14187*/    OPC_MoveSibling1,
/* 14188*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14191*/    OPC_Scope, 54, /*->14247*/ // 4 children in Scope
/* 14193*/     OPC_MoveChild0,
/* 14194*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14197*/     OPC_CheckChild0Same, 0,
/* 14199*/     OPC_MoveChild1,
/* 14200*/     OPC_CheckImmAllOnesV,
/* 14201*/     OPC_MoveParent,
/* 14202*/     OPC_MoveParent,
/* 14203*/     OPC_RecordChild1, // #2 = $v2
/* 14204*/     OPC_MoveParent,
/* 14205*/     OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->14216
/* 14208*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v16i8*/39, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14216*/     /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->14226
/* 14218*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14226*/     /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->14236
/* 14228*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14236*/     /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->14246
/* 14238*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14246*/     0, // EndSwitchType
/* 14247*/    /*Scope*/ 22, /*->14270*/
/* 14248*/     OPC_RecordChild0, // #2 = $v2
/* 14249*/     OPC_MoveChild1,
/* 14250*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14253*/     OPC_CheckChild0Same, 0,
/* 14255*/     OPC_MoveChild1,
/* 14256*/     OPC_CheckImmAllOnesV,
/* 14257*/     OPC_MoveParent,
/* 14258*/     OPC_MoveParent,
/* 14259*/     OPC_MoveParent,
/* 14260*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 14262*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 1, 2, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14270*/    /*Scope*/ 22, /*->14293*/
/* 14271*/     OPC_MoveChild0,
/* 14272*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14275*/     OPC_CheckChild0Same, 1,
/* 14277*/     OPC_MoveChild1,
/* 14278*/     OPC_CheckImmAllOnesV,
/* 14279*/     OPC_MoveParent,
/* 14280*/     OPC_MoveParent,
/* 14281*/     OPC_RecordChild1, // #2 = $v2
/* 14282*/     OPC_MoveParent,
/* 14283*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 14285*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 0, 2, 1, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14293*/    /*Scope*/ 22, /*->14316*/
/* 14294*/     OPC_RecordChild0, // #2 = $v2
/* 14295*/     OPC_MoveChild1,
/* 14296*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14299*/     OPC_CheckChild0Same, 1,
/* 14301*/     OPC_MoveChild1,
/* 14302*/     OPC_CheckImmAllOnesV,
/* 14303*/     OPC_MoveParent,
/* 14304*/     OPC_MoveParent,
/* 14305*/     OPC_MoveParent,
/* 14306*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 14308*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 0, 2, 1, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14316*/    0, /*End of Scope*/
/* 14317*/   /*Scope*/ 46, /*->14364*/
/* 14318*/    OPC_MoveChild0,
/* 14319*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14322*/    OPC_RecordChild0, // #0 = $c
/* 14323*/    OPC_MoveChild1,
/* 14324*/    OPC_CheckImmAllOnesV,
/* 14325*/    OPC_MoveParent,
/* 14326*/    OPC_MoveParent,
/* 14327*/    OPC_RecordChild1, // #1 = $v2
/* 14328*/    OPC_MoveSibling1,
/* 14329*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14332*/    OPC_Scope, 14, /*->14348*/ // 2 children in Scope
/* 14334*/     OPC_CheckChild0Same, 0,
/* 14336*/     OPC_RecordChild1, // #2 = $v1
/* 14337*/     OPC_MoveParent,
/* 14338*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 14340*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14348*/    /*Scope*/ 14, /*->14363*/
/* 14349*/     OPC_RecordChild0, // #2 = $v1
/* 14350*/     OPC_CheckChild1Same, 0,
/* 14352*/     OPC_MoveParent,
/* 14353*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 14355*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14363*/    0, /*End of Scope*/
/* 14364*/   /*Scope*/ 126, /*->14491*/
/* 14365*/    OPC_RecordChild0, // #0 = $v2
/* 14366*/    OPC_Scope, 45, /*->14413*/ // 2 children in Scope
/* 14368*/     OPC_MoveChild1,
/* 14369*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14372*/     OPC_RecordChild0, // #1 = $c
/* 14373*/     OPC_MoveChild1,
/* 14374*/     OPC_CheckImmAllOnesV,
/* 14375*/     OPC_MoveParent,
/* 14376*/     OPC_MoveParent,
/* 14377*/     OPC_MoveSibling1,
/* 14378*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14381*/     OPC_Scope, 14, /*->14397*/ // 2 children in Scope
/* 14383*/      OPC_CheckChild0Same, 1,
/* 14385*/      OPC_RecordChild1, // #2 = $v1
/* 14386*/      OPC_MoveParent,
/* 14387*/      OPC_CheckType, /*MVT::v16i8*/39, 
/* 14389*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v16i8*/39, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14397*/     /*Scope*/ 14, /*->14412*/
/* 14398*/      OPC_RecordChild0, // #2 = $v1
/* 14399*/      OPC_CheckChild1Same, 1,
/* 14401*/      OPC_MoveParent,
/* 14402*/      OPC_CheckType, /*MVT::v16i8*/39, 
/* 14404*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v16i8*/39, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14412*/     0, /*End of Scope*/
/* 14413*/    /*Scope*/ 76, /*->14490*/
/* 14414*/     OPC_RecordChild1, // #1 = $v1
/* 14415*/     OPC_MoveSibling1,
/* 14416*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14419*/     OPC_Scope, 22, /*->14443*/ // 3 children in Scope
/* 14421*/      OPC_RecordChild0, // #2 = $v2
/* 14422*/      OPC_MoveChild1,
/* 14423*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14426*/      OPC_CheckChild0Same, 0,
/* 14428*/      OPC_MoveChild1,
/* 14429*/      OPC_CheckImmAllOnesV,
/* 14430*/      OPC_MoveParent,
/* 14431*/      OPC_MoveParent,
/* 14432*/      OPC_MoveParent,
/* 14433*/      OPC_CheckType, /*MVT::v8i16*/50, 
/* 14435*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14443*/     /*Scope*/ 22, /*->14466*/
/* 14444*/      OPC_MoveChild0,
/* 14445*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14448*/      OPC_CheckChild0Same, 1,
/* 14450*/      OPC_MoveChild1,
/* 14451*/      OPC_CheckImmAllOnesV,
/* 14452*/      OPC_MoveParent,
/* 14453*/      OPC_MoveParent,
/* 14454*/      OPC_RecordChild1, // #2 = $v2
/* 14455*/      OPC_MoveParent,
/* 14456*/      OPC_CheckType, /*MVT::v8i16*/50, 
/* 14458*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14466*/     /*Scope*/ 22, /*->14489*/
/* 14467*/      OPC_RecordChild0, // #2 = $v2
/* 14468*/      OPC_MoveChild1,
/* 14469*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14472*/      OPC_CheckChild0Same, 1,
/* 14474*/      OPC_MoveChild1,
/* 14475*/      OPC_CheckImmAllOnesV,
/* 14476*/      OPC_MoveParent,
/* 14477*/      OPC_MoveParent,
/* 14478*/      OPC_MoveParent,
/* 14479*/      OPC_CheckType, /*MVT::v8i16*/50, 
/* 14481*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14489*/     0, /*End of Scope*/
/* 14490*/    0, /*End of Scope*/
/* 14491*/   /*Scope*/ 46, /*->14538*/
/* 14492*/    OPC_MoveChild0,
/* 14493*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14496*/    OPC_RecordChild0, // #0 = $c
/* 14497*/    OPC_MoveChild1,
/* 14498*/    OPC_CheckImmAllOnesV,
/* 14499*/    OPC_MoveParent,
/* 14500*/    OPC_MoveParent,
/* 14501*/    OPC_RecordChild1, // #1 = $v2
/* 14502*/    OPC_MoveSibling1,
/* 14503*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14506*/    OPC_Scope, 14, /*->14522*/ // 2 children in Scope
/* 14508*/     OPC_CheckChild0Same, 0,
/* 14510*/     OPC_RecordChild1, // #2 = $v1
/* 14511*/     OPC_MoveParent,
/* 14512*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 14514*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14522*/    /*Scope*/ 14, /*->14537*/
/* 14523*/     OPC_RecordChild0, // #2 = $v1
/* 14524*/     OPC_CheckChild1Same, 0,
/* 14526*/     OPC_MoveParent,
/* 14527*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 14529*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14537*/    0, /*End of Scope*/
/* 14538*/   /*Scope*/ 126, /*->14665*/
/* 14539*/    OPC_RecordChild0, // #0 = $v2
/* 14540*/    OPC_Scope, 45, /*->14587*/ // 2 children in Scope
/* 14542*/     OPC_MoveChild1,
/* 14543*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14546*/     OPC_RecordChild0, // #1 = $c
/* 14547*/     OPC_MoveChild1,
/* 14548*/     OPC_CheckImmAllOnesV,
/* 14549*/     OPC_MoveParent,
/* 14550*/     OPC_MoveParent,
/* 14551*/     OPC_MoveSibling1,
/* 14552*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14555*/     OPC_Scope, 14, /*->14571*/ // 2 children in Scope
/* 14557*/      OPC_CheckChild0Same, 1,
/* 14559*/      OPC_RecordChild1, // #2 = $v1
/* 14560*/      OPC_MoveParent,
/* 14561*/      OPC_CheckType, /*MVT::v8i16*/50, 
/* 14563*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14571*/     /*Scope*/ 14, /*->14586*/
/* 14572*/      OPC_RecordChild0, // #2 = $v1
/* 14573*/      OPC_CheckChild1Same, 1,
/* 14575*/      OPC_MoveParent,
/* 14576*/      OPC_CheckType, /*MVT::v8i16*/50, 
/* 14578*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14586*/     0, /*End of Scope*/
/* 14587*/    /*Scope*/ 76, /*->14664*/
/* 14588*/     OPC_RecordChild1, // #1 = $v1
/* 14589*/     OPC_MoveSibling1,
/* 14590*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14593*/     OPC_Scope, 22, /*->14617*/ // 3 children in Scope
/* 14595*/      OPC_RecordChild0, // #2 = $v2
/* 14596*/      OPC_MoveChild1,
/* 14597*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14600*/      OPC_CheckChild0Same, 0,
/* 14602*/      OPC_MoveChild1,
/* 14603*/      OPC_CheckImmAllOnesV,
/* 14604*/      OPC_MoveParent,
/* 14605*/      OPC_MoveParent,
/* 14606*/      OPC_MoveParent,
/* 14607*/      OPC_CheckType, /*MVT::v4i32*/60, 
/* 14609*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14617*/     /*Scope*/ 22, /*->14640*/
/* 14618*/      OPC_MoveChild0,
/* 14619*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14622*/      OPC_CheckChild0Same, 1,
/* 14624*/      OPC_MoveChild1,
/* 14625*/      OPC_CheckImmAllOnesV,
/* 14626*/      OPC_MoveParent,
/* 14627*/      OPC_MoveParent,
/* 14628*/      OPC_RecordChild1, // #2 = $v2
/* 14629*/      OPC_MoveParent,
/* 14630*/      OPC_CheckType, /*MVT::v4i32*/60, 
/* 14632*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14640*/     /*Scope*/ 22, /*->14663*/
/* 14641*/      OPC_RecordChild0, // #2 = $v2
/* 14642*/      OPC_MoveChild1,
/* 14643*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14646*/      OPC_CheckChild0Same, 1,
/* 14648*/      OPC_MoveChild1,
/* 14649*/      OPC_CheckImmAllOnesV,
/* 14650*/      OPC_MoveParent,
/* 14651*/      OPC_MoveParent,
/* 14652*/      OPC_MoveParent,
/* 14653*/      OPC_CheckType, /*MVT::v4i32*/60, 
/* 14655*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14663*/     0, /*End of Scope*/
/* 14664*/    0, /*End of Scope*/
/* 14665*/   /*Scope*/ 46, /*->14712*/
/* 14666*/    OPC_MoveChild0,
/* 14667*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14670*/    OPC_RecordChild0, // #0 = $c
/* 14671*/    OPC_MoveChild1,
/* 14672*/    OPC_CheckImmAllOnesV,
/* 14673*/    OPC_MoveParent,
/* 14674*/    OPC_MoveParent,
/* 14675*/    OPC_RecordChild1, // #1 = $v2
/* 14676*/    OPC_MoveSibling1,
/* 14677*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14680*/    OPC_Scope, 14, /*->14696*/ // 2 children in Scope
/* 14682*/     OPC_CheckChild0Same, 0,
/* 14684*/     OPC_RecordChild1, // #2 = $v1
/* 14685*/     OPC_MoveParent,
/* 14686*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 14688*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14696*/    /*Scope*/ 14, /*->14711*/
/* 14697*/     OPC_RecordChild0, // #2 = $v1
/* 14698*/     OPC_CheckChild1Same, 0,
/* 14700*/     OPC_MoveParent,
/* 14701*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 14703*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14711*/    0, /*End of Scope*/
/* 14712*/   /*Scope*/ 126, /*->14839*/
/* 14713*/    OPC_RecordChild0, // #0 = $v2
/* 14714*/    OPC_Scope, 45, /*->14761*/ // 2 children in Scope
/* 14716*/     OPC_MoveChild1,
/* 14717*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14720*/     OPC_RecordChild0, // #1 = $c
/* 14721*/     OPC_MoveChild1,
/* 14722*/     OPC_CheckImmAllOnesV,
/* 14723*/     OPC_MoveParent,
/* 14724*/     OPC_MoveParent,
/* 14725*/     OPC_MoveSibling1,
/* 14726*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14729*/     OPC_Scope, 14, /*->14745*/ // 2 children in Scope
/* 14731*/      OPC_CheckChild0Same, 1,
/* 14733*/      OPC_RecordChild1, // #2 = $v1
/* 14734*/      OPC_MoveParent,
/* 14735*/      OPC_CheckType, /*MVT::v4i32*/60, 
/* 14737*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14745*/     /*Scope*/ 14, /*->14760*/
/* 14746*/      OPC_RecordChild0, // #2 = $v1
/* 14747*/      OPC_CheckChild1Same, 1,
/* 14749*/      OPC_MoveParent,
/* 14750*/      OPC_CheckType, /*MVT::v4i32*/60, 
/* 14752*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14760*/     0, /*End of Scope*/
/* 14761*/    /*Scope*/ 76, /*->14838*/
/* 14762*/     OPC_RecordChild1, // #1 = $v1
/* 14763*/     OPC_MoveSibling1,
/* 14764*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14767*/     OPC_Scope, 22, /*->14791*/ // 3 children in Scope
/* 14769*/      OPC_RecordChild0, // #2 = $v2
/* 14770*/      OPC_MoveChild1,
/* 14771*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14774*/      OPC_CheckChild0Same, 0,
/* 14776*/      OPC_MoveChild1,
/* 14777*/      OPC_CheckImmAllOnesV,
/* 14778*/      OPC_MoveParent,
/* 14779*/      OPC_MoveParent,
/* 14780*/      OPC_MoveParent,
/* 14781*/      OPC_CheckType, /*MVT::v2i64*/78, 
/* 14783*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14791*/     /*Scope*/ 22, /*->14814*/
/* 14792*/      OPC_MoveChild0,
/* 14793*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14796*/      OPC_CheckChild0Same, 1,
/* 14798*/      OPC_MoveChild1,
/* 14799*/      OPC_CheckImmAllOnesV,
/* 14800*/      OPC_MoveParent,
/* 14801*/      OPC_MoveParent,
/* 14802*/      OPC_RecordChild1, // #2 = $v2
/* 14803*/      OPC_MoveParent,
/* 14804*/      OPC_CheckType, /*MVT::v2i64*/78, 
/* 14806*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14814*/     /*Scope*/ 22, /*->14837*/
/* 14815*/      OPC_RecordChild0, // #2 = $v2
/* 14816*/      OPC_MoveChild1,
/* 14817*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14820*/      OPC_CheckChild0Same, 1,
/* 14822*/      OPC_MoveChild1,
/* 14823*/      OPC_CheckImmAllOnesV,
/* 14824*/      OPC_MoveParent,
/* 14825*/      OPC_MoveParent,
/* 14826*/      OPC_MoveParent,
/* 14827*/      OPC_CheckType, /*MVT::v2i64*/78, 
/* 14829*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14837*/     0, /*End of Scope*/
/* 14838*/    0, /*End of Scope*/
/* 14839*/   /*Scope*/ 46, /*->14886*/
/* 14840*/    OPC_MoveChild0,
/* 14841*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14844*/    OPC_RecordChild0, // #0 = $c
/* 14845*/    OPC_MoveChild1,
/* 14846*/    OPC_CheckImmAllOnesV,
/* 14847*/    OPC_MoveParent,
/* 14848*/    OPC_MoveParent,
/* 14849*/    OPC_RecordChild1, // #1 = $v2
/* 14850*/    OPC_MoveSibling1,
/* 14851*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14854*/    OPC_Scope, 14, /*->14870*/ // 2 children in Scope
/* 14856*/     OPC_CheckChild0Same, 0,
/* 14858*/     OPC_RecordChild1, // #2 = $v1
/* 14859*/     OPC_MoveParent,
/* 14860*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 14862*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14870*/    /*Scope*/ 14, /*->14885*/
/* 14871*/     OPC_RecordChild0, // #2 = $v1
/* 14872*/     OPC_CheckChild1Same, 0,
/* 14874*/     OPC_MoveParent,
/* 14875*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 14877*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14885*/    0, /*End of Scope*/
/* 14886*/   /*Scope*/ 46, /*->14933*/
/* 14887*/    OPC_RecordChild0, // #0 = $v2
/* 14888*/    OPC_MoveChild1,
/* 14889*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14892*/    OPC_RecordChild0, // #1 = $c
/* 14893*/    OPC_MoveChild1,
/* 14894*/    OPC_CheckImmAllOnesV,
/* 14895*/    OPC_MoveParent,
/* 14896*/    OPC_MoveParent,
/* 14897*/    OPC_MoveSibling1,
/* 14898*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14901*/    OPC_Scope, 14, /*->14917*/ // 2 children in Scope
/* 14903*/     OPC_CheckChild0Same, 1,
/* 14905*/     OPC_RecordChild1, // #2 = $v1
/* 14906*/     OPC_MoveParent,
/* 14907*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 14909*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 2, 0, 1, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14917*/    /*Scope*/ 14, /*->14932*/
/* 14918*/     OPC_RecordChild0, // #2 = $v1
/* 14919*/     OPC_CheckChild1Same, 1,
/* 14921*/     OPC_MoveParent,
/* 14922*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 14924*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 2, 0, 1, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14932*/    0, /*End of Scope*/
/* 14933*/   0, /*End of Scope*/
/* 14934*/  /*Scope*/ 40, /*->14975*/
/* 14935*/   OPC_RecordChild0, // #0 = $lhs
/* 14936*/   OPC_RecordChild1, // #1 = $rhs
/* 14937*/   OPC_SwitchType /*4 cases */, 7, /*MVT::v16i8*/39, // ->14947
/* 14940*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 14947*/   /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->14956
/* 14949*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 14956*/   /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->14965
/* 14958*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 14965*/   /*SwitchType*/ 7, /*MVT::v2i64*/78, // ->14974
/* 14967*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 14974*/   0, // EndSwitchType
/* 14975*/  0, /*End of Scope*/
/* 14976*/ /*SwitchOpcode*/ 121|128,11/*1529*/, TARGET_VAL(ISD::XOR),// ->16509
/* 14980*/  OPC_Scope, 22, /*->15004*/ // 17 children in Scope
/* 14982*/   OPC_RecordChild0, // #0 = $lhs
/* 14983*/   OPC_RecordChild1, // #1 = $rhs
/* 14984*/   OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->14994
/* 14987*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (xor:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (XOR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14994*/   /*SwitchType*/ 7, /*MVT::i64*/8, // ->15003
/* 14996*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (xor:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (XOR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 15003*/   0, // EndSwitchType
/* 15004*/  /*Scope*/ 121, /*->15126*/
/* 15005*/   OPC_MoveChild0,
/* 15006*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15009*/   OPC_MoveChild0,
/* 15010*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15013*/   OPC_RecordChild0, // #0 = $v1
/* 15014*/   OPC_Scope, 71, /*->15087*/ // 2 children in Scope
/* 15016*/    OPC_RecordChild1, // #1 = $v2
/* 15017*/    OPC_MoveSibling1,
/* 15018*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15021*/    OPC_RecordChild0, // #2 = $c
/* 15022*/    OPC_MoveChild1,
/* 15023*/    OPC_CheckImmAllOnesV,
/* 15024*/    OPC_MoveParent,
/* 15025*/    OPC_MoveParent,
/* 15026*/    OPC_MoveParent,
/* 15027*/    OPC_Scope, 44, /*->15073*/ // 2 children in Scope
/* 15029*/     OPC_CheckChild1Same, 1,
/* 15031*/     OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->15042
/* 15034*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v16i8*/39, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15042*/     /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->15052
/* 15044*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15052*/     /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->15062
/* 15054*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15062*/     /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->15072
/* 15064*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15072*/     0, // EndSwitchType
/* 15073*/    /*Scope*/ 12, /*->15086*/
/* 15074*/     OPC_CheckChild1Same, 0,
/* 15076*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15078*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 0, 1, 2, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15086*/    0, /*End of Scope*/
/* 15087*/   /*Scope*/ 37, /*->15125*/
/* 15088*/    OPC_MoveChild1,
/* 15089*/    OPC_CheckImmAllOnesV,
/* 15090*/    OPC_MoveParent,
/* 15091*/    OPC_MoveSibling1,
/* 15092*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15095*/    OPC_RecordChild0, // #1 = $v1
/* 15096*/    OPC_RecordChild1, // #2 = $v2
/* 15097*/    OPC_MoveParent,
/* 15098*/    OPC_MoveParent,
/* 15099*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 15101*/    OPC_Scope, 10, /*->15113*/ // 2 children in Scope
/* 15103*/     OPC_CheckChild1Same, 2,
/* 15105*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2)), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15113*/    /*Scope*/ 10, /*->15124*/
/* 15114*/     OPC_CheckChild1Same, 1,
/* 15116*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1)), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15124*/    0, /*End of Scope*/
/* 15125*/   0, /*End of Scope*/
/* 15126*/  /*Scope*/ 102, /*->15229*/
/* 15127*/   OPC_RecordChild0, // #0 = $v2
/* 15128*/   OPC_MoveChild1,
/* 15129*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15132*/   OPC_MoveChild0,
/* 15133*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15136*/   OPC_Scope, 23, /*->15161*/ // 3 children in Scope
/* 15138*/    OPC_RecordChild0, // #1 = $v1
/* 15139*/    OPC_CheckChild1Same, 0,
/* 15141*/    OPC_MoveSibling1,
/* 15142*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15145*/    OPC_RecordChild0, // #2 = $c
/* 15146*/    OPC_MoveChild1,
/* 15147*/    OPC_CheckImmAllOnesV,
/* 15148*/    OPC_MoveParent,
/* 15149*/    OPC_MoveParent,
/* 15150*/    OPC_MoveParent,
/* 15151*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 15153*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v16i8*/39, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15161*/   /*Scope*/ 23, /*->15185*/
/* 15162*/    OPC_CheckChild0Same, 0,
/* 15164*/    OPC_RecordChild1, // #1 = $v1
/* 15165*/    OPC_MoveSibling1,
/* 15166*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15169*/    OPC_RecordChild0, // #2 = $c
/* 15170*/    OPC_MoveChild1,
/* 15171*/    OPC_CheckImmAllOnesV,
/* 15172*/    OPC_MoveParent,
/* 15173*/    OPC_MoveParent,
/* 15174*/    OPC_MoveParent,
/* 15175*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 15177*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v16i8*/39, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15185*/   /*Scope*/ 42, /*->15228*/
/* 15186*/    OPC_RecordChild0, // #1 = $c
/* 15187*/    OPC_MoveChild1,
/* 15188*/    OPC_CheckImmAllOnesV,
/* 15189*/    OPC_MoveParent,
/* 15190*/    OPC_MoveSibling1,
/* 15191*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15194*/    OPC_Scope, 15, /*->15211*/ // 2 children in Scope
/* 15196*/     OPC_RecordChild0, // #2 = $v1
/* 15197*/     OPC_CheckChild1Same, 0,
/* 15199*/     OPC_MoveParent,
/* 15200*/     OPC_MoveParent,
/* 15201*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15203*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15211*/    /*Scope*/ 15, /*->15227*/
/* 15212*/     OPC_CheckChild0Same, 0,
/* 15214*/     OPC_RecordChild1, // #2 = $v1
/* 15215*/     OPC_MoveParent,
/* 15216*/     OPC_MoveParent,
/* 15217*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15219*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15227*/    0, /*End of Scope*/
/* 15228*/   0, /*End of Scope*/
/* 15229*/  /*Scope*/ 73, /*->15303*/
/* 15230*/   OPC_MoveChild0,
/* 15231*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15234*/   OPC_MoveChild0,
/* 15235*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15238*/   OPC_RecordChild0, // #0 = $v2
/* 15239*/   OPC_Scope, 23, /*->15264*/ // 2 children in Scope
/* 15241*/    OPC_RecordChild1, // #1 = $v1
/* 15242*/    OPC_MoveSibling1,
/* 15243*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15246*/    OPC_RecordChild0, // #2 = $c
/* 15247*/    OPC_MoveChild1,
/* 15248*/    OPC_CheckImmAllOnesV,
/* 15249*/    OPC_MoveParent,
/* 15250*/    OPC_MoveParent,
/* 15251*/    OPC_MoveParent,
/* 15252*/    OPC_CheckChild1Same, 0,
/* 15254*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 15256*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15264*/   /*Scope*/ 37, /*->15302*/
/* 15265*/    OPC_MoveChild1,
/* 15266*/    OPC_CheckImmAllOnesV,
/* 15267*/    OPC_MoveParent,
/* 15268*/    OPC_MoveSibling1,
/* 15269*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15272*/    OPC_RecordChild0, // #1 = $v1
/* 15273*/    OPC_RecordChild1, // #2 = $v2
/* 15274*/    OPC_MoveParent,
/* 15275*/    OPC_MoveParent,
/* 15276*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 15278*/    OPC_Scope, 10, /*->15290*/ // 2 children in Scope
/* 15280*/     OPC_CheckChild1Same, 2,
/* 15282*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2)), V128:{ *:[v8i16] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15290*/    /*Scope*/ 10, /*->15301*/
/* 15291*/     OPC_CheckChild1Same, 1,
/* 15293*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1)), V128:{ *:[v8i16] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15301*/    0, /*End of Scope*/
/* 15302*/   0, /*End of Scope*/
/* 15303*/  /*Scope*/ 102, /*->15406*/
/* 15304*/   OPC_RecordChild0, // #0 = $v2
/* 15305*/   OPC_MoveChild1,
/* 15306*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15309*/   OPC_MoveChild0,
/* 15310*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15313*/   OPC_Scope, 23, /*->15338*/ // 3 children in Scope
/* 15315*/    OPC_RecordChild0, // #1 = $v1
/* 15316*/    OPC_CheckChild1Same, 0,
/* 15318*/    OPC_MoveSibling1,
/* 15319*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15322*/    OPC_RecordChild0, // #2 = $c
/* 15323*/    OPC_MoveChild1,
/* 15324*/    OPC_CheckImmAllOnesV,
/* 15325*/    OPC_MoveParent,
/* 15326*/    OPC_MoveParent,
/* 15327*/    OPC_MoveParent,
/* 15328*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 15330*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15338*/   /*Scope*/ 23, /*->15362*/
/* 15339*/    OPC_CheckChild0Same, 0,
/* 15341*/    OPC_RecordChild1, // #1 = $v1
/* 15342*/    OPC_MoveSibling1,
/* 15343*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15346*/    OPC_RecordChild0, // #2 = $c
/* 15347*/    OPC_MoveChild1,
/* 15348*/    OPC_CheckImmAllOnesV,
/* 15349*/    OPC_MoveParent,
/* 15350*/    OPC_MoveParent,
/* 15351*/    OPC_MoveParent,
/* 15352*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 15354*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15362*/   /*Scope*/ 42, /*->15405*/
/* 15363*/    OPC_RecordChild0, // #1 = $c
/* 15364*/    OPC_MoveChild1,
/* 15365*/    OPC_CheckImmAllOnesV,
/* 15366*/    OPC_MoveParent,
/* 15367*/    OPC_MoveSibling1,
/* 15368*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15371*/    OPC_Scope, 15, /*->15388*/ // 2 children in Scope
/* 15373*/     OPC_RecordChild0, // #2 = $v1
/* 15374*/     OPC_CheckChild1Same, 0,
/* 15376*/     OPC_MoveParent,
/* 15377*/     OPC_MoveParent,
/* 15378*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 15380*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15388*/    /*Scope*/ 15, /*->15404*/
/* 15389*/     OPC_CheckChild0Same, 0,
/* 15391*/     OPC_RecordChild1, // #2 = $v1
/* 15392*/     OPC_MoveParent,
/* 15393*/     OPC_MoveParent,
/* 15394*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 15396*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15404*/    0, /*End of Scope*/
/* 15405*/   0, /*End of Scope*/
/* 15406*/  /*Scope*/ 73, /*->15480*/
/* 15407*/   OPC_MoveChild0,
/* 15408*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15411*/   OPC_MoveChild0,
/* 15412*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15415*/   OPC_RecordChild0, // #0 = $v2
/* 15416*/   OPC_Scope, 23, /*->15441*/ // 2 children in Scope
/* 15418*/    OPC_RecordChild1, // #1 = $v1
/* 15419*/    OPC_MoveSibling1,
/* 15420*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15423*/    OPC_RecordChild0, // #2 = $c
/* 15424*/    OPC_MoveChild1,
/* 15425*/    OPC_CheckImmAllOnesV,
/* 15426*/    OPC_MoveParent,
/* 15427*/    OPC_MoveParent,
/* 15428*/    OPC_MoveParent,
/* 15429*/    OPC_CheckChild1Same, 0,
/* 15431*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 15433*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15441*/   /*Scope*/ 37, /*->15479*/
/* 15442*/    OPC_MoveChild1,
/* 15443*/    OPC_CheckImmAllOnesV,
/* 15444*/    OPC_MoveParent,
/* 15445*/    OPC_MoveSibling1,
/* 15446*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15449*/    OPC_RecordChild0, // #1 = $v1
/* 15450*/    OPC_RecordChild1, // #2 = $v2
/* 15451*/    OPC_MoveParent,
/* 15452*/    OPC_MoveParent,
/* 15453*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 15455*/    OPC_Scope, 10, /*->15467*/ // 2 children in Scope
/* 15457*/     OPC_CheckChild1Same, 2,
/* 15459*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2)), V128:{ *:[v4i32] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15467*/    /*Scope*/ 10, /*->15478*/
/* 15468*/     OPC_CheckChild1Same, 1,
/* 15470*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1)), V128:{ *:[v4i32] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15478*/    0, /*End of Scope*/
/* 15479*/   0, /*End of Scope*/
/* 15480*/  /*Scope*/ 102, /*->15583*/
/* 15481*/   OPC_RecordChild0, // #0 = $v2
/* 15482*/   OPC_MoveChild1,
/* 15483*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15486*/   OPC_MoveChild0,
/* 15487*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15490*/   OPC_Scope, 23, /*->15515*/ // 3 children in Scope
/* 15492*/    OPC_RecordChild0, // #1 = $v1
/* 15493*/    OPC_CheckChild1Same, 0,
/* 15495*/    OPC_MoveSibling1,
/* 15496*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15499*/    OPC_RecordChild0, // #2 = $c
/* 15500*/    OPC_MoveChild1,
/* 15501*/    OPC_CheckImmAllOnesV,
/* 15502*/    OPC_MoveParent,
/* 15503*/    OPC_MoveParent,
/* 15504*/    OPC_MoveParent,
/* 15505*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 15507*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15515*/   /*Scope*/ 23, /*->15539*/
/* 15516*/    OPC_CheckChild0Same, 0,
/* 15518*/    OPC_RecordChild1, // #1 = $v1
/* 15519*/    OPC_MoveSibling1,
/* 15520*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15523*/    OPC_RecordChild0, // #2 = $c
/* 15524*/    OPC_MoveChild1,
/* 15525*/    OPC_CheckImmAllOnesV,
/* 15526*/    OPC_MoveParent,
/* 15527*/    OPC_MoveParent,
/* 15528*/    OPC_MoveParent,
/* 15529*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 15531*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15539*/   /*Scope*/ 42, /*->15582*/
/* 15540*/    OPC_RecordChild0, // #1 = $c
/* 15541*/    OPC_MoveChild1,
/* 15542*/    OPC_CheckImmAllOnesV,
/* 15543*/    OPC_MoveParent,
/* 15544*/    OPC_MoveSibling1,
/* 15545*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15548*/    OPC_Scope, 15, /*->15565*/ // 2 children in Scope
/* 15550*/     OPC_RecordChild0, // #2 = $v1
/* 15551*/     OPC_CheckChild1Same, 0,
/* 15553*/     OPC_MoveParent,
/* 15554*/     OPC_MoveParent,
/* 15555*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 15557*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15565*/    /*Scope*/ 15, /*->15581*/
/* 15566*/     OPC_CheckChild0Same, 0,
/* 15568*/     OPC_RecordChild1, // #2 = $v1
/* 15569*/     OPC_MoveParent,
/* 15570*/     OPC_MoveParent,
/* 15571*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 15573*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15581*/    0, /*End of Scope*/
/* 15582*/   0, /*End of Scope*/
/* 15583*/  /*Scope*/ 73, /*->15657*/
/* 15584*/   OPC_MoveChild0,
/* 15585*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15588*/   OPC_MoveChild0,
/* 15589*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15592*/   OPC_RecordChild0, // #0 = $v2
/* 15593*/   OPC_Scope, 23, /*->15618*/ // 2 children in Scope
/* 15595*/    OPC_RecordChild1, // #1 = $v1
/* 15596*/    OPC_MoveSibling1,
/* 15597*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15600*/    OPC_RecordChild0, // #2 = $c
/* 15601*/    OPC_MoveChild1,
/* 15602*/    OPC_CheckImmAllOnesV,
/* 15603*/    OPC_MoveParent,
/* 15604*/    OPC_MoveParent,
/* 15605*/    OPC_MoveParent,
/* 15606*/    OPC_CheckChild1Same, 0,
/* 15608*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 15610*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15618*/   /*Scope*/ 37, /*->15656*/
/* 15619*/    OPC_MoveChild1,
/* 15620*/    OPC_CheckImmAllOnesV,
/* 15621*/    OPC_MoveParent,
/* 15622*/    OPC_MoveSibling1,
/* 15623*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15626*/    OPC_RecordChild0, // #1 = $v1
/* 15627*/    OPC_RecordChild1, // #2 = $v2
/* 15628*/    OPC_MoveParent,
/* 15629*/    OPC_MoveParent,
/* 15630*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 15632*/    OPC_Scope, 10, /*->15644*/ // 2 children in Scope
/* 15634*/     OPC_CheckChild1Same, 2,
/* 15636*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2)), V128:{ *:[v2i64] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15644*/    /*Scope*/ 10, /*->15655*/
/* 15645*/     OPC_CheckChild1Same, 1,
/* 15647*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1)), V128:{ *:[v2i64] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15655*/    0, /*End of Scope*/
/* 15656*/   0, /*End of Scope*/
/* 15657*/  /*Scope*/ 102, /*->15760*/
/* 15658*/   OPC_RecordChild0, // #0 = $v2
/* 15659*/   OPC_MoveChild1,
/* 15660*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15663*/   OPC_MoveChild0,
/* 15664*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15667*/   OPC_Scope, 23, /*->15692*/ // 3 children in Scope
/* 15669*/    OPC_RecordChild0, // #1 = $v1
/* 15670*/    OPC_CheckChild1Same, 0,
/* 15672*/    OPC_MoveSibling1,
/* 15673*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15676*/    OPC_RecordChild0, // #2 = $c
/* 15677*/    OPC_MoveChild1,
/* 15678*/    OPC_CheckImmAllOnesV,
/* 15679*/    OPC_MoveParent,
/* 15680*/    OPC_MoveParent,
/* 15681*/    OPC_MoveParent,
/* 15682*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 15684*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15692*/   /*Scope*/ 23, /*->15716*/
/* 15693*/    OPC_CheckChild0Same, 0,
/* 15695*/    OPC_RecordChild1, // #1 = $v1
/* 15696*/    OPC_MoveSibling1,
/* 15697*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15700*/    OPC_RecordChild0, // #2 = $c
/* 15701*/    OPC_MoveChild1,
/* 15702*/    OPC_CheckImmAllOnesV,
/* 15703*/    OPC_MoveParent,
/* 15704*/    OPC_MoveParent,
/* 15705*/    OPC_MoveParent,
/* 15706*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 15708*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15716*/   /*Scope*/ 42, /*->15759*/
/* 15717*/    OPC_RecordChild0, // #1 = $c
/* 15718*/    OPC_MoveChild1,
/* 15719*/    OPC_CheckImmAllOnesV,
/* 15720*/    OPC_MoveParent,
/* 15721*/    OPC_MoveSibling1,
/* 15722*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15725*/    OPC_Scope, 15, /*->15742*/ // 2 children in Scope
/* 15727*/     OPC_RecordChild0, // #2 = $v1
/* 15728*/     OPC_CheckChild1Same, 0,
/* 15730*/     OPC_MoveParent,
/* 15731*/     OPC_MoveParent,
/* 15732*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 15734*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15742*/    /*Scope*/ 15, /*->15758*/
/* 15743*/     OPC_CheckChild0Same, 0,
/* 15745*/     OPC_RecordChild1, // #2 = $v1
/* 15746*/     OPC_MoveParent,
/* 15747*/     OPC_MoveParent,
/* 15748*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 15750*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15758*/    0, /*End of Scope*/
/* 15759*/   0, /*End of Scope*/
/* 15760*/  /*Scope*/ 112, /*->15873*/
/* 15761*/   OPC_MoveChild0,
/* 15762*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15765*/   OPC_Scope, 69, /*->15836*/ // 2 children in Scope
/* 15767*/    OPC_MoveChild0,
/* 15768*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15771*/    OPC_RecordChild0, // #0 = $v1
/* 15772*/    OPC_RecordChild1, // #1 = $v2
/* 15773*/    OPC_MoveParent,
/* 15774*/    OPC_RecordChild1, // #2 = $c
/* 15775*/    OPC_MoveParent,
/* 15776*/    OPC_Scope, 44, /*->15822*/ // 2 children in Scope
/* 15778*/     OPC_CheckChild1Same, 1,
/* 15780*/     OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->15791
/* 15783*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v16i8*/39, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), V128:{ *:[v16i8] }:$c), V128:{ *:[v16i8] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15791*/     /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->15801
/* 15793*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), V128:{ *:[v8i16] }:$c), V128:{ *:[v8i16] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15801*/     /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->15811
/* 15803*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), V128:{ *:[v4i32] }:$c), V128:{ *:[v4i32] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15811*/     /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->15821
/* 15813*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), V128:{ *:[v2i64] }:$c), V128:{ *:[v2i64] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 15821*/     0, // EndSwitchType
/* 15822*/    /*Scope*/ 12, /*->15835*/
/* 15823*/     OPC_CheckChild1Same, 0,
/* 15825*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15827*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), V128:{ *:[v16i8] }:$c), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15835*/    0, /*End of Scope*/
/* 15836*/   /*Scope*/ 35, /*->15872*/
/* 15837*/    OPC_RecordChild0, // #0 = $c
/* 15838*/    OPC_MoveChild1,
/* 15839*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15842*/    OPC_RecordChild0, // #1 = $v1
/* 15843*/    OPC_RecordChild1, // #2 = $v2
/* 15844*/    OPC_MoveParent,
/* 15845*/    OPC_MoveParent,
/* 15846*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 15848*/    OPC_Scope, 10, /*->15860*/ // 2 children in Scope
/* 15850*/     OPC_CheckChild1Same, 2,
/* 15852*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2)), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15860*/    /*Scope*/ 10, /*->15871*/
/* 15861*/     OPC_CheckChild1Same, 1,
/* 15863*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1)), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15871*/    0, /*End of Scope*/
/* 15872*/   0, /*End of Scope*/
/* 15873*/  /*Scope*/ 88, /*->15962*/
/* 15874*/   OPC_RecordChild0, // #0 = $v2
/* 15875*/   OPC_MoveChild1,
/* 15876*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15879*/   OPC_Scope, 40, /*->15921*/ // 2 children in Scope
/* 15881*/    OPC_MoveChild0,
/* 15882*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15885*/    OPC_Scope, 16, /*->15903*/ // 2 children in Scope
/* 15887*/     OPC_RecordChild0, // #1 = $v1
/* 15888*/     OPC_CheckChild1Same, 0,
/* 15890*/     OPC_MoveParent,
/* 15891*/     OPC_RecordChild1, // #2 = $c
/* 15892*/     OPC_MoveParent,
/* 15893*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15895*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), V128:{ *:[v16i8] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15903*/    /*Scope*/ 16, /*->15920*/
/* 15904*/     OPC_CheckChild0Same, 0,
/* 15906*/     OPC_RecordChild1, // #1 = $v1
/* 15907*/     OPC_MoveParent,
/* 15908*/     OPC_RecordChild1, // #2 = $c
/* 15909*/     OPC_MoveParent,
/* 15910*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15912*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), V128:{ *:[v16i8] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15920*/    0, /*End of Scope*/
/* 15921*/   /*Scope*/ 39, /*->15961*/
/* 15922*/    OPC_RecordChild0, // #1 = $c
/* 15923*/    OPC_MoveChild1,
/* 15924*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15927*/    OPC_Scope, 15, /*->15944*/ // 2 children in Scope
/* 15929*/     OPC_RecordChild0, // #2 = $v1
/* 15930*/     OPC_CheckChild1Same, 0,
/* 15932*/     OPC_MoveParent,
/* 15933*/     OPC_MoveParent,
/* 15934*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15936*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15944*/    /*Scope*/ 15, /*->15960*/
/* 15945*/     OPC_CheckChild0Same, 0,
/* 15947*/     OPC_RecordChild1, // #2 = $v1
/* 15948*/     OPC_MoveParent,
/* 15949*/     OPC_MoveParent,
/* 15950*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15952*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15960*/    0, /*End of Scope*/
/* 15961*/   0, /*End of Scope*/
/* 15962*/  /*Scope*/ 64, /*->16027*/
/* 15963*/   OPC_MoveChild0,
/* 15964*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15967*/   OPC_Scope, 21, /*->15990*/ // 2 children in Scope
/* 15969*/    OPC_MoveChild0,
/* 15970*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15973*/    OPC_RecordChild0, // #0 = $v2
/* 15974*/    OPC_RecordChild1, // #1 = $v1
/* 15975*/    OPC_MoveParent,
/* 15976*/    OPC_RecordChild1, // #2 = $c
/* 15977*/    OPC_MoveParent,
/* 15978*/    OPC_CheckChild1Same, 0,
/* 15980*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 15982*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), V128:{ *:[v8i16] }:$c), V128:{ *:[v8i16] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15990*/   /*Scope*/ 35, /*->16026*/
/* 15991*/    OPC_RecordChild0, // #0 = $c
/* 15992*/    OPC_MoveChild1,
/* 15993*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15996*/    OPC_RecordChild0, // #1 = $v1
/* 15997*/    OPC_RecordChild1, // #2 = $v2
/* 15998*/    OPC_MoveParent,
/* 15999*/    OPC_MoveParent,
/* 16000*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 16002*/    OPC_Scope, 10, /*->16014*/ // 2 children in Scope
/* 16004*/     OPC_CheckChild1Same, 2,
/* 16006*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2)), V128:{ *:[v8i16] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 16014*/    /*Scope*/ 10, /*->16025*/
/* 16015*/     OPC_CheckChild1Same, 1,
/* 16017*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1)), V128:{ *:[v8i16] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 16025*/    0, /*End of Scope*/
/* 16026*/   0, /*End of Scope*/
/* 16027*/  /*Scope*/ 88, /*->16116*/
/* 16028*/   OPC_RecordChild0, // #0 = $v2
/* 16029*/   OPC_MoveChild1,
/* 16030*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16033*/   OPC_Scope, 40, /*->16075*/ // 2 children in Scope
/* 16035*/    OPC_MoveChild0,
/* 16036*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16039*/    OPC_Scope, 16, /*->16057*/ // 2 children in Scope
/* 16041*/     OPC_RecordChild0, // #1 = $v1
/* 16042*/     OPC_CheckChild1Same, 0,
/* 16044*/     OPC_MoveParent,
/* 16045*/     OPC_RecordChild1, // #2 = $c
/* 16046*/     OPC_MoveParent,
/* 16047*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 16049*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), V128:{ *:[v8i16] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 16057*/    /*Scope*/ 16, /*->16074*/
/* 16058*/     OPC_CheckChild0Same, 0,
/* 16060*/     OPC_RecordChild1, // #1 = $v1
/* 16061*/     OPC_MoveParent,
/* 16062*/     OPC_RecordChild1, // #2 = $c
/* 16063*/     OPC_MoveParent,
/* 16064*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 16066*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), V128:{ *:[v8i16] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 16074*/    0, /*End of Scope*/
/* 16075*/   /*Scope*/ 39, /*->16115*/
/* 16076*/    OPC_RecordChild0, // #1 = $c
/* 16077*/    OPC_MoveChild1,
/* 16078*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16081*/    OPC_Scope, 15, /*->16098*/ // 2 children in Scope
/* 16083*/     OPC_RecordChild0, // #2 = $v1
/* 16084*/     OPC_CheckChild1Same, 0,
/* 16086*/     OPC_MoveParent,
/* 16087*/     OPC_MoveParent,
/* 16088*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 16090*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 16098*/    /*Scope*/ 15, /*->16114*/
/* 16099*/     OPC_CheckChild0Same, 0,
/* 16101*/     OPC_RecordChild1, // #2 = $v1
/* 16102*/     OPC_MoveParent,
/* 16103*/     OPC_MoveParent,
/* 16104*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 16106*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 16114*/    0, /*End of Scope*/
/* 16115*/   0, /*End of Scope*/
/* 16116*/  /*Scope*/ 64, /*->16181*/
/* 16117*/   OPC_MoveChild0,
/* 16118*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16121*/   OPC_Scope, 21, /*->16144*/ // 2 children in Scope
/* 16123*/    OPC_MoveChild0,
/* 16124*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16127*/    OPC_RecordChild0, // #0 = $v2
/* 16128*/    OPC_RecordChild1, // #1 = $v1
/* 16129*/    OPC_MoveParent,
/* 16130*/    OPC_RecordChild1, // #2 = $c
/* 16131*/    OPC_MoveParent,
/* 16132*/    OPC_CheckChild1Same, 0,
/* 16134*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 16136*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), V128:{ *:[v4i32] }:$c), V128:{ *:[v4i32] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16144*/   /*Scope*/ 35, /*->16180*/
/* 16145*/    OPC_RecordChild0, // #0 = $c
/* 16146*/    OPC_MoveChild1,
/* 16147*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16150*/    OPC_RecordChild0, // #1 = $v1
/* 16151*/    OPC_RecordChild1, // #2 = $v2
/* 16152*/    OPC_MoveParent,
/* 16153*/    OPC_MoveParent,
/* 16154*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 16156*/    OPC_Scope, 10, /*->16168*/ // 2 children in Scope
/* 16158*/     OPC_CheckChild1Same, 2,
/* 16160*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2)), V128:{ *:[v4i32] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16168*/    /*Scope*/ 10, /*->16179*/
/* 16169*/     OPC_CheckChild1Same, 1,
/* 16171*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1)), V128:{ *:[v4i32] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16179*/    0, /*End of Scope*/
/* 16180*/   0, /*End of Scope*/
/* 16181*/  /*Scope*/ 88, /*->16270*/
/* 16182*/   OPC_RecordChild0, // #0 = $v2
/* 16183*/   OPC_MoveChild1,
/* 16184*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16187*/   OPC_Scope, 40, /*->16229*/ // 2 children in Scope
/* 16189*/    OPC_MoveChild0,
/* 16190*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16193*/    OPC_Scope, 16, /*->16211*/ // 2 children in Scope
/* 16195*/     OPC_RecordChild0, // #1 = $v1
/* 16196*/     OPC_CheckChild1Same, 0,
/* 16198*/     OPC_MoveParent,
/* 16199*/     OPC_RecordChild1, // #2 = $c
/* 16200*/     OPC_MoveParent,
/* 16201*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 16203*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), V128:{ *:[v4i32] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16211*/    /*Scope*/ 16, /*->16228*/
/* 16212*/     OPC_CheckChild0Same, 0,
/* 16214*/     OPC_RecordChild1, // #1 = $v1
/* 16215*/     OPC_MoveParent,
/* 16216*/     OPC_RecordChild1, // #2 = $c
/* 16217*/     OPC_MoveParent,
/* 16218*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 16220*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), V128:{ *:[v4i32] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16228*/    0, /*End of Scope*/
/* 16229*/   /*Scope*/ 39, /*->16269*/
/* 16230*/    OPC_RecordChild0, // #1 = $c
/* 16231*/    OPC_MoveChild1,
/* 16232*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16235*/    OPC_Scope, 15, /*->16252*/ // 2 children in Scope
/* 16237*/     OPC_RecordChild0, // #2 = $v1
/* 16238*/     OPC_CheckChild1Same, 0,
/* 16240*/     OPC_MoveParent,
/* 16241*/     OPC_MoveParent,
/* 16242*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 16244*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16252*/    /*Scope*/ 15, /*->16268*/
/* 16253*/     OPC_CheckChild0Same, 0,
/* 16255*/     OPC_RecordChild1, // #2 = $v1
/* 16256*/     OPC_MoveParent,
/* 16257*/     OPC_MoveParent,
/* 16258*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 16260*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16268*/    0, /*End of Scope*/
/* 16269*/   0, /*End of Scope*/
/* 16270*/  /*Scope*/ 64, /*->16335*/
/* 16271*/   OPC_MoveChild0,
/* 16272*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16275*/   OPC_Scope, 21, /*->16298*/ // 2 children in Scope
/* 16277*/    OPC_MoveChild0,
/* 16278*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16281*/    OPC_RecordChild0, // #0 = $v2
/* 16282*/    OPC_RecordChild1, // #1 = $v1
/* 16283*/    OPC_MoveParent,
/* 16284*/    OPC_RecordChild1, // #2 = $c
/* 16285*/    OPC_MoveParent,
/* 16286*/    OPC_CheckChild1Same, 0,
/* 16288*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 16290*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), V128:{ *:[v2i64] }:$c), V128:{ *:[v2i64] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16298*/   /*Scope*/ 35, /*->16334*/
/* 16299*/    OPC_RecordChild0, // #0 = $c
/* 16300*/    OPC_MoveChild1,
/* 16301*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16304*/    OPC_RecordChild0, // #1 = $v1
/* 16305*/    OPC_RecordChild1, // #2 = $v2
/* 16306*/    OPC_MoveParent,
/* 16307*/    OPC_MoveParent,
/* 16308*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 16310*/    OPC_Scope, 10, /*->16322*/ // 2 children in Scope
/* 16312*/     OPC_CheckChild1Same, 2,
/* 16314*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2)), V128:{ *:[v2i64] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16322*/    /*Scope*/ 10, /*->16333*/
/* 16323*/     OPC_CheckChild1Same, 1,
/* 16325*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1)), V128:{ *:[v2i64] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16333*/    0, /*End of Scope*/
/* 16334*/   0, /*End of Scope*/
/* 16335*/  /*Scope*/ 43|128,1/*171*/, /*->16508*/
/* 16337*/   OPC_RecordChild0, // #0 = $v2
/* 16338*/   OPC_Scope, 127, /*->16467*/ // 2 children in Scope
/* 16340*/    OPC_MoveChild1,
/* 16341*/    OPC_Scope, 86, /*->16429*/ // 2 children in Scope
/* 16343*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16346*/     OPC_Scope, 40, /*->16388*/ // 2 children in Scope
/* 16348*/      OPC_MoveChild0,
/* 16349*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16352*/      OPC_Scope, 16, /*->16370*/ // 2 children in Scope
/* 16354*/       OPC_RecordChild0, // #1 = $v1
/* 16355*/       OPC_CheckChild1Same, 0,
/* 16357*/       OPC_MoveParent,
/* 16358*/       OPC_RecordChild1, // #2 = $c
/* 16359*/       OPC_MoveParent,
/* 16360*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 16362*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     /*MVT::v2i64*/78, 3/*#Ops*/, 1, 0, 2, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), V128:{ *:[v2i64] }:$c)) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16370*/      /*Scope*/ 16, /*->16387*/
/* 16371*/       OPC_CheckChild0Same, 0,
/* 16373*/       OPC_RecordChild1, // #1 = $v1
/* 16374*/       OPC_MoveParent,
/* 16375*/       OPC_RecordChild1, // #2 = $c
/* 16376*/       OPC_MoveParent,
/* 16377*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 16379*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     /*MVT::v2i64*/78, 3/*#Ops*/, 1, 0, 2, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), V128:{ *:[v2i64] }:$c)) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16387*/      0, /*End of Scope*/
/* 16388*/     /*Scope*/ 39, /*->16428*/
/* 16389*/      OPC_RecordChild0, // #1 = $c
/* 16390*/      OPC_MoveChild1,
/* 16391*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16394*/      OPC_Scope, 15, /*->16411*/ // 2 children in Scope
/* 16396*/       OPC_RecordChild0, // #2 = $v1
/* 16397*/       OPC_CheckChild1Same, 0,
/* 16399*/       OPC_MoveParent,
/* 16400*/       OPC_MoveParent,
/* 16401*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 16403*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     /*MVT::v2i64*/78, 3/*#Ops*/, 2, 0, 1, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2))) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16411*/      /*Scope*/ 15, /*->16427*/
/* 16412*/       OPC_CheckChild0Same, 0,
/* 16414*/       OPC_RecordChild1, // #2 = $v1
/* 16415*/       OPC_MoveParent,
/* 16416*/       OPC_MoveParent,
/* 16417*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 16419*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     /*MVT::v2i64*/78, 3/*#Ops*/, 2, 0, 1, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1))) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16427*/      0, /*End of Scope*/
/* 16428*/     0, /*End of Scope*/
/* 16429*/    /*Scope*/ 36, /*->16466*/
/* 16430*/     OPC_CheckImmAllOnesV,
/* 16431*/     OPC_MoveParent,
/* 16432*/     OPC_SwitchType /*4 cases */, 6, /*MVT::v16i8*/39, // ->16441
/* 16435*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    /*MVT::v16i8*/39, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v, immAllOnesV:{ *:[v16i8] }) - Complexity = 7
                // Dst: (NOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v)
/* 16441*/     /*SwitchType*/ 6, /*MVT::v8i16*/50, // ->16449
/* 16443*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v, immAllOnesV:{ *:[v8i16] }) - Complexity = 7
                // Dst: (NOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v)
/* 16449*/     /*SwitchType*/ 6, /*MVT::v4i32*/60, // ->16457
/* 16451*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v, immAllOnesV:{ *:[v4i32] }) - Complexity = 7
                // Dst: (NOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v)
/* 16457*/     /*SwitchType*/ 6, /*MVT::v2i64*/78, // ->16465
/* 16459*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v, immAllOnesV:{ *:[v2i64] }) - Complexity = 7
                // Dst: (NOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v)
/* 16465*/     0, // EndSwitchType
/* 16466*/    0, /*End of Scope*/
/* 16467*/   /*Scope*/ 39, /*->16507*/
/* 16468*/    OPC_RecordChild1, // #1 = $rhs
/* 16469*/    OPC_SwitchType /*4 cases */, 7, /*MVT::v16i8*/39, // ->16479
/* 16472*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 16479*/    /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->16488
/* 16481*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 16488*/    /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->16497
/* 16490*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 16497*/    /*SwitchType*/ 7, /*MVT::v2i64*/78, // ->16506
/* 16499*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 16506*/    0, // EndSwitchType
/* 16507*/   0, /*End of Scope*/
/* 16508*/  0, /*End of Scope*/
/* 16509*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CTLZ),// ->16533
/* 16512*/  OPC_RecordChild0, // #0 = $src
/* 16513*/  OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->16523
/* 16516*/   OPC_CheckChild0TypeI32,
/* 16517*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CLZ_I32),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (ctlz:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (CLZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 16523*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->16532
/* 16525*/   OPC_CheckChild0TypeI64,
/* 16526*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CLZ_I64),
                 /*MVT::i64*/8, 1/*#Ops*/, 0, 
             // Src: (ctlz:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (CLZ_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 16532*/  0, // EndSwitchType
/* 16533*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CTTZ),// ->16557
/* 16536*/  OPC_RecordChild0, // #0 = $src
/* 16537*/  OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->16547
/* 16540*/   OPC_CheckChild0TypeI32,
/* 16541*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CTZ_I32),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (cttz:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (CTZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 16547*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->16556
/* 16549*/   OPC_CheckChild0TypeI64,
/* 16550*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CTZ_I64),
                 /*MVT::i64*/8, 1/*#Ops*/, 0, 
             // Src: (cttz:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (CTZ_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 16556*/  0, // EndSwitchType
/* 16557*/ /*SwitchOpcode*/ 32, TARGET_VAL(ISD::CTPOP),// ->16592
/* 16560*/  OPC_RecordChild0, // #0 = $src
/* 16561*/  OPC_SwitchType /*3 cases */, 7, /*MVT::i32*/7, // ->16571
/* 16564*/   OPC_CheckChild0TypeI32,
/* 16565*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::POPCNT_I32),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (POPCNT_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 16571*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->16580
/* 16573*/   OPC_CheckChild0TypeI64,
/* 16574*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::POPCNT_I64),
                 /*MVT::i64*/8, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (POPCNT_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 16580*/  /*SwitchType*/ 9, /*MVT::v16i8*/39, // ->16591
/* 16582*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 16584*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16585*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::POPCNT_I8x16),
                 /*MVT::v16i8*/39, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[v16i8] } V128:{ *:[v16i8] }:$v) - Complexity = 3
             // Dst: (POPCNT_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 16591*/  0, // EndSwitchType
/* 16592*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::TRUNCATE),// ->16602
/* 16595*/  OPC_RecordChild0, // #0 = $src
/* 16596*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                /*MVT::i32*/7, 1/*#Ops*/, 0, 
            // Src: (trunc:{ *:[i32] } I64:{ *:[i64] }:$src) - Complexity = 3
            // Dst: (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$src)
/* 16602*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::SIGN_EXTEND),// ->16612
/* 16605*/  OPC_RecordChild0, // #0 = $src
/* 16606*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND_S_I32),
                /*MVT::i64*/8, 1/*#Ops*/, 0, 
            // Src: (sext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
            // Dst: (I64_EXTEND_S_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/* 16612*/ /*SwitchOpcode*/ 121, TARGET_VAL(ISD::FP_TO_SINT),// ->16736
/* 16615*/  OPC_RecordChild0, // #0 = $src
/* 16616*/  OPC_Scope, 48, /*->16666*/ // 4 children in Scope
/* 16618*/   OPC_CheckChild0Type, /*MVT::f32*/12, 
/* 16620*/   OPC_SwitchType /*2 cases */, 20, /*MVT::i32*/7, // ->16643
/* 16623*/    OPC_Scope, 8, /*->16633*/ // 2 children in Scope
/* 16625*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16627*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_S_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16633*/    /*Scope*/ 8, /*->16642*/
/* 16634*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16636*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I32_F32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I32_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16642*/    0, /*End of Scope*/
/* 16643*/   /*SwitchType*/ 20, /*MVT::i64*/8, // ->16665
/* 16645*/    OPC_Scope, 8, /*->16655*/ // 2 children in Scope
/* 16647*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16649*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F32),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_S_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16655*/    /*Scope*/ 8, /*->16664*/
/* 16656*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16658*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I64_F32),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I64_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16664*/    0, /*End of Scope*/
/* 16665*/   0, // EndSwitchType
/* 16666*/  /*Scope*/ 48, /*->16715*/
/* 16667*/   OPC_CheckChild0Type, /*MVT::f64*/13, 
/* 16669*/   OPC_SwitchType /*2 cases */, 20, /*MVT::i32*/7, // ->16692
/* 16672*/    OPC_Scope, 8, /*->16682*/ // 2 children in Scope
/* 16674*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16676*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F64),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_S_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16682*/    /*Scope*/ 8, /*->16691*/
/* 16683*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16685*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I32_F64),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I32_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16691*/    0, /*End of Scope*/
/* 16692*/   /*SwitchType*/ 20, /*MVT::i64*/8, // ->16714
/* 16694*/    OPC_Scope, 8, /*->16704*/ // 2 children in Scope
/* 16696*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16698*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_S_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16704*/    /*Scope*/ 8, /*->16713*/
/* 16705*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16707*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I64_F64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I64_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16713*/    0, /*End of Scope*/
/* 16714*/   0, // EndSwitchType
/* 16715*/  /*Scope*/ 9, /*->16725*/
/* 16716*/   OPC_CheckType, /*MVT::v4i32*/60, 
/* 16718*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16719*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_sint_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
             // Dst: (fp_to_sint_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 16725*/  /*Scope*/ 9, /*->16735*/
/* 16726*/   OPC_CheckType, /*MVT::v8i16*/50, 
/* 16728*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 16729*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_sint_I16x8),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (fp_to_sint:{ *:[v8i16] } V128:{ *:[v8f16] }:$vec) - Complexity = 3
             // Dst: (fp_to_sint_I16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$vec)
/* 16735*/  0, /*End of Scope*/
/* 16736*/ /*SwitchOpcode*/ 121, TARGET_VAL(ISD::FP_TO_UINT),// ->16860
/* 16739*/  OPC_RecordChild0, // #0 = $src
/* 16740*/  OPC_Scope, 48, /*->16790*/ // 4 children in Scope
/* 16742*/   OPC_CheckChild0Type, /*MVT::f32*/12, 
/* 16744*/   OPC_SwitchType /*2 cases */, 20, /*MVT::i32*/7, // ->16767
/* 16747*/    OPC_Scope, 8, /*->16757*/ // 2 children in Scope
/* 16749*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16751*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_U_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16757*/    /*Scope*/ 8, /*->16766*/
/* 16758*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16760*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I32_F32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I32_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16766*/    0, /*End of Scope*/
/* 16767*/   /*SwitchType*/ 20, /*MVT::i64*/8, // ->16789
/* 16769*/    OPC_Scope, 8, /*->16779*/ // 2 children in Scope
/* 16771*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16773*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F32),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_U_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16779*/    /*Scope*/ 8, /*->16788*/
/* 16780*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16782*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I64_F32),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I64_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16788*/    0, /*End of Scope*/
/* 16789*/   0, // EndSwitchType
/* 16790*/  /*Scope*/ 48, /*->16839*/
/* 16791*/   OPC_CheckChild0Type, /*MVT::f64*/13, 
/* 16793*/   OPC_SwitchType /*2 cases */, 20, /*MVT::i32*/7, // ->16816
/* 16796*/    OPC_Scope, 8, /*->16806*/ // 2 children in Scope
/* 16798*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16800*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F64),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_U_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16806*/    /*Scope*/ 8, /*->16815*/
/* 16807*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16809*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I32_F64),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I32_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16815*/    0, /*End of Scope*/
/* 16816*/   /*SwitchType*/ 20, /*MVT::i64*/8, // ->16838
/* 16818*/    OPC_Scope, 8, /*->16828*/ // 2 children in Scope
/* 16820*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16822*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_U_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16828*/    /*Scope*/ 8, /*->16837*/
/* 16829*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16831*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I64_F64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I64_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16837*/    0, /*End of Scope*/
/* 16838*/   0, // EndSwitchType
/* 16839*/  /*Scope*/ 9, /*->16849*/
/* 16840*/   OPC_CheckType, /*MVT::v4i32*/60, 
/* 16842*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16843*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_uint_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
             // Dst: (fp_to_uint_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 16849*/  /*Scope*/ 9, /*->16859*/
/* 16850*/   OPC_CheckType, /*MVT::v8i16*/50, 
/* 16852*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 16853*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_uint_I16x8),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (fp_to_uint:{ *:[v8i16] } V128:{ *:[v8f16] }:$vec) - Complexity = 3
             // Dst: (fp_to_uint_I16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$vec)
/* 16859*/  0, /*End of Scope*/
/* 16860*/ /*SwitchOpcode*/ 87, TARGET_VAL(ISD::FP_TO_SINT_SAT),// ->16950
/* 16863*/  OPC_RecordChild0, // #0 = $src
/* 16864*/  OPC_Scope, 27, /*->16893*/ // 3 children in Scope
/* 16866*/   OPC_CheckChild0Type, /*MVT::f32*/12, 
/* 16868*/   OPC_MoveChild1,
/* 16869*/   OPC_Scope, 10, /*->16881*/ // 2 children in Scope
/* 16871*/    OPC_CheckValueType, /*MVT::i32*/7, 
/* 16873*/    OPC_MoveParent,
/* 16874*/    OPC_CheckTypeI32,
/* 16875*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F32),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i32] } F32:{ *:[f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_S_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16881*/   /*Scope*/ 10, /*->16892*/
/* 16882*/    OPC_CheckValueType, /*MVT::i64*/8, 
/* 16884*/    OPC_MoveParent,
/* 16885*/    OPC_CheckTypeI64,
/* 16886*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F32),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i64] } F32:{ *:[f32] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_S_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16892*/   0, /*End of Scope*/
/* 16893*/  /*Scope*/ 27, /*->16921*/
/* 16894*/   OPC_CheckChild0Type, /*MVT::f64*/13, 
/* 16896*/   OPC_MoveChild1,
/* 16897*/   OPC_Scope, 10, /*->16909*/ // 2 children in Scope
/* 16899*/    OPC_CheckValueType, /*MVT::i32*/7, 
/* 16901*/    OPC_MoveParent,
/* 16902*/    OPC_CheckTypeI32,
/* 16903*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F64),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i32] } F64:{ *:[f64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_S_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16909*/   /*Scope*/ 10, /*->16920*/
/* 16910*/    OPC_CheckValueType, /*MVT::i64*/8, 
/* 16912*/    OPC_MoveParent,
/* 16913*/    OPC_CheckTypeI64,
/* 16914*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F64),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i64] } F64:{ *:[f64] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_S_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16920*/   0, /*End of Scope*/
/* 16921*/  /*Scope*/ 27, /*->16949*/
/* 16922*/   OPC_MoveChild1,
/* 16923*/   OPC_Scope, 11, /*->16936*/ // 2 children in Scope
/* 16925*/    OPC_CheckValueType, /*MVT::i32*/7, 
/* 16927*/    OPC_MoveParent,
/* 16928*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 16930*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_sint_I32x4),
                  /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[v4i32] } V128:{ *:[v4f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (fp_to_sint_I32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$src)
/* 16936*/   /*Scope*/ 11, /*->16948*/
/* 16937*/    OPC_CheckValueType, /*MVT::i16*/6, 
/* 16939*/    OPC_MoveParent,
/* 16940*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 16942*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_sint_I16x8),
                  /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[v8i16] } V128:{ *:[v8f16] }:$src, i16:{ *:[Other] }) - Complexity = 3
              // Dst: (fp_to_sint_I16x8:{ *:[v8i16] } ?:{ *:[v8f16] }:$src)
/* 16948*/   0, /*End of Scope*/
/* 16949*/  0, /*End of Scope*/
/* 16950*/ /*SwitchOpcode*/ 87, TARGET_VAL(ISD::FP_TO_UINT_SAT),// ->17040
/* 16953*/  OPC_RecordChild0, // #0 = $src
/* 16954*/  OPC_Scope, 27, /*->16983*/ // 3 children in Scope
/* 16956*/   OPC_CheckChild0Type, /*MVT::f32*/12, 
/* 16958*/   OPC_MoveChild1,
/* 16959*/   OPC_Scope, 10, /*->16971*/ // 2 children in Scope
/* 16961*/    OPC_CheckValueType, /*MVT::i32*/7, 
/* 16963*/    OPC_MoveParent,
/* 16964*/    OPC_CheckTypeI32,
/* 16965*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F32),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i32] } F32:{ *:[f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_U_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16971*/   /*Scope*/ 10, /*->16982*/
/* 16972*/    OPC_CheckValueType, /*MVT::i64*/8, 
/* 16974*/    OPC_MoveParent,
/* 16975*/    OPC_CheckTypeI64,
/* 16976*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F32),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i64] } F32:{ *:[f32] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_U_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16982*/   0, /*End of Scope*/
/* 16983*/  /*Scope*/ 27, /*->17011*/
/* 16984*/   OPC_CheckChild0Type, /*MVT::f64*/13, 
/* 16986*/   OPC_MoveChild1,
/* 16987*/   OPC_Scope, 10, /*->16999*/ // 2 children in Scope
/* 16989*/    OPC_CheckValueType, /*MVT::i32*/7, 
/* 16991*/    OPC_MoveParent,
/* 16992*/    OPC_CheckTypeI32,
/* 16993*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F64),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i32] } F64:{ *:[f64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_U_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16999*/   /*Scope*/ 10, /*->17010*/
/* 17000*/    OPC_CheckValueType, /*MVT::i64*/8, 
/* 17002*/    OPC_MoveParent,
/* 17003*/    OPC_CheckTypeI64,
/* 17004*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F64),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i64] } F64:{ *:[f64] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_U_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 17010*/   0, /*End of Scope*/
/* 17011*/  /*Scope*/ 27, /*->17039*/
/* 17012*/   OPC_MoveChild1,
/* 17013*/   OPC_Scope, 11, /*->17026*/ // 2 children in Scope
/* 17015*/    OPC_CheckValueType, /*MVT::i32*/7, 
/* 17017*/    OPC_MoveParent,
/* 17018*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 17020*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_uint_I32x4),
                  /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[v4i32] } V128:{ *:[v4f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (fp_to_uint_I32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$src)
/* 17026*/   /*Scope*/ 11, /*->17038*/
/* 17027*/    OPC_CheckValueType, /*MVT::i16*/6, 
/* 17029*/    OPC_MoveParent,
/* 17030*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 17032*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_uint_I16x8),
                  /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[v8i16] } V128:{ *:[v8f16] }:$src, i16:{ *:[Other] }) - Complexity = 3
              // Dst: (fp_to_uint_I16x8:{ *:[v8i16] } ?:{ *:[v8f16] }:$src)
/* 17038*/   0, /*End of Scope*/
/* 17039*/  0, /*End of Scope*/
/* 17040*/ /*SwitchOpcode*/ 39|128,2/*295*/, TARGET_VAL(ISD::BITCAST),// ->17339
/* 17044*/  OPC_RecordChild0, // #0 = $src
/* 17045*/  OPC_Scope, 9, /*->17056*/ // 11 children in Scope
/* 17047*/   OPC_CheckChild0Type, /*MVT::f32*/12, 
/* 17049*/   OPC_CheckTypeI32,
/* 17050*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_REINTERPRET_F32),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (I32_REINTERPRET_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 17056*/  /*Scope*/ 9, /*->17066*/
/* 17057*/   OPC_CheckChild0Type, /*MVT::f64*/13, 
/* 17059*/   OPC_CheckTypeI64,
/* 17060*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_REINTERPRET_F64),
                 /*MVT::i64*/8, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (I64_REINTERPRET_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 17066*/  /*Scope*/ 9, /*->17076*/
/* 17067*/   OPC_CheckChild0TypeI32,
/* 17068*/   OPC_CheckType, /*MVT::f32*/12, 
/* 17070*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_REINTERPRET_I32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (F32_REINTERPRET_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 17076*/  /*Scope*/ 9, /*->17086*/
/* 17077*/   OPC_CheckChild0TypeI64,
/* 17078*/   OPC_CheckType, /*MVT::f64*/13, 
/* 17080*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_REINTERPRET_I64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (F64_REINTERPRET_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 17086*/  /*Scope*/ 35, /*->17122*/
/* 17087*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 17089*/   OPC_SwitchType /*6 cases */, 3, /*MVT::v16i8*/39, // ->17095
/* 17092*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 17095*/   /*SwitchType*/ 3, /*MVT::v4i32*/60, // ->17100
/* 17097*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 17100*/   /*SwitchType*/ 3, /*MVT::v2i64*/78, // ->17105
/* 17102*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 17105*/   /*SwitchType*/ 3, /*MVT::v4f32*/110, // ->17110
/* 17107*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17110*/   /*SwitchType*/ 3, /*MVT::v2f64*/0|128,1/*128*/, // ->17116
/* 17113*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17116*/   /*SwitchType*/ 3, /*MVT::v8f16*/92, // ->17121
/* 17118*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8f16] }:$v
/* 17121*/   0, // EndSwitchType
/* 17122*/  /*Scope*/ 35, /*->17158*/
/* 17123*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 17125*/   OPC_SwitchType /*6 cases */, 3, /*MVT::v16i8*/39, // ->17131
/* 17128*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 17131*/   /*SwitchType*/ 3, /*MVT::v8i16*/50, // ->17136
/* 17133*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 17136*/   /*SwitchType*/ 3, /*MVT::v2i64*/78, // ->17141
/* 17138*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 17141*/   /*SwitchType*/ 3, /*MVT::v4f32*/110, // ->17146
/* 17143*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17146*/   /*SwitchType*/ 3, /*MVT::v2f64*/0|128,1/*128*/, // ->17152
/* 17149*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17152*/   /*SwitchType*/ 3, /*MVT::v8f16*/92, // ->17157
/* 17154*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8f16] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8f16] }:$v
/* 17157*/   0, // EndSwitchType
/* 17158*/  /*Scope*/ 35, /*->17194*/
/* 17159*/   OPC_CheckChild0Type, /*MVT::v2i64*/78, 
/* 17161*/   OPC_SwitchType /*6 cases */, 3, /*MVT::v16i8*/39, // ->17167
/* 17164*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 17167*/   /*SwitchType*/ 3, /*MVT::v8i16*/50, // ->17172
/* 17169*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 17172*/   /*SwitchType*/ 3, /*MVT::v4i32*/60, // ->17177
/* 17174*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 17177*/   /*SwitchType*/ 3, /*MVT::v4f32*/110, // ->17182
/* 17179*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17182*/   /*SwitchType*/ 3, /*MVT::v2f64*/0|128,1/*128*/, // ->17188
/* 17185*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17188*/   /*SwitchType*/ 3, /*MVT::v8f16*/92, // ->17193
/* 17190*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8f16] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8f16] }:$v
/* 17193*/   0, // EndSwitchType
/* 17194*/  /*Scope*/ 35, /*->17230*/
/* 17195*/   OPC_CheckChild0Type, /*MVT::v4f32*/110, 
/* 17197*/   OPC_SwitchType /*6 cases */, 3, /*MVT::v16i8*/39, // ->17203
/* 17200*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 17203*/   /*SwitchType*/ 3, /*MVT::v8i16*/50, // ->17208
/* 17205*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 17208*/   /*SwitchType*/ 3, /*MVT::v4i32*/60, // ->17213
/* 17210*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 17213*/   /*SwitchType*/ 3, /*MVT::v2i64*/78, // ->17218
/* 17215*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 17218*/   /*SwitchType*/ 3, /*MVT::v2f64*/0|128,1/*128*/, // ->17224
/* 17221*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17224*/   /*SwitchType*/ 3, /*MVT::v8f16*/92, // ->17229
/* 17226*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8f16] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8f16] }:$v
/* 17229*/   0, // EndSwitchType
/* 17230*/  /*Scope*/ 35, /*->17266*/
/* 17231*/   OPC_CheckChild0Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 17234*/   OPC_SwitchType /*6 cases */, 3, /*MVT::v16i8*/39, // ->17240
/* 17237*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 17240*/   /*SwitchType*/ 3, /*MVT::v8i16*/50, // ->17245
/* 17242*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 17245*/   /*SwitchType*/ 3, /*MVT::v4i32*/60, // ->17250
/* 17247*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 17250*/   /*SwitchType*/ 3, /*MVT::v2i64*/78, // ->17255
/* 17252*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 17255*/   /*SwitchType*/ 3, /*MVT::v4f32*/110, // ->17260
/* 17257*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17260*/   /*SwitchType*/ 3, /*MVT::v8f16*/92, // ->17265
/* 17262*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8f16] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8f16] }:$v
/* 17265*/   0, // EndSwitchType
/* 17266*/  /*Scope*/ 35, /*->17302*/
/* 17267*/   OPC_CheckChild0Type, /*MVT::v8f16*/92, 
/* 17269*/   OPC_SwitchType /*6 cases */, 3, /*MVT::v16i8*/39, // ->17275
/* 17272*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v8f16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 17275*/   /*SwitchType*/ 3, /*MVT::v8i16*/50, // ->17280
/* 17277*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 17280*/   /*SwitchType*/ 3, /*MVT::v4i32*/60, // ->17285
/* 17282*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v8f16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 17285*/   /*SwitchType*/ 3, /*MVT::v2i64*/78, // ->17290
/* 17287*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v8f16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 17290*/   /*SwitchType*/ 3, /*MVT::v4f32*/110, // ->17295
/* 17292*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v8f16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17295*/   /*SwitchType*/ 3, /*MVT::v2f64*/0|128,1/*128*/, // ->17301
/* 17298*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v8f16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17301*/   0, // EndSwitchType
/* 17302*/  /*Scope*/ 35, /*->17338*/
/* 17303*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 17305*/   OPC_SwitchType /*6 cases */, 3, /*MVT::v8i16*/50, // ->17311
/* 17308*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 17311*/   /*SwitchType*/ 3, /*MVT::v4i32*/60, // ->17316
/* 17313*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 17316*/   /*SwitchType*/ 3, /*MVT::v2i64*/78, // ->17321
/* 17318*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 17321*/   /*SwitchType*/ 3, /*MVT::v4f32*/110, // ->17326
/* 17323*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17326*/   /*SwitchType*/ 3, /*MVT::v2f64*/0|128,1/*128*/, // ->17332
/* 17329*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17332*/   /*SwitchType*/ 3, /*MVT::v8f16*/92, // ->17337
/* 17334*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8f16] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8f16] }:$v
/* 17337*/   0, // EndSwitchType
/* 17338*/  0, /*End of Scope*/
/* 17339*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::ConstantFP),// ->17363
/* 17342*/  OPC_RecordNode, // #0 = $imm
/* 17343*/  OPC_SwitchType /*2 cases */, 7, /*MVT::f32*/12, // ->17353
/* 17346*/   OPC_EmitConvertToTarget0,
/* 17347*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 1, 
             // Src: (fpimm:{ *:[f32] }):$imm - Complexity = 3
             // Dst: (CONST_F32:{ *:[f32] } (fpimm:{ *:[f32] }):$imm)
/* 17353*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->17362
/* 17355*/   OPC_EmitConvertToTarget0,
/* 17356*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 1, 
             // Src: (fpimm:{ *:[f64] }):$imm - Complexity = 3
             // Dst: (CONST_F64:{ *:[f64] } (fpimm:{ *:[f64] }):$imm)
/* 17362*/  0, // EndSwitchType
/* 17363*/ /*SwitchOpcode*/ 63, TARGET_VAL(ISD::SINT_TO_FP),// ->17429
/* 17366*/  OPC_RecordChild0, // #0 = $src
/* 17367*/  OPC_Scope, 19, /*->17388*/ // 4 children in Scope
/* 17369*/   OPC_CheckChild0TypeI32,
/* 17370*/   OPC_SwitchType /*2 cases */, 6, /*MVT::f32*/12, // ->17379
/* 17373*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_S_I32),
                  /*MVT::f32*/12, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_S_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 17379*/   /*SwitchType*/ 6, /*MVT::f64*/13, // ->17387
/* 17381*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_S_I32),
                  /*MVT::f64*/13, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f64] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_S_I32:{ *:[f64] } I32:{ *:[i32] }:$src)
/* 17387*/   0, // EndSwitchType
/* 17388*/  /*Scope*/ 19, /*->17408*/
/* 17389*/   OPC_CheckChild0TypeI64,
/* 17390*/   OPC_SwitchType /*2 cases */, 6, /*MVT::f32*/12, // ->17399
/* 17393*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_S_I64),
                  /*MVT::f32*/12, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f32] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_S_I64:{ *:[f32] } I64:{ *:[i64] }:$src)
/* 17399*/   /*SwitchType*/ 6, /*MVT::f64*/13, // ->17407
/* 17401*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_S_I64),
                  /*MVT::f64*/13, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_S_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 17407*/   0, // EndSwitchType
/* 17408*/  /*Scope*/ 9, /*->17418*/
/* 17409*/   OPC_CheckType, /*MVT::v4f32*/110, 
/* 17411*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17412*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::sint_to_fp_F32x4),
                 /*MVT::v4f32*/110, 1/*#Ops*/, 0, 
             // Src: (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (sint_to_fp_F32x4:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec)
/* 17418*/  /*Scope*/ 9, /*->17428*/
/* 17419*/   OPC_CheckType, /*MVT::v8f16*/92, 
/* 17421*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17422*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::sint_to_fp_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (sint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (sint_to_fp_F16x8:{ *:[v8f16] } V128:{ *:[v8i16] }:$vec)
/* 17428*/  0, /*End of Scope*/
/* 17429*/ /*SwitchOpcode*/ 63, TARGET_VAL(ISD::UINT_TO_FP),// ->17495
/* 17432*/  OPC_RecordChild0, // #0 = $src
/* 17433*/  OPC_Scope, 19, /*->17454*/ // 4 children in Scope
/* 17435*/   OPC_CheckChild0TypeI32,
/* 17436*/   OPC_SwitchType /*2 cases */, 6, /*MVT::f32*/12, // ->17445
/* 17439*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_U_I32),
                  /*MVT::f32*/12, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_U_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 17445*/   /*SwitchType*/ 6, /*MVT::f64*/13, // ->17453
/* 17447*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_U_I32),
                  /*MVT::f64*/13, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f64] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_U_I32:{ *:[f64] } I32:{ *:[i32] }:$src)
/* 17453*/   0, // EndSwitchType
/* 17454*/  /*Scope*/ 19, /*->17474*/
/* 17455*/   OPC_CheckChild0TypeI64,
/* 17456*/   OPC_SwitchType /*2 cases */, 6, /*MVT::f32*/12, // ->17465
/* 17459*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_U_I64),
                  /*MVT::f32*/12, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f32] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_U_I64:{ *:[f32] } I64:{ *:[i64] }:$src)
/* 17465*/   /*SwitchType*/ 6, /*MVT::f64*/13, // ->17473
/* 17467*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_U_I64),
                  /*MVT::f64*/13, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_U_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 17473*/   0, // EndSwitchType
/* 17474*/  /*Scope*/ 9, /*->17484*/
/* 17475*/   OPC_CheckType, /*MVT::v4f32*/110, 
/* 17477*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17478*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::uint_to_fp_F32x4),
                 /*MVT::v4f32*/110, 1/*#Ops*/, 0, 
             // Src: (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (uint_to_fp_F32x4:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec)
/* 17484*/  /*Scope*/ 9, /*->17494*/
/* 17485*/   OPC_CheckType, /*MVT::v8f16*/92, 
/* 17487*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17488*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::uint_to_fp_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (uint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (uint_to_fp_F16x8:{ *:[v8f16] } V128:{ *:[v8i16] }:$vec)
/* 17494*/  0, /*End of Scope*/
/* 17495*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::FP_EXTEND),// ->17505
/* 17498*/  OPC_RecordChild0, // #0 = $src
/* 17499*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_PROMOTE_F32),
                /*MVT::f64*/13, 1/*#Ops*/, 0, 
            // Src: (fpextend:{ *:[f64] } F32:{ *:[f32] }:$src) - Complexity = 3
            // Dst: (F64_PROMOTE_F32:{ *:[f64] } F32:{ *:[f32] }:$src)
/* 17505*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::FP_ROUND),// ->17515
/* 17508*/  OPC_RecordChild0, // #0 = $src
/* 17509*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_DEMOTE_F64),
                /*MVT::f32*/12, 1/*#Ops*/, 0, 
            // Src: (fpround:{ *:[f32] } F64:{ *:[f64] }:$src) - Complexity = 3
            // Dst: (F32_DEMOTE_F64:{ *:[f32] } F64:{ *:[f64] }:$src)
/* 17515*/ /*SwitchOpcode*/ 54, TARGET_VAL(ISD::FADD),// ->17572
/* 17518*/  OPC_RecordChild0, // #0 = $lhs
/* 17519*/  OPC_RecordChild1, // #1 = $rhs
/* 17520*/  OPC_SwitchType /*5 cases */, 7, /*MVT::f32*/12, // ->17530
/* 17523*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F32),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (ADD_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17530*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->17539
/* 17532*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F64),
                 /*MVT::f64*/13, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (ADD_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17539*/  /*SwitchType*/ 8, /*MVT::v4f32*/110, // ->17549
/* 17541*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17542*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F32x4),
                 /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (ADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17549*/  /*SwitchType*/ 9, /*MVT::v2f64*/0|128,1/*128*/, // ->17561
/* 17552*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17553*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F64x2),
                 /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (ADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17561*/  /*SwitchType*/ 8, /*MVT::v8f16*/92, // ->17571
/* 17563*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17564*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F16x8),
                 /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (ADD_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17571*/  0, // EndSwitchType
/* 17572*/ /*SwitchOpcode*/ 54, TARGET_VAL(ISD::FSUB),// ->17629
/* 17575*/  OPC_RecordChild0, // #0 = $lhs
/* 17576*/  OPC_RecordChild1, // #1 = $rhs
/* 17577*/  OPC_SwitchType /*5 cases */, 7, /*MVT::f32*/12, // ->17587
/* 17580*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F32),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (SUB_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17587*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->17596
/* 17589*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F64),
                 /*MVT::f64*/13, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (SUB_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17596*/  /*SwitchType*/ 8, /*MVT::v4f32*/110, // ->17606
/* 17598*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17599*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F32x4),
                 /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (SUB_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17606*/  /*SwitchType*/ 9, /*MVT::v2f64*/0|128,1/*128*/, // ->17618
/* 17609*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17610*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F64x2),
                 /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (SUB_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17618*/  /*SwitchType*/ 8, /*MVT::v8f16*/92, // ->17628
/* 17620*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17621*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F16x8),
                 /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (SUB_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17628*/  0, // EndSwitchType
/* 17629*/ /*SwitchOpcode*/ 54, TARGET_VAL(ISD::FMUL),// ->17686
/* 17632*/  OPC_RecordChild0, // #0 = $lhs
/* 17633*/  OPC_RecordChild1, // #1 = $rhs
/* 17634*/  OPC_SwitchType /*5 cases */, 7, /*MVT::f32*/12, // ->17644
/* 17637*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F32),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MUL_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17644*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->17653
/* 17646*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F64),
                 /*MVT::f64*/13, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MUL_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17653*/  /*SwitchType*/ 8, /*MVT::v4f32*/110, // ->17663
/* 17655*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17656*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F32x4),
                 /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MUL_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17663*/  /*SwitchType*/ 9, /*MVT::v2f64*/0|128,1/*128*/, // ->17675
/* 17666*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17667*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F64x2),
                 /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MUL_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17675*/  /*SwitchType*/ 8, /*MVT::v8f16*/92, // ->17685
/* 17677*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17678*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F16x8),
                 /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (MUL_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17685*/  0, // EndSwitchType
/* 17686*/ /*SwitchOpcode*/ 54, TARGET_VAL(ISD::FDIV),// ->17743
/* 17689*/  OPC_RecordChild0, // #0 = $lhs
/* 17690*/  OPC_RecordChild1, // #1 = $rhs
/* 17691*/  OPC_SwitchType /*5 cases */, 7, /*MVT::f32*/12, // ->17701
/* 17694*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F32),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (DIV_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17701*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->17710
/* 17703*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F64),
                 /*MVT::f64*/13, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (DIV_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17710*/  /*SwitchType*/ 8, /*MVT::v4f32*/110, // ->17720
/* 17712*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17713*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F32x4),
                 /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (DIV_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17720*/  /*SwitchType*/ 9, /*MVT::v2f64*/0|128,1/*128*/, // ->17732
/* 17723*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17724*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F64x2),
                 /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (DIV_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17732*/  /*SwitchType*/ 8, /*MVT::v8f16*/92, // ->17742
/* 17734*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17735*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F16x8),
                 /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (DIV_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17742*/  0, // EndSwitchType
/* 17743*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FSQRT),// ->17794
/* 17746*/  OPC_RecordChild0, // #0 = $src
/* 17747*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->17756
/* 17750*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (SQRT_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17756*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->17764
/* 17758*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (SQRT_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17764*/  /*SwitchType*/ 7, /*MVT::v4f32*/110, // ->17773
/* 17766*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17767*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F32x4),
                 /*MVT::v4f32*/110, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (SQRT_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17773*/  /*SwitchType*/ 8, /*MVT::v2f64*/0|128,1/*128*/, // ->17784
/* 17776*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17777*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F64x2),
                 /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (SQRT_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17784*/  /*SwitchType*/ 7, /*MVT::v8f16*/92, // ->17793
/* 17786*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17787*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (SQRT_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 17793*/  0, // EndSwitchType
/* 17794*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FABS),// ->17845
/* 17797*/  OPC_RecordChild0, // #0 = $src
/* 17798*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->17807
/* 17801*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (ABS_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17807*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->17815
/* 17809*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (ABS_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17815*/  /*SwitchType*/ 7, /*MVT::v4f32*/110, // ->17824
/* 17817*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17818*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F32x4),
                 /*MVT::v4f32*/110, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (ABS_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17824*/  /*SwitchType*/ 8, /*MVT::v2f64*/0|128,1/*128*/, // ->17835
/* 17827*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17828*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F64x2),
                 /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (ABS_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17835*/  /*SwitchType*/ 7, /*MVT::v8f16*/92, // ->17844
/* 17837*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17838*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (ABS_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 17844*/  0, // EndSwitchType
/* 17845*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FNEG),// ->17896
/* 17848*/  OPC_RecordChild0, // #0 = $src
/* 17849*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->17858
/* 17852*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEG_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17858*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->17866
/* 17860*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEG_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17866*/  /*SwitchType*/ 7, /*MVT::v4f32*/110, // ->17875
/* 17868*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17869*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F32x4),
                 /*MVT::v4f32*/110, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (NEG_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17875*/  /*SwitchType*/ 8, /*MVT::v2f64*/0|128,1/*128*/, // ->17886
/* 17878*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17879*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F64x2),
                 /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (NEG_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17886*/  /*SwitchType*/ 7, /*MVT::v8f16*/92, // ->17895
/* 17888*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17889*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (NEG_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 17895*/  0, // EndSwitchType
/* 17896*/ /*SwitchOpcode*/ 62, TARGET_VAL(ISD::FCOPYSIGN),// ->17961
/* 17899*/  OPC_RecordChild0, // #0 = $lhs
/* 17900*/  OPC_RecordChild1, // #1 = $rhs
/* 17901*/  OPC_Scope, 28, /*->17931*/ // 2 children in Scope
/* 17903*/   OPC_CheckChild1Type, /*MVT::f32*/12, 
/* 17905*/   OPC_SwitchType /*2 cases */, 7, /*MVT::f32*/12, // ->17915
/* 17908*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F32),
                  /*MVT::f32*/12, 2/*#Ops*/, 0, 1, 
              // Src: (fcopysign:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17915*/   /*SwitchType*/ 13, /*MVT::f64*/13, // ->17930
/* 17917*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::F64_PROMOTE_F32),
                  /*MVT::f64*/13, 1/*#Ops*/, 1,  // Results = #2
/* 17923*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F64),
                  /*MVT::f64*/13, 2/*#Ops*/, 0, 2, 
              // Src: (fcopysign:{ *:[f64] } F64:{ *:[f64] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, (F64_PROMOTE_F32:{ *:[f64] } F32:{ *:[f32] }:$rhs))
/* 17930*/   0, // EndSwitchType
/* 17931*/  /*Scope*/ 28, /*->17960*/
/* 17932*/   OPC_CheckChild1Type, /*MVT::f64*/13, 
/* 17934*/   OPC_SwitchType /*2 cases */, 7, /*MVT::f64*/13, // ->17944
/* 17937*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F64),
                  /*MVT::f64*/13, 2/*#Ops*/, 0, 1, 
              // Src: (fcopysign:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17944*/   /*SwitchType*/ 13, /*MVT::f32*/12, // ->17959
/* 17946*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::F32_DEMOTE_F64),
                  /*MVT::f32*/12, 1/*#Ops*/, 1,  // Results = #2
/* 17952*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F32),
                  /*MVT::f32*/12, 2/*#Ops*/, 0, 2, 
              // Src: (fcopysign:{ *:[f32] } F32:{ *:[f32] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, (F32_DEMOTE_F64:{ *:[f32] } F64:{ *:[f64] }:$rhs))
/* 17959*/   0, // EndSwitchType
/* 17960*/  0, /*End of Scope*/
/* 17961*/ /*SwitchOpcode*/ 54, TARGET_VAL(ISD::FMINIMUM),// ->18018
/* 17964*/  OPC_RecordChild0, // #0 = $lhs
/* 17965*/  OPC_RecordChild1, // #1 = $rhs
/* 17966*/  OPC_SwitchType /*5 cases */, 7, /*MVT::f32*/12, // ->17976
/* 17969*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F32),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MIN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17976*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->17985
/* 17978*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F64),
                 /*MVT::f64*/13, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MIN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17985*/  /*SwitchType*/ 8, /*MVT::v4f32*/110, // ->17995
/* 17987*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17988*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F32x4),
                 /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17995*/  /*SwitchType*/ 9, /*MVT::v2f64*/0|128,1/*128*/, // ->18007
/* 17998*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17999*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F64x2),
                 /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 18007*/  /*SwitchType*/ 8, /*MVT::v8f16*/92, // ->18017
/* 18009*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 18010*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F16x8),
                 /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (MIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 18017*/  0, // EndSwitchType
/* 18018*/ /*SwitchOpcode*/ 54, TARGET_VAL(ISD::FMAXIMUM),// ->18075
/* 18021*/  OPC_RecordChild0, // #0 = $lhs
/* 18022*/  OPC_RecordChild1, // #1 = $rhs
/* 18023*/  OPC_SwitchType /*5 cases */, 7, /*MVT::f32*/12, // ->18033
/* 18026*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F32),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MAX_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 18033*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->18042
/* 18035*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F64),
                 /*MVT::f64*/13, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MAX_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 18042*/  /*SwitchType*/ 8, /*MVT::v4f32*/110, // ->18052
/* 18044*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18045*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F32x4),
                 /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 18052*/  /*SwitchType*/ 9, /*MVT::v2f64*/0|128,1/*128*/, // ->18064
/* 18055*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18056*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F64x2),
                 /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 18064*/  /*SwitchType*/ 8, /*MVT::v8f16*/92, // ->18074
/* 18066*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 18067*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F16x8),
                 /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (MAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 18074*/  0, // EndSwitchType
/* 18075*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FCEIL),// ->18126
/* 18078*/  OPC_RecordChild0, // #0 = $src
/* 18079*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->18088
/* 18082*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (CEIL_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 18088*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->18096
/* 18090*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (CEIL_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 18096*/  /*SwitchType*/ 7, /*MVT::v4f32*/110, // ->18105
/* 18098*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18099*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F32x4),
                 /*MVT::v4f32*/110, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (CEIL_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 18105*/  /*SwitchType*/ 8, /*MVT::v2f64*/0|128,1/*128*/, // ->18116
/* 18108*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18109*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F64x2),
                 /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (CEIL_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 18116*/  /*SwitchType*/ 7, /*MVT::v8f16*/92, // ->18125
/* 18118*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 18119*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (CEIL_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 18125*/  0, // EndSwitchType
/* 18126*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FFLOOR),// ->18177
/* 18129*/  OPC_RecordChild0, // #0 = $src
/* 18130*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->18139
/* 18133*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (FLOOR_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 18139*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->18147
/* 18141*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (FLOOR_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 18147*/  /*SwitchType*/ 7, /*MVT::v4f32*/110, // ->18156
/* 18149*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18150*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F32x4),
                 /*MVT::v4f32*/110, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (FLOOR_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 18156*/  /*SwitchType*/ 8, /*MVT::v2f64*/0|128,1/*128*/, // ->18167
/* 18159*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18160*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F64x2),
                 /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (FLOOR_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 18167*/  /*SwitchType*/ 7, /*MVT::v8f16*/92, // ->18176
/* 18169*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 18170*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (FLOOR_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 18176*/  0, // EndSwitchType
/* 18177*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FTRUNC),// ->18228
/* 18180*/  OPC_RecordChild0, // #0 = $src
/* 18181*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->18190
/* 18184*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (TRUNC_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 18190*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->18198
/* 18192*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (TRUNC_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 18198*/  /*SwitchType*/ 7, /*MVT::v4f32*/110, // ->18207
/* 18200*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18201*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F32x4),
                 /*MVT::v4f32*/110, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (TRUNC_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 18207*/  /*SwitchType*/ 8, /*MVT::v2f64*/0|128,1/*128*/, // ->18218
/* 18210*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18211*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F64x2),
                 /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (TRUNC_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 18218*/  /*SwitchType*/ 7, /*MVT::v8f16*/92, // ->18227
/* 18220*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 18221*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (TRUNC_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 18227*/  0, // EndSwitchType
/* 18228*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FNEARBYINT),// ->18279
/* 18231*/  OPC_RecordChild0, // #0 = $src
/* 18232*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->18241
/* 18235*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 18241*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->18249
/* 18243*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 18249*/  /*SwitchType*/ 7, /*MVT::v4f32*/110, // ->18258
/* 18251*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18252*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32x4),
                 /*MVT::v4f32*/110, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (NEAREST_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 18258*/  /*SwitchType*/ 8, /*MVT::v2f64*/0|128,1/*128*/, // ->18269
/* 18261*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18262*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64x2),
                 /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (NEAREST_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 18269*/  /*SwitchType*/ 7, /*MVT::v8f16*/92, // ->18278
/* 18271*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 18272*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (NEAREST_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 18278*/  0, // EndSwitchType
/* 18279*/ /*SwitchOpcode*/ 45, TARGET_VAL(ISD::FRINT),// ->18327
/* 18282*/  OPC_RecordChild0, // #0 = $src
/* 18283*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->18292
/* 18286*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[f32] } f32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } f32:{ *:[f32] }:$src)
/* 18292*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->18300
/* 18294*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[f64] } f64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } f64:{ *:[f64] }:$src)
/* 18300*/  /*SwitchType*/ 6, /*MVT::v4f32*/110, // ->18308
/* 18302*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32x4),
                 /*MVT::v4f32*/110, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[v4f32] } V128:{ *:[v4f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$src)
/* 18308*/  /*SwitchType*/ 7, /*MVT::v2f64*/0|128,1/*128*/, // ->18318
/* 18311*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64x2),
                 /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[v2f64] } V128:{ *:[v2f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$src)
/* 18318*/  /*SwitchType*/ 6, /*MVT::v8f16*/92, // ->18326
/* 18320*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$src) - Complexity = 3
             // Dst: (NEAREST_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$src)
/* 18326*/  0, // EndSwitchType
/* 18327*/ /*SwitchOpcode*/ 45, TARGET_VAL(ISD::FROUNDEVEN),// ->18375
/* 18330*/  OPC_RecordChild0, // #0 = $src
/* 18331*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->18340
/* 18334*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[f32] } f32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } f32:{ *:[f32] }:$src)
/* 18340*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->18348
/* 18342*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[f64] } f64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } f64:{ *:[f64] }:$src)
/* 18348*/  /*SwitchType*/ 6, /*MVT::v4f32*/110, // ->18356
/* 18350*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32x4),
                 /*MVT::v4f32*/110, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[v4f32] } V128:{ *:[v4f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$src)
/* 18356*/  /*SwitchType*/ 7, /*MVT::v2f64*/0|128,1/*128*/, // ->18366
/* 18359*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64x2),
                 /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[v2f64] } V128:{ *:[v2f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$src)
/* 18366*/  /*SwitchType*/ 6, /*MVT::v8f16*/92, // ->18374
/* 18368*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$src) - Complexity = 3
             // Dst: (NEAREST_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$src)
/* 18374*/  0, // EndSwitchType
/* 18375*/ /*SwitchOpcode*/ 22|128,3/*406*/, TARGET_VAL(ISD::BUILD_VECTOR),// ->18785
/* 18379*/  OPC_RecordChild0, // #0 = $i0
/* 18380*/  OPC_MoveChild0,
/* 18381*/  OPC_SwitchOpcode /*2 cases */, 73|128,2/*329*/, TARGET_VAL(ISD::Constant),// ->18715
/* 18386*/   OPC_SwitchType /*2 cases */, 47|128,2/*303*/, /*MVT::i32*/7, // ->18693
/* 18390*/    OPC_Scope, 51|128,1/*179*/, /*->18572*/ // 3 children in Scope
/* 18393*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18395*/     OPC_MoveSibling1,
/* 18396*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18399*/     OPC_RecordNode, // #1 = $i1
/* 18400*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18402*/     OPC_CheckTypeI32,
/* 18403*/     OPC_MoveSibling2,
/* 18404*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18407*/     OPC_RecordNode, // #2 = $i2
/* 18408*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18410*/     OPC_CheckTypeI32,
/* 18411*/     OPC_MoveSibling3,
/* 18412*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18415*/     OPC_RecordNode, // #3 = $i3
/* 18416*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18418*/     OPC_CheckTypeI32,
/* 18419*/     OPC_MoveSibling4,
/* 18420*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18423*/     OPC_RecordNode, // #4 = $i4
/* 18424*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18426*/     OPC_CheckTypeI32,
/* 18427*/     OPC_MoveSibling5,
/* 18428*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18431*/     OPC_RecordNode, // #5 = $i5
/* 18432*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18434*/     OPC_CheckTypeI32,
/* 18435*/     OPC_MoveSibling6,
/* 18436*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18439*/     OPC_RecordNode, // #6 = $i6
/* 18440*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18442*/     OPC_CheckTypeI32,
/* 18443*/     OPC_MoveSibling7,
/* 18444*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18447*/     OPC_RecordNode, // #7 = $i7
/* 18448*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18450*/     OPC_CheckTypeI32,
/* 18451*/     OPC_MoveSibling, 8,
/* 18453*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18456*/     OPC_RecordNode, // #8 = $i8
/* 18457*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18459*/     OPC_CheckTypeI32,
/* 18460*/     OPC_MoveSibling, 9,
/* 18462*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18465*/     OPC_RecordNode, // #9 = $i9
/* 18466*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18468*/     OPC_CheckTypeI32,
/* 18469*/     OPC_MoveSibling, 10,
/* 18471*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18474*/     OPC_RecordNode, // #10 = $iA
/* 18475*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18477*/     OPC_CheckTypeI32,
/* 18478*/     OPC_MoveSibling, 11,
/* 18480*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18483*/     OPC_RecordNode, // #11 = $iB
/* 18484*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18486*/     OPC_CheckTypeI32,
/* 18487*/     OPC_MoveSibling, 12,
/* 18489*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18492*/     OPC_RecordNode, // #12 = $iC
/* 18493*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18495*/     OPC_CheckTypeI32,
/* 18496*/     OPC_MoveSibling, 13,
/* 18498*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18501*/     OPC_RecordNode, // #13 = $iD
/* 18502*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18504*/     OPC_CheckTypeI32,
/* 18505*/     OPC_MoveSibling, 14,
/* 18507*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18510*/     OPC_RecordNode, // #14 = $iE
/* 18511*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18513*/     OPC_CheckTypeI32,
/* 18514*/     OPC_MoveSibling, 15,
/* 18516*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18519*/     OPC_RecordNode, // #15 = $iF
/* 18520*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18522*/     OPC_CheckTypeI32,
/* 18523*/     OPC_MoveParent,
/* 18524*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 18526*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18527*/     OPC_EmitConvertToTarget0,
/* 18528*/     OPC_EmitConvertToTarget1,
/* 18529*/     OPC_EmitConvertToTarget2,
/* 18530*/     OPC_EmitConvertToTarget3,
/* 18531*/     OPC_EmitConvertToTarget4,
/* 18532*/     OPC_EmitConvertToTarget5,
/* 18533*/     OPC_EmitConvertToTarget6,
/* 18534*/     OPC_EmitConvertToTarget7,
/* 18535*/     OPC_EmitConvertToTarget, 8,
/* 18537*/     OPC_EmitConvertToTarget, 9,
/* 18539*/     OPC_EmitConvertToTarget, 10,
/* 18541*/     OPC_EmitConvertToTarget, 11,
/* 18543*/     OPC_EmitConvertToTarget, 12,
/* 18545*/     OPC_EmitConvertToTarget, 13,
/* 18547*/     OPC_EmitConvertToTarget, 14,
/* 18549*/     OPC_EmitConvertToTarget, 15,
/* 18551*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I8x16),
                   /*MVT::v16i8*/39, 16/*#Ops*/, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 
               // Src: (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i0, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i1, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i2, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i3, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i4, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i5, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i6, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i7, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i8, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i9, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iA, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iB, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iC, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iD, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iE, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iF) - Complexity = 67
               // Dst: (CONST_V128_I8x16:{ *:[v16i8] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3, (imm:{ *:[i32] }):$i4, (imm:{ *:[i32] }):$i5, (imm:{ *:[i32] }):$i6, (imm:{ *:[i32] }):$i7, (imm:{ *:[i32] }):$i8, (imm:{ *:[i32] }):$i9, (imm:{ *:[i32] }):$iA, (imm:{ *:[i32] }):$iB, (imm:{ *:[i32] }):$iC, (imm:{ *:[i32] }):$iD, (imm:{ *:[i32] }):$iE, (imm:{ *:[i32] }):$iF)
/* 18572*/    /*Scope*/ 83, /*->18656*/
/* 18573*/     OPC_CheckPredicate, 17, // Predicate_ImmI16
/* 18575*/     OPC_MoveSibling1,
/* 18576*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18579*/     OPC_RecordNode, // #1 = $i1
/* 18580*/     OPC_CheckPredicate, 17, // Predicate_ImmI16
/* 18582*/     OPC_CheckTypeI32,
/* 18583*/     OPC_MoveSibling2,
/* 18584*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18587*/     OPC_RecordNode, // #2 = $i2
/* 18588*/     OPC_CheckPredicate, 17, // Predicate_ImmI16
/* 18590*/     OPC_CheckTypeI32,
/* 18591*/     OPC_MoveSibling3,
/* 18592*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18595*/     OPC_RecordNode, // #3 = $i3
/* 18596*/     OPC_CheckPredicate, 17, // Predicate_ImmI16
/* 18598*/     OPC_CheckTypeI32,
/* 18599*/     OPC_MoveSibling4,
/* 18600*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18603*/     OPC_RecordNode, // #4 = $i4
/* 18604*/     OPC_CheckPredicate, 17, // Predicate_ImmI16
/* 18606*/     OPC_CheckTypeI32,
/* 18607*/     OPC_MoveSibling5,
/* 18608*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18611*/     OPC_RecordNode, // #5 = $i5
/* 18612*/     OPC_CheckPredicate, 17, // Predicate_ImmI16
/* 18614*/     OPC_CheckTypeI32,
/* 18615*/     OPC_MoveSibling6,
/* 18616*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18619*/     OPC_RecordNode, // #6 = $i6
/* 18620*/     OPC_CheckPredicate, 17, // Predicate_ImmI16
/* 18622*/     OPC_CheckTypeI32,
/* 18623*/     OPC_MoveSibling7,
/* 18624*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18627*/     OPC_RecordNode, // #7 = $i7
/* 18628*/     OPC_CheckPredicate, 17, // Predicate_ImmI16
/* 18630*/     OPC_CheckTypeI32,
/* 18631*/     OPC_MoveParent,
/* 18632*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 18634*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18635*/     OPC_EmitConvertToTarget0,
/* 18636*/     OPC_EmitConvertToTarget1,
/* 18637*/     OPC_EmitConvertToTarget2,
/* 18638*/     OPC_EmitConvertToTarget3,
/* 18639*/     OPC_EmitConvertToTarget4,
/* 18640*/     OPC_EmitConvertToTarget5,
/* 18641*/     OPC_EmitConvertToTarget6,
/* 18642*/     OPC_EmitConvertToTarget7,
/* 18643*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I16x8),
                   /*MVT::v8i16*/50, 8/*#Ops*/, 8, 9, 10, 11, 12, 13, 14, 15, 
               // Src: (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i0, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i1, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i2, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i3, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i4, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i5, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i6, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i7) - Complexity = 35
               // Dst: (CONST_V128_I16x8:{ *:[v8i16] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3, (imm:{ *:[i32] }):$i4, (imm:{ *:[i32] }):$i5, (imm:{ *:[i32] }):$i6, (imm:{ *:[i32] }):$i7)
/* 18656*/    /*Scope*/ 35, /*->18692*/
/* 18657*/     OPC_MoveSibling1,
/* 18658*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18661*/     OPC_RecordNode, // #1 = $i1
/* 18662*/     OPC_CheckTypeI32,
/* 18663*/     OPC_MoveSibling2,
/* 18664*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18667*/     OPC_RecordNode, // #2 = $i2
/* 18668*/     OPC_CheckTypeI32,
/* 18669*/     OPC_MoveSibling3,
/* 18670*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18673*/     OPC_RecordNode, // #3 = $i3
/* 18674*/     OPC_CheckTypeI32,
/* 18675*/     OPC_MoveParent,
/* 18676*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 18678*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18679*/     OPC_EmitConvertToTarget0,
/* 18680*/     OPC_EmitConvertToTarget1,
/* 18681*/     OPC_EmitConvertToTarget2,
/* 18682*/     OPC_EmitConvertToTarget3,
/* 18683*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I32x4),
                   /*MVT::v4i32*/60, 4/*#Ops*/, 4, 5, 6, 7, 
               // Src: (build_vector:{ *:[v4i32] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3) - Complexity = 15
               // Dst: (CONST_V128_I32x4:{ *:[v4i32] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3)
/* 18692*/    0, /*End of Scope*/
/* 18693*/   /*SwitchType*/ 19, /*MVT::i64*/8, // ->18714
/* 18695*/    OPC_MoveSibling1,
/* 18696*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18699*/    OPC_RecordNode, // #1 = $i1
/* 18700*/    OPC_CheckTypeI64,
/* 18701*/    OPC_MoveParent,
/* 18702*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 18704*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18705*/    OPC_EmitConvertToTarget0,
/* 18706*/    OPC_EmitConvertToTarget1,
/* 18707*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 2, 3, 
              // Src: (build_vector:{ *:[v2i64] } (imm:{ *:[i64] }):$i0, (imm:{ *:[i64] }):$i1) - Complexity = 9
              // Dst: (CONST_V128_I64x2:{ *:[v2i64] } (imm:{ *:[i64] }):$i0, (imm:{ *:[i64] }):$i1)
/* 18714*/   0, // EndSwitchType
/* 18715*/  /*SwitchOpcode*/ 66, TARGET_VAL(ISD::ConstantFP),// ->18784
/* 18718*/   OPC_SwitchType /*2 cases */, 38, /*MVT::f32*/12, // ->18759
/* 18721*/    OPC_MoveSibling1,
/* 18722*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18725*/    OPC_RecordNode, // #1 = $i1
/* 18726*/    OPC_CheckType, /*MVT::f32*/12, 
/* 18728*/    OPC_MoveSibling2,
/* 18729*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18732*/    OPC_RecordNode, // #2 = $i2
/* 18733*/    OPC_CheckType, /*MVT::f32*/12, 
/* 18735*/    OPC_MoveSibling3,
/* 18736*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18739*/    OPC_RecordNode, // #3 = $i3
/* 18740*/    OPC_CheckType, /*MVT::f32*/12, 
/* 18742*/    OPC_MoveParent,
/* 18743*/    OPC_CheckType, /*MVT::v4f32*/110, 
/* 18745*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18746*/    OPC_EmitConvertToTarget0,
/* 18747*/    OPC_EmitConvertToTarget1,
/* 18748*/    OPC_EmitConvertToTarget2,
/* 18749*/    OPC_EmitConvertToTarget3,
/* 18750*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F32x4),
                  /*MVT::v4f32*/110, 4/*#Ops*/, 4, 5, 6, 7, 
              // Src: (build_vector:{ *:[v4f32] } (fpimm:{ *:[f32] }):$i0, (fpimm:{ *:[f32] }):$i1, (fpimm:{ *:[f32] }):$i2, (fpimm:{ *:[f32] }):$i3) - Complexity = 15
              // Dst: (CONST_V128_F32x4:{ *:[v4f32] } (fpimm:{ *:[f32] }):$i0, (fpimm:{ *:[f32] }):$i1, (fpimm:{ *:[f32] }):$i2, (fpimm:{ *:[f32] }):$i3)
/* 18759*/   /*SwitchType*/ 22, /*MVT::f64*/13, // ->18783
/* 18761*/    OPC_MoveSibling1,
/* 18762*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18765*/    OPC_RecordNode, // #1 = $i1
/* 18766*/    OPC_CheckType, /*MVT::f64*/13, 
/* 18768*/    OPC_MoveParent,
/* 18769*/    OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 18772*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18773*/    OPC_EmitConvertToTarget0,
/* 18774*/    OPC_EmitConvertToTarget1,
/* 18775*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F64x2),
                  /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 2, 3, 
              // Src: (build_vector:{ *:[v2f64] } (fpimm:{ *:[f64] }):$i0, (fpimm:{ *:[f64] }):$i1) - Complexity = 9
              // Dst: (CONST_V128_F64x2:{ *:[v2f64] } (fpimm:{ *:[f64] }):$i0, (fpimm:{ *:[f64] }):$i1)
/* 18783*/   0, // EndSwitchType
/* 18784*/  0, // EndSwitchOpcode
/* 18785*/ /*SwitchOpcode*/ 7|128,16/*2055*/, TARGET_VAL(WebAssemblyISD::SHUFFLE),// ->20844
/* 18789*/  OPC_RecordChild0, // #0 = $x
/* 18790*/  OPC_Scope, 83|128,2/*339*/, /*->19132*/ // 6 children in Scope
/* 18793*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 18795*/   OPC_RecordChild1, // #1 = $y
/* 18796*/   OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 18798*/   OPC_RecordChild2, // #2 = $m0
/* 18799*/   OPC_MoveChild2,
/* 18800*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->18974
/* 18805*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18806*/    OPC_CheckTypeI32,
/* 18807*/    OPC_MoveSibling3,
/* 18808*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18811*/    OPC_RecordNode, // #3 = $m1
/* 18812*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18813*/    OPC_CheckTypeI32,
/* 18814*/    OPC_MoveSibling4,
/* 18815*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18818*/    OPC_RecordNode, // #4 = $m2
/* 18819*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18820*/    OPC_CheckTypeI32,
/* 18821*/    OPC_MoveSibling5,
/* 18822*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18825*/    OPC_RecordNode, // #5 = $m3
/* 18826*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18827*/    OPC_CheckTypeI32,
/* 18828*/    OPC_MoveSibling6,
/* 18829*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18832*/    OPC_RecordNode, // #6 = $m4
/* 18833*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18834*/    OPC_CheckTypeI32,
/* 18835*/    OPC_MoveSibling7,
/* 18836*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18839*/    OPC_RecordNode, // #7 = $m5
/* 18840*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18841*/    OPC_CheckTypeI32,
/* 18842*/    OPC_MoveSibling, 8,
/* 18844*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18847*/    OPC_RecordNode, // #8 = $m6
/* 18848*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18849*/    OPC_CheckTypeI32,
/* 18850*/    OPC_MoveSibling, 9,
/* 18852*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18855*/    OPC_RecordNode, // #9 = $m7
/* 18856*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18857*/    OPC_CheckTypeI32,
/* 18858*/    OPC_MoveSibling, 10,
/* 18860*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18863*/    OPC_RecordNode, // #10 = $m8
/* 18864*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18865*/    OPC_CheckTypeI32,
/* 18866*/    OPC_MoveSibling, 11,
/* 18868*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18871*/    OPC_RecordNode, // #11 = $m9
/* 18872*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18873*/    OPC_CheckTypeI32,
/* 18874*/    OPC_MoveSibling, 12,
/* 18876*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18879*/    OPC_RecordNode, // #12 = $mA
/* 18880*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18881*/    OPC_CheckTypeI32,
/* 18882*/    OPC_MoveSibling, 13,
/* 18884*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18887*/    OPC_RecordNode, // #13 = $mB
/* 18888*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18889*/    OPC_CheckTypeI32,
/* 18890*/    OPC_MoveSibling, 14,
/* 18892*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18895*/    OPC_RecordNode, // #14 = $mC
/* 18896*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18897*/    OPC_CheckTypeI32,
/* 18898*/    OPC_MoveSibling, 15,
/* 18900*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18903*/    OPC_RecordNode, // #15 = $mD
/* 18904*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18905*/    OPC_CheckTypeI32,
/* 18906*/    OPC_MoveSibling, 16,
/* 18908*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18911*/    OPC_RecordNode, // #16 = $mE
/* 18912*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18913*/    OPC_CheckTypeI32,
/* 18914*/    OPC_MoveSibling, 17,
/* 18916*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18919*/    OPC_RecordNode, // #17 = $mF
/* 18920*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18921*/    OPC_CheckTypeI32,
/* 18922*/    OPC_MoveParent,
/* 18923*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 18925*/    OPC_EmitConvertToTarget2,
/* 18926*/    OPC_EmitConvertToTarget3,
/* 18927*/    OPC_EmitConvertToTarget4,
/* 18928*/    OPC_EmitConvertToTarget5,
/* 18929*/    OPC_EmitConvertToTarget6,
/* 18930*/    OPC_EmitConvertToTarget7,
/* 18931*/    OPC_EmitConvertToTarget, 8,
/* 18933*/    OPC_EmitConvertToTarget, 9,
/* 18935*/    OPC_EmitConvertToTarget, 10,
/* 18937*/    OPC_EmitConvertToTarget, 11,
/* 18939*/    OPC_EmitConvertToTarget, 12,
/* 18941*/    OPC_EmitConvertToTarget, 13,
/* 18943*/    OPC_EmitConvertToTarget, 14,
/* 18945*/    OPC_EmitConvertToTarget, 15,
/* 18947*/    OPC_EmitConvertToTarget, 16,
/* 18949*/    OPC_EmitConvertToTarget, 17,
/* 18951*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v16i8*/39, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v16i8] } V128:{ *:[v16i8] }:$x, V128:{ *:[v16i8] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$x, ?:{ *:[v16i8] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 18974*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->19131
/* 18978*/    OPC_CheckTypeI32,
/* 18979*/    OPC_MoveSibling3,
/* 18980*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18983*/    OPC_RecordNode, // #3 = $m1
/* 18984*/    OPC_CheckTypeI32,
/* 18985*/    OPC_MoveSibling4,
/* 18986*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18989*/    OPC_RecordNode, // #4 = $m2
/* 18990*/    OPC_CheckTypeI32,
/* 18991*/    OPC_MoveSibling5,
/* 18992*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18995*/    OPC_RecordNode, // #5 = $m3
/* 18996*/    OPC_CheckTypeI32,
/* 18997*/    OPC_MoveSibling6,
/* 18998*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19001*/    OPC_RecordNode, // #6 = $m4
/* 19002*/    OPC_CheckTypeI32,
/* 19003*/    OPC_MoveSibling7,
/* 19004*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19007*/    OPC_RecordNode, // #7 = $m5
/* 19008*/    OPC_CheckTypeI32,
/* 19009*/    OPC_MoveSibling, 8,
/* 19011*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19014*/    OPC_RecordNode, // #8 = $m6
/* 19015*/    OPC_CheckTypeI32,
/* 19016*/    OPC_MoveSibling, 9,
/* 19018*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19021*/    OPC_RecordNode, // #9 = $m7
/* 19022*/    OPC_CheckTypeI32,
/* 19023*/    OPC_MoveSibling, 10,
/* 19025*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19028*/    OPC_RecordNode, // #10 = $m8
/* 19029*/    OPC_CheckTypeI32,
/* 19030*/    OPC_MoveSibling, 11,
/* 19032*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19035*/    OPC_RecordNode, // #11 = $m9
/* 19036*/    OPC_CheckTypeI32,
/* 19037*/    OPC_MoveSibling, 12,
/* 19039*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19042*/    OPC_RecordNode, // #12 = $mA
/* 19043*/    OPC_CheckTypeI32,
/* 19044*/    OPC_MoveSibling, 13,
/* 19046*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19049*/    OPC_RecordNode, // #13 = $mB
/* 19050*/    OPC_CheckTypeI32,
/* 19051*/    OPC_MoveSibling, 14,
/* 19053*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19056*/    OPC_RecordNode, // #14 = $mC
/* 19057*/    OPC_CheckTypeI32,
/* 19058*/    OPC_MoveSibling, 15,
/* 19060*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19063*/    OPC_RecordNode, // #15 = $mD
/* 19064*/    OPC_CheckTypeI32,
/* 19065*/    OPC_MoveSibling, 16,
/* 19067*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19070*/    OPC_RecordNode, // #16 = $mE
/* 19071*/    OPC_CheckTypeI32,
/* 19072*/    OPC_MoveSibling, 17,
/* 19074*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19077*/    OPC_RecordNode, // #17 = $mF
/* 19078*/    OPC_CheckTypeI32,
/* 19079*/    OPC_MoveParent,
/* 19080*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 19082*/    OPC_EmitConvertToTarget2,
/* 19083*/    OPC_EmitConvertToTarget3,
/* 19084*/    OPC_EmitConvertToTarget4,
/* 19085*/    OPC_EmitConvertToTarget5,
/* 19086*/    OPC_EmitConvertToTarget6,
/* 19087*/    OPC_EmitConvertToTarget7,
/* 19088*/    OPC_EmitConvertToTarget, 8,
/* 19090*/    OPC_EmitConvertToTarget, 9,
/* 19092*/    OPC_EmitConvertToTarget, 10,
/* 19094*/    OPC_EmitConvertToTarget, 11,
/* 19096*/    OPC_EmitConvertToTarget, 12,
/* 19098*/    OPC_EmitConvertToTarget, 13,
/* 19100*/    OPC_EmitConvertToTarget, 14,
/* 19102*/    OPC_EmitConvertToTarget, 15,
/* 19104*/    OPC_EmitConvertToTarget, 16,
/* 19106*/    OPC_EmitConvertToTarget, 17,
/* 19108*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v16i8*/39, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v16i8] } V128:{ *:[v16i8] }:$x, V128:{ *:[v16i8] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$x, ?:{ *:[v16i8] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19131*/   0, // EndSwitchOpcode
/* 19132*/  /*Scope*/ 83|128,2/*339*/, /*->19473*/
/* 19134*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 19136*/   OPC_RecordChild1, // #1 = $y
/* 19137*/   OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 19139*/   OPC_RecordChild2, // #2 = $m0
/* 19140*/   OPC_MoveChild2,
/* 19141*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->19315
/* 19146*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19147*/    OPC_CheckTypeI32,
/* 19148*/    OPC_MoveSibling3,
/* 19149*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19152*/    OPC_RecordNode, // #3 = $m1
/* 19153*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19154*/    OPC_CheckTypeI32,
/* 19155*/    OPC_MoveSibling4,
/* 19156*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19159*/    OPC_RecordNode, // #4 = $m2
/* 19160*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19161*/    OPC_CheckTypeI32,
/* 19162*/    OPC_MoveSibling5,
/* 19163*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19166*/    OPC_RecordNode, // #5 = $m3
/* 19167*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19168*/    OPC_CheckTypeI32,
/* 19169*/    OPC_MoveSibling6,
/* 19170*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19173*/    OPC_RecordNode, // #6 = $m4
/* 19174*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19175*/    OPC_CheckTypeI32,
/* 19176*/    OPC_MoveSibling7,
/* 19177*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19180*/    OPC_RecordNode, // #7 = $m5
/* 19181*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19182*/    OPC_CheckTypeI32,
/* 19183*/    OPC_MoveSibling, 8,
/* 19185*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19188*/    OPC_RecordNode, // #8 = $m6
/* 19189*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19190*/    OPC_CheckTypeI32,
/* 19191*/    OPC_MoveSibling, 9,
/* 19193*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19196*/    OPC_RecordNode, // #9 = $m7
/* 19197*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19198*/    OPC_CheckTypeI32,
/* 19199*/    OPC_MoveSibling, 10,
/* 19201*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19204*/    OPC_RecordNode, // #10 = $m8
/* 19205*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19206*/    OPC_CheckTypeI32,
/* 19207*/    OPC_MoveSibling, 11,
/* 19209*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19212*/    OPC_RecordNode, // #11 = $m9
/* 19213*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19214*/    OPC_CheckTypeI32,
/* 19215*/    OPC_MoveSibling, 12,
/* 19217*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19220*/    OPC_RecordNode, // #12 = $mA
/* 19221*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19222*/    OPC_CheckTypeI32,
/* 19223*/    OPC_MoveSibling, 13,
/* 19225*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19228*/    OPC_RecordNode, // #13 = $mB
/* 19229*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19230*/    OPC_CheckTypeI32,
/* 19231*/    OPC_MoveSibling, 14,
/* 19233*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19236*/    OPC_RecordNode, // #14 = $mC
/* 19237*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19238*/    OPC_CheckTypeI32,
/* 19239*/    OPC_MoveSibling, 15,
/* 19241*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19244*/    OPC_RecordNode, // #15 = $mD
/* 19245*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19246*/    OPC_CheckTypeI32,
/* 19247*/    OPC_MoveSibling, 16,
/* 19249*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19252*/    OPC_RecordNode, // #16 = $mE
/* 19253*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19254*/    OPC_CheckTypeI32,
/* 19255*/    OPC_MoveSibling, 17,
/* 19257*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19260*/    OPC_RecordNode, // #17 = $mF
/* 19261*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19262*/    OPC_CheckTypeI32,
/* 19263*/    OPC_MoveParent,
/* 19264*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 19266*/    OPC_EmitConvertToTarget2,
/* 19267*/    OPC_EmitConvertToTarget3,
/* 19268*/    OPC_EmitConvertToTarget4,
/* 19269*/    OPC_EmitConvertToTarget5,
/* 19270*/    OPC_EmitConvertToTarget6,
/* 19271*/    OPC_EmitConvertToTarget7,
/* 19272*/    OPC_EmitConvertToTarget, 8,
/* 19274*/    OPC_EmitConvertToTarget, 9,
/* 19276*/    OPC_EmitConvertToTarget, 10,
/* 19278*/    OPC_EmitConvertToTarget, 11,
/* 19280*/    OPC_EmitConvertToTarget, 12,
/* 19282*/    OPC_EmitConvertToTarget, 13,
/* 19284*/    OPC_EmitConvertToTarget, 14,
/* 19286*/    OPC_EmitConvertToTarget, 15,
/* 19288*/    OPC_EmitConvertToTarget, 16,
/* 19290*/    OPC_EmitConvertToTarget, 17,
/* 19292*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v8i16*/50, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v8i16] } V128:{ *:[v8i16] }:$x, V128:{ *:[v8i16] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v8i16] } ?:{ *:[v8i16] }:$x, ?:{ *:[v8i16] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19315*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->19472
/* 19319*/    OPC_CheckTypeI32,
/* 19320*/    OPC_MoveSibling3,
/* 19321*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19324*/    OPC_RecordNode, // #3 = $m1
/* 19325*/    OPC_CheckTypeI32,
/* 19326*/    OPC_MoveSibling4,
/* 19327*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19330*/    OPC_RecordNode, // #4 = $m2
/* 19331*/    OPC_CheckTypeI32,
/* 19332*/    OPC_MoveSibling5,
/* 19333*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19336*/    OPC_RecordNode, // #5 = $m3
/* 19337*/    OPC_CheckTypeI32,
/* 19338*/    OPC_MoveSibling6,
/* 19339*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19342*/    OPC_RecordNode, // #6 = $m4
/* 19343*/    OPC_CheckTypeI32,
/* 19344*/    OPC_MoveSibling7,
/* 19345*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19348*/    OPC_RecordNode, // #7 = $m5
/* 19349*/    OPC_CheckTypeI32,
/* 19350*/    OPC_MoveSibling, 8,
/* 19352*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19355*/    OPC_RecordNode, // #8 = $m6
/* 19356*/    OPC_CheckTypeI32,
/* 19357*/    OPC_MoveSibling, 9,
/* 19359*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19362*/    OPC_RecordNode, // #9 = $m7
/* 19363*/    OPC_CheckTypeI32,
/* 19364*/    OPC_MoveSibling, 10,
/* 19366*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19369*/    OPC_RecordNode, // #10 = $m8
/* 19370*/    OPC_CheckTypeI32,
/* 19371*/    OPC_MoveSibling, 11,
/* 19373*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19376*/    OPC_RecordNode, // #11 = $m9
/* 19377*/    OPC_CheckTypeI32,
/* 19378*/    OPC_MoveSibling, 12,
/* 19380*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19383*/    OPC_RecordNode, // #12 = $mA
/* 19384*/    OPC_CheckTypeI32,
/* 19385*/    OPC_MoveSibling, 13,
/* 19387*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19390*/    OPC_RecordNode, // #13 = $mB
/* 19391*/    OPC_CheckTypeI32,
/* 19392*/    OPC_MoveSibling, 14,
/* 19394*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19397*/    OPC_RecordNode, // #14 = $mC
/* 19398*/    OPC_CheckTypeI32,
/* 19399*/    OPC_MoveSibling, 15,
/* 19401*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19404*/    OPC_RecordNode, // #15 = $mD
/* 19405*/    OPC_CheckTypeI32,
/* 19406*/    OPC_MoveSibling, 16,
/* 19408*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19411*/    OPC_RecordNode, // #16 = $mE
/* 19412*/    OPC_CheckTypeI32,
/* 19413*/    OPC_MoveSibling, 17,
/* 19415*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19418*/    OPC_RecordNode, // #17 = $mF
/* 19419*/    OPC_CheckTypeI32,
/* 19420*/    OPC_MoveParent,
/* 19421*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 19423*/    OPC_EmitConvertToTarget2,
/* 19424*/    OPC_EmitConvertToTarget3,
/* 19425*/    OPC_EmitConvertToTarget4,
/* 19426*/    OPC_EmitConvertToTarget5,
/* 19427*/    OPC_EmitConvertToTarget6,
/* 19428*/    OPC_EmitConvertToTarget7,
/* 19429*/    OPC_EmitConvertToTarget, 8,
/* 19431*/    OPC_EmitConvertToTarget, 9,
/* 19433*/    OPC_EmitConvertToTarget, 10,
/* 19435*/    OPC_EmitConvertToTarget, 11,
/* 19437*/    OPC_EmitConvertToTarget, 12,
/* 19439*/    OPC_EmitConvertToTarget, 13,
/* 19441*/    OPC_EmitConvertToTarget, 14,
/* 19443*/    OPC_EmitConvertToTarget, 15,
/* 19445*/    OPC_EmitConvertToTarget, 16,
/* 19447*/    OPC_EmitConvertToTarget, 17,
/* 19449*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v8i16*/50, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v8i16] } V128:{ *:[v8i16] }:$x, V128:{ *:[v8i16] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v8i16] } ?:{ *:[v8i16] }:$x, ?:{ *:[v8i16] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19472*/   0, // EndSwitchOpcode
/* 19473*/  /*Scope*/ 83|128,2/*339*/, /*->19814*/
/* 19475*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 19477*/   OPC_RecordChild1, // #1 = $y
/* 19478*/   OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 19480*/   OPC_RecordChild2, // #2 = $m0
/* 19481*/   OPC_MoveChild2,
/* 19482*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->19656
/* 19487*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19488*/    OPC_CheckTypeI32,
/* 19489*/    OPC_MoveSibling3,
/* 19490*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19493*/    OPC_RecordNode, // #3 = $m1
/* 19494*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19495*/    OPC_CheckTypeI32,
/* 19496*/    OPC_MoveSibling4,
/* 19497*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19500*/    OPC_RecordNode, // #4 = $m2
/* 19501*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19502*/    OPC_CheckTypeI32,
/* 19503*/    OPC_MoveSibling5,
/* 19504*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19507*/    OPC_RecordNode, // #5 = $m3
/* 19508*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19509*/    OPC_CheckTypeI32,
/* 19510*/    OPC_MoveSibling6,
/* 19511*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19514*/    OPC_RecordNode, // #6 = $m4
/* 19515*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19516*/    OPC_CheckTypeI32,
/* 19517*/    OPC_MoveSibling7,
/* 19518*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19521*/    OPC_RecordNode, // #7 = $m5
/* 19522*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19523*/    OPC_CheckTypeI32,
/* 19524*/    OPC_MoveSibling, 8,
/* 19526*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19529*/    OPC_RecordNode, // #8 = $m6
/* 19530*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19531*/    OPC_CheckTypeI32,
/* 19532*/    OPC_MoveSibling, 9,
/* 19534*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19537*/    OPC_RecordNode, // #9 = $m7
/* 19538*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19539*/    OPC_CheckTypeI32,
/* 19540*/    OPC_MoveSibling, 10,
/* 19542*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19545*/    OPC_RecordNode, // #10 = $m8
/* 19546*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19547*/    OPC_CheckTypeI32,
/* 19548*/    OPC_MoveSibling, 11,
/* 19550*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19553*/    OPC_RecordNode, // #11 = $m9
/* 19554*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19555*/    OPC_CheckTypeI32,
/* 19556*/    OPC_MoveSibling, 12,
/* 19558*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19561*/    OPC_RecordNode, // #12 = $mA
/* 19562*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19563*/    OPC_CheckTypeI32,
/* 19564*/    OPC_MoveSibling, 13,
/* 19566*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19569*/    OPC_RecordNode, // #13 = $mB
/* 19570*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19571*/    OPC_CheckTypeI32,
/* 19572*/    OPC_MoveSibling, 14,
/* 19574*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19577*/    OPC_RecordNode, // #14 = $mC
/* 19578*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19579*/    OPC_CheckTypeI32,
/* 19580*/    OPC_MoveSibling, 15,
/* 19582*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19585*/    OPC_RecordNode, // #15 = $mD
/* 19586*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19587*/    OPC_CheckTypeI32,
/* 19588*/    OPC_MoveSibling, 16,
/* 19590*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19593*/    OPC_RecordNode, // #16 = $mE
/* 19594*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19595*/    OPC_CheckTypeI32,
/* 19596*/    OPC_MoveSibling, 17,
/* 19598*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19601*/    OPC_RecordNode, // #17 = $mF
/* 19602*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19603*/    OPC_CheckTypeI32,
/* 19604*/    OPC_MoveParent,
/* 19605*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 19607*/    OPC_EmitConvertToTarget2,
/* 19608*/    OPC_EmitConvertToTarget3,
/* 19609*/    OPC_EmitConvertToTarget4,
/* 19610*/    OPC_EmitConvertToTarget5,
/* 19611*/    OPC_EmitConvertToTarget6,
/* 19612*/    OPC_EmitConvertToTarget7,
/* 19613*/    OPC_EmitConvertToTarget, 8,
/* 19615*/    OPC_EmitConvertToTarget, 9,
/* 19617*/    OPC_EmitConvertToTarget, 10,
/* 19619*/    OPC_EmitConvertToTarget, 11,
/* 19621*/    OPC_EmitConvertToTarget, 12,
/* 19623*/    OPC_EmitConvertToTarget, 13,
/* 19625*/    OPC_EmitConvertToTarget, 14,
/* 19627*/    OPC_EmitConvertToTarget, 15,
/* 19629*/    OPC_EmitConvertToTarget, 16,
/* 19631*/    OPC_EmitConvertToTarget, 17,
/* 19633*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v4i32*/60, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4i32] } V128:{ *:[v4i32] }:$x, V128:{ *:[v4i32] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v4i32] } ?:{ *:[v4i32] }:$x, ?:{ *:[v4i32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19656*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->19813
/* 19660*/    OPC_CheckTypeI32,
/* 19661*/    OPC_MoveSibling3,
/* 19662*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19665*/    OPC_RecordNode, // #3 = $m1
/* 19666*/    OPC_CheckTypeI32,
/* 19667*/    OPC_MoveSibling4,
/* 19668*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19671*/    OPC_RecordNode, // #4 = $m2
/* 19672*/    OPC_CheckTypeI32,
/* 19673*/    OPC_MoveSibling5,
/* 19674*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19677*/    OPC_RecordNode, // #5 = $m3
/* 19678*/    OPC_CheckTypeI32,
/* 19679*/    OPC_MoveSibling6,
/* 19680*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19683*/    OPC_RecordNode, // #6 = $m4
/* 19684*/    OPC_CheckTypeI32,
/* 19685*/    OPC_MoveSibling7,
/* 19686*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19689*/    OPC_RecordNode, // #7 = $m5
/* 19690*/    OPC_CheckTypeI32,
/* 19691*/    OPC_MoveSibling, 8,
/* 19693*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19696*/    OPC_RecordNode, // #8 = $m6
/* 19697*/    OPC_CheckTypeI32,
/* 19698*/    OPC_MoveSibling, 9,
/* 19700*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19703*/    OPC_RecordNode, // #9 = $m7
/* 19704*/    OPC_CheckTypeI32,
/* 19705*/    OPC_MoveSibling, 10,
/* 19707*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19710*/    OPC_RecordNode, // #10 = $m8
/* 19711*/    OPC_CheckTypeI32,
/* 19712*/    OPC_MoveSibling, 11,
/* 19714*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19717*/    OPC_RecordNode, // #11 = $m9
/* 19718*/    OPC_CheckTypeI32,
/* 19719*/    OPC_MoveSibling, 12,
/* 19721*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19724*/    OPC_RecordNode, // #12 = $mA
/* 19725*/    OPC_CheckTypeI32,
/* 19726*/    OPC_MoveSibling, 13,
/* 19728*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19731*/    OPC_RecordNode, // #13 = $mB
/* 19732*/    OPC_CheckTypeI32,
/* 19733*/    OPC_MoveSibling, 14,
/* 19735*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19738*/    OPC_RecordNode, // #14 = $mC
/* 19739*/    OPC_CheckTypeI32,
/* 19740*/    OPC_MoveSibling, 15,
/* 19742*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19745*/    OPC_RecordNode, // #15 = $mD
/* 19746*/    OPC_CheckTypeI32,
/* 19747*/    OPC_MoveSibling, 16,
/* 19749*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19752*/    OPC_RecordNode, // #16 = $mE
/* 19753*/    OPC_CheckTypeI32,
/* 19754*/    OPC_MoveSibling, 17,
/* 19756*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19759*/    OPC_RecordNode, // #17 = $mF
/* 19760*/    OPC_CheckTypeI32,
/* 19761*/    OPC_MoveParent,
/* 19762*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 19764*/    OPC_EmitConvertToTarget2,
/* 19765*/    OPC_EmitConvertToTarget3,
/* 19766*/    OPC_EmitConvertToTarget4,
/* 19767*/    OPC_EmitConvertToTarget5,
/* 19768*/    OPC_EmitConvertToTarget6,
/* 19769*/    OPC_EmitConvertToTarget7,
/* 19770*/    OPC_EmitConvertToTarget, 8,
/* 19772*/    OPC_EmitConvertToTarget, 9,
/* 19774*/    OPC_EmitConvertToTarget, 10,
/* 19776*/    OPC_EmitConvertToTarget, 11,
/* 19778*/    OPC_EmitConvertToTarget, 12,
/* 19780*/    OPC_EmitConvertToTarget, 13,
/* 19782*/    OPC_EmitConvertToTarget, 14,
/* 19784*/    OPC_EmitConvertToTarget, 15,
/* 19786*/    OPC_EmitConvertToTarget, 16,
/* 19788*/    OPC_EmitConvertToTarget, 17,
/* 19790*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v4i32*/60, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4i32] } V128:{ *:[v4i32] }:$x, V128:{ *:[v4i32] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v4i32] } ?:{ *:[v4i32] }:$x, ?:{ *:[v4i32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19813*/   0, // EndSwitchOpcode
/* 19814*/  /*Scope*/ 83|128,2/*339*/, /*->20155*/
/* 19816*/   OPC_CheckChild0Type, /*MVT::v2i64*/78, 
/* 19818*/   OPC_RecordChild1, // #1 = $y
/* 19819*/   OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/* 19821*/   OPC_RecordChild2, // #2 = $m0
/* 19822*/   OPC_MoveChild2,
/* 19823*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->19997
/* 19828*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19829*/    OPC_CheckTypeI32,
/* 19830*/    OPC_MoveSibling3,
/* 19831*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19834*/    OPC_RecordNode, // #3 = $m1
/* 19835*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19836*/    OPC_CheckTypeI32,
/* 19837*/    OPC_MoveSibling4,
/* 19838*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19841*/    OPC_RecordNode, // #4 = $m2
/* 19842*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19843*/    OPC_CheckTypeI32,
/* 19844*/    OPC_MoveSibling5,
/* 19845*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19848*/    OPC_RecordNode, // #5 = $m3
/* 19849*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19850*/    OPC_CheckTypeI32,
/* 19851*/    OPC_MoveSibling6,
/* 19852*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19855*/    OPC_RecordNode, // #6 = $m4
/* 19856*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19857*/    OPC_CheckTypeI32,
/* 19858*/    OPC_MoveSibling7,
/* 19859*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19862*/    OPC_RecordNode, // #7 = $m5
/* 19863*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19864*/    OPC_CheckTypeI32,
/* 19865*/    OPC_MoveSibling, 8,
/* 19867*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19870*/    OPC_RecordNode, // #8 = $m6
/* 19871*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19872*/    OPC_CheckTypeI32,
/* 19873*/    OPC_MoveSibling, 9,
/* 19875*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19878*/    OPC_RecordNode, // #9 = $m7
/* 19879*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19880*/    OPC_CheckTypeI32,
/* 19881*/    OPC_MoveSibling, 10,
/* 19883*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19886*/    OPC_RecordNode, // #10 = $m8
/* 19887*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19888*/    OPC_CheckTypeI32,
/* 19889*/    OPC_MoveSibling, 11,
/* 19891*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19894*/    OPC_RecordNode, // #11 = $m9
/* 19895*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19896*/    OPC_CheckTypeI32,
/* 19897*/    OPC_MoveSibling, 12,
/* 19899*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19902*/    OPC_RecordNode, // #12 = $mA
/* 19903*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19904*/    OPC_CheckTypeI32,
/* 19905*/    OPC_MoveSibling, 13,
/* 19907*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19910*/    OPC_RecordNode, // #13 = $mB
/* 19911*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19912*/    OPC_CheckTypeI32,
/* 19913*/    OPC_MoveSibling, 14,
/* 19915*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19918*/    OPC_RecordNode, // #14 = $mC
/* 19919*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19920*/    OPC_CheckTypeI32,
/* 19921*/    OPC_MoveSibling, 15,
/* 19923*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19926*/    OPC_RecordNode, // #15 = $mD
/* 19927*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19928*/    OPC_CheckTypeI32,
/* 19929*/    OPC_MoveSibling, 16,
/* 19931*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19934*/    OPC_RecordNode, // #16 = $mE
/* 19935*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19936*/    OPC_CheckTypeI32,
/* 19937*/    OPC_MoveSibling, 17,
/* 19939*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19942*/    OPC_RecordNode, // #17 = $mF
/* 19943*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19944*/    OPC_CheckTypeI32,
/* 19945*/    OPC_MoveParent,
/* 19946*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 19948*/    OPC_EmitConvertToTarget2,
/* 19949*/    OPC_EmitConvertToTarget3,
/* 19950*/    OPC_EmitConvertToTarget4,
/* 19951*/    OPC_EmitConvertToTarget5,
/* 19952*/    OPC_EmitConvertToTarget6,
/* 19953*/    OPC_EmitConvertToTarget7,
/* 19954*/    OPC_EmitConvertToTarget, 8,
/* 19956*/    OPC_EmitConvertToTarget, 9,
/* 19958*/    OPC_EmitConvertToTarget, 10,
/* 19960*/    OPC_EmitConvertToTarget, 11,
/* 19962*/    OPC_EmitConvertToTarget, 12,
/* 19964*/    OPC_EmitConvertToTarget, 13,
/* 19966*/    OPC_EmitConvertToTarget, 14,
/* 19968*/    OPC_EmitConvertToTarget, 15,
/* 19970*/    OPC_EmitConvertToTarget, 16,
/* 19972*/    OPC_EmitConvertToTarget, 17,
/* 19974*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v2i64*/78, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2i64] } V128:{ *:[v2i64] }:$x, V128:{ *:[v2i64] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v2i64] } ?:{ *:[v2i64] }:$x, ?:{ *:[v2i64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19997*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->20154
/* 20001*/    OPC_CheckTypeI32,
/* 20002*/    OPC_MoveSibling3,
/* 20003*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20006*/    OPC_RecordNode, // #3 = $m1
/* 20007*/    OPC_CheckTypeI32,
/* 20008*/    OPC_MoveSibling4,
/* 20009*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20012*/    OPC_RecordNode, // #4 = $m2
/* 20013*/    OPC_CheckTypeI32,
/* 20014*/    OPC_MoveSibling5,
/* 20015*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20018*/    OPC_RecordNode, // #5 = $m3
/* 20019*/    OPC_CheckTypeI32,
/* 20020*/    OPC_MoveSibling6,
/* 20021*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20024*/    OPC_RecordNode, // #6 = $m4
/* 20025*/    OPC_CheckTypeI32,
/* 20026*/    OPC_MoveSibling7,
/* 20027*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20030*/    OPC_RecordNode, // #7 = $m5
/* 20031*/    OPC_CheckTypeI32,
/* 20032*/    OPC_MoveSibling, 8,
/* 20034*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20037*/    OPC_RecordNode, // #8 = $m6
/* 20038*/    OPC_CheckTypeI32,
/* 20039*/    OPC_MoveSibling, 9,
/* 20041*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20044*/    OPC_RecordNode, // #9 = $m7
/* 20045*/    OPC_CheckTypeI32,
/* 20046*/    OPC_MoveSibling, 10,
/* 20048*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20051*/    OPC_RecordNode, // #10 = $m8
/* 20052*/    OPC_CheckTypeI32,
/* 20053*/    OPC_MoveSibling, 11,
/* 20055*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20058*/    OPC_RecordNode, // #11 = $m9
/* 20059*/    OPC_CheckTypeI32,
/* 20060*/    OPC_MoveSibling, 12,
/* 20062*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20065*/    OPC_RecordNode, // #12 = $mA
/* 20066*/    OPC_CheckTypeI32,
/* 20067*/    OPC_MoveSibling, 13,
/* 20069*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20072*/    OPC_RecordNode, // #13 = $mB
/* 20073*/    OPC_CheckTypeI32,
/* 20074*/    OPC_MoveSibling, 14,
/* 20076*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20079*/    OPC_RecordNode, // #14 = $mC
/* 20080*/    OPC_CheckTypeI32,
/* 20081*/    OPC_MoveSibling, 15,
/* 20083*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20086*/    OPC_RecordNode, // #15 = $mD
/* 20087*/    OPC_CheckTypeI32,
/* 20088*/    OPC_MoveSibling, 16,
/* 20090*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20093*/    OPC_RecordNode, // #16 = $mE
/* 20094*/    OPC_CheckTypeI32,
/* 20095*/    OPC_MoveSibling, 17,
/* 20097*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20100*/    OPC_RecordNode, // #17 = $mF
/* 20101*/    OPC_CheckTypeI32,
/* 20102*/    OPC_MoveParent,
/* 20103*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 20105*/    OPC_EmitConvertToTarget2,
/* 20106*/    OPC_EmitConvertToTarget3,
/* 20107*/    OPC_EmitConvertToTarget4,
/* 20108*/    OPC_EmitConvertToTarget5,
/* 20109*/    OPC_EmitConvertToTarget6,
/* 20110*/    OPC_EmitConvertToTarget7,
/* 20111*/    OPC_EmitConvertToTarget, 8,
/* 20113*/    OPC_EmitConvertToTarget, 9,
/* 20115*/    OPC_EmitConvertToTarget, 10,
/* 20117*/    OPC_EmitConvertToTarget, 11,
/* 20119*/    OPC_EmitConvertToTarget, 12,
/* 20121*/    OPC_EmitConvertToTarget, 13,
/* 20123*/    OPC_EmitConvertToTarget, 14,
/* 20125*/    OPC_EmitConvertToTarget, 15,
/* 20127*/    OPC_EmitConvertToTarget, 16,
/* 20129*/    OPC_EmitConvertToTarget, 17,
/* 20131*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v2i64*/78, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2i64] } V128:{ *:[v2i64] }:$x, V128:{ *:[v2i64] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v2i64] } ?:{ *:[v2i64] }:$x, ?:{ *:[v2i64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20154*/   0, // EndSwitchOpcode
/* 20155*/  /*Scope*/ 83|128,2/*339*/, /*->20496*/
/* 20157*/   OPC_CheckChild0Type, /*MVT::v4f32*/110, 
/* 20159*/   OPC_RecordChild1, // #1 = $y
/* 20160*/   OPC_CheckChild1Type, /*MVT::v4f32*/110, 
/* 20162*/   OPC_RecordChild2, // #2 = $m0
/* 20163*/   OPC_MoveChild2,
/* 20164*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->20338
/* 20169*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20170*/    OPC_CheckTypeI32,
/* 20171*/    OPC_MoveSibling3,
/* 20172*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20175*/    OPC_RecordNode, // #3 = $m1
/* 20176*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20177*/    OPC_CheckTypeI32,
/* 20178*/    OPC_MoveSibling4,
/* 20179*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20182*/    OPC_RecordNode, // #4 = $m2
/* 20183*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20184*/    OPC_CheckTypeI32,
/* 20185*/    OPC_MoveSibling5,
/* 20186*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20189*/    OPC_RecordNode, // #5 = $m3
/* 20190*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20191*/    OPC_CheckTypeI32,
/* 20192*/    OPC_MoveSibling6,
/* 20193*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20196*/    OPC_RecordNode, // #6 = $m4
/* 20197*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20198*/    OPC_CheckTypeI32,
/* 20199*/    OPC_MoveSibling7,
/* 20200*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20203*/    OPC_RecordNode, // #7 = $m5
/* 20204*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20205*/    OPC_CheckTypeI32,
/* 20206*/    OPC_MoveSibling, 8,
/* 20208*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20211*/    OPC_RecordNode, // #8 = $m6
/* 20212*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20213*/    OPC_CheckTypeI32,
/* 20214*/    OPC_MoveSibling, 9,
/* 20216*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20219*/    OPC_RecordNode, // #9 = $m7
/* 20220*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20221*/    OPC_CheckTypeI32,
/* 20222*/    OPC_MoveSibling, 10,
/* 20224*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20227*/    OPC_RecordNode, // #10 = $m8
/* 20228*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20229*/    OPC_CheckTypeI32,
/* 20230*/    OPC_MoveSibling, 11,
/* 20232*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20235*/    OPC_RecordNode, // #11 = $m9
/* 20236*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20237*/    OPC_CheckTypeI32,
/* 20238*/    OPC_MoveSibling, 12,
/* 20240*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20243*/    OPC_RecordNode, // #12 = $mA
/* 20244*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20245*/    OPC_CheckTypeI32,
/* 20246*/    OPC_MoveSibling, 13,
/* 20248*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20251*/    OPC_RecordNode, // #13 = $mB
/* 20252*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20253*/    OPC_CheckTypeI32,
/* 20254*/    OPC_MoveSibling, 14,
/* 20256*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20259*/    OPC_RecordNode, // #14 = $mC
/* 20260*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20261*/    OPC_CheckTypeI32,
/* 20262*/    OPC_MoveSibling, 15,
/* 20264*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20267*/    OPC_RecordNode, // #15 = $mD
/* 20268*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20269*/    OPC_CheckTypeI32,
/* 20270*/    OPC_MoveSibling, 16,
/* 20272*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20275*/    OPC_RecordNode, // #16 = $mE
/* 20276*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20277*/    OPC_CheckTypeI32,
/* 20278*/    OPC_MoveSibling, 17,
/* 20280*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20283*/    OPC_RecordNode, // #17 = $mF
/* 20284*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20285*/    OPC_CheckTypeI32,
/* 20286*/    OPC_MoveParent,
/* 20287*/    OPC_CheckType, /*MVT::v4f32*/110, 
/* 20289*/    OPC_EmitConvertToTarget2,
/* 20290*/    OPC_EmitConvertToTarget3,
/* 20291*/    OPC_EmitConvertToTarget4,
/* 20292*/    OPC_EmitConvertToTarget5,
/* 20293*/    OPC_EmitConvertToTarget6,
/* 20294*/    OPC_EmitConvertToTarget7,
/* 20295*/    OPC_EmitConvertToTarget, 8,
/* 20297*/    OPC_EmitConvertToTarget, 9,
/* 20299*/    OPC_EmitConvertToTarget, 10,
/* 20301*/    OPC_EmitConvertToTarget, 11,
/* 20303*/    OPC_EmitConvertToTarget, 12,
/* 20305*/    OPC_EmitConvertToTarget, 13,
/* 20307*/    OPC_EmitConvertToTarget, 14,
/* 20309*/    OPC_EmitConvertToTarget, 15,
/* 20311*/    OPC_EmitConvertToTarget, 16,
/* 20313*/    OPC_EmitConvertToTarget, 17,
/* 20315*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v4f32*/110, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4f32] } V128:{ *:[v4f32] }:$x, V128:{ *:[v4f32] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v4f32] } ?:{ *:[v4f32] }:$x, ?:{ *:[v4f32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20338*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->20495
/* 20342*/    OPC_CheckTypeI32,
/* 20343*/    OPC_MoveSibling3,
/* 20344*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20347*/    OPC_RecordNode, // #3 = $m1
/* 20348*/    OPC_CheckTypeI32,
/* 20349*/    OPC_MoveSibling4,
/* 20350*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20353*/    OPC_RecordNode, // #4 = $m2
/* 20354*/    OPC_CheckTypeI32,
/* 20355*/    OPC_MoveSibling5,
/* 20356*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20359*/    OPC_RecordNode, // #5 = $m3
/* 20360*/    OPC_CheckTypeI32,
/* 20361*/    OPC_MoveSibling6,
/* 20362*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20365*/    OPC_RecordNode, // #6 = $m4
/* 20366*/    OPC_CheckTypeI32,
/* 20367*/    OPC_MoveSibling7,
/* 20368*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20371*/    OPC_RecordNode, // #7 = $m5
/* 20372*/    OPC_CheckTypeI32,
/* 20373*/    OPC_MoveSibling, 8,
/* 20375*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20378*/    OPC_RecordNode, // #8 = $m6
/* 20379*/    OPC_CheckTypeI32,
/* 20380*/    OPC_MoveSibling, 9,
/* 20382*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20385*/    OPC_RecordNode, // #9 = $m7
/* 20386*/    OPC_CheckTypeI32,
/* 20387*/    OPC_MoveSibling, 10,
/* 20389*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20392*/    OPC_RecordNode, // #10 = $m8
/* 20393*/    OPC_CheckTypeI32,
/* 20394*/    OPC_MoveSibling, 11,
/* 20396*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20399*/    OPC_RecordNode, // #11 = $m9
/* 20400*/    OPC_CheckTypeI32,
/* 20401*/    OPC_MoveSibling, 12,
/* 20403*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20406*/    OPC_RecordNode, // #12 = $mA
/* 20407*/    OPC_CheckTypeI32,
/* 20408*/    OPC_MoveSibling, 13,
/* 20410*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20413*/    OPC_RecordNode, // #13 = $mB
/* 20414*/    OPC_CheckTypeI32,
/* 20415*/    OPC_MoveSibling, 14,
/* 20417*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20420*/    OPC_RecordNode, // #14 = $mC
/* 20421*/    OPC_CheckTypeI32,
/* 20422*/    OPC_MoveSibling, 15,
/* 20424*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20427*/    OPC_RecordNode, // #15 = $mD
/* 20428*/    OPC_CheckTypeI32,
/* 20429*/    OPC_MoveSibling, 16,
/* 20431*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20434*/    OPC_RecordNode, // #16 = $mE
/* 20435*/    OPC_CheckTypeI32,
/* 20436*/    OPC_MoveSibling, 17,
/* 20438*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20441*/    OPC_RecordNode, // #17 = $mF
/* 20442*/    OPC_CheckTypeI32,
/* 20443*/    OPC_MoveParent,
/* 20444*/    OPC_CheckType, /*MVT::v4f32*/110, 
/* 20446*/    OPC_EmitConvertToTarget2,
/* 20447*/    OPC_EmitConvertToTarget3,
/* 20448*/    OPC_EmitConvertToTarget4,
/* 20449*/    OPC_EmitConvertToTarget5,
/* 20450*/    OPC_EmitConvertToTarget6,
/* 20451*/    OPC_EmitConvertToTarget7,
/* 20452*/    OPC_EmitConvertToTarget, 8,
/* 20454*/    OPC_EmitConvertToTarget, 9,
/* 20456*/    OPC_EmitConvertToTarget, 10,
/* 20458*/    OPC_EmitConvertToTarget, 11,
/* 20460*/    OPC_EmitConvertToTarget, 12,
/* 20462*/    OPC_EmitConvertToTarget, 13,
/* 20464*/    OPC_EmitConvertToTarget, 14,
/* 20466*/    OPC_EmitConvertToTarget, 15,
/* 20468*/    OPC_EmitConvertToTarget, 16,
/* 20470*/    OPC_EmitConvertToTarget, 17,
/* 20472*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v4f32*/110, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4f32] } V128:{ *:[v4f32] }:$x, V128:{ *:[v4f32] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v4f32] } ?:{ *:[v4f32] }:$x, ?:{ *:[v4f32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20495*/   0, // EndSwitchOpcode
/* 20496*/  /*Scope*/ 89|128,2/*345*/, /*->20843*/
/* 20498*/   OPC_CheckChild0Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 20501*/   OPC_RecordChild1, // #1 = $y
/* 20502*/   OPC_CheckChild1Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 20505*/   OPC_RecordChild2, // #2 = $m0
/* 20506*/   OPC_MoveChild2,
/* 20507*/   OPC_SwitchOpcode /*2 cases */, 43|128,1/*171*/, TARGET_VAL(ISD::Constant),// ->20683
/* 20512*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20513*/    OPC_CheckTypeI32,
/* 20514*/    OPC_MoveSibling3,
/* 20515*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20518*/    OPC_RecordNode, // #3 = $m1
/* 20519*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20520*/    OPC_CheckTypeI32,
/* 20521*/    OPC_MoveSibling4,
/* 20522*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20525*/    OPC_RecordNode, // #4 = $m2
/* 20526*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20527*/    OPC_CheckTypeI32,
/* 20528*/    OPC_MoveSibling5,
/* 20529*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20532*/    OPC_RecordNode, // #5 = $m3
/* 20533*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20534*/    OPC_CheckTypeI32,
/* 20535*/    OPC_MoveSibling6,
/* 20536*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20539*/    OPC_RecordNode, // #6 = $m4
/* 20540*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20541*/    OPC_CheckTypeI32,
/* 20542*/    OPC_MoveSibling7,
/* 20543*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20546*/    OPC_RecordNode, // #7 = $m5
/* 20547*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20548*/    OPC_CheckTypeI32,
/* 20549*/    OPC_MoveSibling, 8,
/* 20551*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20554*/    OPC_RecordNode, // #8 = $m6
/* 20555*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20556*/    OPC_CheckTypeI32,
/* 20557*/    OPC_MoveSibling, 9,
/* 20559*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20562*/    OPC_RecordNode, // #9 = $m7
/* 20563*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20564*/    OPC_CheckTypeI32,
/* 20565*/    OPC_MoveSibling, 10,
/* 20567*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20570*/    OPC_RecordNode, // #10 = $m8
/* 20571*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20572*/    OPC_CheckTypeI32,
/* 20573*/    OPC_MoveSibling, 11,
/* 20575*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20578*/    OPC_RecordNode, // #11 = $m9
/* 20579*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20580*/    OPC_CheckTypeI32,
/* 20581*/    OPC_MoveSibling, 12,
/* 20583*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20586*/    OPC_RecordNode, // #12 = $mA
/* 20587*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20588*/    OPC_CheckTypeI32,
/* 20589*/    OPC_MoveSibling, 13,
/* 20591*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20594*/    OPC_RecordNode, // #13 = $mB
/* 20595*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20596*/    OPC_CheckTypeI32,
/* 20597*/    OPC_MoveSibling, 14,
/* 20599*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20602*/    OPC_RecordNode, // #14 = $mC
/* 20603*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20604*/    OPC_CheckTypeI32,
/* 20605*/    OPC_MoveSibling, 15,
/* 20607*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20610*/    OPC_RecordNode, // #15 = $mD
/* 20611*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20612*/    OPC_CheckTypeI32,
/* 20613*/    OPC_MoveSibling, 16,
/* 20615*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20618*/    OPC_RecordNode, // #16 = $mE
/* 20619*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20620*/    OPC_CheckTypeI32,
/* 20621*/    OPC_MoveSibling, 17,
/* 20623*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20626*/    OPC_RecordNode, // #17 = $mF
/* 20627*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20628*/    OPC_CheckTypeI32,
/* 20629*/    OPC_MoveParent,
/* 20630*/    OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 20633*/    OPC_EmitConvertToTarget2,
/* 20634*/    OPC_EmitConvertToTarget3,
/* 20635*/    OPC_EmitConvertToTarget4,
/* 20636*/    OPC_EmitConvertToTarget5,
/* 20637*/    OPC_EmitConvertToTarget6,
/* 20638*/    OPC_EmitConvertToTarget7,
/* 20639*/    OPC_EmitConvertToTarget, 8,
/* 20641*/    OPC_EmitConvertToTarget, 9,
/* 20643*/    OPC_EmitConvertToTarget, 10,
/* 20645*/    OPC_EmitConvertToTarget, 11,
/* 20647*/    OPC_EmitConvertToTarget, 12,
/* 20649*/    OPC_EmitConvertToTarget, 13,
/* 20651*/    OPC_EmitConvertToTarget, 14,
/* 20653*/    OPC_EmitConvertToTarget, 15,
/* 20655*/    OPC_EmitConvertToTarget, 16,
/* 20657*/    OPC_EmitConvertToTarget, 17,
/* 20659*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v2f64*/0|128,1/*128*/, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2f64] } V128:{ *:[v2f64] }:$x, V128:{ *:[v2f64] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v2f64] } ?:{ *:[v2f64] }:$x, ?:{ *:[v2f64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20683*/   /*SwitchOpcode*/ 27|128,1/*155*/, TARGET_VAL(ISD::TargetConstant),// ->20842
/* 20687*/    OPC_CheckTypeI32,
/* 20688*/    OPC_MoveSibling3,
/* 20689*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20692*/    OPC_RecordNode, // #3 = $m1
/* 20693*/    OPC_CheckTypeI32,
/* 20694*/    OPC_MoveSibling4,
/* 20695*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20698*/    OPC_RecordNode, // #4 = $m2
/* 20699*/    OPC_CheckTypeI32,
/* 20700*/    OPC_MoveSibling5,
/* 20701*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20704*/    OPC_RecordNode, // #5 = $m3
/* 20705*/    OPC_CheckTypeI32,
/* 20706*/    OPC_MoveSibling6,
/* 20707*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20710*/    OPC_RecordNode, // #6 = $m4
/* 20711*/    OPC_CheckTypeI32,
/* 20712*/    OPC_MoveSibling7,
/* 20713*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20716*/    OPC_RecordNode, // #7 = $m5
/* 20717*/    OPC_CheckTypeI32,
/* 20718*/    OPC_MoveSibling, 8,
/* 20720*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20723*/    OPC_RecordNode, // #8 = $m6
/* 20724*/    OPC_CheckTypeI32,
/* 20725*/    OPC_MoveSibling, 9,
/* 20727*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20730*/    OPC_RecordNode, // #9 = $m7
/* 20731*/    OPC_CheckTypeI32,
/* 20732*/    OPC_MoveSibling, 10,
/* 20734*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20737*/    OPC_RecordNode, // #10 = $m8
/* 20738*/    OPC_CheckTypeI32,
/* 20739*/    OPC_MoveSibling, 11,
/* 20741*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20744*/    OPC_RecordNode, // #11 = $m9
/* 20745*/    OPC_CheckTypeI32,
/* 20746*/    OPC_MoveSibling, 12,
/* 20748*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20751*/    OPC_RecordNode, // #12 = $mA
/* 20752*/    OPC_CheckTypeI32,
/* 20753*/    OPC_MoveSibling, 13,
/* 20755*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20758*/    OPC_RecordNode, // #13 = $mB
/* 20759*/    OPC_CheckTypeI32,
/* 20760*/    OPC_MoveSibling, 14,
/* 20762*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20765*/    OPC_RecordNode, // #14 = $mC
/* 20766*/    OPC_CheckTypeI32,
/* 20767*/    OPC_MoveSibling, 15,
/* 20769*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20772*/    OPC_RecordNode, // #15 = $mD
/* 20773*/    OPC_CheckTypeI32,
/* 20774*/    OPC_MoveSibling, 16,
/* 20776*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20779*/    OPC_RecordNode, // #16 = $mE
/* 20780*/    OPC_CheckTypeI32,
/* 20781*/    OPC_MoveSibling, 17,
/* 20783*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20786*/    OPC_RecordNode, // #17 = $mF
/* 20787*/    OPC_CheckTypeI32,
/* 20788*/    OPC_MoveParent,
/* 20789*/    OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 20792*/    OPC_EmitConvertToTarget2,
/* 20793*/    OPC_EmitConvertToTarget3,
/* 20794*/    OPC_EmitConvertToTarget4,
/* 20795*/    OPC_EmitConvertToTarget5,
/* 20796*/    OPC_EmitConvertToTarget6,
/* 20797*/    OPC_EmitConvertToTarget7,
/* 20798*/    OPC_EmitConvertToTarget, 8,
/* 20800*/    OPC_EmitConvertToTarget, 9,
/* 20802*/    OPC_EmitConvertToTarget, 10,
/* 20804*/    OPC_EmitConvertToTarget, 11,
/* 20806*/    OPC_EmitConvertToTarget, 12,
/* 20808*/    OPC_EmitConvertToTarget, 13,
/* 20810*/    OPC_EmitConvertToTarget, 14,
/* 20812*/    OPC_EmitConvertToTarget, 15,
/* 20814*/    OPC_EmitConvertToTarget, 16,
/* 20816*/    OPC_EmitConvertToTarget, 17,
/* 20818*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v2f64*/0|128,1/*128*/, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2f64] } V128:{ *:[v2f64] }:$x, V128:{ *:[v2f64] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v2f64] } ?:{ *:[v2f64] }:$x, ?:{ *:[v2f64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20842*/   0, // EndSwitchOpcode
/* 20843*/  0, /*End of Scope*/
/* 20844*/ /*SwitchOpcode*/ 73|128,8/*1097*/, TARGET_VAL(ISD::INSERT_VECTOR_ELT),// ->21945
/* 20848*/  OPC_Scope, 6|128,1/*134*/, /*->20985*/ // 2 children in Scope
/* 20851*/   OPC_MoveChild0,
/* 20852*/   OPC_CheckOpcode, TARGET_VAL(ISD::SPLAT_VECTOR),
/* 20855*/   OPC_CheckChild0Integer, 0, 
/* 20857*/   OPC_Scope, 62, /*->20921*/ // 2 children in Scope
/* 20859*/    OPC_CheckChild0TypeI32,
/* 20860*/    OPC_MoveSibling1,
/* 20861*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 20864*/    OPC_RecordMemRef,
/* 20865*/    OPC_RecordNode, // #0 = 'ld' chained node
/* 20866*/    OPC_CheckFoldableChainNode,
/* 20867*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 20868*/    OPC_CheckTypeI32,
/* 20869*/    OPC_Scope, 24, /*->20895*/ // 2 children in Scope
/* 20871*/     OPC_CheckChild1TypeI32,
/* 20872*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 20874*/     OPC_CheckPredicate6,  // Predicate_load
/* 20875*/     OPC_MoveParent,
/* 20876*/     OPC_CheckChild2Integer, 0, 
/* 20878*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 20880*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 20881*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 20883*/     OPC_EmitMergeInputChains1_0,
/* 20884*/     OPC_EmitInteger32, 0, 
/* 20886*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v4i32] } (splat_vector:{ *:[v4i32] } 0:{ *:[i32] }), (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_32_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 20895*/    /*Scope*/ 24, /*->20920*/
/* 20896*/     OPC_CheckChild1TypeI64,
/* 20897*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 20899*/     OPC_CheckPredicate6,  // Predicate_load
/* 20900*/     OPC_MoveParent,
/* 20901*/     OPC_CheckChild2Integer, 0, 
/* 20903*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 20905*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 20906*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 20908*/     OPC_EmitMergeInputChains1_0,
/* 20909*/     OPC_EmitInteger32, 0, 
/* 20911*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v4i32] } (splat_vector:{ *:[v4i32] } 0:{ *:[i32] }), (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_32_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 20920*/    0, /*End of Scope*/
/* 20921*/   /*Scope*/ 62, /*->20984*/
/* 20922*/    OPC_CheckChild0TypeI64,
/* 20923*/    OPC_MoveSibling1,
/* 20924*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 20927*/    OPC_RecordMemRef,
/* 20928*/    OPC_RecordNode, // #0 = 'ld' chained node
/* 20929*/    OPC_CheckFoldableChainNode,
/* 20930*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 20931*/    OPC_CheckTypeI64,
/* 20932*/    OPC_Scope, 24, /*->20958*/ // 2 children in Scope
/* 20934*/     OPC_CheckChild1TypeI32,
/* 20935*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 20937*/     OPC_CheckPredicate6,  // Predicate_load
/* 20938*/     OPC_MoveParent,
/* 20939*/     OPC_CheckChild2Integer, 0, 
/* 20941*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 20943*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 20944*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 20946*/     OPC_EmitMergeInputChains1_0,
/* 20947*/     OPC_EmitInteger32, 0, 
/* 20949*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v2i64] } (splat_vector:{ *:[v2i64] } 0:{ *:[i64] }), (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_64_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 20958*/    /*Scope*/ 24, /*->20983*/
/* 20959*/     OPC_CheckChild1TypeI64,
/* 20960*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 20962*/     OPC_CheckPredicate6,  // Predicate_load
/* 20963*/     OPC_MoveParent,
/* 20964*/     OPC_CheckChild2Integer, 0, 
/* 20966*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 20968*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 20969*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 20971*/     OPC_EmitMergeInputChains1_0,
/* 20972*/     OPC_EmitInteger32, 0, 
/* 20974*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v2i64] } (splat_vector:{ *:[v2i64] } 0:{ *:[i64] }), (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_64_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 20983*/    0, /*End of Scope*/
/* 20984*/   0, /*End of Scope*/
/* 20985*/  /*Scope*/ 61|128,7/*957*/, /*->21944*/
/* 20987*/   OPC_RecordChild0, // #0 = $vec
/* 20988*/   OPC_Scope, 32|128,3/*416*/, /*->21407*/ // 4 children in Scope
/* 20991*/    OPC_MoveChild1,
/* 20992*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 20995*/    OPC_RecordMemRef,
/* 20996*/    OPC_RecordNode, // #1 = 'ld' chained node
/* 20997*/    OPC_CheckFoldableChainNode,
/* 20998*/    OPC_RecordChild1, // #2 = $addr
/* 20999*/    OPC_Scope, 73|128,1/*201*/, /*->21203*/ // 2 children in Scope
/* 21002*/     OPC_CheckChild1TypeI32,
/* 21003*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 21005*/     OPC_Scope, 67, /*->21074*/ // 2 children in Scope
/* 21007*/      OPC_CheckPredicate, 10, // Predicate_extload
/* 21009*/      OPC_CheckTypeI32,
/* 21010*/      OPC_Scope, 30, /*->21042*/ // 2 children in Scope
/* 21012*/       OPC_CheckPredicate1,  // Predicate_extloadi8
/* 21013*/       OPC_MoveSibling2,
/* 21014*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21017*/       OPC_RecordNode, // #3 = $idx
/* 21018*/       OPC_CheckPredicate, 18, // Predicate_LaneIdx16
/* 21020*/       OPC_CheckTypeI32,
/* 21021*/       OPC_MoveParent,
/* 21022*/       OPC_CheckType, /*MVT::v16i8*/39, 
/* 21024*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21025*/       OPC_EmitMergeInputChains1_1,
/* 21026*/       OPC_EmitInteger32, 0, 
/* 21028*/       OPC_EmitInteger32, 0, 
/* 21030*/       OPC_EmitConvertToTarget3,
/* 21031*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v16i8*/39, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_8_A32:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v16i8] }:$vec)
/* 21042*/      /*Scope*/ 30, /*->21073*/
/* 21043*/       OPC_CheckPredicate2,  // Predicate_extloadi16
/* 21044*/       OPC_MoveSibling2,
/* 21045*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21048*/       OPC_RecordNode, // #3 = $idx
/* 21049*/       OPC_CheckPredicate, 13, // Predicate_LaneIdx8
/* 21051*/       OPC_CheckTypeI32,
/* 21052*/       OPC_MoveParent,
/* 21053*/       OPC_CheckType, /*MVT::v8i16*/50, 
/* 21055*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21056*/       OPC_EmitMergeInputChains1_1,
/* 21057*/       OPC_EmitInteger32, 0, 
/* 21059*/       OPC_EmitInteger32, 0, 
/* 21061*/       OPC_EmitConvertToTarget3,
/* 21062*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_16_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v8i16*/50, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_16_A32:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v8i16] }:$vec)
/* 21073*/      0, /*End of Scope*/
/* 21074*/     /*Scope*/ 127, /*->21202*/
/* 21075*/      OPC_CheckPredicate6,  // Predicate_load
/* 21076*/      OPC_SwitchType /*4 cases */, 29, /*MVT::i32*/7, // ->21108
/* 21079*/       OPC_MoveSibling2,
/* 21080*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21083*/       OPC_RecordNode, // #3 = $idx
/* 21084*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21086*/       OPC_CheckTypeI32,
/* 21087*/       OPC_MoveParent,
/* 21088*/       OPC_CheckType, /*MVT::v4i32*/60, 
/* 21090*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21091*/       OPC_EmitMergeInputChains1_1,
/* 21092*/       OPC_EmitInteger32, 0, 
/* 21094*/       OPC_EmitInteger32, 0, 
/* 21096*/       OPC_EmitConvertToTarget3,
/* 21097*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v4i32*/60, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_32_A32:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 21108*/      /*SwitchType*/ 29, /*MVT::f32*/12, // ->21139
/* 21110*/       OPC_MoveSibling2,
/* 21111*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21114*/       OPC_RecordNode, // #3 = $idx
/* 21115*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21117*/       OPC_CheckTypeI32,
/* 21118*/       OPC_MoveParent,
/* 21119*/       OPC_CheckType, /*MVT::v4i32*/60, 
/* 21121*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21122*/       OPC_EmitMergeInputChains1_1,
/* 21123*/       OPC_EmitInteger32, 0, 
/* 21125*/       OPC_EmitInteger32, 0, 
/* 21127*/       OPC_EmitConvertToTarget3,
/* 21128*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v4i32*/60, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[f32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_32_A32:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 21139*/      /*SwitchType*/ 29, /*MVT::i64*/8, // ->21170
/* 21141*/       OPC_MoveSibling2,
/* 21142*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21145*/       OPC_RecordNode, // #3 = $idx
/* 21146*/       OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21148*/       OPC_CheckTypeI32,
/* 21149*/       OPC_MoveParent,
/* 21150*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 21152*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21153*/       OPC_EmitMergeInputChains1_1,
/* 21154*/       OPC_EmitInteger32, 0, 
/* 21156*/       OPC_EmitInteger32, 0, 
/* 21158*/       OPC_EmitConvertToTarget3,
/* 21159*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v2i64*/78, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_64_A32:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 21170*/      /*SwitchType*/ 29, /*MVT::f64*/13, // ->21201
/* 21172*/       OPC_MoveSibling2,
/* 21173*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21176*/       OPC_RecordNode, // #3 = $idx
/* 21177*/       OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21179*/       OPC_CheckTypeI32,
/* 21180*/       OPC_MoveParent,
/* 21181*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 21183*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21184*/       OPC_EmitMergeInputChains1_1,
/* 21185*/       OPC_EmitInteger32, 0, 
/* 21187*/       OPC_EmitInteger32, 0, 
/* 21189*/       OPC_EmitConvertToTarget3,
/* 21190*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v2i64*/78, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[f64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_64_A32:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 21201*/      0, // EndSwitchType
/* 21202*/     0, /*End of Scope*/
/* 21203*/    /*Scope*/ 73|128,1/*201*/, /*->21406*/
/* 21205*/     OPC_CheckChild1TypeI64,
/* 21206*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 21208*/     OPC_Scope, 67, /*->21277*/ // 2 children in Scope
/* 21210*/      OPC_CheckPredicate, 10, // Predicate_extload
/* 21212*/      OPC_CheckTypeI32,
/* 21213*/      OPC_Scope, 30, /*->21245*/ // 2 children in Scope
/* 21215*/       OPC_CheckPredicate1,  // Predicate_extloadi8
/* 21216*/       OPC_MoveSibling2,
/* 21217*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21220*/       OPC_RecordNode, // #3 = $idx
/* 21221*/       OPC_CheckPredicate, 18, // Predicate_LaneIdx16
/* 21223*/       OPC_CheckTypeI32,
/* 21224*/       OPC_MoveParent,
/* 21225*/       OPC_CheckType, /*MVT::v16i8*/39, 
/* 21227*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21228*/       OPC_EmitMergeInputChains1_1,
/* 21229*/       OPC_EmitInteger32, 0, 
/* 21231*/       OPC_EmitInteger64, 0, 
/* 21233*/       OPC_EmitConvertToTarget3,
/* 21234*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v16i8*/39, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_8_A64:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v16i8] }:$vec)
/* 21245*/      /*Scope*/ 30, /*->21276*/
/* 21246*/       OPC_CheckPredicate2,  // Predicate_extloadi16
/* 21247*/       OPC_MoveSibling2,
/* 21248*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21251*/       OPC_RecordNode, // #3 = $idx
/* 21252*/       OPC_CheckPredicate, 13, // Predicate_LaneIdx8
/* 21254*/       OPC_CheckTypeI32,
/* 21255*/       OPC_MoveParent,
/* 21256*/       OPC_CheckType, /*MVT::v8i16*/50, 
/* 21258*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21259*/       OPC_EmitMergeInputChains1_1,
/* 21260*/       OPC_EmitInteger32, 0, 
/* 21262*/       OPC_EmitInteger64, 0, 
/* 21264*/       OPC_EmitConvertToTarget3,
/* 21265*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_16_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v8i16*/50, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_16_A64:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v8i16] }:$vec)
/* 21276*/      0, /*End of Scope*/
/* 21277*/     /*Scope*/ 127, /*->21405*/
/* 21278*/      OPC_CheckPredicate6,  // Predicate_load
/* 21279*/      OPC_SwitchType /*4 cases */, 29, /*MVT::i32*/7, // ->21311
/* 21282*/       OPC_MoveSibling2,
/* 21283*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21286*/       OPC_RecordNode, // #3 = $idx
/* 21287*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21289*/       OPC_CheckTypeI32,
/* 21290*/       OPC_MoveParent,
/* 21291*/       OPC_CheckType, /*MVT::v4i32*/60, 
/* 21293*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21294*/       OPC_EmitMergeInputChains1_1,
/* 21295*/       OPC_EmitInteger32, 0, 
/* 21297*/       OPC_EmitInteger64, 0, 
/* 21299*/       OPC_EmitConvertToTarget3,
/* 21300*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v4i32*/60, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_32_A64:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 21311*/      /*SwitchType*/ 29, /*MVT::f32*/12, // ->21342
/* 21313*/       OPC_MoveSibling2,
/* 21314*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21317*/       OPC_RecordNode, // #3 = $idx
/* 21318*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21320*/       OPC_CheckTypeI32,
/* 21321*/       OPC_MoveParent,
/* 21322*/       OPC_CheckType, /*MVT::v4i32*/60, 
/* 21324*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21325*/       OPC_EmitMergeInputChains1_1,
/* 21326*/       OPC_EmitInteger32, 0, 
/* 21328*/       OPC_EmitInteger64, 0, 
/* 21330*/       OPC_EmitConvertToTarget3,
/* 21331*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v4i32*/60, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[f32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_32_A64:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 21342*/      /*SwitchType*/ 29, /*MVT::i64*/8, // ->21373
/* 21344*/       OPC_MoveSibling2,
/* 21345*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21348*/       OPC_RecordNode, // #3 = $idx
/* 21349*/       OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21351*/       OPC_CheckTypeI32,
/* 21352*/       OPC_MoveParent,
/* 21353*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 21355*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21356*/       OPC_EmitMergeInputChains1_1,
/* 21357*/       OPC_EmitInteger32, 0, 
/* 21359*/       OPC_EmitInteger64, 0, 
/* 21361*/       OPC_EmitConvertToTarget3,
/* 21362*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v2i64*/78, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[i64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_64_A64:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 21373*/      /*SwitchType*/ 29, /*MVT::f64*/13, // ->21404
/* 21375*/       OPC_MoveSibling2,
/* 21376*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21379*/       OPC_RecordNode, // #3 = $idx
/* 21380*/       OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21382*/       OPC_CheckTypeI32,
/* 21383*/       OPC_MoveParent,
/* 21384*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 21386*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21387*/       OPC_EmitMergeInputChains1_1,
/* 21388*/       OPC_EmitInteger32, 0, 
/* 21390*/       OPC_EmitInteger64, 0, 
/* 21392*/       OPC_EmitConvertToTarget3,
/* 21393*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v2i64*/78, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[f64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_64_A64:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 21404*/      0, // EndSwitchType
/* 21405*/     0, /*End of Scope*/
/* 21406*/    0, /*End of Scope*/
/* 21407*/   /*Scope*/ 24|128,1/*152*/, /*->21561*/
/* 21409*/    OPC_RecordChild1, // #1 = $x
/* 21410*/    OPC_Scope, 104, /*->21516*/ // 2 children in Scope
/* 21412*/     OPC_CheckChild1TypeI32,
/* 21413*/     OPC_Scope, 56, /*->21471*/ // 2 children in Scope
/* 21415*/      OPC_RecordChild2, // #2 = $idx
/* 21416*/      OPC_MoveChild2,
/* 21417*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21420*/      OPC_CheckTypeI32,
/* 21421*/      OPC_Scope, 15, /*->21438*/ // 3 children in Scope
/* 21423*/       OPC_CheckPredicate, 18, // Predicate_LaneIdx16
/* 21425*/       OPC_MoveParent,
/* 21426*/       OPC_CheckType, /*MVT::v16i8*/39, 
/* 21428*/       OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21429*/       OPC_EmitConvertToTarget2,
/* 21430*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I8x16),
                     /*MVT::v16i8*/39, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 21438*/      /*Scope*/ 15, /*->21454*/
/* 21439*/       OPC_CheckPredicate, 13, // Predicate_LaneIdx8
/* 21441*/       OPC_MoveParent,
/* 21442*/       OPC_CheckType, /*MVT::v8i16*/50, 
/* 21444*/       OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21445*/       OPC_EmitConvertToTarget2,
/* 21446*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I16x8),
                     /*MVT::v8i16*/50, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 21454*/      /*Scope*/ 15, /*->21470*/
/* 21455*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21457*/       OPC_MoveParent,
/* 21458*/       OPC_CheckType, /*MVT::v4i32*/60, 
/* 21460*/       OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21461*/       OPC_EmitConvertToTarget2,
/* 21462*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I32x4),
                     /*MVT::v4i32*/60, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 21470*/      0, /*End of Scope*/
/* 21471*/     /*Scope*/ 43, /*->21515*/
/* 21472*/      OPC_MoveChild2,
/* 21473*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 21476*/      OPC_MoveParent,
/* 21477*/      OPC_SwitchType /*3 cases */, 10, /*MVT::v16i8*/39, // ->21490
/* 21480*/       OPC_EmitInteger32, 0, 
/* 21482*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I8x16),
                     /*MVT::v16i8*/39, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 21490*/      /*SwitchType*/ 10, /*MVT::v8i16*/50, // ->21502
/* 21492*/       OPC_EmitInteger32, 0, 
/* 21494*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I16x8),
                     /*MVT::v8i16*/50, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 21502*/      /*SwitchType*/ 10, /*MVT::v4i32*/60, // ->21514
/* 21504*/       OPC_EmitInteger32, 0, 
/* 21506*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I32x4),
                     /*MVT::v4i32*/60, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 21514*/      0, // EndSwitchType
/* 21515*/     0, /*End of Scope*/
/* 21516*/    /*Scope*/ 43, /*->21560*/
/* 21517*/     OPC_CheckChild1TypeI64,
/* 21518*/     OPC_Scope, 21, /*->21541*/ // 2 children in Scope
/* 21520*/      OPC_RecordChild2, // #2 = $idx
/* 21521*/      OPC_MoveChild2,
/* 21522*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21525*/      OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21527*/      OPC_CheckTypeI32,
/* 21528*/      OPC_MoveParent,
/* 21529*/      OPC_CheckType, /*MVT::v2i64*/78, 
/* 21531*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21532*/      OPC_EmitConvertToTarget2,
/* 21533*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I64x2),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I64:{ *:[i64] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$x)
/* 21541*/     /*Scope*/ 17, /*->21559*/
/* 21542*/      OPC_MoveChild2,
/* 21543*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 21546*/      OPC_MoveParent,
/* 21547*/      OPC_CheckType, /*MVT::v2i64*/78, 
/* 21549*/      OPC_EmitInteger32, 0, 
/* 21551*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I64x2),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I64:{ *:[i64] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_I64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$vec, 0:{ *:[i32] }, ?:{ *:[i64] }:$x)
/* 21559*/     0, /*End of Scope*/
/* 21560*/    0, /*End of Scope*/
/* 21561*/   /*Scope*/ 26|128,2/*282*/, /*->21845*/
/* 21563*/    OPC_MoveChild1,
/* 21564*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 21567*/    OPC_RecordMemRef,
/* 21568*/    OPC_RecordNode, // #1 = 'ld' chained node
/* 21569*/    OPC_CheckFoldableChainNode,
/* 21570*/    OPC_RecordChild1, // #2 = $addr
/* 21571*/    OPC_Scope, 6|128,1/*134*/, /*->21708*/ // 2 children in Scope
/* 21574*/     OPC_CheckChild1TypeI32,
/* 21575*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 21577*/     OPC_CheckPredicate6,  // Predicate_load
/* 21578*/     OPC_SwitchType /*4 cases */, 29, /*MVT::i32*/7, // ->21610
/* 21581*/      OPC_MoveSibling2,
/* 21582*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21585*/      OPC_RecordNode, // #3 = $idx
/* 21586*/      OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21588*/      OPC_CheckTypeI32,
/* 21589*/      OPC_MoveParent,
/* 21590*/      OPC_CheckType, /*MVT::v4f32*/110, 
/* 21592*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21593*/      OPC_EmitMergeInputChains1_1,
/* 21594*/      OPC_EmitInteger32, 0, 
/* 21596*/      OPC_EmitInteger32, 0, 
/* 21598*/      OPC_EmitConvertToTarget3,
/* 21599*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v4f32*/110, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_32_A32:{ *:[v4f32] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4f32] }:$vec)
/* 21610*/     /*SwitchType*/ 29, /*MVT::f32*/12, // ->21641
/* 21612*/      OPC_MoveSibling2,
/* 21613*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21616*/      OPC_RecordNode, // #3 = $idx
/* 21617*/      OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21619*/      OPC_CheckTypeI32,
/* 21620*/      OPC_MoveParent,
/* 21621*/      OPC_CheckType, /*MVT::v4f32*/110, 
/* 21623*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21624*/      OPC_EmitMergeInputChains1_1,
/* 21625*/      OPC_EmitInteger32, 0, 
/* 21627*/      OPC_EmitInteger32, 0, 
/* 21629*/      OPC_EmitConvertToTarget3,
/* 21630*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v4f32*/110, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, (ld:{ *:[f32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_32_A32:{ *:[v4f32] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4f32] }:$vec)
/* 21641*/     /*SwitchType*/ 31, /*MVT::i64*/8, // ->21674
/* 21643*/      OPC_MoveSibling2,
/* 21644*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21647*/      OPC_RecordNode, // #3 = $idx
/* 21648*/      OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21650*/      OPC_CheckTypeI32,
/* 21651*/      OPC_MoveParent,
/* 21652*/      OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 21655*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21656*/      OPC_EmitMergeInputChains1_1,
/* 21657*/      OPC_EmitInteger32, 0, 
/* 21659*/      OPC_EmitInteger32, 0, 
/* 21661*/      OPC_EmitConvertToTarget3,
/* 21662*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v2f64*/0|128,1/*128*/, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_64_A32:{ *:[v2f64] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2f64] }:$vec)
/* 21674*/     /*SwitchType*/ 31, /*MVT::f64*/13, // ->21707
/* 21676*/      OPC_MoveSibling2,
/* 21677*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21680*/      OPC_RecordNode, // #3 = $idx
/* 21681*/      OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21683*/      OPC_CheckTypeI32,
/* 21684*/      OPC_MoveParent,
/* 21685*/      OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 21688*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21689*/      OPC_EmitMergeInputChains1_1,
/* 21690*/      OPC_EmitInteger32, 0, 
/* 21692*/      OPC_EmitInteger32, 0, 
/* 21694*/      OPC_EmitConvertToTarget3,
/* 21695*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v2f64*/0|128,1/*128*/, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, (ld:{ *:[f64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_64_A32:{ *:[v2f64] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2f64] }:$vec)
/* 21707*/     0, // EndSwitchType
/* 21708*/    /*Scope*/ 6|128,1/*134*/, /*->21844*/
/* 21710*/     OPC_CheckChild1TypeI64,
/* 21711*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 21713*/     OPC_CheckPredicate6,  // Predicate_load
/* 21714*/     OPC_SwitchType /*4 cases */, 29, /*MVT::i32*/7, // ->21746
/* 21717*/      OPC_MoveSibling2,
/* 21718*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21721*/      OPC_RecordNode, // #3 = $idx
/* 21722*/      OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21724*/      OPC_CheckTypeI32,
/* 21725*/      OPC_MoveParent,
/* 21726*/      OPC_CheckType, /*MVT::v4f32*/110, 
/* 21728*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21729*/      OPC_EmitMergeInputChains1_1,
/* 21730*/      OPC_EmitInteger32, 0, 
/* 21732*/      OPC_EmitInteger64, 0, 
/* 21734*/      OPC_EmitConvertToTarget3,
/* 21735*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v4f32*/110, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_32_A64:{ *:[v4f32] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4f32] }:$vec)
/* 21746*/     /*SwitchType*/ 29, /*MVT::f32*/12, // ->21777
/* 21748*/      OPC_MoveSibling2,
/* 21749*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21752*/      OPC_RecordNode, // #3 = $idx
/* 21753*/      OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21755*/      OPC_CheckTypeI32,
/* 21756*/      OPC_MoveParent,
/* 21757*/      OPC_CheckType, /*MVT::v4f32*/110, 
/* 21759*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21760*/      OPC_EmitMergeInputChains1_1,
/* 21761*/      OPC_EmitInteger32, 0, 
/* 21763*/      OPC_EmitInteger64, 0, 
/* 21765*/      OPC_EmitConvertToTarget3,
/* 21766*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v4f32*/110, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, (ld:{ *:[f32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_32_A64:{ *:[v4f32] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4f32] }:$vec)
/* 21777*/     /*SwitchType*/ 31, /*MVT::i64*/8, // ->21810
/* 21779*/      OPC_MoveSibling2,
/* 21780*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21783*/      OPC_RecordNode, // #3 = $idx
/* 21784*/      OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21786*/      OPC_CheckTypeI32,
/* 21787*/      OPC_MoveParent,
/* 21788*/      OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 21791*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21792*/      OPC_EmitMergeInputChains1_1,
/* 21793*/      OPC_EmitInteger32, 0, 
/* 21795*/      OPC_EmitInteger64, 0, 
/* 21797*/      OPC_EmitConvertToTarget3,
/* 21798*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v2f64*/0|128,1/*128*/, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, (ld:{ *:[i64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_64_A64:{ *:[v2f64] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2f64] }:$vec)
/* 21810*/     /*SwitchType*/ 31, /*MVT::f64*/13, // ->21843
/* 21812*/      OPC_MoveSibling2,
/* 21813*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21816*/      OPC_RecordNode, // #3 = $idx
/* 21817*/      OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21819*/      OPC_CheckTypeI32,
/* 21820*/      OPC_MoveParent,
/* 21821*/      OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 21824*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21825*/      OPC_EmitMergeInputChains1_1,
/* 21826*/      OPC_EmitInteger32, 0, 
/* 21828*/      OPC_EmitInteger64, 0, 
/* 21830*/      OPC_EmitConvertToTarget3,
/* 21831*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v2f64*/0|128,1/*128*/, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, (ld:{ *:[f64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_64_A64:{ *:[v2f64] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2f64] }:$vec)
/* 21843*/     0, // EndSwitchType
/* 21844*/    0, /*End of Scope*/
/* 21845*/   /*Scope*/ 97, /*->21943*/
/* 21846*/    OPC_RecordChild1, // #1 = $x
/* 21847*/    OPC_Scope, 44, /*->21893*/ // 2 children in Scope
/* 21849*/     OPC_CheckChild1Type, /*MVT::f32*/12, 
/* 21851*/     OPC_Scope, 21, /*->21874*/ // 2 children in Scope
/* 21853*/      OPC_RecordChild2, // #2 = $idx
/* 21854*/      OPC_MoveChild2,
/* 21855*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21858*/      OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21860*/      OPC_CheckTypeI32,
/* 21861*/      OPC_MoveParent,
/* 21862*/      OPC_CheckType, /*MVT::v4f32*/110, 
/* 21864*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21865*/      OPC_EmitConvertToTarget2,
/* 21866*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F32x4),
                    /*MVT::v4f32*/110, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, F32:{ *:[f32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, (imm:{ *:[i32] }):$idx, F32:{ *:[f32] }:$x)
/* 21874*/     /*Scope*/ 17, /*->21892*/
/* 21875*/      OPC_MoveChild2,
/* 21876*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 21879*/      OPC_MoveParent,
/* 21880*/      OPC_CheckType, /*MVT::v4f32*/110, 
/* 21882*/      OPC_EmitInteger32, 0, 
/* 21884*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F32x4),
                    /*MVT::v4f32*/110, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, F32:{ *:[f32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_F32x4:{ *:[v4f32] } ?:{ *:[v4f32] }:$vec, 0:{ *:[i32] }, ?:{ *:[f32] }:$x)
/* 21892*/     0, /*End of Scope*/
/* 21893*/    /*Scope*/ 48, /*->21942*/
/* 21894*/     OPC_CheckChild1Type, /*MVT::f64*/13, 
/* 21896*/     OPC_Scope, 23, /*->21921*/ // 2 children in Scope
/* 21898*/      OPC_RecordChild2, // #2 = $idx
/* 21899*/      OPC_MoveChild2,
/* 21900*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21903*/      OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21905*/      OPC_CheckTypeI32,
/* 21906*/      OPC_MoveParent,
/* 21907*/      OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 21910*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21911*/      OPC_EmitConvertToTarget2,
/* 21912*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, F64:{ *:[f64] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, (imm:{ *:[i32] }):$idx, F64:{ *:[f64] }:$x)
/* 21921*/     /*Scope*/ 19, /*->21941*/
/* 21922*/      OPC_MoveChild2,
/* 21923*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 21926*/      OPC_MoveParent,
/* 21927*/      OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 21930*/      OPC_EmitInteger32, 0, 
/* 21932*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, F64:{ *:[f64] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_F64x2:{ *:[v2f64] } ?:{ *:[v2f64] }:$vec, 0:{ *:[i32] }, ?:{ *:[f64] }:$x)
/* 21941*/     0, /*End of Scope*/
/* 21942*/    0, /*End of Scope*/
/* 21943*/   0, /*End of Scope*/
/* 21944*/  0, /*End of Scope*/
/* 21945*/ /*SwitchOpcode*/ 96|128,1/*224*/, TARGET_VAL(WebAssemblyISD::VEC_SHR_U),// ->22173
/* 21949*/  OPC_Scope, 87, /*->22038*/ // 2 children in Scope
/* 21951*/   OPC_MoveChild0,
/* 21952*/   OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 21955*/   OPC_MoveChild0,
/* 21956*/   OPC_SwitchOpcode /*2 cases */, 37, TARGET_VAL(ISD::ADD),// ->21997
/* 21960*/    OPC_RecordChild0, // #0 = $lhs
/* 21961*/    OPC_RecordChild1, // #1 = $rhs
/* 21962*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 21964*/    OPC_MoveSibling1,
/* 21965*/    OPC_CheckOpcode, TARGET_VAL(ISD::SPLAT_VECTOR),
/* 21968*/    OPC_CheckChild0Integer, 2, 
/* 21970*/    OPC_CheckChild0TypeI32,
/* 21971*/    OPC_MoveParent,
/* 21972*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 21974*/    OPC_MoveParent,
/* 21975*/    OPC_CheckChild1Integer, 2, 
/* 21977*/    OPC_SwitchType /*2 cases */, 7, /*MVT::v16i8*/39, // ->21987
/* 21980*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } (add:{ *:[v16i8] } (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)<<P:Predicate_add_nuw>>, (splat_vector:{ *:[v16i8] } 1:{ *:[i32] }))<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 21987*/    /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->21996
/* 21989*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } (add:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)<<P:Predicate_add_nuw>>, (splat_vector:{ *:[v8i16] } 1:{ *:[i32] }))<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 21996*/    0, // EndSwitchType
/* 21997*/   /*SwitchOpcode*/ 37, TARGET_VAL(ISD::SPLAT_VECTOR),// ->22037
/* 22000*/    OPC_CheckChild0Integer, 2, 
/* 22002*/    OPC_CheckChild0TypeI32,
/* 22003*/    OPC_MoveSibling1,
/* 22004*/    OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 22007*/    OPC_RecordChild0, // #0 = $lhs
/* 22008*/    OPC_RecordChild1, // #1 = $rhs
/* 22009*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 22011*/    OPC_MoveParent,
/* 22012*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 22014*/    OPC_MoveParent,
/* 22015*/    OPC_CheckChild1Integer, 2, 
/* 22017*/    OPC_SwitchType /*2 cases */, 7, /*MVT::v16i8*/39, // ->22027
/* 22020*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } (add:{ *:[v16i8] } (splat_vector:{ *:[v16i8] } 1:{ *:[i32] }), (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)<<P:Predicate_add_nuw>>)<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 22027*/    /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->22036
/* 22029*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } (add:{ *:[v8i16] } (splat_vector:{ *:[v8i16] } 1:{ *:[i32] }), (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)<<P:Predicate_add_nuw>>)<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 22036*/    0, // EndSwitchType
/* 22037*/   0, // EndSwitchOpcode
/* 22038*/  /*Scope*/ 4|128,1/*132*/, /*->22172*/
/* 22040*/   OPC_RecordChild0, // #0 = $lhs
/* 22041*/   OPC_Scope, 84, /*->22127*/ // 2 children in Scope
/* 22043*/    OPC_MoveChild1,
/* 22044*/    OPC_Scope, 24, /*->22070*/ // 5 children in Scope
/* 22046*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 22049*/     OPC_MoveChild0,
/* 22050*/     OPC_CheckAndImm, 63, 
/* 22052*/     OPC_RecordChild0, // #1 = $rhs
/* 22053*/     OPC_MoveParent,
/* 22054*/     OPC_MoveParent,
/* 22055*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 22057*/     OPC_EmitNode1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                   /*MVT::i32*/7, 1/*#Ops*/, 1,  // Results = #2
/* 22063*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 2, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 22070*/    /*Scope*/ 13, /*->22084*/
/* 22071*/     OPC_CheckAndImm, 7, 
/* 22073*/     OPC_RecordChild0, // #1 = $rhs
/* 22074*/     OPC_MoveParent,
/* 22075*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 22077*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22084*/    /*Scope*/ 13, /*->22098*/
/* 22085*/     OPC_CheckAndImm, 15, 
/* 22087*/     OPC_RecordChild0, // #1 = $rhs
/* 22088*/     OPC_MoveParent,
/* 22089*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 22091*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22098*/    /*Scope*/ 13, /*->22112*/
/* 22099*/     OPC_CheckAndImm, 31, 
/* 22101*/     OPC_RecordChild0, // #1 = $rhs
/* 22102*/     OPC_MoveParent,
/* 22103*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 22105*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22112*/    /*Scope*/ 13, /*->22126*/
/* 22113*/     OPC_CheckAndImm, 63, 
/* 22115*/     OPC_RecordChild0, // #1 = $rhs
/* 22116*/     OPC_MoveParent,
/* 22117*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 22119*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 63:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22126*/    0, /*End of Scope*/
/* 22127*/   /*Scope*/ 43, /*->22171*/
/* 22128*/    OPC_RecordChild1, // #1 = $x
/* 22129*/    OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->22140
/* 22132*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22133*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 22140*/    /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->22150
/* 22142*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22143*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 22150*/    /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->22160
/* 22152*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22153*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 22160*/    /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->22170
/* 22162*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22163*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 22170*/    0, // EndSwitchType
/* 22171*/   0, /*End of Scope*/
/* 22172*/  0, /*End of Scope*/
/* 22173*/ /*SwitchOpcode*/ 22|128,4/*534*/, TARGET_VAL(ISD::SPLAT_VECTOR),// ->22711
/* 22177*/  OPC_Scope, 73|128,1/*201*/, /*->22381*/ // 4 children in Scope
/* 22180*/   OPC_MoveChild0,
/* 22181*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 22184*/   OPC_RecordMemRef,
/* 22185*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 22186*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 22187*/   OPC_Scope, 95, /*->22284*/ // 2 children in Scope
/* 22189*/    OPC_CheckChild1TypeI32,
/* 22190*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 22192*/    OPC_Scope, 45, /*->22239*/ // 2 children in Scope
/* 22194*/     OPC_CheckPredicate, 10, // Predicate_extload
/* 22196*/     OPC_CheckTypeI32,
/* 22197*/     OPC_Scope, 19, /*->22218*/ // 2 children in Scope
/* 22199*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/* 22200*/      OPC_MoveParent,
/* 22201*/      OPC_CheckType, /*MVT::v16i8*/39, 
/* 22203*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22204*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22206*/      OPC_EmitMergeInputChains1_0,
/* 22207*/      OPC_EmitInteger32, 0, 
/* 22209*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v16i8*/39, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v16i8] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>) - Complexity = 16
                // Dst: (LOAD8_SPLAT_A32:{ *:[v16i8] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22218*/     /*Scope*/ 19, /*->22238*/
/* 22219*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/* 22220*/      OPC_MoveParent,
/* 22221*/      OPC_CheckType, /*MVT::v8i16*/50, 
/* 22223*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22224*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22226*/      OPC_EmitMergeInputChains1_0,
/* 22227*/      OPC_EmitInteger32, 0, 
/* 22229*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v8i16] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>) - Complexity = 16
                // Dst: (LOAD16_SPLAT_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22238*/     0, /*End of Scope*/
/* 22239*/    /*Scope*/ 43, /*->22283*/
/* 22240*/     OPC_CheckPredicate6,  // Predicate_load
/* 22241*/     OPC_SwitchType /*2 cases */, 18, /*MVT::i32*/7, // ->22262
/* 22244*/      OPC_MoveParent,
/* 22245*/      OPC_CheckType, /*MVT::v4i32*/60, 
/* 22247*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22248*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22250*/      OPC_EmitMergeInputChains1_0,
/* 22251*/      OPC_EmitInteger32, 0, 
/* 22253*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD32_SPLAT_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22262*/     /*SwitchType*/ 18, /*MVT::i64*/8, // ->22282
/* 22264*/      OPC_MoveParent,
/* 22265*/      OPC_CheckType, /*MVT::v2i64*/78, 
/* 22267*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22268*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22270*/      OPC_EmitMergeInputChains1_0,
/* 22271*/      OPC_EmitInteger32, 0, 
/* 22273*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD64_SPLAT_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22282*/     0, // EndSwitchType
/* 22283*/    0, /*End of Scope*/
/* 22284*/   /*Scope*/ 95, /*->22380*/
/* 22285*/    OPC_CheckChild1TypeI64,
/* 22286*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 22288*/    OPC_Scope, 45, /*->22335*/ // 2 children in Scope
/* 22290*/     OPC_CheckPredicate, 10, // Predicate_extload
/* 22292*/     OPC_CheckTypeI32,
/* 22293*/     OPC_Scope, 19, /*->22314*/ // 2 children in Scope
/* 22295*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/* 22296*/      OPC_MoveParent,
/* 22297*/      OPC_CheckType, /*MVT::v16i8*/39, 
/* 22299*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22300*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22302*/      OPC_EmitMergeInputChains1_0,
/* 22303*/      OPC_EmitInteger32, 0, 
/* 22305*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v16i8*/39, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v16i8] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>) - Complexity = 16
                // Dst: (LOAD8_SPLAT_A64:{ *:[v16i8] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22314*/     /*Scope*/ 19, /*->22334*/
/* 22315*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/* 22316*/      OPC_MoveParent,
/* 22317*/      OPC_CheckType, /*MVT::v8i16*/50, 
/* 22319*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22320*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22322*/      OPC_EmitMergeInputChains1_0,
/* 22323*/      OPC_EmitInteger32, 0, 
/* 22325*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v8i16] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>) - Complexity = 16
                // Dst: (LOAD16_SPLAT_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22334*/     0, /*End of Scope*/
/* 22335*/    /*Scope*/ 43, /*->22379*/
/* 22336*/     OPC_CheckPredicate6,  // Predicate_load
/* 22337*/     OPC_SwitchType /*2 cases */, 18, /*MVT::i32*/7, // ->22358
/* 22340*/      OPC_MoveParent,
/* 22341*/      OPC_CheckType, /*MVT::v4i32*/60, 
/* 22343*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22344*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22346*/      OPC_EmitMergeInputChains1_0,
/* 22347*/      OPC_EmitInteger32, 0, 
/* 22349*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD32_SPLAT_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22358*/     /*SwitchType*/ 18, /*MVT::i64*/8, // ->22378
/* 22360*/      OPC_MoveParent,
/* 22361*/      OPC_CheckType, /*MVT::v2i64*/78, 
/* 22363*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22364*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22366*/      OPC_EmitMergeInputChains1_0,
/* 22367*/      OPC_EmitInteger32, 0, 
/* 22369*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD64_SPLAT_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22378*/     0, // EndSwitchType
/* 22379*/    0, /*End of Scope*/
/* 22380*/   0, /*End of Scope*/
/* 22381*/  /*Scope*/ 20|128,1/*148*/, /*->22531*/
/* 22383*/   OPC_RecordChild0, // #0 = $x
/* 22384*/   OPC_Scope, 102, /*->22488*/ // 3 children in Scope
/* 22386*/    OPC_MoveChild0,
/* 22387*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22390*/    OPC_SwitchType /*2 cases */, 80, /*MVT::i32*/7, // ->22473
/* 22393*/     OPC_MoveParent,
/* 22394*/     OPC_SwitchType /*3 cases */, 37, /*MVT::v16i8*/39, // ->22434
/* 22397*/      OPC_EmitConvertToTarget0,
/* 22398*/      OPC_EmitConvertToTarget0,
/* 22399*/      OPC_EmitConvertToTarget0,
/* 22400*/      OPC_EmitConvertToTarget0,
/* 22401*/      OPC_EmitConvertToTarget0,
/* 22402*/      OPC_EmitConvertToTarget0,
/* 22403*/      OPC_EmitConvertToTarget0,
/* 22404*/      OPC_EmitConvertToTarget0,
/* 22405*/      OPC_EmitConvertToTarget0,
/* 22406*/      OPC_EmitConvertToTarget0,
/* 22407*/      OPC_EmitConvertToTarget0,
/* 22408*/      OPC_EmitConvertToTarget0,
/* 22409*/      OPC_EmitConvertToTarget0,
/* 22410*/      OPC_EmitConvertToTarget0,
/* 22411*/      OPC_EmitConvertToTarget0,
/* 22412*/      OPC_EmitConvertToTarget0,
/* 22413*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I8x16),
                    /*MVT::v16i8*/39, 16/*#Ops*/, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 
                // Src: (splat_vector:{ *:[v16i8] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I8x16:{ *:[v16i8] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 22434*/     /*SwitchType*/ 21, /*MVT::v8i16*/50, // ->22457
/* 22436*/      OPC_EmitConvertToTarget0,
/* 22437*/      OPC_EmitConvertToTarget0,
/* 22438*/      OPC_EmitConvertToTarget0,
/* 22439*/      OPC_EmitConvertToTarget0,
/* 22440*/      OPC_EmitConvertToTarget0,
/* 22441*/      OPC_EmitConvertToTarget0,
/* 22442*/      OPC_EmitConvertToTarget0,
/* 22443*/      OPC_EmitConvertToTarget0,
/* 22444*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I16x8),
                    /*MVT::v8i16*/50, 8/*#Ops*/, 1, 2, 3, 4, 5, 6, 7, 8, 
                // Src: (splat_vector:{ *:[v8i16] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I16x8:{ *:[v8i16] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 22457*/     /*SwitchType*/ 13, /*MVT::v4i32*/60, // ->22472
/* 22459*/      OPC_EmitConvertToTarget0,
/* 22460*/      OPC_EmitConvertToTarget0,
/* 22461*/      OPC_EmitConvertToTarget0,
/* 22462*/      OPC_EmitConvertToTarget0,
/* 22463*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I32x4),
                    /*MVT::v4i32*/60, 4/*#Ops*/, 1, 2, 3, 4, 
                // Src: (splat_vector:{ *:[v4i32] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I32x4:{ *:[v4i32] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 22472*/     0, // EndSwitchType
/* 22473*/    /*SwitchType*/ 12, /*MVT::i64*/8, // ->22487
/* 22475*/     OPC_MoveParent,
/* 22476*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 22478*/     OPC_EmitConvertToTarget0,
/* 22479*/     OPC_EmitConvertToTarget0,
/* 22480*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 1, 2, 
               // Src: (splat_vector:{ *:[v2i64] } (imm:{ *:[i64] }):$x) - Complexity = 6
               // Dst: (CONST_V128_I64x2:{ *:[v2i64] } (imm:{ *:[i64] }):$x, (imm:{ *:[i64] }):$x)
/* 22487*/    0, // EndSwitchType
/* 22488*/   /*Scope*/ 30, /*->22519*/
/* 22489*/    OPC_CheckChild0TypeI32,
/* 22490*/    OPC_SwitchType /*3 cases */, 7, /*MVT::v16i8*/39, // ->22500
/* 22493*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22494*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I8x16),
                   /*MVT::v16i8*/39, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v16i8] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I8x16:{ *:[v16i8] } I32:{ *:[i32] }:$x)
/* 22500*/    /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->22509
/* 22502*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22503*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I16x8),
                   /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v8i16] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I16x8:{ *:[v8i16] } I32:{ *:[i32] }:$x)
/* 22509*/    /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->22518
/* 22511*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22512*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I32x4),
                   /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v4i32] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I32x4:{ *:[v4i32] } I32:{ *:[i32] }:$x)
/* 22518*/    0, // EndSwitchType
/* 22519*/   /*Scope*/ 10, /*->22530*/
/* 22520*/    OPC_CheckChild0TypeI64,
/* 22521*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 22523*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22524*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I64x2),
                  /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v2i64] } I64:{ *:[i64] }:$x) - Complexity = 3
              // Dst: (SPLAT_I64x2:{ *:[v2i64] } I64:{ *:[i64] }:$x)
/* 22530*/   0, /*End of Scope*/
/* 22531*/  /*Scope*/ 107, /*->22639*/
/* 22532*/   OPC_MoveChild0,
/* 22533*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 22536*/   OPC_RecordMemRef,
/* 22537*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 22538*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 22539*/   OPC_Scope, 48, /*->22589*/ // 2 children in Scope
/* 22541*/    OPC_CheckChild1TypeI32,
/* 22542*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 22544*/    OPC_CheckPredicate6,  // Predicate_load
/* 22545*/    OPC_SwitchType /*2 cases */, 18, /*MVT::f32*/12, // ->22566
/* 22548*/     OPC_MoveParent,
/* 22549*/     OPC_CheckType, /*MVT::v4f32*/110, 
/* 22551*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22552*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22554*/     OPC_EmitMergeInputChains1_0,
/* 22555*/     OPC_EmitInteger32, 0, 
/* 22557*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4f32*/110, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v4f32] } (ld:{ *:[f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD32_SPLAT_A32:{ *:[v4f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22566*/    /*SwitchType*/ 20, /*MVT::f64*/13, // ->22588
/* 22568*/     OPC_MoveParent,
/* 22569*/     OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 22572*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22573*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22575*/     OPC_EmitMergeInputChains1_0,
/* 22576*/     OPC_EmitInteger32, 0, 
/* 22578*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2f64*/0|128,1/*128*/, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v2f64] } (ld:{ *:[f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD64_SPLAT_A32:{ *:[v2f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22588*/    0, // EndSwitchType
/* 22589*/   /*Scope*/ 48, /*->22638*/
/* 22590*/    OPC_CheckChild1TypeI64,
/* 22591*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 22593*/    OPC_CheckPredicate6,  // Predicate_load
/* 22594*/    OPC_SwitchType /*2 cases */, 18, /*MVT::f32*/12, // ->22615
/* 22597*/     OPC_MoveParent,
/* 22598*/     OPC_CheckType, /*MVT::v4f32*/110, 
/* 22600*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22601*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22603*/     OPC_EmitMergeInputChains1_0,
/* 22604*/     OPC_EmitInteger32, 0, 
/* 22606*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4f32*/110, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v4f32] } (ld:{ *:[f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD32_SPLAT_A64:{ *:[v4f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22615*/    /*SwitchType*/ 20, /*MVT::f64*/13, // ->22637
/* 22617*/     OPC_MoveParent,
/* 22618*/     OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 22621*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22622*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22624*/     OPC_EmitMergeInputChains1_0,
/* 22625*/     OPC_EmitInteger32, 0, 
/* 22627*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2f64*/0|128,1/*128*/, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v2f64] } (ld:{ *:[f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD64_SPLAT_A64:{ *:[v2f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22637*/    0, // EndSwitchType
/* 22638*/   0, /*End of Scope*/
/* 22639*/  /*Scope*/ 70, /*->22710*/
/* 22640*/   OPC_RecordChild0, // #0 = $x
/* 22641*/   OPC_Scope, 40, /*->22683*/ // 3 children in Scope
/* 22643*/    OPC_MoveChild0,
/* 22644*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 22647*/    OPC_SwitchType /*2 cases */, 16, /*MVT::f32*/12, // ->22666
/* 22650*/     OPC_MoveParent,
/* 22651*/     OPC_CheckType, /*MVT::v4f32*/110, 
/* 22653*/     OPC_EmitConvertToTarget0,
/* 22654*/     OPC_EmitConvertToTarget0,
/* 22655*/     OPC_EmitConvertToTarget0,
/* 22656*/     OPC_EmitConvertToTarget0,
/* 22657*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F32x4),
                   /*MVT::v4f32*/110, 4/*#Ops*/, 1, 2, 3, 4, 
               // Src: (splat_vector:{ *:[v4f32] } (fpimm:{ *:[f32] }):$x) - Complexity = 6
               // Dst: (CONST_V128_F32x4:{ *:[v4f32] } (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x)
/* 22666*/    /*SwitchType*/ 14, /*MVT::f64*/13, // ->22682
/* 22668*/     OPC_MoveParent,
/* 22669*/     OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 22672*/     OPC_EmitConvertToTarget0,
/* 22673*/     OPC_EmitConvertToTarget0,
/* 22674*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F64x2),
                   /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 1, 2, 
               // Src: (splat_vector:{ *:[v2f64] } (fpimm:{ *:[f64] }):$x) - Complexity = 6
               // Dst: (CONST_V128_F64x2:{ *:[v2f64] } (fpimm:{ *:[f64] }):$x, (fpimm:{ *:[f64] }):$x)
/* 22682*/    0, // EndSwitchType
/* 22683*/   /*Scope*/ 11, /*->22695*/
/* 22684*/    OPC_CheckChild0Type, /*MVT::f32*/12, 
/* 22686*/    OPC_CheckType, /*MVT::v4f32*/110, 
/* 22688*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22689*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F32x4),
                  /*MVT::v4f32*/110, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v4f32] } F32:{ *:[f32] }:$x) - Complexity = 3
              // Dst: (SPLAT_F32x4:{ *:[v4f32] } F32:{ *:[f32] }:$x)
/* 22695*/   /*Scope*/ 13, /*->22709*/
/* 22696*/    OPC_CheckChild0Type, /*MVT::f64*/13, 
/* 22698*/    OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 22701*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22702*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F64x2),
                  /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v2f64] } F64:{ *:[f64] }:$x) - Complexity = 3
              // Dst: (SPLAT_F64x2:{ *:[v2f64] } F64:{ *:[f64] }:$x)
/* 22709*/   0, /*End of Scope*/
/* 22710*/  0, /*End of Scope*/
/* 22711*/ /*SwitchOpcode*/ 26|128,2/*282*/, TARGET_VAL(ISD::SCALAR_TO_VECTOR),// ->22997
/* 22715*/  OPC_Scope, 103, /*->22820*/ // 4 children in Scope
/* 22717*/   OPC_MoveChild0,
/* 22718*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 22721*/   OPC_RecordMemRef,
/* 22722*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 22723*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 22724*/   OPC_Scope, 46, /*->22772*/ // 2 children in Scope
/* 22726*/    OPC_CheckChild1TypeI32,
/* 22727*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 22729*/    OPC_CheckPredicate6,  // Predicate_load
/* 22730*/    OPC_SwitchType /*2 cases */, 18, /*MVT::i32*/7, // ->22751
/* 22733*/     OPC_MoveParent,
/* 22734*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 22736*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22737*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22739*/     OPC_EmitMergeInputChains1_0,
/* 22740*/     OPC_EmitInteger32, 0, 
/* 22742*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_32_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22751*/    /*SwitchType*/ 18, /*MVT::i64*/8, // ->22771
/* 22753*/     OPC_MoveParent,
/* 22754*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 22756*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22757*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22759*/     OPC_EmitMergeInputChains1_0,
/* 22760*/     OPC_EmitInteger32, 0, 
/* 22762*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_64_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22771*/    0, // EndSwitchType
/* 22772*/   /*Scope*/ 46, /*->22819*/
/* 22773*/    OPC_CheckChild1TypeI64,
/* 22774*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 22776*/    OPC_CheckPredicate6,  // Predicate_load
/* 22777*/    OPC_SwitchType /*2 cases */, 18, /*MVT::i32*/7, // ->22798
/* 22780*/     OPC_MoveParent,
/* 22781*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 22783*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22784*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22786*/     OPC_EmitMergeInputChains1_0,
/* 22787*/     OPC_EmitInteger32, 0, 
/* 22789*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_32_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22798*/    /*SwitchType*/ 18, /*MVT::i64*/8, // ->22818
/* 22800*/     OPC_MoveParent,
/* 22801*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 22803*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22804*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22806*/     OPC_EmitMergeInputChains1_0,
/* 22807*/     OPC_EmitInteger32, 0, 
/* 22809*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_64_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22818*/    0, // EndSwitchType
/* 22819*/   0, /*End of Scope*/
/* 22820*/  /*Scope*/ 41, /*->22862*/
/* 22821*/   OPC_RecordChild0, // #0 = $x
/* 22822*/   OPC_Scope, 27, /*->22851*/ // 2 children in Scope
/* 22824*/    OPC_CheckChild0TypeI32,
/* 22825*/    OPC_SwitchType /*3 cases */, 6, /*MVT::v16i8*/39, // ->22834
/* 22828*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I8x16),
                   /*MVT::v16i8*/39, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v16i8] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I8x16:{ *:[v16i8] } ?:{ *:[i32] }:$x)
/* 22834*/    /*SwitchType*/ 6, /*MVT::v8i16*/50, // ->22842
/* 22836*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I16x8),
                   /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v8i16] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I16x8:{ *:[v8i16] } ?:{ *:[i32] }:$x)
/* 22842*/    /*SwitchType*/ 6, /*MVT::v4i32*/60, // ->22850
/* 22844*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I32x4),
                   /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v4i32] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I32x4:{ *:[v4i32] } ?:{ *:[i32] }:$x)
/* 22850*/    0, // EndSwitchType
/* 22851*/   /*Scope*/ 9, /*->22861*/
/* 22852*/    OPC_CheckChild0TypeI64,
/* 22853*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 22855*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I64x2),
                  /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v2i64] } I64:{ *:[i64] }:$x) - Complexity = 3
              // Dst: (SPLAT_I64x2:{ *:[v2i64] } ?:{ *:[i64] }:$x)
/* 22861*/   0, /*End of Scope*/
/* 22862*/  /*Scope*/ 107, /*->22970*/
/* 22863*/   OPC_MoveChild0,
/* 22864*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 22867*/   OPC_RecordMemRef,
/* 22868*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 22869*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 22870*/   OPC_Scope, 48, /*->22920*/ // 2 children in Scope
/* 22872*/    OPC_CheckChild1TypeI32,
/* 22873*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 22875*/    OPC_CheckPredicate6,  // Predicate_load
/* 22876*/    OPC_SwitchType /*2 cases */, 18, /*MVT::f32*/12, // ->22897
/* 22879*/     OPC_MoveParent,
/* 22880*/     OPC_CheckType, /*MVT::v4f32*/110, 
/* 22882*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22883*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22885*/     OPC_EmitMergeInputChains1_0,
/* 22886*/     OPC_EmitInteger32, 0, 
/* 22888*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4f32*/110, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v4f32] } (ld:{ *:[f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_32_A32:{ *:[v4f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22897*/    /*SwitchType*/ 20, /*MVT::f64*/13, // ->22919
/* 22899*/     OPC_MoveParent,
/* 22900*/     OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 22903*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22904*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22906*/     OPC_EmitMergeInputChains1_0,
/* 22907*/     OPC_EmitInteger32, 0, 
/* 22909*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2f64*/0|128,1/*128*/, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v2f64] } (ld:{ *:[f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_64_A32:{ *:[v2f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22919*/    0, // EndSwitchType
/* 22920*/   /*Scope*/ 48, /*->22969*/
/* 22921*/    OPC_CheckChild1TypeI64,
/* 22922*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 22924*/    OPC_CheckPredicate6,  // Predicate_load
/* 22925*/    OPC_SwitchType /*2 cases */, 18, /*MVT::f32*/12, // ->22946
/* 22928*/     OPC_MoveParent,
/* 22929*/     OPC_CheckType, /*MVT::v4f32*/110, 
/* 22931*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22932*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22934*/     OPC_EmitMergeInputChains1_0,
/* 22935*/     OPC_EmitInteger32, 0, 
/* 22937*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4f32*/110, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v4f32] } (ld:{ *:[f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_32_A64:{ *:[v4f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22946*/    /*SwitchType*/ 20, /*MVT::f64*/13, // ->22968
/* 22948*/     OPC_MoveParent,
/* 22949*/     OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 22952*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22953*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22955*/     OPC_EmitMergeInputChains1_0,
/* 22956*/     OPC_EmitInteger32, 0, 
/* 22958*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2f64*/0|128,1/*128*/, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v2f64] } (ld:{ *:[f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_64_A64:{ *:[v2f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22968*/    0, // EndSwitchType
/* 22969*/   0, /*End of Scope*/
/* 22970*/  /*Scope*/ 25, /*->22996*/
/* 22971*/   OPC_RecordChild0, // #0 = $x
/* 22972*/   OPC_SwitchType /*2 cases */, 8, /*MVT::v4f32*/110, // ->22983
/* 22975*/    OPC_CheckChild0Type, /*MVT::f32*/12, 
/* 22977*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F32x4),
                  /*MVT::v4f32*/110, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v4f32] } F32:{ *:[f32] }:$x) - Complexity = 3
              // Dst: (SPLAT_F32x4:{ *:[v4f32] } ?:{ *:[f32] }:$x)
/* 22983*/   /*SwitchType*/ 9, /*MVT::v2f64*/0|128,1/*128*/, // ->22995
/* 22986*/    OPC_CheckChild0Type, /*MVT::f64*/13, 
/* 22988*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F64x2),
                  /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v2f64] } F64:{ *:[f64] }:$x) - Complexity = 3
              // Dst: (SPLAT_F64x2:{ *:[v2f64] } ?:{ *:[f64] }:$x)
/* 22995*/   0, // EndSwitchType
/* 22996*/  0, /*End of Scope*/
/* 22997*/ /*SwitchOpcode*/ 4|128,1/*132*/, TARGET_VAL(WebAssemblyISD::VEC_SHL),// ->23133
/* 23001*/  OPC_RecordChild0, // #0 = $lhs
/* 23002*/  OPC_Scope, 84, /*->23088*/ // 2 children in Scope
/* 23004*/   OPC_MoveChild1,
/* 23005*/   OPC_Scope, 24, /*->23031*/ // 5 children in Scope
/* 23007*/    OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 23010*/    OPC_MoveChild0,
/* 23011*/    OPC_CheckAndImm, 63, 
/* 23013*/    OPC_RecordChild0, // #1 = $rhs
/* 23014*/    OPC_MoveParent,
/* 23015*/    OPC_MoveParent,
/* 23016*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 23018*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                  /*MVT::i32*/7, 1/*#Ops*/, 1,  // Results = #2
/* 23024*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 2, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 23031*/   /*Scope*/ 13, /*->23045*/
/* 23032*/    OPC_CheckAndImm, 7, 
/* 23034*/    OPC_RecordChild0, // #1 = $rhs
/* 23035*/    OPC_MoveParent,
/* 23036*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 23038*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23045*/   /*Scope*/ 13, /*->23059*/
/* 23046*/    OPC_CheckAndImm, 15, 
/* 23048*/    OPC_RecordChild0, // #1 = $rhs
/* 23049*/    OPC_MoveParent,
/* 23050*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 23052*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23059*/   /*Scope*/ 13, /*->23073*/
/* 23060*/    OPC_CheckAndImm, 31, 
/* 23062*/    OPC_RecordChild0, // #1 = $rhs
/* 23063*/    OPC_MoveParent,
/* 23064*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 23066*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32x4),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23073*/   /*Scope*/ 13, /*->23087*/
/* 23074*/    OPC_CheckAndImm, 63, 
/* 23076*/    OPC_RecordChild0, // #1 = $rhs
/* 23077*/    OPC_MoveParent,
/* 23078*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 23080*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 63:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23087*/   0, /*End of Scope*/
/* 23088*/  /*Scope*/ 43, /*->23132*/
/* 23089*/   OPC_RecordChild1, // #1 = $x
/* 23090*/   OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->23101
/* 23093*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23094*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 23101*/   /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->23111
/* 23103*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23104*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 23111*/   /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->23121
/* 23113*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23114*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32x4),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 23121*/   /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->23131
/* 23123*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23124*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 23131*/   0, // EndSwitchType
/* 23132*/  0, /*End of Scope*/
/* 23133*/ /*SwitchOpcode*/ 4|128,1/*132*/, TARGET_VAL(WebAssemblyISD::VEC_SHR_S),// ->23269
/* 23137*/  OPC_RecordChild0, // #0 = $lhs
/* 23138*/  OPC_Scope, 84, /*->23224*/ // 2 children in Scope
/* 23140*/   OPC_MoveChild1,
/* 23141*/   OPC_Scope, 24, /*->23167*/ // 5 children in Scope
/* 23143*/    OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 23146*/    OPC_MoveChild0,
/* 23147*/    OPC_CheckAndImm, 63, 
/* 23149*/    OPC_RecordChild0, // #1 = $rhs
/* 23150*/    OPC_MoveParent,
/* 23151*/    OPC_MoveParent,
/* 23152*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 23154*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                  /*MVT::i32*/7, 1/*#Ops*/, 1,  // Results = #2
/* 23160*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 2, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 23167*/   /*Scope*/ 13, /*->23181*/
/* 23168*/    OPC_CheckAndImm, 7, 
/* 23170*/    OPC_RecordChild0, // #1 = $rhs
/* 23171*/    OPC_MoveParent,
/* 23172*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 23174*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23181*/   /*Scope*/ 13, /*->23195*/
/* 23182*/    OPC_CheckAndImm, 15, 
/* 23184*/    OPC_RecordChild0, // #1 = $rhs
/* 23185*/    OPC_MoveParent,
/* 23186*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 23188*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23195*/   /*Scope*/ 13, /*->23209*/
/* 23196*/    OPC_CheckAndImm, 31, 
/* 23198*/    OPC_RecordChild0, // #1 = $rhs
/* 23199*/    OPC_MoveParent,
/* 23200*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 23202*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32x4),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23209*/   /*Scope*/ 13, /*->23223*/
/* 23210*/    OPC_CheckAndImm, 63, 
/* 23212*/    OPC_RecordChild0, // #1 = $rhs
/* 23213*/    OPC_MoveParent,
/* 23214*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 23216*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 63:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23223*/   0, /*End of Scope*/
/* 23224*/  /*Scope*/ 43, /*->23268*/
/* 23225*/   OPC_RecordChild1, // #1 = $x
/* 23226*/   OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->23237
/* 23229*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23230*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 23237*/   /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->23247
/* 23239*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23240*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 23247*/   /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->23257
/* 23249*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23250*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32x4),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 23257*/   /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->23267
/* 23259*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23260*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 23267*/   0, // EndSwitchType
/* 23268*/  0, /*End of Scope*/
/* 23269*/ /*SwitchOpcode*/ 66|128,8/*1090*/, TARGET_VAL(ISD::VSELECT),// ->24363
/* 23273*/  OPC_Scope, 13|128,1/*141*/, /*->23417*/ // 4 children in Scope
/* 23276*/   OPC_MoveChild0,
/* 23277*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 23280*/   OPC_MoveChild0,
/* 23281*/   OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 23284*/   OPC_RecordChild0, // #0 = $rhs
/* 23285*/   OPC_SwitchType /*3 cases */, 41, /*MVT::v4f32*/110, // ->23329
/* 23288*/    OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 23290*/    OPC_MoveSibling1,
/* 23291*/    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 23294*/    OPC_RecordChild0, // #1 = $lhs
/* 23295*/    OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 23297*/    OPC_MoveParent,
/* 23298*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 23300*/    OPC_MoveParent,
/* 23301*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 23303*/    OPC_Scope, 11, /*->23316*/ // 2 children in Scope
/* 23305*/     OPC_CheckChild1Same, 0,
/* 23307*/     OPC_CheckChild2Same, 1,
/* 23309*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v4i32] } (setcc:{ *:[v4i32] } (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$rhs), (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$lhs), SETOLT:{ *:[Other] }), V128:{ *:[v4i32] }:$rhs, V128:{ *:[v4i32] }:$lhs) - Complexity = 12
               // Dst: (PMIN_F32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 23316*/    /*Scope*/ 11, /*->23328*/
/* 23317*/     OPC_CheckChild1Same, 1,
/* 23319*/     OPC_CheckChild2Same, 0,
/* 23321*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v4i32] } (setcc:{ *:[v4i32] } (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$lhs), (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$rhs), SETOLT:{ *:[Other] }), V128:{ *:[v4i32] }:$rhs, V128:{ *:[v4i32] }:$lhs) - Complexity = 12
               // Dst: (PMAX_F32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 23328*/    0, /*End of Scope*/
/* 23329*/   /*SwitchType*/ 41, /*MVT::v2f64*/0|128,1/*128*/, // ->23373
/* 23332*/    OPC_CheckChild0Type, /*MVT::v2i64*/78, 
/* 23334*/    OPC_MoveSibling1,
/* 23335*/    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 23338*/    OPC_RecordChild0, // #1 = $lhs
/* 23339*/    OPC_CheckChild0Type, /*MVT::v2i64*/78, 
/* 23341*/    OPC_MoveParent,
/* 23342*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 23344*/    OPC_MoveParent,
/* 23345*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 23347*/    OPC_Scope, 11, /*->23360*/ // 2 children in Scope
/* 23349*/     OPC_CheckChild1Same, 0,
/* 23351*/     OPC_CheckChild2Same, 1,
/* 23353*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v2i64] } (setcc:{ *:[v2i64] } (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$rhs), (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$lhs), SETOLT:{ *:[Other] }), V128:{ *:[v2i64] }:$rhs, V128:{ *:[v2i64] }:$lhs) - Complexity = 12
               // Dst: (PMIN_F64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 23360*/    /*Scope*/ 11, /*->23372*/
/* 23361*/     OPC_CheckChild1Same, 1,
/* 23363*/     OPC_CheckChild2Same, 0,
/* 23365*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v2i64] } (setcc:{ *:[v2i64] } (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$lhs), (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$rhs), SETOLT:{ *:[Other] }), V128:{ *:[v2i64] }:$rhs, V128:{ *:[v2i64] }:$lhs) - Complexity = 12
               // Dst: (PMAX_F64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 23372*/    0, /*End of Scope*/
/* 23373*/   /*SwitchType*/ 41, /*MVT::v8f16*/92, // ->23416
/* 23375*/    OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 23377*/    OPC_MoveSibling1,
/* 23378*/    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 23381*/    OPC_RecordChild0, // #1 = $lhs
/* 23382*/    OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 23384*/    OPC_MoveParent,
/* 23385*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 23387*/    OPC_MoveParent,
/* 23388*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 23390*/    OPC_Scope, 11, /*->23403*/ // 2 children in Scope
/* 23392*/     OPC_CheckChild1Same, 0,
/* 23394*/     OPC_CheckChild2Same, 1,
/* 23396*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v8i16] } (setcc:{ *:[v8i16] } (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$rhs), (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$lhs), SETOLT:{ *:[Other] }), V128:{ *:[v8i16] }:$rhs, V128:{ *:[v8i16] }:$lhs) - Complexity = 12
               // Dst: (PMIN_F16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 23403*/    /*Scope*/ 11, /*->23415*/
/* 23404*/     OPC_CheckChild1Same, 1,
/* 23406*/     OPC_CheckChild2Same, 0,
/* 23408*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v8i16] } (setcc:{ *:[v8i16] } (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$lhs), (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$rhs), SETOLT:{ *:[Other] }), V128:{ *:[v8i16] }:$rhs, V128:{ *:[v8i16] }:$lhs) - Complexity = 12
               // Dst: (PMAX_F16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 23415*/    0, /*End of Scope*/
/* 23416*/   0, // EndSwitchType
/* 23417*/  /*Scope*/ 45, /*->23463*/
/* 23418*/   OPC_RecordChild0, // #0 = $c
/* 23419*/   OPC_RecordChild1, // #1 = $v1
/* 23420*/   OPC_RecordChild2, // #2 = $v2
/* 23421*/   OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->23432
/* 23424*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v16i8*/39, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 23432*/   /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->23442
/* 23434*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 23442*/   /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->23452
/* 23444*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 23452*/   /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->23462
/* 23454*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 23462*/   0, // EndSwitchType
/* 23463*/  /*Scope*/ 101|128,6/*869*/, /*->24334*/
/* 23465*/   OPC_MoveChild0,
/* 23466*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 23469*/   OPC_RecordChild0, // #0 = $rhs
/* 23470*/   OPC_Scope, 21|128,2/*277*/, /*->23750*/ // 3 children in Scope
/* 23473*/    OPC_CheckChild0Type, /*MVT::v4f32*/110, 
/* 23475*/    OPC_RecordChild1, // #1 = $lhs
/* 23476*/    OPC_Scope, 33, /*->23511*/ // 8 children in Scope
/* 23478*/     OPC_CheckChild2CondCode, ISD::SETOLT,
/* 23480*/     OPC_MoveParent,
/* 23481*/     OPC_CheckType, /*MVT::v4f32*/110, 
/* 23483*/     OPC_Scope, 12, /*->23497*/ // 2 children in Scope
/* 23485*/      OPC_CheckChild1Same, 0,
/* 23487*/      OPC_CheckChild2Same, 1,
/* 23489*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23490*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/110, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOLT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23497*/     /*Scope*/ 12, /*->23510*/
/* 23498*/      OPC_CheckChild1Same, 1,
/* 23500*/      OPC_CheckChild2Same, 0,
/* 23502*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23503*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23510*/     0, /*End of Scope*/
/* 23511*/    /*Scope*/ 33, /*->23545*/
/* 23512*/     OPC_CheckChild2CondCode, ISD::SETOLE,
/* 23514*/     OPC_MoveParent,
/* 23515*/     OPC_CheckType, /*MVT::v4f32*/110, 
/* 23517*/     OPC_Scope, 12, /*->23531*/ // 2 children in Scope
/* 23519*/      OPC_CheckChild1Same, 0,
/* 23521*/      OPC_CheckChild2Same, 1,
/* 23523*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23524*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/110, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOLE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23531*/     /*Scope*/ 12, /*->23544*/
/* 23532*/      OPC_CheckChild1Same, 1,
/* 23534*/      OPC_CheckChild2Same, 0,
/* 23536*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23537*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23544*/     0, /*End of Scope*/
/* 23545*/    /*Scope*/ 33, /*->23579*/
/* 23546*/     OPC_CheckChild2CondCode, ISD::SETOGT,
/* 23548*/     OPC_MoveParent,
/* 23549*/     OPC_CheckType, /*MVT::v4f32*/110, 
/* 23551*/     OPC_Scope, 12, /*->23565*/ // 2 children in Scope
/* 23553*/      OPC_CheckChild1Same, 1,
/* 23555*/      OPC_CheckChild2Same, 0,
/* 23557*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23558*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23565*/     /*Scope*/ 12, /*->23578*/
/* 23566*/      OPC_CheckChild1Same, 0,
/* 23568*/      OPC_CheckChild2Same, 1,
/* 23570*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23571*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/110, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOGT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23578*/     0, /*End of Scope*/
/* 23579*/    /*Scope*/ 33, /*->23613*/
/* 23580*/     OPC_CheckChild2CondCode, ISD::SETOGE,
/* 23582*/     OPC_MoveParent,
/* 23583*/     OPC_CheckType, /*MVT::v4f32*/110, 
/* 23585*/     OPC_Scope, 12, /*->23599*/ // 2 children in Scope
/* 23587*/      OPC_CheckChild1Same, 1,
/* 23589*/      OPC_CheckChild2Same, 0,
/* 23591*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23592*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23599*/     /*Scope*/ 12, /*->23612*/
/* 23600*/      OPC_CheckChild1Same, 0,
/* 23602*/      OPC_CheckChild2Same, 1,
/* 23604*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23605*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/110, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOGE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23612*/     0, /*End of Scope*/
/* 23613*/    /*Scope*/ 33, /*->23647*/
/* 23614*/     OPC_CheckChild2CondCode, ISD::SETLT,
/* 23616*/     OPC_MoveParent,
/* 23617*/     OPC_CheckType, /*MVT::v4f32*/110, 
/* 23619*/     OPC_Scope, 12, /*->23633*/ // 2 children in Scope
/* 23621*/      OPC_CheckChild1Same, 0,
/* 23623*/      OPC_CheckChild2Same, 1,
/* 23625*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23626*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLT:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23633*/     /*Scope*/ 12, /*->23646*/
/* 23634*/      OPC_CheckChild1Same, 1,
/* 23636*/      OPC_CheckChild2Same, 0,
/* 23638*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23639*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23646*/     0, /*End of Scope*/
/* 23647*/    /*Scope*/ 33, /*->23681*/
/* 23648*/     OPC_CheckChild2CondCode, ISD::SETLE,
/* 23650*/     OPC_MoveParent,
/* 23651*/     OPC_CheckType, /*MVT::v4f32*/110, 
/* 23653*/     OPC_Scope, 12, /*->23667*/ // 2 children in Scope
/* 23655*/      OPC_CheckChild1Same, 0,
/* 23657*/      OPC_CheckChild2Same, 1,
/* 23659*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23660*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLE:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23667*/     /*Scope*/ 12, /*->23680*/
/* 23668*/      OPC_CheckChild1Same, 1,
/* 23670*/      OPC_CheckChild2Same, 0,
/* 23672*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23673*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23680*/     0, /*End of Scope*/
/* 23681*/    /*Scope*/ 33, /*->23715*/
/* 23682*/     OPC_CheckChild2CondCode, ISD::SETGT,
/* 23684*/     OPC_MoveParent,
/* 23685*/     OPC_CheckType, /*MVT::v4f32*/110, 
/* 23687*/     OPC_Scope, 12, /*->23701*/ // 2 children in Scope
/* 23689*/      OPC_CheckChild1Same, 1,
/* 23691*/      OPC_CheckChild2Same, 0,
/* 23693*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23694*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23701*/     /*Scope*/ 12, /*->23714*/
/* 23702*/      OPC_CheckChild1Same, 0,
/* 23704*/      OPC_CheckChild2Same, 1,
/* 23706*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23707*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGT:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23714*/     0, /*End of Scope*/
/* 23715*/    /*Scope*/ 33, /*->23749*/
/* 23716*/     OPC_CheckChild2CondCode, ISD::SETGE,
/* 23718*/     OPC_MoveParent,
/* 23719*/     OPC_CheckType, /*MVT::v4f32*/110, 
/* 23721*/     OPC_Scope, 12, /*->23735*/ // 2 children in Scope
/* 23723*/      OPC_CheckChild1Same, 1,
/* 23725*/      OPC_CheckChild2Same, 0,
/* 23727*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23728*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23735*/     /*Scope*/ 12, /*->23748*/
/* 23736*/      OPC_CheckChild1Same, 0,
/* 23738*/      OPC_CheckChild2Same, 1,
/* 23740*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23741*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGE:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23748*/     0, /*End of Scope*/
/* 23749*/    0, /*End of Scope*/
/* 23750*/   /*Scope*/ 46|128,2/*302*/, /*->24054*/
/* 23752*/    OPC_CheckChild0Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 23755*/    OPC_RecordChild1, // #1 = $lhs
/* 23756*/    OPC_Scope, 36, /*->23794*/ // 8 children in Scope
/* 23758*/     OPC_CheckChild2CondCode, ISD::SETOLT,
/* 23760*/     OPC_MoveParent,
/* 23761*/     OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 23764*/     OPC_Scope, 13, /*->23779*/ // 2 children in Scope
/* 23766*/      OPC_CheckChild1Same, 0,
/* 23768*/      OPC_CheckChild2Same, 1,
/* 23770*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23771*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOLT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23779*/     /*Scope*/ 13, /*->23793*/
/* 23780*/      OPC_CheckChild1Same, 1,
/* 23782*/      OPC_CheckChild2Same, 0,
/* 23784*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23785*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23793*/     0, /*End of Scope*/
/* 23794*/    /*Scope*/ 36, /*->23831*/
/* 23795*/     OPC_CheckChild2CondCode, ISD::SETOLE,
/* 23797*/     OPC_MoveParent,
/* 23798*/     OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 23801*/     OPC_Scope, 13, /*->23816*/ // 2 children in Scope
/* 23803*/      OPC_CheckChild1Same, 0,
/* 23805*/      OPC_CheckChild2Same, 1,
/* 23807*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23808*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOLE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23816*/     /*Scope*/ 13, /*->23830*/
/* 23817*/      OPC_CheckChild1Same, 1,
/* 23819*/      OPC_CheckChild2Same, 0,
/* 23821*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23822*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23830*/     0, /*End of Scope*/
/* 23831*/    /*Scope*/ 36, /*->23868*/
/* 23832*/     OPC_CheckChild2CondCode, ISD::SETOGT,
/* 23834*/     OPC_MoveParent,
/* 23835*/     OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 23838*/     OPC_Scope, 13, /*->23853*/ // 2 children in Scope
/* 23840*/      OPC_CheckChild1Same, 1,
/* 23842*/      OPC_CheckChild2Same, 0,
/* 23844*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23845*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23853*/     /*Scope*/ 13, /*->23867*/
/* 23854*/      OPC_CheckChild1Same, 0,
/* 23856*/      OPC_CheckChild2Same, 1,
/* 23858*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23859*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOGT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23867*/     0, /*End of Scope*/
/* 23868*/    /*Scope*/ 36, /*->23905*/
/* 23869*/     OPC_CheckChild2CondCode, ISD::SETOGE,
/* 23871*/     OPC_MoveParent,
/* 23872*/     OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 23875*/     OPC_Scope, 13, /*->23890*/ // 2 children in Scope
/* 23877*/      OPC_CheckChild1Same, 1,
/* 23879*/      OPC_CheckChild2Same, 0,
/* 23881*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23882*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23890*/     /*Scope*/ 13, /*->23904*/
/* 23891*/      OPC_CheckChild1Same, 0,
/* 23893*/      OPC_CheckChild2Same, 1,
/* 23895*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23896*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOGE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23904*/     0, /*End of Scope*/
/* 23905*/    /*Scope*/ 36, /*->23942*/
/* 23906*/     OPC_CheckChild2CondCode, ISD::SETLT,
/* 23908*/     OPC_MoveParent,
/* 23909*/     OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 23912*/     OPC_Scope, 13, /*->23927*/ // 2 children in Scope
/* 23914*/      OPC_CheckChild1Same, 0,
/* 23916*/      OPC_CheckChild2Same, 1,
/* 23918*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23919*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLT:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23927*/     /*Scope*/ 13, /*->23941*/
/* 23928*/      OPC_CheckChild1Same, 1,
/* 23930*/      OPC_CheckChild2Same, 0,
/* 23932*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23933*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23941*/     0, /*End of Scope*/
/* 23942*/    /*Scope*/ 36, /*->23979*/
/* 23943*/     OPC_CheckChild2CondCode, ISD::SETLE,
/* 23945*/     OPC_MoveParent,
/* 23946*/     OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 23949*/     OPC_Scope, 13, /*->23964*/ // 2 children in Scope
/* 23951*/      OPC_CheckChild1Same, 0,
/* 23953*/      OPC_CheckChild2Same, 1,
/* 23955*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23956*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLE:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23964*/     /*Scope*/ 13, /*->23978*/
/* 23965*/      OPC_CheckChild1Same, 1,
/* 23967*/      OPC_CheckChild2Same, 0,
/* 23969*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23970*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23978*/     0, /*End of Scope*/
/* 23979*/    /*Scope*/ 36, /*->24016*/
/* 23980*/     OPC_CheckChild2CondCode, ISD::SETGT,
/* 23982*/     OPC_MoveParent,
/* 23983*/     OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 23986*/     OPC_Scope, 13, /*->24001*/ // 2 children in Scope
/* 23988*/      OPC_CheckChild1Same, 1,
/* 23990*/      OPC_CheckChild2Same, 0,
/* 23992*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23993*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24001*/     /*Scope*/ 13, /*->24015*/
/* 24002*/      OPC_CheckChild1Same, 0,
/* 24004*/      OPC_CheckChild2Same, 1,
/* 24006*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24007*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGT:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24015*/     0, /*End of Scope*/
/* 24016*/    /*Scope*/ 36, /*->24053*/
/* 24017*/     OPC_CheckChild2CondCode, ISD::SETGE,
/* 24019*/     OPC_MoveParent,
/* 24020*/     OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 24023*/     OPC_Scope, 13, /*->24038*/ // 2 children in Scope
/* 24025*/      OPC_CheckChild1Same, 1,
/* 24027*/      OPC_CheckChild2Same, 0,
/* 24029*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24030*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24038*/     /*Scope*/ 13, /*->24052*/
/* 24039*/      OPC_CheckChild1Same, 0,
/* 24041*/      OPC_CheckChild2Same, 1,
/* 24043*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24044*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGE:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24052*/     0, /*End of Scope*/
/* 24053*/    0, /*End of Scope*/
/* 24054*/   /*Scope*/ 21|128,2/*277*/, /*->24333*/
/* 24056*/    OPC_CheckChild0Type, /*MVT::v8f16*/92, 
/* 24058*/    OPC_RecordChild1, // #1 = $lhs
/* 24059*/    OPC_Scope, 33, /*->24094*/ // 8 children in Scope
/* 24061*/     OPC_CheckChild2CondCode, ISD::SETOLT,
/* 24063*/     OPC_MoveParent,
/* 24064*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24066*/     OPC_Scope, 12, /*->24080*/ // 2 children in Scope
/* 24068*/      OPC_CheckChild1Same, 0,
/* 24070*/      OPC_CheckChild2Same, 1,
/* 24072*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24073*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs, SETOLT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24080*/     /*Scope*/ 12, /*->24093*/
/* 24081*/      OPC_CheckChild1Same, 1,
/* 24083*/      OPC_CheckChild2Same, 0,
/* 24085*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24086*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOLT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24093*/     0, /*End of Scope*/
/* 24094*/    /*Scope*/ 33, /*->24128*/
/* 24095*/     OPC_CheckChild2CondCode, ISD::SETOLE,
/* 24097*/     OPC_MoveParent,
/* 24098*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24100*/     OPC_Scope, 12, /*->24114*/ // 2 children in Scope
/* 24102*/      OPC_CheckChild1Same, 0,
/* 24104*/      OPC_CheckChild2Same, 1,
/* 24106*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24107*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs, SETOLE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24114*/     /*Scope*/ 12, /*->24127*/
/* 24115*/      OPC_CheckChild1Same, 1,
/* 24117*/      OPC_CheckChild2Same, 0,
/* 24119*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24120*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOLE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24127*/     0, /*End of Scope*/
/* 24128*/    /*Scope*/ 33, /*->24162*/
/* 24129*/     OPC_CheckChild2CondCode, ISD::SETOGT,
/* 24131*/     OPC_MoveParent,
/* 24132*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24134*/     OPC_Scope, 12, /*->24148*/ // 2 children in Scope
/* 24136*/      OPC_CheckChild1Same, 1,
/* 24138*/      OPC_CheckChild2Same, 0,
/* 24140*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24141*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOGT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24148*/     /*Scope*/ 12, /*->24161*/
/* 24149*/      OPC_CheckChild1Same, 0,
/* 24151*/      OPC_CheckChild2Same, 1,
/* 24153*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24154*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs, SETOGT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24161*/     0, /*End of Scope*/
/* 24162*/    /*Scope*/ 33, /*->24196*/
/* 24163*/     OPC_CheckChild2CondCode, ISD::SETOGE,
/* 24165*/     OPC_MoveParent,
/* 24166*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24168*/     OPC_Scope, 12, /*->24182*/ // 2 children in Scope
/* 24170*/      OPC_CheckChild1Same, 1,
/* 24172*/      OPC_CheckChild2Same, 0,
/* 24174*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24175*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOGE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24182*/     /*Scope*/ 12, /*->24195*/
/* 24183*/      OPC_CheckChild1Same, 0,
/* 24185*/      OPC_CheckChild2Same, 1,
/* 24187*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24188*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs, SETOGE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24195*/     0, /*End of Scope*/
/* 24196*/    /*Scope*/ 33, /*->24230*/
/* 24197*/     OPC_CheckChild2CondCode, ISD::SETLT,
/* 24199*/     OPC_MoveParent,
/* 24200*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24202*/     OPC_Scope, 12, /*->24216*/ // 2 children in Scope
/* 24204*/      OPC_CheckChild1Same, 0,
/* 24206*/      OPC_CheckChild2Same, 1,
/* 24208*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24209*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETLT:{ *:[Other] }), V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24216*/     /*Scope*/ 12, /*->24229*/
/* 24217*/      OPC_CheckChild1Same, 1,
/* 24219*/      OPC_CheckChild2Same, 0,
/* 24221*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24222*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETLT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24229*/     0, /*End of Scope*/
/* 24230*/    /*Scope*/ 33, /*->24264*/
/* 24231*/     OPC_CheckChild2CondCode, ISD::SETLE,
/* 24233*/     OPC_MoveParent,
/* 24234*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24236*/     OPC_Scope, 12, /*->24250*/ // 2 children in Scope
/* 24238*/      OPC_CheckChild1Same, 0,
/* 24240*/      OPC_CheckChild2Same, 1,
/* 24242*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24243*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETLE:{ *:[Other] }), V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24250*/     /*Scope*/ 12, /*->24263*/
/* 24251*/      OPC_CheckChild1Same, 1,
/* 24253*/      OPC_CheckChild2Same, 0,
/* 24255*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24256*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETLE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24263*/     0, /*End of Scope*/
/* 24264*/    /*Scope*/ 33, /*->24298*/
/* 24265*/     OPC_CheckChild2CondCode, ISD::SETGT,
/* 24267*/     OPC_MoveParent,
/* 24268*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24270*/     OPC_Scope, 12, /*->24284*/ // 2 children in Scope
/* 24272*/      OPC_CheckChild1Same, 1,
/* 24274*/      OPC_CheckChild2Same, 0,
/* 24276*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24277*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETGT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24284*/     /*Scope*/ 12, /*->24297*/
/* 24285*/      OPC_CheckChild1Same, 0,
/* 24287*/      OPC_CheckChild2Same, 1,
/* 24289*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24290*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETGT:{ *:[Other] }), V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24297*/     0, /*End of Scope*/
/* 24298*/    /*Scope*/ 33, /*->24332*/
/* 24299*/     OPC_CheckChild2CondCode, ISD::SETGE,
/* 24301*/     OPC_MoveParent,
/* 24302*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24304*/     OPC_Scope, 12, /*->24318*/ // 2 children in Scope
/* 24306*/      OPC_CheckChild1Same, 1,
/* 24308*/      OPC_CheckChild2Same, 0,
/* 24310*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24311*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETGE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24318*/     /*Scope*/ 12, /*->24331*/
/* 24319*/      OPC_CheckChild1Same, 0,
/* 24321*/      OPC_CheckChild2Same, 1,
/* 24323*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24324*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETGE:{ *:[Other] }), V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24331*/     0, /*End of Scope*/
/* 24332*/    0, /*End of Scope*/
/* 24333*/   0, /*End of Scope*/
/* 24334*/  /*Scope*/ 27, /*->24362*/
/* 24335*/   OPC_RecordChild0, // #0 = $c
/* 24336*/   OPC_RecordChild1, // #1 = $v1
/* 24337*/   OPC_RecordChild2, // #2 = $v2
/* 24338*/   OPC_SwitchType /*2 cases */, 8, /*MVT::v4f32*/110, // ->24349
/* 24341*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4f32*/110, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v4f32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4f32] }:$v1, V128:{ *:[v4f32] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v4f32] } ?:{ *:[v4f32] }:$v1, ?:{ *:[v4f32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 24349*/   /*SwitchType*/ 9, /*MVT::v2f64*/0|128,1/*128*/, // ->24361
/* 24352*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2f64*/0|128,1/*128*/, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v2f64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2f64] }:$v1, V128:{ *:[v2f64] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v2f64] } ?:{ *:[v2f64] }:$v1, ?:{ *:[v2f64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 24361*/   0, // EndSwitchType
/* 24362*/  0, /*End of Scope*/
/* 24363*/ /*SwitchOpcode*/ 16, TARGET_VAL(WebAssemblyISD::SWIZZLE),// ->24382
/* 24366*/  OPC_RecordChild0, // #0 = $src
/* 24367*/  OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 24369*/  OPC_RecordChild1, // #1 = $mask
/* 24370*/  OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 24372*/  OPC_CheckType, /*MVT::v16i8*/39, 
/* 24374*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24375*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SWIZZLE),
                /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
            // Src: (wasm_swizzle:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 3
            // Dst: (SWIZZLE:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask)
/* 24382*/ /*SwitchOpcode*/ 39, TARGET_VAL(ISD::ABS),// ->24424
/* 24385*/  OPC_RecordChild0, // #0 = $v
/* 24386*/  OPC_SwitchType /*4 cases */, 7, /*MVT::v16i8*/39, // ->24396
/* 24389*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24390*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I8x16),
                 /*MVT::v16i8*/39, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v16i8] } V128:{ *:[v16i8] }:$v) - Complexity = 3
             // Dst: (ABS_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 24396*/  /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->24405
/* 24398*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24399*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I16x8),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v8i16] } V128:{ *:[v8i16] }:$v) - Complexity = 3
             // Dst: (ABS_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$v)
/* 24405*/  /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->24414
/* 24407*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24408*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v4i32] } V128:{ *:[v4i32] }:$v) - Complexity = 3
             // Dst: (ABS_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$v)
/* 24414*/  /*SwitchType*/ 7, /*MVT::v2i64*/78, // ->24423
/* 24416*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24417*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I64x2),
                 /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v2i64] } V128:{ *:[v2i64] }:$v) - Complexity = 3
             // Dst: (ABS_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$v)
/* 24423*/  0, // EndSwitchType
/* 24424*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::SADDSAT),// ->24451
/* 24427*/  OPC_RecordChild0, // #0 = $lhs
/* 24428*/  OPC_RecordChild1, // #1 = $rhs
/* 24429*/  OPC_SwitchType /*2 cases */, 8, /*MVT::v16i8*/39, // ->24440
/* 24432*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24433*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_S_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 24440*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->24450
/* 24442*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24443*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_S_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 24450*/  0, // EndSwitchType
/* 24451*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::UADDSAT),// ->24478
/* 24454*/  OPC_RecordChild0, // #0 = $lhs
/* 24455*/  OPC_RecordChild1, // #1 = $rhs
/* 24456*/  OPC_SwitchType /*2 cases */, 8, /*MVT::v16i8*/39, // ->24467
/* 24459*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24460*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_U_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 24467*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->24477
/* 24469*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24470*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_U_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 24477*/  0, // EndSwitchType
/* 24478*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::SMIN),// ->24515
/* 24481*/  OPC_RecordChild0, // #0 = $lhs
/* 24482*/  OPC_RecordChild1, // #1 = $rhs
/* 24483*/  OPC_SwitchType /*3 cases */, 8, /*MVT::v16i8*/39, // ->24494
/* 24486*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24487*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_S_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 24494*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->24504
/* 24496*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24497*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_S_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 24504*/  /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->24514
/* 24506*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24507*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_S_I32x4),
                 /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 24514*/  0, // EndSwitchType
/* 24515*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::UMIN),// ->24552
/* 24518*/  OPC_RecordChild0, // #0 = $lhs
/* 24519*/  OPC_RecordChild1, // #1 = $rhs
/* 24520*/  OPC_SwitchType /*3 cases */, 8, /*MVT::v16i8*/39, // ->24531
/* 24523*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24524*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_U_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 24531*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->24541
/* 24533*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24534*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_U_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 24541*/  /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->24551
/* 24543*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24544*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_U_I32x4),
                 /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 24551*/  0, // EndSwitchType
/* 24552*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::SMAX),// ->24589
/* 24555*/  OPC_RecordChild0, // #0 = $lhs
/* 24556*/  OPC_RecordChild1, // #1 = $rhs
/* 24557*/  OPC_SwitchType /*3 cases */, 8, /*MVT::v16i8*/39, // ->24568
/* 24560*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24561*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_S_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 24568*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->24578
/* 24570*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24571*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_S_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 24578*/  /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->24588
/* 24580*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24581*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_S_I32x4),
                 /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 24588*/  0, // EndSwitchType
/* 24589*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::UMAX),// ->24626
/* 24592*/  OPC_RecordChild0, // #0 = $lhs
/* 24593*/  OPC_RecordChild1, // #1 = $rhs
/* 24594*/  OPC_SwitchType /*3 cases */, 8, /*MVT::v16i8*/39, // ->24605
/* 24597*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24598*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_U_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 24605*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->24615
/* 24607*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24608*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_U_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 24615*/  /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->24625
/* 24617*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24618*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_U_I32x4),
                 /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 24625*/  0, // EndSwitchType
/* 24626*/ /*SwitchOpcode*/ 13, TARGET_VAL(WebAssemblyISD::TRUNC_SAT_ZERO_S),// ->24642
/* 24629*/  OPC_RecordChild0, // #0 = $vec
/* 24630*/  OPC_CheckChild0Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 24633*/  OPC_CheckType, /*MVT::v4i32*/60, 
/* 24635*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24636*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::trunc_sat_zero_s_I32x4),
                /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
            // Src: (trunc_sat_zero_s:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (trunc_sat_zero_s_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 24642*/ /*SwitchOpcode*/ 13, TARGET_VAL(WebAssemblyISD::TRUNC_SAT_ZERO_U),// ->24658
/* 24645*/  OPC_RecordChild0, // #0 = $vec
/* 24646*/  OPC_CheckChild0Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 24649*/  OPC_CheckType, /*MVT::v4i32*/60, 
/* 24651*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24652*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::trunc_sat_zero_u_I32x4),
                /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
            // Src: (trunc_sat_zero_u:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (trunc_sat_zero_u_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 24658*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),// ->24697
/* 24661*/  OPC_RecordChild0, // #0 = $vec
/* 24662*/  OPC_SwitchType /*3 cases */, 9, /*MVT::v8i16*/50, // ->24674
/* 24665*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 24667*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24668*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_s_I16x8),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 24674*/  /*SwitchType*/ 9, /*MVT::v4i32*/60, // ->24685
/* 24676*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 24678*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24679*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_s_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 24685*/  /*SwitchType*/ 9, /*MVT::v2i64*/78, // ->24696
/* 24687*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 24689*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24690*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_s_I64x2),
                 /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 24696*/  0, // EndSwitchType
/* 24697*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),// ->24736
/* 24700*/  OPC_RecordChild0, // #0 = $vec
/* 24701*/  OPC_SwitchType /*3 cases */, 9, /*MVT::v8i16*/50, // ->24713
/* 24704*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 24706*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24707*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_s_I16x8),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 24713*/  /*SwitchType*/ 9, /*MVT::v4i32*/60, // ->24724
/* 24715*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 24717*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24718*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_s_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 24724*/  /*SwitchType*/ 9, /*MVT::v2i64*/78, // ->24735
/* 24726*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 24728*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24729*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_s_I64x2),
                 /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 24735*/  0, // EndSwitchType
/* 24736*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),// ->24775
/* 24739*/  OPC_RecordChild0, // #0 = $vec
/* 24740*/  OPC_SwitchType /*3 cases */, 9, /*MVT::v8i16*/50, // ->24752
/* 24743*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 24745*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24746*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_u_I16x8),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 24752*/  /*SwitchType*/ 9, /*MVT::v4i32*/60, // ->24763
/* 24754*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 24756*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24757*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_u_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 24763*/  /*SwitchType*/ 9, /*MVT::v2i64*/78, // ->24774
/* 24765*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 24767*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24768*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_u_I64x2),
                 /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 24774*/  0, // EndSwitchType
/* 24775*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),// ->24814
/* 24778*/  OPC_RecordChild0, // #0 = $vec
/* 24779*/  OPC_SwitchType /*3 cases */, 9, /*MVT::v8i16*/50, // ->24791
/* 24782*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 24784*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24785*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_u_I16x8),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 24791*/  /*SwitchType*/ 9, /*MVT::v4i32*/60, // ->24802
/* 24793*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 24795*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24796*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_u_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 24802*/  /*SwitchType*/ 9, /*MVT::v2i64*/78, // ->24813
/* 24804*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 24806*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24807*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_u_I64x2),
                 /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 24813*/  0, // EndSwitchType
/* 24814*/ /*SwitchOpcode*/ 31, TARGET_VAL(WebAssemblyISD::NARROW_U),// ->24848
/* 24817*/  OPC_RecordChild0, // #0 = $left
/* 24818*/  OPC_SwitchType /*2 cases */, 12, /*MVT::v16i8*/39, // ->24833
/* 24821*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 24823*/   OPC_RecordChild1, // #1 = $right
/* 24824*/   OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 24826*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (wasm_narrow_u:{ *:[v16i8] } V128:{ *:[v8i16] }:$left, V128:{ *:[v8i16] }:$right) - Complexity = 3
             // Dst: (NARROW_U_I8x16:{ *:[v16i8] } ?:{ *:[v8i16] }:$left, ?:{ *:[v8i16] }:$right)
/* 24833*/  /*SwitchType*/ 12, /*MVT::v8i16*/50, // ->24847
/* 24835*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 24837*/   OPC_RecordChild1, // #1 = $right
/* 24838*/   OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 24840*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (wasm_narrow_u:{ *:[v8i16] } V128:{ *:[v4i32] }:$left, V128:{ *:[v4i32] }:$right) - Complexity = 3
             // Dst: (NARROW_U_I16x8:{ *:[v8i16] } ?:{ *:[v4i32] }:$left, ?:{ *:[v4i32] }:$right)
/* 24847*/  0, // EndSwitchType
/* 24848*/ /*SwitchOpcode*/ 14, TARGET_VAL(WebAssemblyISD::CONVERT_LOW_S),// ->24865
/* 24851*/  OPC_RecordChild0, // #0 = $vec
/* 24852*/  OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 24854*/  OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 24857*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24858*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::convert_low_s_F64x2),
                /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 0, 
            // Src: (convert_low_s:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
            // Dst: (convert_low_s_F64x2:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec)
/* 24865*/ /*SwitchOpcode*/ 14, TARGET_VAL(WebAssemblyISD::CONVERT_LOW_U),// ->24882
/* 24868*/  OPC_RecordChild0, // #0 = $vec
/* 24869*/  OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 24871*/  OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 24874*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24875*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::convert_low_u_F64x2),
                /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 0, 
            // Src: (convert_low_u:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
            // Dst: (convert_low_u_F64x2:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec)
/* 24882*/ /*SwitchOpcode*/ 13, TARGET_VAL(WebAssemblyISD::DEMOTE_ZERO),// ->24898
/* 24885*/  OPC_RecordChild0, // #0 = $vec
/* 24886*/  OPC_CheckChild0Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 24889*/  OPC_CheckType, /*MVT::v4f32*/110, 
/* 24891*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24892*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::demote_zero_F32x4),
                /*MVT::v4f32*/110, 1/*#Ops*/, 0, 
            // Src: (demote_zero:{ *:[v4f32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (demote_zero_F32x4:{ *:[v4f32] } V128:{ *:[v2f64] }:$vec)
/* 24898*/ /*SwitchOpcode*/ 14, TARGET_VAL(WebAssemblyISD::PROMOTE_LOW),// ->24915
/* 24901*/  OPC_RecordChild0, // #0 = $vec
/* 24902*/  OPC_CheckChild0Type, /*MVT::v4f32*/110, 
/* 24904*/  OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 24907*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24908*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::promote_low_F64x2),
                /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 0, 
            // Src: (promote_low:{ *:[v2f64] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
            // Dst: (promote_low_F64x2:{ *:[v2f64] } V128:{ *:[v4f32] }:$vec)
/* 24915*/ 0, // EndSwitchOpcode
    0
  }; // Total Array size is 24917 bytes

  // Opcode Histogram:
  // #OPC_Scope                                = 360
  // #OPC_RecordNode                           = 299
  // #OPC_RecordChild                          = 748
  // #OPC_RecordMemRef                         = 43
  // #OPC_CaptureGlueInput                     = 1
  // #OPC_MoveChild                            = 297
  // #OPC_MoveSibling                          = 297
  // #OPC_MoveParent                           = 611
  // #OPC_CheckSame                            = 0
  // #OPC_CheckChildSame                       = 195
  // #OPC_CheckPatternPredicate                = 762
  // #OPC_CheckPredicate                       = 557
  // #OPC_CheckOpcode                          = 518
  // #OPC_SwitchOpcode                         = 15
  // #OPC_CheckType                            = 566
  // #OPC_SwitchType                           = 184
  // #OPC_CheckChildType                       = 464
  // #OPC_CheckInteger                         = 0
  // #OPC_CheckChildInteger                    = 108
  // #OPC_CheckCondCode                        = 0
  // #OPC_CheckChild2CondCode                  = 165
  // #OPC_CheckValueType                       = 17
  // #OPC_CheckComplexPat                      = 330
  // #OPC_CheckAndImm                          = 27
  // #OPC_CheckOrImm                           = 0
  // #OPC_CheckImmAllOnesV                     = 44
  // #OPC_CheckImmAllZerosV                    = 1
  // #OPC_CheckFoldableChainNode               = 6
  // #OPC_EmitInteger                          = 381
  // #OPC_EmitStringInteger                    = 0
  // #OPC_EmitRegister                         = 0
  // #OPC_EmitConvertToTarget                  = 324
  // #OPC_EmitMergeInputChains                 = 452
  // #OPC_EmitCopyToReg                        = 0
  // #OPC_EmitNode                             = 9
  // #OPC_EmitNodeXForm                        = 0
  // #OPC_CompleteMatch                        = 44
  // #OPC_MorphNodeTo                          = 1262

  #undef TARGET_VAL
  SelectCodeCommon(N, MatcherTable, sizeof(MatcherTable));
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckPatternPredicate(unsigned PredNo) const override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckPatternPredicate(unsigned PredNo) const
#if DAGISEL_INLINE
  override
#endif
{
  switch (PredNo) {
  default: llvm_unreachable("Invalid predicate in table?");
  case 0: return (Subtarget->hasSIMD128());
  case 1: return (!Subtarget->hasAddr64());
  case 2: return (Subtarget->hasAddr64());
  case 3: return (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics());
  case 4: return (Subtarget->hasAddr64()) && (Subtarget->hasAtomics());
  case 5: return (Subtarget->hasFP16()) && (Subtarget->hasSIMD128());
  case 6: return (Subtarget->hasReferenceTypes());
  case 7: return (Subtarget->hasRelaxedSIMD());
  case 8: return (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes());
  case 9: return (Subtarget->hasNontrappingFPToInt());
  case 10: return (!Subtarget->hasNontrappingFPToInt());
  case 11: return (Subtarget->hasSignExt());
  case 12: return (Subtarget->hasBulkMemory());
  case 13: return (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128());
  case 14: return (!Subtarget->hasAddr64()) && (TM.isPositionIndependent());
  case 15: return (Subtarget->hasAddr64()) && (TM.isPositionIndependent());
  case 16: return (Subtarget->hasExceptionHandling());
  case 17: return (Subtarget->hasFP16());
  case 18: return (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent());
  case 19: return (Subtarget->hasAddr64()) && (!TM.isPositionIndependent());
  }
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckNodePredicate(SDNode *Node, unsigned PredNo) const override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckNodePredicate(SDNode *Node, unsigned PredNo) const
#if DAGISEL_INLINE
  override
#endif
{
  switch (PredNo) {
  default: llvm_unreachable("Invalid predicate in table?");
  case 0: {
    // Predicate_LaneIdx32
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 32;
  }
  case 1: {
    // Predicate_atomic_cmp_swap_i8
    // Predicate_atomic_load_8
    // Predicate_atomic_load_add_i8
    // Predicate_atomic_load_and_i8
    // Predicate_atomic_load_or_i8
    // Predicate_atomic_load_sub_i8
    // Predicate_atomic_load_xor_i8
    // Predicate_atomic_store_8
    // Predicate_atomic_swap_i8
    // Predicate_extloadi8
    // Predicate_sextloadi8
    // Predicate_zextloadi8
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i8) return false;
return true;

  }
  case 2: {
    // Predicate_atomic_cmp_swap_i16
    // Predicate_atomic_load_16
    // Predicate_atomic_load_add_i16
    // Predicate_atomic_load_and_i16
    // Predicate_atomic_load_or_i16
    // Predicate_atomic_load_sub_i16
    // Predicate_atomic_load_xor_i16
    // Predicate_atomic_store_16
    // Predicate_atomic_swap_i16
    // Predicate_extloadi16
    // Predicate_sextloadi16
    // Predicate_zextloadi16
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i16) return false;
return true;

  }
  case 3: {
    // Predicate_atomic_cmp_swap_i32
    // Predicate_atomic_load_32
    // Predicate_atomic_load_add_i32
    // Predicate_atomic_load_and_i32
    // Predicate_atomic_load_or_i32
    // Predicate_atomic_load_sub_i32
    // Predicate_atomic_load_xor_i32
    // Predicate_atomic_store_32
    // Predicate_atomic_swap_i32
    // Predicate_extloadi32
    // Predicate_sextloadi32
    // Predicate_zextloadi32
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i32) return false;
return true;

  }
  case 4: {
    // Predicate_unindexedstore
    SDNode *N = Node;
    (void)N;
if (cast<StoreSDNode>(N)->getAddressingMode() != ISD::UNINDEXED) return false;
return true;

  }
  case 5: {
    // Predicate_store
    SDNode *N = Node;
    (void)N;
 if (cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 6: {
    // Predicate_load
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::NON_EXTLOAD) return false;
return true;

  }
  case 7: {
    // Predicate_atomic_cmp_swap_i64
    // Predicate_atomic_load_64
    // Predicate_atomic_load_add_i64
    // Predicate_atomic_load_and_i64
    // Predicate_atomic_load_or_i64
    // Predicate_atomic_load_sub_i64
    // Predicate_atomic_load_xor_i64
    // Predicate_atomic_store_64
    // Predicate_atomic_swap_i64
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i64) return false;
return true;

  }
  case 8: {
    // Predicate_unindexedload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getAddressingMode() != ISD::UNINDEXED) return false;
return true;

  }
  case 9: {
    // Predicate_ImmI8
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return -(1 << (8 - 1)) <= Imm && Imm < (1 << 8);
  }
  case 10: {
    // Predicate_extload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::EXTLOAD) return false;
return true;

  }
  case 11: {
    // Predicate_LaneIdx4
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 4;
  }
  case 12: {
    // Predicate_LaneIdx2
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 2;
  }
  case 13: {
    // Predicate_LaneIdx8
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 8;
  }
  case 14: {
    // Predicate_truncstore
    SDNode *N = Node;
    (void)N;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 15: {
    // Predicate_sextload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::SEXTLOAD) return false;
return true;

  }
  case 16: {
    // Predicate_zextload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::ZEXTLOAD) return false;
return true;

  }
  case 17: {
    // Predicate_ImmI16
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return -(1 << (16 - 1)) <= Imm && Imm < (1 << 16);
  }
  case 18: {
    // Predicate_LaneIdx16
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 16;
  }
  case 19: {
    // Predicate_truncstorei8
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i8) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 20: {
    // Predicate_truncstorei16
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i16) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 21: {
    // Predicate_extloadvi8
    // Predicate_sextloadvi8
    // Predicate_zextloadvi8
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i8) return false;
return true;

  }
  case 22: {
    // Predicate_extloadvi16
    // Predicate_sextloadvi16
    // Predicate_zextloadvi16
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i16) return false;
return true;

  }
  case 23: {
    // Predicate_extloadvi32
    // Predicate_sextloadvi32
    // Predicate_zextloadvi32
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i32) return false;
return true;

  }
  case 24: {
    // Predicate_add_nuw
    SDNode *N = Node;
    (void)N;
return N->getFlags().hasNoUnsignedWrap();
  }
  case 25: {
    // Predicate_truncstorei32
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i32) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 26: {
    // Predicate_bool_node
    SDNode *N = Node;
    (void)N;

  return CurDAG->computeKnownBits(SDValue(N, 0)).countMinLeadingZeros() == 31;

  }
  }
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckComplexPattern(SDNode *Root, SDNode *Parent,
      SDValue N, unsigned PatternNo,
      SmallVectorImpl<std::pair<SDValue, SDNode *>> &Result) override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckComplexPattern(SDNode *Root, SDNode *Parent,
      SDValue N, unsigned PatternNo,
      SmallVectorImpl<std::pair<SDValue, SDNode *>> &Result)
#if DAGISEL_INLINE
  override
#endif
{
  unsigned NextRes = Result.size();
  switch (PatternNo) {
  default: llvm_unreachable("Invalid pattern # in table?");
  case 0:
    Result.resize(NextRes+2);
  return SelectAddrOperands32(N, Result[NextRes+0].first, Result[NextRes+1].first);
  case 1:
    Result.resize(NextRes+2);
  return SelectAddrOperands64(N, Result[NextRes+0].first, Result[NextRes+1].first);
  }
}
#endif // GET_DAGISEL_BODY


#ifdef DAGISEL_INLINE
#undef DAGISEL_INLINE
#endif
#ifdef DAGISEL_CLASS_COLONCOLON
#undef DAGISEL_CLASS_COLONCOLON
#endif
#ifdef GET_DAGISEL_DECL
#undef GET_DAGISEL_DECL
#endif
#ifdef GET_DAGISEL_BODY
#undef GET_DAGISEL_BODY
#endif
